/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_HFmode:
      if (!nvptx_register_operand (operands[0], E_HFmode)
          || GET_MODE (x1) != E_HFmode
          || !nvptx_register_operand (operands[1], E_HFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
    return -1;
  x6 = XEXP (x1, 0);
  operands[3] = x6;
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  if (!nvptx_register_operand (operands[0], E_SImode))
    return -1;
  x10 = XEXP (x3, 0);
  operands[1] = x10;
  if (!nvptx_register_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x4, 0);
  operands[2] = x11;
  if (!nvptx_nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern50 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 16L:
      return pattern60 (x1, 
E_HImode, 
E_SImode); /* [-1, 0] */

    case 32L:
      if (pattern60 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 0:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nvptx_register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode)
                return -1;
              return 11; /* load_arg_regqi */

            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode)
                return -1;
              return 12; /* load_arg_reghi */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              return 13; /* load_arg_regsi */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              return 14; /* load_arg_regdi */

            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode)
                return -1;
              return 15; /* load_arg_regsf */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode)
                return -1;
              return 16; /* load_arg_regdf */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1310 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 221; /* sinsf2 */

        case 5:
          if (GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1317 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 222; /* cossf2 */

        case 2:
          if (GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1324 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 223; /* log2sf2 */

        case 3:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || !nvptx_register_operand (operands[1], E_SFmode)
                  || !
#line 1331 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 224; /* exp2sf2 */

            case E_HFmode:
              if (!nvptx_register_operand (operands[0], E_HFmode)
                  || GET_MODE (x3) != E_HFmode
                  || !nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1400 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 233; /* exp2hf2 */

            default:
              return -1;
            }

        case 7:
          if (GET_MODE (x3) != E_BImode
              || !nvptx_register_operand (operands[0], E_BImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nvptx_register_operand (operands[1], E_SFmode))
                return -1;
              return 225; /* setcc_isinfsf */

            case E_DFmode:
              if (!nvptx_register_operand (operands[1], E_DFmode))
                return -1;
              return 226; /* setcc_isinfdf */

            default:
              return -1;
            }

        case 6:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (!nvptx_register_operand (operands[0], E_HFmode)
                  || GET_MODE (x3) != E_HFmode
                  || !nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1407 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 234; /* tanhhf2 */

            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || !nvptx_register_operand (operands[1], E_SFmode)
                  || !
#line 1407 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 235; /* tanhsf2 */

            default:
              return -1;
            }

        case 8:
          switch (pattern23 (x3))
            {
            case 0:
              return 256; /* floorsf2 */

            case 1:
              return 260; /* floordf2 */

            case 2:
              return 264; /* lfloorsfsi2 */

            case 3:
              return 266; /* lfloordfsi2 */

            case 4:
              return 268; /* lfloorsfdi2 */

            case 5:
              return 270; /* lfloordfdi2 */

            default:
              return -1;
            }

        case 9:
          switch (pattern24 (x3))
            {
            case 0:
              return 257; /* btruncsf2 */

            case 1:
              return 261; /* btruncdf2 */

            default:
              return -1;
            }

        case 10:
          switch (pattern23 (x3))
            {
            case 0:
              return 258; /* ceilsf2 */

            case 1:
              return 262; /* ceildf2 */

            case 2:
              return 265; /* lceilsfsi2 */

            case 3:
              return 267; /* lceildfsi2 */

            case 4:
              return 269; /* lceilsfdi2 */

            case 5:
              return 271; /* lceildfdi2 */

            default:
              return -1;
            }

        case 11:
          switch (pattern24 (x3))
            {
            case 0:
              return 259; /* nearbyintsf2 */

            case 1:
              return 263; /* nearbyintdf2 */

            default:
              return -1;
            }

        case 12:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nvptx_nonmemory_operand (operands[1], E_SImode)
                  || !(
#line 1692 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_7_3
   && TARGET_SM52) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
                return -1;
              return 290; /* nvptx_alloca_si */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nvptx_nonmemory_operand (operands[1], E_DImode)
                  || !(
#line 1692 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_7_3
   && TARGET_SM52) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
                return -1;
              return 291; /* nvptx_alloca_di */

            default:
              return -1;
            }

        case 14:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !(
#line 1743 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_7_3
   && TARGET_SM52) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
                return -1;
              return 294; /* nvptx_stacksave_si */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 1743 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_7_3
   && TARGET_SM52) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
                return -1;
              return 295; /* nvptx_stacksave_di */

            default:
              return -1;
            }

        case 15:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode)
                  || !(
#line 1775 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_7_3
   && TARGET_SM52) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
                return -1;
              return 296; /* nvptx_stackrestore_si */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode)
                  || !(
#line 1775 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_7_3
   && TARGET_SM52) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
                return -1;
              return 297; /* nvptx_stackrestore_di */

            default:
              return -1;
            }

        case 16:
          if (GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 301; /* oacc_dim_size */

        case 18:
          if (GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 309; /* nvptx_vote_ballot */

        case 19:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !nvptx_register_operand (operands[0], E_SImode))
            return -1;
          return 314; /* omp_simt_lane */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern41 (x3, 
E_SFmode) != 0)
                return -1;
              return 209; /* copysignsf3 */

            case E_DFmode:
              if (pattern41 (x3, 
E_DFmode) != 0)
                return -1;
              return 210; /* copysigndf3 */

            default:
              return -1;
            }

        case 17:
          if (!nvptx_register_operand (operands[1], E_SImode)
              || !nvptx_register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              return 317; /* packsidi2 */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode)
                return -1;
              return 318; /* packsidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 20)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!nvptx_nonmemory_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 307; /* nvptx_shufflesi */

        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 308; /* nvptx_shufflesf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
