/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nvptx_nonmemory_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!nvptx_register_operand (operands[1], E_BImode))
    return -1;
  return pattern20 (x1); /* [-1, 2] */
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern25 (x7, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern25 (x7, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern25 (x7, 
E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern35 (x7, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern35 (x7, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern43 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[2], E_HImode)
          || !nvptx_nonmemory_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[2], E_SImode)
          || !nvptx_nonmemory_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[2], E_DImode)
          || !nvptx_nonmemory_operand (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_double_operand (operands[2], i1)
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern67 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_CODE (x2))
    {
    case EQ:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!nvptx_register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[1], E_HImode))
                return -1;
              return 89; /* *cnothi2 */

            case E_BImode:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 150; /* *setcchi_from_not_bi */

            default:
              return -1;
            }

        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[1], E_SImode))
                return -1;
              return 90; /* *cnotsi2 */

            case E_BImode:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 151; /* *setccsi_from_not_bi */

            default:
              return -1;
            }

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 91; /* *cnotdi2 */

            case E_BImode:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 152; /* *setccdi_from_not_bi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
      if (!nvptx_register_operand (operands[1], E_BImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nvptx_register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          return 146; /* setccqi_from_bi */

        case E_HImode:
          if (!nvptx_register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          return 147; /* setcchi_from_bi */

        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          return 148; /* setccsi_from_bi */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          return 149; /* setccdi_from_bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x8 = XEXP (x6, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nvptx_nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[1], E_HImode))
                return -1;
              return 451; /* *p trunchiqi2 */

            case E_SImode:
              if (!nvptx_register_operand (operands[1], E_SImode))
                return -1;
              return 452; /* *p truncsiqi2 */

            case E_DImode:
              if (!nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 454; /* *p truncdiqi2 */

            default:
              return -1;
            }

        case E_HImode:
          if (!nvptx_nonimmediate_operand (operands[0], E_HImode))
            return -1;
          switch (pattern33 (x4, 
E_HImode))
            {
            case 0:
              return 453; /* *p truncsihi2 */

            case 1:
              return 455; /* *p truncdihi2 */

            default:
              return -1;
            }

        case E_SImode:
          if (!nvptx_nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !nvptx_register_operand (operands[1], E_DImode))
            return -1;
          return 456; /* *p truncdisi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x8 = XEXP (x6, 1);
      operands[4] = x8;
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 519; /* *p popcountdi2 */

    case LSHIFTRT:
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != MULT)
        return -1;
      x10 = XEXP (x5, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x6, 1);
      operands[5] = x8;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case SIGN_EXTEND:
          switch (pattern61 (x4, 
SIGN_EXTEND))
            {
            case 0:
              return 530; /* *p *smulhi3_highpart_2 */

            case 1:
              return 531; /* *p *smulsi3_highpart_2 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern61 (x4, 
ZERO_EXTEND))
            {
            case 0:
              return 532; /* *p *umulhi3_highpart_2 */

            case 1:
              return 533; /* *p *umulsi3_highpart_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
