/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!nvptx_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!nvptx_register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[2] = x7;
  if (!nvptx_nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern18 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_SImode:
      res = pattern22 (x1, 
E_SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_DImode:
      res = pattern22 (x1, 
E_DImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode))
        return -1;
      return pattern33 (x7, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode))
        return -1;
      res = pattern33 (x7, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nvptx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern66 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || !nvptx_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[2], E_HImode)
          || !nvptx_nonmemory_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[2], E_SImode)
          || !nvptx_nonmemory_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[2], E_DImode)
          || !nvptx_nonmemory_operand (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nvptx_nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[1], E_HImode))
                return -1;
              return 29; /* trunchiqi2 */

            case E_SImode:
              if (!nvptx_register_operand (operands[1], E_SImode))
                return -1;
              return 30; /* truncsiqi2 */

            case E_DImode:
              if (!nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 32; /* truncdiqi2 */

            default:
              return -1;
            }

        case E_HImode:
          if (!nvptx_nonimmediate_operand (operands[0], E_HImode))
            return -1;
          switch (pattern6 (x3, 
E_HImode))
            {
            case 0:
              return 31; /* truncsihi2 */

            case 1:
              return 33; /* truncdihi2 */

            default:
              return -1;
            }

        case E_SImode:
          if (!nvptx_nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[1], E_DImode))
            return -1;
          return 34; /* truncdisi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      if (GET_MODE (x4) != E_DImode
          || !nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 97; /* popcountdi2 */

    case LSHIFTRT:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          switch (pattern38 (x3, 
SIGN_EXTEND))
            {
            case 0:
              return 108; /* *smulhi3_highpart_2 */

            case 1:
              return 109; /* *smulsi3_highpart_2 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern38 (x3, 
ZERO_EXTEND))
            {
            case 0:
              return 110; /* *umulhi3_highpart_2 */

            case 1:
              return 111; /* *umulsi3_highpart_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      operands[2] = x2;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[0], E_SImode)
              || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 611; /* *p call_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[0], E_DImode)
              || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 612; /* *p call_insn_di */

        default:
          return -1;
        }

    case SET:
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != CALL)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != MEM
          || GET_MODE (x10) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      operands[3] = x2;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (!nvptx_register_operand (operands[0], E_VOIDmode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      x12 = XEXP (x9, 1);
      operands[2] = x12;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[1], E_SImode)
              || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 613; /* *p call_value_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[1], E_DImode)
              || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 614; /* *p call_value_insn_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
