/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern0 (x3, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern0 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern0 (x3, 
E_DImode) != 0)
        return -1;
      return 2;

    case E_BImode:
      if (pattern4 (x3, 
E_BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !nvptx_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nvptx_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nvptx_register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!nvptx_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 16L:
      return pattern37 (x1, 
E_HImode, 
E_SImode); /* [-1, 0] */

    case 32L:
      if (pattern37 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          return 0;

        case E_BImode:
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_BImode:
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 5;

        case E_HImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 6;

        case E_SImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 7;

        case E_BImode:
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_QImode:
      if (!nvptx_register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !nvptx_register_operand (operands[1], E_BImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!nvptx_register_operand (operands[0], E_BImode)
          || !nvptx_nonmemory_operand (operands[1], E_BImode))
        return -1;
      return 423; /* *p movbi */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 248 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 424; /* *p *movv2si_insn */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode)
          || !
#line 248 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 425; /* *p *movv2di_insn */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode)
          || !
#line 262 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 426; /* *p *movqi_insn */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode)
          || !
#line 262 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 427; /* *p *movhi_insn */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode)
          || !
#line 262 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 428; /* *p *movsi_insn */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode)
          || !
#line 262 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 429; /* *p *movdi_insn */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode)
          || !
#line 287 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 430; /* *p *movsf_insn */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 287 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 431; /* *p *movdf_insn */

    case E_HFmode:
      if (!nonimmediate_operand (operands[0], E_HFmode)
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 301 "../../gcc/config/nvptx/nvptx.md"
(!MEM_P (operands[0]) || REG_P (operands[1])))
        return -1;
      return 432; /* *p *movhf_insn */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_6 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_4 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case MEM:
          switch (pattern16 (x2))
            {
            case 0:
              if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
                return -1;
              return 17; /* zero_extendqihi2 */

            case 1:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 158; /* zero_extendbihi2 */

            case 2:
              return 18; /* zero_extendqisi2 */

            case 3:
              return 19; /* zero_extendhisi2 */

            case 4:
              return 159; /* zero_extendbisi2 */

            case 5:
              return 20; /* zero_extendqidi2 */

            case 6:
              return 21; /* zero_extendhidi2 */

            case 7:
              return 22; /* zero_extendsidi2 */

            case 8:
              return 160; /* zero_extendbidi2 */

            case 9:
              return 157; /* zero_extendbiqi2 */

            default:
              return -1;
            }

        case TRUNCATE:
          if (GET_MODE (x4) != E_QImode
              || !nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 350; /* *zext_truncsi2_qi */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case MEM:
          switch (pattern16 (x2))
            {
            case 0:
              if (!nvptx_register_operand (operands[1], E_QImode))
                return -1;
              return 23; /* extendqihi2 */

            case 1:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 154; /* extendbihi2 */

            case 2:
              return 24; /* extendqisi2 */

            case 3:
              return 25; /* extendhisi2 */

            case 4:
              return 155; /* extendbisi2 */

            case 5:
              return 26; /* extendqidi2 */

            case 6:
              return 27; /* extendhidi2 */

            case 7:
              return 28; /* extendsidi2 */

            case 8:
              return 156; /* extendbidi2 */

            case 9:
              return 153; /* extendbiqi2 */

            default:
              return -1;
            }

        case TRUNCATE:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || GET_MODE (x4) != E_QImode
                  || !nvptx_register_operand (operands[1], E_HImode))
                return -1;
              return 35; /* *extend_trunc_hi2_qi */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_QImode:
                  return 36; /* *extend_trunc_si2_qi */

                case E_HImode:
                  return 38; /* *extend_trunc_si2_hi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_QImode:
                  return 37; /* *extend_trunc_di2_qi */

                case E_HImode:
                  return 39; /* *extend_trunc_di2_hi */

                case E_SImode:
                  return 40; /* *extend_trunc_di2_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      return recog_7 (x1, insn, pnum_clobbers);

    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          switch (pattern10 (x2))
            {
            case 0:
              return 41; /* addhi3 */

            case 1:
              return 42; /* addsi3 */

            case 2:
              return 43; /* adddi3 */

            case 3:
              return 197; /* addsf3 */

            case 4:
              return 198; /* adddf3 */

            case 5:
              if (!
#line 1359 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 227; /* addhf3 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern17 (x2) != 0)
            return -1;
          return 44; /* *vadd_addsi4 */

        case MINUS:
          if (pattern17 (x2) != 0)
            return -1;
          return 45; /* *vsub_addsi4 */

        case MULT:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern42 (x2, 
E_HImode) != 0)
                return -1;
              return 52; /* *madhi3 */

            case E_SImode:
              if (pattern42 (x2, 
E_SImode) != 0)
                return -1;
              return 53; /* *madsi3 */

            case E_DImode:
              if (pattern42 (x2, 
E_DImode) != 0)
                return -1;
              return 54; /* *maddi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern4 (x2, 
E_HImode) != 0)
            return -1;
          return 46; /* subhi3 */

        case E_SImode:
          if (pattern4 (x2, 
E_SImode) != 0)
            return -1;
          return 47; /* subsi3 */

        case E_DImode:
          if (pattern4 (x2, 
E_DImode) != 0)
            return -1;
          return 48; /* subdi3 */

        case E_SFmode:
          if (pattern4 (x2, 
E_SFmode) != 0)
            return -1;
          return 199; /* subsf3 */

        case E_DFmode:
          if (pattern4 (x2, 
E_DFmode) != 0)
            return -1;
          return 200; /* subdf3 */

        case E_HFmode:
          if (pattern4 (x2, 
E_HFmode) != 0
              || !
#line 1366 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 228; /* subhf3 */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          switch (pattern10 (x2))
            {
            case 0:
              return 49; /* mulhi3 */

            case 1:
              return 50; /* mulsi3 */

            case 2:
              return 51; /* muldi3 */

            case 3:
              return 201; /* mulsf3 */

            case 4:
              return 202; /* muldf3 */

            case 5:
              if (!
#line 1373 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 229; /* mulhf3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern19 (x2, 
SIGN_EXTEND))
            {
            case 0:
              return 98; /* mulhisi3 */

            case 1:
              return 99; /* mulsidi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern19 (x2, 
ZERO_EXTEND))
            {
            case 0:
              return 100; /* umulhisi3 */

            case 1:
              return 101; /* umulsidi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern0 (x2, 
E_HImode) != 0)
                return -1;
              return 55; /* divhi3 */

            case E_SImode:
              if (pattern0 (x2, 
E_SImode) != 0)
                return -1;
              return 56; /* divsi3 */

            case E_DImode:
              if (pattern0 (x2, 
E_DImode) != 0)
                return -1;
              return 57; /* divdi3 */

            case E_SFmode:
              if (pattern0 (x2, 
E_SFmode) != 0)
                return -1;
              return 207; /* divsf3 */

            case E_DFmode:
              if (pattern0 (x2, 
E_DFmode) != 0)
                return -1;
              return 208; /* divdf3 */

            default:
              return -1;
            }

        case CONST_DOUBLE:
          operands[2] = x4;
          x7 = XEXP (x2, 1);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern39 (x2, 
E_SFmode) != 0
                  || !
#line 1244 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 205; /* *recipsf2 */

            case E_DFmode:
              if (pattern39 (x2, 
E_DFmode) != 0
                  || !
#line 1244 "../../gcc/config/nvptx/nvptx.md"
(CONST_DOUBLE_P (operands[2])
   && real_identical (CONST_DOUBLE_REAL_VALUE (operands[2]), &dconst1)))
                return -1;
              return 206; /* *recipdf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          return 58; /* udivhi3 */

        case 1:
          return 59; /* udivsi3 */

        case 2:
          return 60; /* udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          return 61; /* modhi3 */

        case 1:
          return 62; /* modsi3 */

        case 2:
          return 63; /* moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          return 64; /* umodhi3 */

        case 1:
          return 65; /* umodsi3 */

        case 2:
          return 66; /* umoddi3 */

        default:
          return -1;
        }

    case SMIN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern10 (x2))
        {
        case 0:
          return 67; /* sminhi3 */

        case 1:
          return 68; /* sminsi3 */

        case 2:
          return 69; /* smindi3 */

        case 3:
          return 211; /* sminsf3 */

        case 4:
          return 212; /* smindf3 */

        case 5:
          if (!
#line 1416 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM80))
            return -1;
          return 236; /* sminhf3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern1 (x1))
        {
        case 0:
          return 70; /* uminhi3 */

        case 1:
          return 71; /* uminsi3 */

        case 2:
          return 72; /* umindi3 */

        default:
          return -1;
        }

    case SMAX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern10 (x2))
        {
        case 0:
          return 73; /* smaxhi3 */

        case 1:
          return 74; /* smaxsi3 */

        case 2:
          return 75; /* smaxdi3 */

        case 3:
          return 213; /* smaxsf3 */

        case 4:
          return 214; /* smaxdf3 */

        case 5:
          if (!
#line 1423 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM80))
            return -1;
          return 237; /* smaxhf3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern1 (x1))
        {
        case 0:
          return 76; /* umaxhi3 */

        case 1:
          return 77; /* umaxsi3 */

        case 2:
          return 78; /* umaxdi3 */

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern11 (x2))
        {
        case 0:
          return 79; /* abshi2 */

        case 1:
          return 80; /* abssi2 */

        case 2:
          return 81; /* absdi2 */

        case 3:
          return 215; /* abssf2 */

        case 4:
          return 216; /* absdf2 */

        case 5:
          return 232; /* abshf2 */

        default:
          return -1;
        }

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          switch (pattern11 (x2))
            {
            case 0:
              return 82; /* neghi2 */

            case 1:
              return 83; /* negsi2 */

            case 2:
              return 84; /* negdi2 */

            case 3:
              return 217; /* negsf2 */

            case 4:
              return 218; /* negdf2 */

            case 5:
              return 231; /* neghf2 */

            default:
              return -1;
            }

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case UNORDERED:
            case ORDERED:
            case UNEQ:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              res = recog_1 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          if (!nvptx_comparison_operator (x4, E_SImode))
            return -1;
          operands[1] = x4;
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[2]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[2], E_HImode)
                  || !nvptx_nonmemory_operand (operands[3], E_HImode))
                return -1;
              return 183; /* *setcc_inthi */

            case E_SImode:
              if (!nvptx_register_operand (operands[2], E_SImode)
                  || !nvptx_nonmemory_operand (operands[3], E_SImode))
                return -1;
              return 184; /* *setcc_intsi */

            case E_DImode:
              if (!nvptx_register_operand (operands[2], E_DImode)
                  || !nvptx_nonmemory_operand (operands[3], E_DImode))
                return -1;
              return 185; /* *setcc_intdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !nvptx_register_operand (operands[1], E_HImode))
                return -1;
              return 85; /* one_cmplhi2 */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode))
                return -1;
              return 86; /* one_cmplsi2 */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 87; /* one_cmpldi2 */

            case E_BImode:
              if (!nvptx_register_operand (operands[0], E_BImode)
                  || GET_MODE (x2) != E_BImode
                  || !nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 88; /* one_cmplbi2 */

            default:
              return -1;
            }

        case EQ:
          switch (pattern21 (x2))
            {
            case 0:
              return 177; /* *selphi_not_eq */

            case 1:
              return 179; /* *selpsi_not_eq */

            case 2:
              return 181; /* *selpdi_not_eq */

            default:
              return -1;
            }

        case NE:
          switch (pattern21 (x2))
            {
            case 0:
              return 178; /* *selphi_not_ne */

            case 1:
              return 180; /* *selpsi_not_ne */

            case 2:
              return 182; /* *selpdi_not_ne */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[1] = x2;
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_BImode:
              switch (pattern43 (
E_BImode))
                {
                case 0:
                  return 135; /* cmphi */

                case 1:
                  return 136; /* cmpsi */

                case 2:
                  return 137; /* cmpdi */

                default:
                  return -1;
                }

            case E_SFmode:
              switch (pattern43 (
E_SFmode))
                {
                case 0:
                  return 188; /* setcc_floathi */

                case 1:
                  return 189; /* setcc_floatsi */

                case 2:
                  return 190; /* setcc_floatdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case BITREVERSE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 92; /* bitrevsi2 */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nvptx_register_operand (operands[1], E_DImode))
            return -1;
          return 93; /* bitrevdi2 */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 94; /* clzsi2 */

        case E_DImode:
          if (!nvptx_register_operand (operands[1], E_DImode))
            return -1;
          return 95; /* clzdi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 96; /* popcountsi2 */

    case SMUL_HIGHPART:
      switch (pattern1 (x1))
        {
        case 0:
          return 102; /* smulhi3_highpart */

        case 1:
          return 103; /* smulsi3_highpart */

        case 2:
          return 104; /* smuldi3_highpart */

        default:
          return -1;
        }

    case UMUL_HIGHPART:
      switch (pattern1 (x1))
        {
        case 0:
          return 105; /* umulhi3_highpart */

        case 1:
          return 106; /* umulsi3_highpart */

        case 2:
          return 107; /* umuldi3_highpart */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern2 (x1))
        {
        case 0:
          return 112; /* ashlhi3 */

        case 1:
          return 113; /* ashlsi3 */

        case 2:
          return 114; /* ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern2 (x1))
        {
        case 0:
          return 115; /* ashrhi3 */

        case 1:
          return 116; /* ashrsi3 */

        case 2:
          return 117; /* ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern2 (x1))
        {
        case 0:
          return 118; /* lshrhi3 */

        case 1:
          return 119; /* lshrsi3 */

        case 2:
          return 120; /* lshrdi3 */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern3 (x1) != 0
          || !
#line 836 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM35))
        return -1;
      return 121; /* rotlsi3 */

    case ROTATERT:
      if (pattern3 (x1) != 0
          || !
#line 844 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM35))
        return -1;
      return 122; /* rotrsi3 */

    case AND:
      switch (pattern5 (x1))
        {
        case 0:
          return 123; /* andhi3 */

        case 1:
          return 126; /* andsi3 */

        case 2:
          return 129; /* anddi3 */

        case 3:
          return 132; /* andbi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern5 (x1))
        {
        case 0:
          return 124; /* iorhi3 */

        case 1:
          return 127; /* iorsi3 */

        case 2:
          return 130; /* iordi3 */

        case 3:
          return 133; /* iorbi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern5 (x1))
        {
        case 0:
          return 125; /* xorhi3 */

        case 1:
          return 128; /* xorsi3 */

        case 2:
          return 131; /* xordi3 */

        case 3:
          return 134; /* xorbi3 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
          switch (pattern13 (x1))
            {
            case 0:
              return 142; /* br_true */

            case 1:
              return 161; /* sel_truehi */

            case 2:
              return 162; /* sel_truesi */

            case 3:
              return 163; /* sel_truedi */

            case 4:
              return 164; /* sel_truesf */

            case 5:
              return 165; /* sel_truedf */

            case 6:
              return 144; /* br_true_uni */

            default:
              return -1;
            }

        case EQ:
          switch (pattern13 (x1))
            {
            case 0:
              return 143; /* br_false */

            case 1:
              return 166; /* sel_falsehi */

            case 2:
              return 167; /* sel_falsesi */

            case 3:
              return 168; /* sel_falsedi */

            case 4:
              return 169; /* sel_falsesf */

            case 5:
              return 170; /* sel_falsedf */

            case 6:
              return 145; /* br_false_uni */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern40 (x2, 
E_SFmode) != 0)
            return -1;
          return 203; /* fmasf4 */

        case E_DFmode:
          if (pattern40 (x2, 
E_DFmode) != 0)
            return -1;
          return 204; /* fmadf4 */

        case E_HFmode:
          if (pattern40 (x2, 
E_HFmode) != 0
              || !
#line 1381 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 230; /* fmahf4 */

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 219; /* sqrtsf2 */

        case E_DFmode:
          if (!nvptx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !nvptx_register_operand (operands[1], E_DFmode))
            return -1;
          return 220; /* sqrtdf2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!nvptx_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nvptx_register_operand (operands[1], E_SFmode))
                return -1;
              return 238; /* extendsfdf2 */

            case E_HFmode:
              if (!nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1522 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 273; /* extendhfdf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nvptx_register_operand (operands[1], E_HFmode)
              || !
#line 1522 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
            return -1;
          return 272; /* extendhfsf2 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nvptx_register_operand (operands[1], E_DFmode))
            return -1;
          return 239; /* truncdfsf2 */

        case E_HFmode:
          switch (pattern8 (x2, 
E_HFmode))
            {
            case 0:
              if (!
#line 1528 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 274; /* truncsfhf2 */

            case 1:
              if (!
#line 1528 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM53))
                return -1;
              return 275; /* truncdfhf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern7 (x1))
        {
        case 0:
          return 240; /* floatunssisf2 */

        case 1:
          return 244; /* floatunsdisf2 */

        case 2:
          return 241; /* floatunssidf2 */

        case 3:
          return 245; /* floatunsdidf2 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern7 (x1))
        {
        case 0:
          return 242; /* floatsisf2 */

        case 1:
          return 246; /* floatdisf2 */

        case 2:
          return 243; /* floatsidf2 */

        case 3:
          return 247; /* floatdidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern9 (x1))
        {
        case 0:
          return 248; /* fixuns_truncsfsi2 */

        case 1:
          return 249; /* fixuns_truncdfsi2 */

        case 2:
          return 252; /* fixuns_truncsfdi2 */

        case 3:
          return 253; /* fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern9 (x1))
        {
        case 0:
          return 250; /* fix_truncsfsi2 */

        case 1:
          return 251; /* fix_truncdfsi2 */

        case 2:
          return 254; /* fix_truncsfdi2 */

        case 3:
          return 255; /* fix_truncdfdi2 */

        default:
          return -1;
        }

    case VEC_MERGE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != VEC_DUPLICATE)
        return -1;
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x2, 1);
      if (!rtx_equal_p (x7, operands[0]))
        return -1;
      switch (XWINT (x8, 0))
        {
        case 1L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern45 (x2, 
E_SImode, 
E_V2SImode) != 0)
                return -1;
              return 276; /* *vec_setv2si_0 */

            case E_V2DImode:
              if (pattern45 (x2, 
E_DImode, 
E_V2DImode) != 0)
                return -1;
              return 277; /* *vec_setv2di_0 */

            default:
              return -1;
            }

        case 2L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern45 (x2, 
E_SImode, 
E_V2SImode) != 0)
                return -1;
              return 278; /* *vec_setv2si_1 */

            case E_V2DImode:
              if (pattern45 (x2, 
E_DImode, 
E_V2DImode) != 0)
                return -1;
              return 279; /* *vec_setv2di_1 */

            default:
              return -1;
            }

        case 4L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern45 (x2, 
E_SImode, 
E_V2SImode) != 0)
                return -1;
              return 280; /* *vec_setv2si_2 */

            case E_V2DImode:
              if (pattern45 (x2, 
E_DImode, 
E_V2DImode) != 0)
                return -1;
              return 281; /* *vec_setv2di_2 */

            default:
              return -1;
            }

        case 8L:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern45 (x2, 
E_SImode, 
E_V2SImode) != 0)
                return -1;
              return 282; /* *vec_setv2si_3 */

            case E_V2DImode:
              if (pattern45 (x2, 
E_DImode, 
E_V2DImode) != 0)
                return -1;
              return 283; /* *vec_setv2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x9 = XVECEXP (x7, 0, 0);
      operands[2] = x9;
      if (!nvptx_vector_index_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nvptx_register_operand (operands[1], E_V2SImode))
            return -1;
          return 284; /* vec_extractv2sisi */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nvptx_register_operand (operands[1], E_V2DImode))
            return -1;
          return 285; /* vec_extractv2didi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_5 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}
