/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode))
        return -1;
      return pattern6 (x3, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode))
        return -1;
      res = pattern6 (x3, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          return 0;

        case E_BImode:
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_BImode:
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 5;

        case E_HImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 6;

        case E_SImode:
          if (!nvptx_nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 7;

        case E_BImode:
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_QImode:
      if (!nvptx_register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !nvptx_register_operand (operands[1], E_BImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern50 (x1, 
E_HImode, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern50 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern55 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern55 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_nonmemory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern69 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern68 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern68 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 14:
          if (GET_MODE (x3) != E_SImode
              || !nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 302; /* oacc_dim_pos */

        case 11:
          if (GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[0]))
            return -1;
          return 344; /* *memory_barrier */

        case 12:
          if (GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[0]))
            return -1;
          return 345; /* *nvptx_membar_cta */

        case 13:
          if (GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[0]))
            return -1;
          return 346; /* *nvptx_membar_gl */

        case 22:
          if (GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_DImode))
            return -1;
          return 348; /* nvptx_red_partition */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 20:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern41 (x3, 
E_SImode) != 0
                  || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                return -1;
              return 310; /* omp_simt_enter_si */

            case E_DImode:
              if (pattern41 (x3, 
E_DImode) != 0
                  || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                return -1;
              return 311; /* omp_simt_enter_di */

            default:
              return -1;
            }

        case 4:
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!memory_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nvptx_nonmemory_operand (operands[1], E_SImode))
                return -1;
              if (
#line 2222 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM70))
                return 325; /* nvptx_atomic_store_sm70si */
              if (!
#line 2236 "../../gcc/config/nvptx/nvptx.md"
(!TARGET_SM70))
                return -1;
              return 327; /* nvptx_atomic_storesi */

            case E_DImode:
              if (!memory_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nvptx_nonmemory_operand (operands[1], E_DImode))
                return -1;
              if (
#line 2222 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM70))
                return 326; /* nvptx_atomic_store_sm70di */
              if (!
#line 2236 "../../gcc/config/nvptx/nvptx.md"
(!TARGET_SM70))
                return -1;
              return 328; /* nvptx_atomic_storedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!nvptx_nonmemory_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!nvptx_nonmemory_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      operands[4] = x7;
      if (!nvptx_register_operand (operands[4], E_BImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 5:
          if (!nvptx_register_operand (operands[0], E_BImode))
            return -1;
          return 340; /* nvptx_barred_and */

        case 6:
          if (!nvptx_register_operand (operands[0], E_BImode))
            return -1;
          return 341; /* nvptx_barred_or */

        case 7:
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          return 342; /* nvptx_barred_popc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case CONST:
          if (GET_MODE (x3) != E_DImode)
            return NULL;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != PLUS
              || GET_MODE (x4) != E_DImode
              || !nvptx_register_operand (operands[0], E_DImode))
            return NULL;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!symbol_ref_function_operand (operands[1], E_DImode))
            return NULL;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return NULL;
          return gen_split_1 (insn, operands);

        case AND:
          switch (pattern15 (x3))
            {
            case 0:
              if (!
#line 875 "../../gcc/config/nvptx/nvptx.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_2 (insn, operands);

            case 1:
              if (!
#line 875 "../../gcc/config/nvptx/nvptx.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_5 (insn, operands);

            case 2:
              if (!
#line 875 "../../gcc/config/nvptx/nvptx.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern15 (x3))
            {
            case 0:
              if (!
#line 875 "../../gcc/config/nvptx/nvptx.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_3 (insn, operands);

            case 1:
              if (!
#line 875 "../../gcc/config/nvptx/nvptx.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_6 (insn, operands);

            case 2:
              if (!
#line 875 "../../gcc/config/nvptx/nvptx.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_9 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern15 (x3))
            {
            case 0:
              if (!
#line 875 "../../gcc/config/nvptx/nvptx.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_4 (insn, operands);

            case 1:
              if (!
#line 875 "../../gcc/config/nvptx/nvptx.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_7 (insn, operands);

            case 2:
              if (!
#line 875 "../../gcc/config/nvptx/nvptx.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_10 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case EQ:
              switch (pattern21 (x3))
                {
                case 0:
                  return gen_split_11 (insn, operands);

                case 1:
                  return gen_split_13 (insn, operands);

                case 2:
                  return gen_split_15 (insn, operands);

                default:
                  return NULL;
                }

            case NE:
              switch (pattern21 (x3))
                {
                case 0:
                  return gen_split_12 (insn, operands);

                case 1:
                  return gen_split_14 (insn, operands);

                case 2:
                  return gen_split_16 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case NOT:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case EQ:
              switch (pattern21 (x3))
                {
                case 0:
                  return gen_split_17 (insn, operands);

                case 1:
                  return gen_split_19 (insn, operands);

                case 2:
                  return gen_split_21 (insn, operands);

                default:
                  return NULL;
                }

            case NE:
              switch (pattern21 (x3))
                {
                case 0:
                  return gen_split_18 (insn, operands);

                case 1:
                  return gen_split_20 (insn, operands);

                case 2:
                  return gen_split_22 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COND_EXEC:
      x2 = XEXP (x1, 0);
      if (!predicate_operator (x2, E_VOIDmode))
        return NULL;
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != SET)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[3] = x7;
      if (!nvptx_register_operand (operands[3], E_BImode))
        return NULL;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      if (!const0_operand (operands[4], E_BImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 1);
      switch (GET_CODE (x9))
        {
        case NEG:
          x10 = XEXP (x9, 0);
          switch (GET_CODE (x10))
            {
            case EQ:
              switch (pattern54 (x9))
                {
                case 0:
                  return gen_split_23 (insn, operands);

                case 1:
                  return gen_split_25 (insn, operands);

                case 2:
                  return gen_split_27 (insn, operands);

                default:
                  return NULL;
                }

            case NE:
              switch (pattern54 (x9))
                {
                case 0:
                  return gen_split_24 (insn, operands);

                case 1:
                  return gen_split_26 (insn, operands);

                case 2:
                  return gen_split_28 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case NOT:
          x10 = XEXP (x9, 0);
          switch (GET_CODE (x10))
            {
            case EQ:
              switch (pattern54 (x9))
                {
                case 0:
                  return gen_split_29 (insn, operands);

                case 1:
                  return gen_split_31 (insn, operands);

                case 2:
                  return gen_split_33 (insn, operands);

                default:
                  return NULL;
                }

            case NE:
              switch (pattern54 (x9))
                {
                case 0:
                  return gen_split_30 (insn, operands);

                case 1:
                  return gen_split_32 (insn, operands);

                case 2:
                  return gen_split_34 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
