/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !gcn_valu_dst_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !gcn_valu_src0_operand (operands[1], E_SImode)
      || !gcn_alu_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8HFmode:
      if (!gcn_alu_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    case E_V8SFmode:
      if (!gcn_alu_operand (operands[1], E_V8SFmode))
        return -1;
      return 3;

    case E_V8DFmode:
      if (!gcn_alu_operand (operands[1], E_V8DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HFmode:
      if (!gcn_alu_operand (operands[1], E_V4HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!gcn_alu_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!gcn_alu_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 4;

    case E_V2HFmode:
      res = pattern13 (x3, 
E_V2HFmode);
      if (res >= 0)
        return res + 5; /* [5, 9] */
      return -1;

    case E_V2SFmode:
      res = pattern13 (x3, 
E_V2SFmode);
      if (res >= 0)
        return res + 10; /* [10, 14] */
      return -1;

    case E_V2DFmode:
      res = pattern13 (x3, 
E_V2DFmode);
      if (res >= 0)
        return res + 15; /* [15, 19] */
      return -1;

    case E_V4HFmode:
      res = pattern14 (x3, 
E_V4HFmode);
      if (res >= 0)
        return res + 20; /* [20, 24] */
      return -1;

    case E_V4SFmode:
      res = pattern14 (x3, 
E_V4SFmode);
      if (res >= 0)
        return res + 25; /* [25, 29] */
      return -1;

    case E_V4DFmode:
      res = pattern14 (x3, 
E_V4DFmode);
      if (res >= 0)
        return res + 30; /* [30, 34] */
      return -1;

    case E_V8HFmode:
      res = pattern15 (x3, 
E_V8HFmode);
      if (res >= 0)
        return res + 35; /* [35, 39] */
      return -1;

    case E_V8SFmode:
      res = pattern15 (x3, 
E_V8SFmode);
      if (res >= 0)
        return res + 40; /* [40, 44] */
      return -1;

    case E_V8DFmode:
      res = pattern15 (x3, 
E_V8DFmode);
      if (res >= 0)
        return res + 45; /* [45, 49] */
      return -1;

    case E_V16HFmode:
      res = pattern16 (x3, 
E_V16HFmode);
      if (res >= 0)
        return res + 50; /* [50, 54] */
      return -1;

    case E_V16SFmode:
      res = pattern16 (x3, 
E_V16SFmode);
      if (res >= 0)
        return res + 55; /* [55, 59] */
      return -1;

    case E_V16DFmode:
      res = pattern16 (x3, 
E_V16DFmode);
      if (res >= 0)
        return res + 60; /* [60, 64] */
      return -1;

    case E_V32HFmode:
      res = pattern17 (x3, 
E_V32HFmode);
      if (res >= 0)
        return res + 65; /* [65, 69] */
      return -1;

    case E_V32SFmode:
      res = pattern17 (x3, 
E_V32SFmode);
      if (res >= 0)
        return res + 70; /* [70, 74] */
      return -1;

    case E_V32DFmode:
      res = pattern17 (x3, 
E_V32DFmode);
      if (res >= 0)
        return res + 75; /* [75, 79] */
      return -1;

    case E_V64HFmode:
      res = pattern18 (x3, 
E_V64HFmode);
      if (res >= 0)
        return res + 80; /* [80, 84] */
      return -1;

    case E_V64SFmode:
      res = pattern18 (x3, 
E_V64SFmode);
      if (res >= 0)
        return res + 85; /* [85, 89] */
      return -1;

    case E_V64DFmode:
      res = pattern18 (x3, 
E_V64DFmode);
      if (res >= 0)
        return res + 90; /* [90, 94] */
      return -1;

    case E_V2HImode:
      res = pattern19 (x3, 
E_V2HImode);
      if (res >= 0)
        return res + 95; /* [95, 97] */
      return -1;

    case E_V2SImode:
      res = pattern19 (x3, 
E_V2SImode);
      if (res >= 0)
        return res + 98; /* [98, 100] */
      return -1;

    case E_V4HImode:
      res = pattern20 (x3, 
E_V4HImode);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_V4SImode:
      res = pattern20 (x3, 
E_V4SImode);
      if (res >= 0)
        return res + 104; /* [104, 106] */
      return -1;

    case E_V8HImode:
      res = pattern21 (x3, 
E_V8HImode);
      if (res >= 0)
        return res + 107; /* [107, 109] */
      return -1;

    case E_V8SImode:
      res = pattern21 (x3, 
E_V8SImode);
      if (res >= 0)
        return res + 110; /* [110, 112] */
      return -1;

    case E_V16HImode:
      res = pattern22 (x3, 
E_V16HImode);
      if (res >= 0)
        return res + 113; /* [113, 115] */
      return -1;

    case E_V16SImode:
      res = pattern22 (x3, 
E_V16SImode);
      if (res >= 0)
        return res + 116; /* [116, 118] */
      return -1;

    case E_V32HImode:
      res = pattern23 (x3, 
E_V32HImode);
      if (res >= 0)
        return res + 119; /* [119, 121] */
      return -1;

    case E_V32SImode:
      res = pattern23 (x3, 
E_V32SImode);
      if (res >= 0)
        return res + 122; /* [122, 124] */
      return -1;

    case E_V64HImode:
      res = pattern24 (x3, 
E_V64HImode);
      if (res >= 0)
        return res + 125; /* [125, 127] */
      return -1;

    case E_V64SImode:
      res = pattern24 (x3, 
E_V64SImode);
      if (res >= 0)
        return res + 128; /* [128, 130] */
      return -1;

    default:
      return -1;
    }
}

int
pattern66 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V4QImode:
      if (!gcn_alu_operand (operands[1], E_V4QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!scratch_operand (operands[3], E_BImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gcn_valu_dst_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gcn_valu_src0_operand (operands[1], E_SImode)
          || !gcn_alu_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (pattern78 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern86 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x1) != E_V2HFmode
          || !gcn_alu_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !gcn_alu_operand (operands[1], E_V2SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !gcn_alu_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !gcn_alu_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !gcn_alu_operand (operands[1], E_V4SFmode))
        return -1;
      return 4;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !gcn_alu_operand (operands[1], E_V4DFmode))
        return -1;
      return 5;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !gcn_alu_operand (operands[1], E_V8HFmode))
        return -1;
      return 6;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !gcn_alu_operand (operands[1], E_V8SFmode))
        return -1;
      return 7;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x1) != E_V8DFmode
          || !gcn_alu_operand (operands[1], E_V8DFmode))
        return -1;
      return 8;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || !gcn_alu_operand (operands[1], E_V16HFmode))
        return -1;
      return 9;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !gcn_alu_operand (operands[1], E_V16SFmode))
        return -1;
      return 10;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x1) != E_V16DFmode
          || !gcn_alu_operand (operands[1], E_V16DFmode))
        return -1;
      return 11;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || !gcn_alu_operand (operands[1], E_V32HFmode))
        return -1;
      return 12;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x1) != E_V32SFmode
          || !gcn_alu_operand (operands[1], E_V32SFmode))
        return -1;
      return 13;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x1) != E_V32DFmode
          || !gcn_alu_operand (operands[1], E_V32DFmode))
        return -1;
      return 14;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x1) != E_V64HFmode
          || !gcn_alu_operand (operands[1], E_V64HFmode))
        return -1;
      return 15;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x1) != E_V64SFmode
          || !gcn_alu_operand (operands[1], E_V64SFmode))
        return -1;
      return 16;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x1) != E_V64DFmode
          || !gcn_alu_operand (operands[1], E_V64DFmode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!gcn_alu_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern106 (x1, 
E_V2SImode, 
E_V2DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern106 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern106 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern106 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern106 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern106 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !nonmemory_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V64SImode:
      return pattern121 (x1, 
E_V64SImode); /* [-1, 0] */

    case E_V64SFmode:
      if (pattern121 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 1;

    case E_V64DImode:
      if (pattern121 (x1, 
E_V64DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gcn_alu_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !gcn_register_or_unspec_operand (operands[4], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_MODE (x12) != i1)
    return -1;
  return 0;
}

int
pattern141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      return 0;

    case E_V2HImode:
      return 1;

    case E_V2SImode:
      return 2;

    case E_V4QImode:
      return 3;

    case E_V4HImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V8QImode:
      return 6;

    case E_V8HImode:
      return 7;

    case E_V8SImode:
      return 8;

    case E_V16QImode:
      return 9;

    case E_V16HImode:
      return 10;

    case E_V16SImode:
      return 11;

    case E_V32QImode:
      return 12;

    case E_V32HImode:
      return 13;

    case E_V32SImode:
      return 14;

    case E_V64QImode:
      return 15;

    case E_V64HImode:
      return 16;

    case E_V64SImode:
      return 17;

    case E_V4DImode:
      return 18;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern172 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern171 (x1, 
E_V2SImode, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern171 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern171 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16SImode:
      if (pattern171 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
        return -1;
      return 3;

    case E_V32SImode:
      if (pattern171 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
        return -1;
      return 4;

    case E_V64SImode:
      if (pattern171 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_alu_operand (operands[3], i1)
      || !gcn_register_or_unspec_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern191 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = XEXP (x2, 1);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XEXP (x1, 1);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern207 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4QImode:
      if (!register_operand (operands[2], E_V4QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!register_operand (operands[2], E_V4HFmode))
        return -1;
      return 2;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 3;

    case E_V4SFmode:
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      return 4;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode))
        return -1;
      return 5;

    case E_V4DFmode:
      if (!register_operand (operands[2], E_V4DFmode))
        return -1;
      return 6;

    case E_V4TImode:
      if (!register_operand (operands[2], E_V4TImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  return pattern222 (x2, 
E_V32DImode, 
E_V32SImode); /* [-1, 0] */
}

int
pattern237 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i1
      || !gcn_register_or_unspec_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x13, 1);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x9, 1);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x18, 1);
  if (GET_MODE (x20) != i1)
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[3] = x7;
  x8 = XVECEXP (x2, 0, 2);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      switch (pattern207 (x2, 
E_V2QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 618; /* gatherv2qi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 714; /* gatherv2qi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V2HImode:
      switch (pattern207 (x2, 
E_V2HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 620; /* gatherv2hi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 716; /* gatherv2hi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V2HFmode:
      switch (pattern207 (x2, 
E_V2HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 622; /* gatherv2hf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 718; /* gatherv2hf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V2SImode:
      switch (pattern207 (x2, 
E_V2SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 624; /* gatherv2si_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 720; /* gatherv2si_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V2SFmode:
      switch (pattern207 (x2, 
E_V2SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 626; /* gatherv2sf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 722; /* gatherv2sf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern207 (x2, 
E_V2DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 628; /* gatherv2di_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 724; /* gatherv2di_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V2DFmode:
      switch (pattern207 (x2, 
E_V2DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 630; /* gatherv2df_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 726; /* gatherv2df_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V2TImode:
      switch (pattern207 (x2, 
E_V2TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 632; /* gatherv2ti_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 728; /* gatherv2ti_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V4QImode:
      switch (pattern208 (x2, 
E_V4QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 634; /* gatherv4qi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 730; /* gatherv4qi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V4HImode:
      switch (pattern208 (x2, 
E_V4HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 636; /* gatherv4hi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 732; /* gatherv4hi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V4HFmode:
      switch (pattern208 (x2, 
E_V4HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 638; /* gatherv4hf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 734; /* gatherv4hf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern208 (x2, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 640; /* gatherv4si_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 736; /* gatherv4si_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V4SFmode:
      switch (pattern208 (x2, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 642; /* gatherv4sf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 738; /* gatherv4sf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern208 (x2, 
E_V4DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 644; /* gatherv4di_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 740; /* gatherv4di_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V4DFmode:
      switch (pattern208 (x2, 
E_V4DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 646; /* gatherv4df_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 742; /* gatherv4df_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V4TImode:
      switch (pattern208 (x2, 
E_V4TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 648; /* gatherv4ti_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 744; /* gatherv4ti_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V8QImode:
      switch (pattern209 (x2, 
E_V8QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 650; /* gatherv8qi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 746; /* gatherv8qi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V8HImode:
      switch (pattern209 (x2, 
E_V8HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 652; /* gatherv8hi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 748; /* gatherv8hi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V8HFmode:
      switch (pattern209 (x2, 
E_V8HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 654; /* gatherv8hf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 750; /* gatherv8hf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V8SImode:
      switch (pattern209 (x2, 
E_V8SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 656; /* gatherv8si_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 752; /* gatherv8si_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V8SFmode:
      switch (pattern209 (x2, 
E_V8SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 658; /* gatherv8sf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 754; /* gatherv8sf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern209 (x2, 
E_V8DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 660; /* gatherv8di_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 756; /* gatherv8di_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V8DFmode:
      switch (pattern209 (x2, 
E_V8DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 662; /* gatherv8df_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 758; /* gatherv8df_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V8TImode:
      switch (pattern209 (x2, 
E_V8TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 664; /* gatherv8ti_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 760; /* gatherv8ti_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V16QImode:
      switch (pattern210 (x2, 
E_V16QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 666; /* gatherv16qi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 762; /* gatherv16qi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V16HImode:
      switch (pattern210 (x2, 
E_V16HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 668; /* gatherv16hi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 764; /* gatherv16hi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V16HFmode:
      switch (pattern210 (x2, 
E_V16HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 670; /* gatherv16hf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 766; /* gatherv16hf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern210 (x2, 
E_V16SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 672; /* gatherv16si_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 768; /* gatherv16si_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V16SFmode:
      switch (pattern210 (x2, 
E_V16SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 674; /* gatherv16sf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 770; /* gatherv16sf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V16DImode:
      switch (pattern210 (x2, 
E_V16DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 676; /* gatherv16di_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 772; /* gatherv16di_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V16DFmode:
      switch (pattern210 (x2, 
E_V16DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 678; /* gatherv16df_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 774; /* gatherv16df_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V16TImode:
      switch (pattern210 (x2, 
E_V16TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 680; /* gatherv16ti_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 776; /* gatherv16ti_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V32QImode:
      switch (pattern211 (x2, 
E_V32QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 682; /* gatherv32qi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 778; /* gatherv32qi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V32HImode:
      switch (pattern211 (x2, 
E_V32HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 684; /* gatherv32hi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 780; /* gatherv32hi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V32HFmode:
      switch (pattern211 (x2, 
E_V32HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 686; /* gatherv32hf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 782; /* gatherv32hf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V32SImode:
      switch (pattern211 (x2, 
E_V32SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 688; /* gatherv32si_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 784; /* gatherv32si_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V32SFmode:
      switch (pattern211 (x2, 
E_V32SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 690; /* gatherv32sf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 786; /* gatherv32sf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V32DImode:
      switch (pattern211 (x2, 
E_V32DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 692; /* gatherv32di_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 788; /* gatherv32di_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V32DFmode:
      switch (pattern211 (x2, 
E_V32DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 694; /* gatherv32df_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 790; /* gatherv32df_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V32TImode:
      switch (pattern211 (x2, 
E_V32TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 696; /* gatherv32ti_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 792; /* gatherv32ti_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V64QImode:
      switch (pattern212 (x2, 
E_V64QImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 698; /* gatherv64qi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 794; /* gatherv64qi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V64HImode:
      switch (pattern212 (x2, 
E_V64HImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 700; /* gatherv64hi_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 796; /* gatherv64hi_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V64HFmode:
      switch (pattern212 (x2, 
E_V64HFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 702; /* gatherv64hf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 798; /* gatherv64hf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V64SImode:
      switch (pattern212 (x2, 
E_V64SImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 704; /* gatherv64si_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 800; /* gatherv64si_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V64SFmode:
      switch (pattern212 (x2, 
E_V64SFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 706; /* gatherv64sf_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 802; /* gatherv64sf_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V64DImode:
      switch (pattern212 (x2, 
E_V64DImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 708; /* gatherv64di_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 804; /* gatherv64di_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V64DFmode:
      switch (pattern212 (x2, 
E_V64DFmode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 710; /* gatherv64df_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 806; /* gatherv64df_insn_1offset_ds */

        default:
          return -1;
        }

    case E_V64TImode:
      switch (pattern212 (x2, 
E_V64TImode))
        {
        case 0:
          if (!
#line 1158 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x1000))
   || (AS_GLOBAL_P (INTVAL (operands[3]))
       && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 712; /* gatherv64ti_insn_1offset */

        case 1:
          if (!
#line 1192 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[2]) < 0x10000))))
            return -1;
          return 808; /* gatherv64ti_insn_1offset_ds */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern144 (x2, 
E_V32QImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5644; /* *truncv2qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8020; /* *truncv2qiv32qi_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5648; /* *truncv2hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8026; /* *truncv2hiv32qi_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5652; /* *truncv2siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8032; /* *truncv2siv32qi_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5656; /* *truncv4qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8038; /* *truncv4qiv32qi_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5660; /* *truncv4hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8044; /* *truncv4hiv32qi_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5664; /* *truncv4siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8050; /* *truncv4siv32qi_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5668; /* *truncv8qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8056; /* *truncv8qiv32qi_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5672; /* *truncv8hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8062; /* *truncv8hiv32qi_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5676; /* *truncv8siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8068; /* *truncv8siv32qi_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5680; /* *truncv16qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8074; /* *truncv16qiv32qi_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5684; /* *truncv16hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8080; /* *truncv16hiv32qi_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5688; /* *truncv16siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8086; /* *truncv16siv32qi_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5692; /* *truncv32qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8092; /* *truncv32qiv32qi_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5696; /* *truncv32hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8098; /* *truncv32hiv32qi_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5700; /* *truncv32siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8104; /* *truncv32siv32qi_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5704; /* *truncv64qiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8110; /* *truncv64qiv32qi_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5708; /* *truncv64hiv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8116; /* *truncv64hiv32qi_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5712; /* *truncv64siv32qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8122; /* *truncv64siv32qi_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V32DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V32QImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8697; /* truncv32div32qi2_exec */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern142 (x2, 
E_V8QImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5212; /* *truncv2qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7372; /* *truncv2qiv8qi_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5216; /* *truncv2hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7378; /* *truncv2hiv8qi_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5220; /* *truncv2siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7384; /* *truncv2siv8qi_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5224; /* *truncv4qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7390; /* *truncv4qiv8qi_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5228; /* *truncv4hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7396; /* *truncv4hiv8qi_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5232; /* *truncv4siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7402; /* *truncv4siv8qi_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5236; /* *truncv8qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7408; /* *truncv8qiv8qi_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5240; /* *truncv8hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7414; /* *truncv8hiv8qi_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5244; /* *truncv8siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7420; /* *truncv8siv8qi_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5248; /* *truncv16qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7426; /* *truncv16qiv8qi_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5252; /* *truncv16hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7432; /* *truncv16hiv8qi_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5256; /* *truncv16siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7438; /* *truncv16siv8qi_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5260; /* *truncv32qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7444; /* *truncv32qiv8qi_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5264; /* *truncv32hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7450; /* *truncv32hiv8qi_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5268; /* *truncv32siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7456; /* *truncv32siv8qi_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5272; /* *truncv64qiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7462; /* *truncv64qiv8qi_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5276; /* *truncv64hiv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7468; /* *truncv64hiv8qi_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5280; /* *truncv64siv8qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7474; /* *truncv64siv8qi_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V8DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V8QImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8691; /* truncv8div8qi2_exec */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (!gcn_exec_reg_operand (x3, E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (XVECLEN (x4, 0))
    {
    case 4:
      if (XINT (x4, 1) != 25)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != VEC_DUPLICATE)
        return -1;
      x7 = XVECEXP (x4, 0, 3);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != SCRATCH)
        return -1;
      x9 = XEXP (x6, 0);
      if (!immediate_operand (x9, E_VOIDmode))
        return -1;
      x10 = XVECEXP (x4, 0, 1);
      if (!immediate_operand (x10, E_VOIDmode))
        return -1;
      x11 = XVECEXP (x4, 0, 2);
      if (!immediate_operand (x11, E_VOIDmode))
        return -1;
      x12 = XEXP (x5, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          return recog_29 (x1, insn, pnum_clobbers);

        case PLUS:
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != VEC_DUPLICATE)
            return -1;
          x14 = XEXP (x12, 1);
          if (GET_CODE (x14) != SIGN_EXTEND)
            return -1;
          x15 = XEXP (x13, 0);
          operands[1] = x15;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x16 = XEXP (x14, 0);
          operands[2] = x16;
          operands[3] = x9;
          operands[4] = x10;
          operands[5] = x11;
          x17 = XEXP (x2, 1);
          operands[6] = x17;
          operands[7] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern235 (x2, 
E_V2QImode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 811; /* gatherv2qi_insn_2offsets_exec */

            case E_V2HImode:
              if (pattern235 (x2, 
E_V2HImode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 813; /* gatherv2hi_insn_2offsets_exec */

            case E_V2HFmode:
              if (pattern235 (x2, 
E_V2HFmode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 815; /* gatherv2hf_insn_2offsets_exec */

            case E_V2SImode:
              if (pattern236 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 817; /* gatherv2si_insn_2offsets_exec */

            case E_V2SFmode:
              if (pattern235 (x2, 
E_V2SFmode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 819; /* gatherv2sf_insn_2offsets_exec */

            case E_V2DImode:
              if (pattern237 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 821; /* gatherv2di_insn_2offsets_exec */

            case E_V2DFmode:
              if (pattern235 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 823; /* gatherv2df_insn_2offsets_exec */

            case E_V2TImode:
              if (pattern235 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 825; /* gatherv2ti_insn_2offsets_exec */

            case E_V4QImode:
              if (pattern235 (x2, 
E_V4QImode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 827; /* gatherv4qi_insn_2offsets_exec */

            case E_V4HImode:
              if (pattern235 (x2, 
E_V4HImode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 829; /* gatherv4hi_insn_2offsets_exec */

            case E_V4HFmode:
              if (pattern235 (x2, 
E_V4HFmode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 831; /* gatherv4hf_insn_2offsets_exec */

            case E_V4SImode:
              if (pattern236 (x2, 
E_V4SImode, 
E_V4DImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 833; /* gatherv4si_insn_2offsets_exec */

            case E_V4SFmode:
              if (pattern235 (x2, 
E_V4SFmode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 835; /* gatherv4sf_insn_2offsets_exec */

            case E_V4DImode:
              if (pattern237 (x2, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 837; /* gatherv4di_insn_2offsets_exec */

            case E_V4DFmode:
              if (pattern235 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 839; /* gatherv4df_insn_2offsets_exec */

            case E_V4TImode:
              if (pattern235 (x2, 
E_V4TImode, 
E_V4DImode, 
E_V4SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 841; /* gatherv4ti_insn_2offsets_exec */

            case E_V8QImode:
              if (pattern235 (x2, 
E_V8QImode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 843; /* gatherv8qi_insn_2offsets_exec */

            case E_V8HImode:
              if (pattern235 (x2, 
E_V8HImode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 845; /* gatherv8hi_insn_2offsets_exec */

            case E_V8HFmode:
              if (pattern235 (x2, 
E_V8HFmode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 847; /* gatherv8hf_insn_2offsets_exec */

            case E_V8SImode:
              if (pattern236 (x2, 
E_V8SImode, 
E_V8DImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 849; /* gatherv8si_insn_2offsets_exec */

            case E_V8SFmode:
              if (pattern235 (x2, 
E_V8SFmode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 851; /* gatherv8sf_insn_2offsets_exec */

            case E_V8DImode:
              if (pattern237 (x2, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 853; /* gatherv8di_insn_2offsets_exec */

            case E_V8DFmode:
              if (pattern235 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 855; /* gatherv8df_insn_2offsets_exec */

            case E_V8TImode:
              if (pattern235 (x2, 
E_V8TImode, 
E_V8DImode, 
E_V8SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 857; /* gatherv8ti_insn_2offsets_exec */

            case E_V16QImode:
              if (pattern235 (x2, 
E_V16QImode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 859; /* gatherv16qi_insn_2offsets_exec */

            case E_V16HImode:
              if (pattern235 (x2, 
E_V16HImode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 861; /* gatherv16hi_insn_2offsets_exec */

            case E_V16HFmode:
              if (pattern235 (x2, 
E_V16HFmode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 863; /* gatherv16hf_insn_2offsets_exec */

            case E_V16SImode:
              if (pattern236 (x2, 
E_V16SImode, 
E_V16DImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 865; /* gatherv16si_insn_2offsets_exec */

            case E_V16SFmode:
              if (pattern235 (x2, 
E_V16SFmode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 867; /* gatherv16sf_insn_2offsets_exec */

            case E_V16DImode:
              if (pattern237 (x2, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 869; /* gatherv16di_insn_2offsets_exec */

            case E_V16DFmode:
              if (pattern235 (x2, 
E_V16DFmode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 871; /* gatherv16df_insn_2offsets_exec */

            case E_V16TImode:
              if (pattern235 (x2, 
E_V16TImode, 
E_V16DImode, 
E_V16SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 873; /* gatherv16ti_insn_2offsets_exec */

            case E_V32QImode:
              if (pattern235 (x2, 
E_V32QImode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 875; /* gatherv32qi_insn_2offsets_exec */

            case E_V32HImode:
              if (pattern235 (x2, 
E_V32HImode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 877; /* gatherv32hi_insn_2offsets_exec */

            case E_V32HFmode:
              if (pattern235 (x2, 
E_V32HFmode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 879; /* gatherv32hf_insn_2offsets_exec */

            case E_V32SImode:
              if (pattern236 (x2, 
E_V32SImode, 
E_V32DImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 881; /* gatherv32si_insn_2offsets_exec */

            case E_V32SFmode:
              if (pattern235 (x2, 
E_V32SFmode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 883; /* gatherv32sf_insn_2offsets_exec */

            case E_V32DImode:
              if (pattern237 (x2, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 885; /* gatherv32di_insn_2offsets_exec */

            case E_V32DFmode:
              if (pattern235 (x2, 
E_V32DFmode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 887; /* gatherv32df_insn_2offsets_exec */

            case E_V32TImode:
              if (pattern235 (x2, 
E_V32TImode, 
E_V32DImode, 
E_V32SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 889; /* gatherv32ti_insn_2offsets_exec */

            case E_V64QImode:
              if (pattern235 (x2, 
E_V64QImode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 891; /* gatherv64qi_insn_2offsets_exec */

            case E_V64HImode:
              if (pattern235 (x2, 
E_V64HImode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 893; /* gatherv64hi_insn_2offsets_exec */

            case E_V64HFmode:
              if (pattern235 (x2, 
E_V64HFmode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 895; /* gatherv64hf_insn_2offsets_exec */

            case E_V64SImode:
              if (pattern235 (x2, 
E_V64SImode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 897; /* gatherv64si_insn_2offsets_exec */

            case E_V64SFmode:
              if (pattern235 (x2, 
E_V64SFmode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 899; /* gatherv64sf_insn_2offsets_exec */

            case E_V64DImode:
              if (pattern235 (x2, 
E_V64DImode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 901; /* gatherv64di_insn_2offsets_exec */

            case E_V64DFmode:
              if (pattern235 (x2, 
E_V64DFmode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 903; /* gatherv64df_insn_2offsets_exec */

            case E_V64TImode:
              if (pattern235 (x2, 
E_V64TImode, 
E_V64DImode, 
E_V64SImode) != 0
                  || !
#line 1220 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[3]) + 0x1000) < 0x2000))))
                return -1;
              return 905; /* gatherv64ti_insn_2offsets_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_31 (x1, insn, pnum_clobbers);

    case 2:
      switch (XINT (x4, 1))
        {
        case 35:
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          x10 = XVECEXP (x4, 0, 1);
          operands[2] = x10;
          x17 = XEXP (x2, 1);
          operands[3] = x17;
          operands[4] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (pattern176 (x2, 
E_V2HFmode, 
E_V2SImode) != 0)
                return -1;
              return 2718; /* ldexpv2hf3_exec */

            case E_V2SFmode:
              if (pattern176 (x2, 
E_V2SFmode, 
E_V2SImode) != 0)
                return -1;
              return 2720; /* ldexpv2sf3_exec */

            case E_V2DFmode:
              if (pattern176 (x2, 
E_V2DFmode, 
E_V2SImode) != 0)
                return -1;
              return 2722; /* ldexpv2df3_exec */

            case E_V4HFmode:
              if (pattern176 (x2, 
E_V4HFmode, 
E_V4SImode) != 0)
                return -1;
              return 2724; /* ldexpv4hf3_exec */

            case E_V4SFmode:
              if (pattern176 (x2, 
E_V4SFmode, 
E_V4SImode) != 0)
                return -1;
              return 2726; /* ldexpv4sf3_exec */

            case E_V4DFmode:
              if (pattern176 (x2, 
E_V4DFmode, 
E_V4SImode) != 0)
                return -1;
              return 2728; /* ldexpv4df3_exec */

            case E_V8HFmode:
              if (pattern176 (x2, 
E_V8HFmode, 
E_V8SImode) != 0)
                return -1;
              return 2730; /* ldexpv8hf3_exec */

            case E_V8SFmode:
              if (pattern176 (x2, 
E_V8SFmode, 
E_V8SImode) != 0)
                return -1;
              return 2732; /* ldexpv8sf3_exec */

            case E_V8DFmode:
              if (pattern176 (x2, 
E_V8DFmode, 
E_V8SImode) != 0)
                return -1;
              return 2734; /* ldexpv8df3_exec */

            case E_V16HFmode:
              if (pattern176 (x2, 
E_V16HFmode, 
E_V16SImode) != 0)
                return -1;
              return 2736; /* ldexpv16hf3_exec */

            case E_V16SFmode:
              if (pattern176 (x2, 
E_V16SFmode, 
E_V16SImode) != 0)
                return -1;
              return 2738; /* ldexpv16sf3_exec */

            case E_V16DFmode:
              if (pattern176 (x2, 
E_V16DFmode, 
E_V16SImode) != 0)
                return -1;
              return 2740; /* ldexpv16df3_exec */

            case E_V32HFmode:
              if (pattern176 (x2, 
E_V32HFmode, 
E_V32SImode) != 0)
                return -1;
              return 2742; /* ldexpv32hf3_exec */

            case E_V32SFmode:
              if (pattern176 (x2, 
E_V32SFmode, 
E_V32SImode) != 0)
                return -1;
              return 2744; /* ldexpv32sf3_exec */

            case E_V32DFmode:
              if (pattern176 (x2, 
E_V32DFmode, 
E_V32SImode) != 0)
                return -1;
              return 2746; /* ldexpv32df3_exec */

            case E_V64HFmode:
              if (pattern176 (x2, 
E_V64HFmode, 
E_V64SImode) != 0)
                return -1;
              return 2748; /* ldexpv64hf3_exec */

            case E_V64SFmode:
              if (pattern176 (x2, 
E_V64SFmode, 
E_V64SImode) != 0)
                return -1;
              return 2750; /* ldexpv64sf3_exec */

            case E_V64DFmode:
              if (pattern176 (x2, 
E_V64DFmode, 
E_V64SImode) != 0)
                return -1;
              return 2752; /* ldexpv64df3_exec */

            default:
              return -1;
            }

        case 39:
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != PLUS)
            return -1;
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) != MULT)
            return -1;
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          x14 = XEXP (x12, 1);
          operands[2] = x14;
          x6 = XEXP (x5, 1);
          operands[3] = x6;
          x10 = XVECEXP (x4, 0, 1);
          operands[4] = x10;
          if (!register_operand (operands[4], E_DImode))
            return -1;
          x17 = XEXP (x2, 1);
          operands[5] = x17;
          operands[6] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              if (pattern203 (x2, 
E_V2SFmode) != 0)
                return -1;
              return 3055; /* div_fmasv2sf_exec */

            case E_V2DFmode:
              if (pattern203 (x2, 
E_V2DFmode) != 0)
                return -1;
              return 3057; /* div_fmasv2df_exec */

            case E_V4SFmode:
              if (pattern203 (x2, 
E_V4SFmode) != 0)
                return -1;
              return 3059; /* div_fmasv4sf_exec */

            case E_V4DFmode:
              if (pattern203 (x2, 
E_V4DFmode) != 0)
                return -1;
              return 3061; /* div_fmasv4df_exec */

            case E_V8SFmode:
              if (pattern203 (x2, 
E_V8SFmode) != 0)
                return -1;
              return 3063; /* div_fmasv8sf_exec */

            case E_V8DFmode:
              if (pattern203 (x2, 
E_V8DFmode) != 0)
                return -1;
              return 3065; /* div_fmasv8df_exec */

            case E_V16SFmode:
              if (pattern203 (x2, 
E_V16SFmode) != 0)
                return -1;
              return 3067; /* div_fmasv16sf_exec */

            case E_V16DFmode:
              if (pattern203 (x2, 
E_V16DFmode) != 0)
                return -1;
              return 3069; /* div_fmasv16df_exec */

            case E_V32SFmode:
              if (pattern203 (x2, 
E_V32SFmode) != 0)
                return -1;
              return 3071; /* div_fmasv32sf_exec */

            case E_V32DFmode:
              if (pattern203 (x2, 
E_V32DFmode) != 0)
                return -1;
              return 3073; /* div_fmasv32df_exec */

            case E_V64SFmode:
              if (pattern203 (x2, 
E_V64SFmode) != 0)
                return -1;
              return 3075; /* div_fmasv64sf_exec */

            case E_V64DFmode:
              if (pattern203 (x2, 
E_V64DFmode) != 0)
                return -1;
              return 3077; /* div_fmasv64df_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x4, 1) != 40)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x10 = XVECEXP (x4, 0, 1);
      operands[2] = x10;
      x11 = XVECEXP (x4, 0, 2);
      operands[3] = x11;
      x17 = XEXP (x2, 1);
      operands[4] = x17;
      operands[5] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern182 (x2, 
E_V2HFmode) != 0)
            return -1;
          return 3082; /* div_fixupv2hf_exec */

        case E_V2SFmode:
          if (pattern182 (x2, 
E_V2SFmode) != 0)
            return -1;
          return 3084; /* div_fixupv2sf_exec */

        case E_V2DFmode:
          if (pattern182 (x2, 
E_V2DFmode) != 0)
            return -1;
          return 3086; /* div_fixupv2df_exec */

        case E_V4HFmode:
          if (pattern182 (x2, 
E_V4HFmode) != 0)
            return -1;
          return 3088; /* div_fixupv4hf_exec */

        case E_V4SFmode:
          if (pattern182 (x2, 
E_V4SFmode) != 0)
            return -1;
          return 3090; /* div_fixupv4sf_exec */

        case E_V4DFmode:
          if (pattern182 (x2, 
E_V4DFmode) != 0)
            return -1;
          return 3092; /* div_fixupv4df_exec */

        case E_V8HFmode:
          if (pattern182 (x2, 
E_V8HFmode) != 0)
            return -1;
          return 3094; /* div_fixupv8hf_exec */

        case E_V8SFmode:
          if (pattern182 (x2, 
E_V8SFmode) != 0)
            return -1;
          return 3096; /* div_fixupv8sf_exec */

        case E_V8DFmode:
          if (pattern182 (x2, 
E_V8DFmode) != 0)
            return -1;
          return 3098; /* div_fixupv8df_exec */

        case E_V16HFmode:
          if (pattern182 (x2, 
E_V16HFmode) != 0)
            return -1;
          return 3100; /* div_fixupv16hf_exec */

        case E_V16SFmode:
          if (pattern182 (x2, 
E_V16SFmode) != 0)
            return -1;
          return 3102; /* div_fixupv16sf_exec */

        case E_V16DFmode:
          if (pattern182 (x2, 
E_V16DFmode) != 0)
            return -1;
          return 3104; /* div_fixupv16df_exec */

        case E_V32HFmode:
          if (pattern182 (x2, 
E_V32HFmode) != 0)
            return -1;
          return 3106; /* div_fixupv32hf_exec */

        case E_V32SFmode:
          if (pattern182 (x2, 
E_V32SFmode) != 0)
            return -1;
          return 3108; /* div_fixupv32sf_exec */

        case E_V32DFmode:
          if (pattern182 (x2, 
E_V32DFmode) != 0)
            return -1;
          return 3110; /* div_fixupv32df_exec */

        case E_V64HFmode:
          if (pattern182 (x2, 
E_V64HFmode) != 0)
            return -1;
          return 3112; /* div_fixupv64hf_exec */

        case E_V64SFmode:
          if (pattern182 (x2, 
E_V64SFmode) != 0)
            return -1;
          return 3114; /* div_fixupv64sf_exec */

        case E_V64DFmode:
          if (pattern182 (x2, 
E_V64DFmode) != 0)
            return -1;
          return 3116; /* div_fixupv64df_exec */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x2, 2);
  operands[4] = x4;
  if (!gcn_exec_reg_operand (operands[4], E_DImode))
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      x7 = XEXP (x5, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x7;
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V2QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1465; /* subv2qi3_exec */

            case E_V2HImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V2HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1467; /* subv2hi3_exec */

            case E_V2SImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V2SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1469; /* subv2si3_exec */

            case E_V4QImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V4QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1471; /* subv4qi3_exec */

            case E_V4HImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V4HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1473; /* subv4hi3_exec */

            case E_V4SImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V4SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1475; /* subv4si3_exec */

            case E_V8QImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V8QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1477; /* subv8qi3_exec */

            case E_V8HImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V8HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1479; /* subv8hi3_exec */

            case E_V8SImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V8SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1481; /* subv8si3_exec */

            case E_V16QImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V16QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1483; /* subv16qi3_exec */

            case E_V16HImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V16HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1485; /* subv16hi3_exec */

            case E_V16SImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V16SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1487; /* subv16si3_exec */

            case E_V32QImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V32QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1489; /* subv32qi3_exec */

            case E_V32HImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V32HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1491; /* subv32hi3_exec */

            case E_V32SImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V32SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1493; /* subv32si3_exec */

            case E_V64QImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V64QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1495; /* subv64qi3_exec */

            case E_V64HImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V64HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1497; /* subv64hi3_exec */

            case E_V64SImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V64SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1499; /* subv64si3_exec */

            case E_V2DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V2DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 1542; /* subv2di3_exec */

            case E_V4DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V4DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 1543; /* subv4di3_exec */

            case E_V8DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V8DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 1544; /* subv8di3_exec */

            case E_V16DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V16DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 1545; /* subv16di3_exec */

            case E_V32DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V32DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 1546; /* subv32di3_exec */

            case E_V64DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V64DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 1547; /* subv64di3_exec */

            case E_V2DFmode:
              if (pattern44 (x2, 
E_V2DFmode) != 0)
                return -1;
              return 2224; /* subv2df3_exec */

            case E_V4DFmode:
              if (pattern44 (x2, 
E_V4DFmode) != 0)
                return -1;
              return 2226; /* subv4df3_exec */

            case E_V8DFmode:
              if (pattern44 (x2, 
E_V8DFmode) != 0)
                return -1;
              return 2228; /* subv8df3_exec */

            case E_V16DFmode:
              if (pattern44 (x2, 
E_V16DFmode) != 0)
                return -1;
              return 2230; /* subv16df3_exec */

            case E_V32DFmode:
              if (pattern44 (x2, 
E_V32DFmode) != 0)
                return -1;
              return 2232; /* subv32df3_exec */

            case E_V64DFmode:
              if (pattern44 (x2, 
E_V64DFmode) != 0)
                return -1;
              return 2234; /* subv64df3_exec */

            case E_V2HFmode:
              if (pattern44 (x2, 
E_V2HFmode) != 0)
                return -1;
              return 2393; /* subv2hf3_exec */

            case E_V2SFmode:
              if (pattern44 (x2, 
E_V2SFmode) != 0)
                return -1;
              return 2395; /* subv2sf3_exec */

            case E_V4HFmode:
              if (pattern44 (x2, 
E_V4HFmode) != 0)
                return -1;
              return 2397; /* subv4hf3_exec */

            case E_V4SFmode:
              if (pattern44 (x2, 
E_V4SFmode) != 0)
                return -1;
              return 2399; /* subv4sf3_exec */

            case E_V8HFmode:
              if (pattern44 (x2, 
E_V8HFmode) != 0)
                return -1;
              return 2401; /* subv8hf3_exec */

            case E_V8SFmode:
              if (pattern44 (x2, 
E_V8SFmode) != 0)
                return -1;
              return 2403; /* subv8sf3_exec */

            case E_V16HFmode:
              if (pattern44 (x2, 
E_V16HFmode) != 0)
                return -1;
              return 2405; /* subv16hf3_exec */

            case E_V16SFmode:
              if (pattern44 (x2, 
E_V16SFmode) != 0)
                return -1;
              return 2407; /* subv16sf3_exec */

            case E_V32HFmode:
              if (pattern44 (x2, 
E_V32HFmode) != 0)
                return -1;
              return 2409; /* subv32hf3_exec */

            case E_V32SFmode:
              if (pattern44 (x2, 
E_V32SFmode) != 0)
                return -1;
              return 2411; /* subv32sf3_exec */

            case E_V64HFmode:
              if (pattern44 (x2, 
E_V64HFmode) != 0)
                return -1;
              return 2413; /* subv64hf3_exec */

            case E_V64SFmode:
              if (pattern44 (x2, 
E_V64SFmode) != 0)
                return -1;
              return 2415; /* subv64sf3_exec */

            default:
              return -1;
            }

        case MEM:
          operands[1] = x7;
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V64SImode:
              if (pattern178 (x2, 
E_V64SImode) != 0
                  || !
#line 2159 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1615; /* subrv64si3_ds_exec */

            case E_V64SFmode:
              if (pattern178 (x2, 
E_V64SFmode) != 0
                  || !
#line 2159 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1617; /* subrv64sf3_ds_exec */

            case E_V64DImode:
              if (pattern178 (x2, 
E_V64DImode) != 0
                  || !
#line 2159 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1619; /* subrv64di3_ds_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      switch (pattern122 (x2))
        {
        case 0:
          if (!
#line 2138 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 1606; /* subv64si3_ds_exec */

        case 1:
          if (!
#line 2138 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 1608; /* subv64sf3_ds_exec */

        case 2:
          if (!
#line 2138 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 1610; /* subv64di3_ds_exec */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          x9 = XEXP (x5, 1);
          switch (GET_CODE (x9))
            {
            case SIGN_EXTEND:
              switch (pattern138 (x3))
                {
                case 0:
                  return 42; /* smulsi3_highpart_reg */

                case 1:
                  return 1623; /* smulv2si3_highpart */

                case 2:
                  return 1627; /* smulv4si3_highpart */

                case 3:
                  return 1631; /* smulv8si3_highpart */

                case 4:
                  return 1635; /* smulv16si3_highpart */

                case 5:
                  return 1639; /* smulv32si3_highpart */

                case 6:
                  return 1643; /* smulv64si3_highpart */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case LABEL_REF:
            case SYMBOL_REF:
              if (pattern139 (x3) != 0)
                return -1;
              return 44; /* smulsi3_highpart_imm */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          x9 = XEXP (x5, 1);
          switch (GET_CODE (x9))
            {
            case ZERO_EXTEND:
              switch (pattern138 (x3))
                {
                case 0:
                  return 43; /* umulsi3_highpart_reg */

                case 1:
                  return 1625; /* umulv2si3_highpart */

                case 2:
                  return 1629; /* umulv4si3_highpart */

                case 3:
                  return 1633; /* umulv8si3_highpart */

                case 4:
                  return 1637; /* umulv16si3_highpart */

                case 5:
                  return 1641; /* umulv32si3_highpart */

                case 6:
                  return 1645; /* umulv64si3_highpart */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case LABEL_REF:
            case SYMBOL_REF:
              if (pattern139 (x3) != 0)
                return -1;
              return 45; /* umulsi3_highpart_imm */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CLZ:
      if (pattern38 (x3) != 0)
        return -1;
      return 59; /* clzdi2 */

    case CTZ:
      if (pattern38 (x3) != 0)
        return -1;
      return 60; /* ctzdi2 */

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          switch (pattern94 (x3, 
E_V2QImode))
            {
            case 0:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4779; /* *truncv2qiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6723; /* *truncv2qiv2qi_shift */

            case 1:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4783; /* *truncv2hiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6729; /* *truncv2hiv2qi_shift */

            case 2:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4787; /* *truncv2siv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6735; /* *truncv2siv2qi_shift */

            case 3:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4791; /* *truncv4qiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6741; /* *truncv4qiv2qi_shift */

            case 4:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4795; /* *truncv4hiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6747; /* *truncv4hiv2qi_shift */

            case 5:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4799; /* *truncv4siv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6753; /* *truncv4siv2qi_shift */

            case 6:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4803; /* *truncv8qiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6759; /* *truncv8qiv2qi_shift */

            case 7:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4807; /* *truncv8hiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6765; /* *truncv8hiv2qi_shift */

            case 8:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4811; /* *truncv8siv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6771; /* *truncv8siv2qi_shift */

            case 9:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4815; /* *truncv16qiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6777; /* *truncv16qiv2qi_shift */

            case 10:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4819; /* *truncv16hiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6783; /* *truncv16hiv2qi_shift */

            case 11:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4823; /* *truncv16siv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6789; /* *truncv16siv2qi_shift */

            case 12:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4827; /* *truncv32qiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6795; /* *truncv32qiv2qi_shift */

            case 13:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4831; /* *truncv32hiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6801; /* *truncv32hiv2qi_shift */

            case 14:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4835; /* *truncv32siv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6807; /* *truncv32siv2qi_shift */

            case 15:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4839; /* *truncv64qiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6813; /* *truncv64qiv2qi_shift */

            case 16:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4843; /* *truncv64hiv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6819; /* *truncv64hiv2qi_shift */

            case 17:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4847; /* *truncv64siv2qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6825; /* *truncv64siv2qi_shift */

            case 18:
              return 8667; /* truncv2div2qi2 */

            default:
              return -1;
            }

        case E_V2HImode:
          switch (pattern94 (x3, 
E_V2HImode))
            {
            case 0:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4851; /* *truncv2qiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6831; /* *truncv2qiv2hi_shift */

            case 1:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4855; /* *truncv2hiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6837; /* *truncv2hiv2hi_shift */

            case 2:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4859; /* *truncv2siv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6843; /* *truncv2siv2hi_shift */

            case 3:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4863; /* *truncv4qiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6849; /* *truncv4qiv2hi_shift */

            case 4:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4867; /* *truncv4hiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6855; /* *truncv4hiv2hi_shift */

            case 5:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4871; /* *truncv4siv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6861; /* *truncv4siv2hi_shift */

            case 6:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4875; /* *truncv8qiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6867; /* *truncv8qiv2hi_shift */

            case 7:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4879; /* *truncv8hiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6873; /* *truncv8hiv2hi_shift */

            case 8:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4883; /* *truncv8siv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6879; /* *truncv8siv2hi_shift */

            case 9:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4887; /* *truncv16qiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6885; /* *truncv16qiv2hi_shift */

            case 10:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4891; /* *truncv16hiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6891; /* *truncv16hiv2hi_shift */

            case 11:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4895; /* *truncv16siv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6897; /* *truncv16siv2hi_shift */

            case 12:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4899; /* *truncv32qiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6903; /* *truncv32qiv2hi_shift */

            case 13:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4903; /* *truncv32hiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6909; /* *truncv32hiv2hi_shift */

            case 14:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4907; /* *truncv32siv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6915; /* *truncv32siv2hi_shift */

            case 15:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4911; /* *truncv64qiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6921; /* *truncv64qiv2hi_shift */

            case 16:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4915; /* *truncv64hiv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6927; /* *truncv64hiv2hi_shift */

            case 17:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4919; /* *truncv64siv2hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6933; /* *truncv64siv2hi_shift */

            case 18:
              return 8668; /* truncv2div2hi2 */

            default:
              return -1;
            }

        case E_V2SImode:
          switch (pattern94 (x3, 
E_V2SImode))
            {
            case 0:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4923; /* *truncv2qiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6939; /* *truncv2qiv2si_shift */

            case 1:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4927; /* *truncv2hiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6945; /* *truncv2hiv2si_shift */

            case 2:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4931; /* *truncv2siv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6951; /* *truncv2siv2si_shift */

            case 3:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4935; /* *truncv4qiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6957; /* *truncv4qiv2si_shift */

            case 4:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4939; /* *truncv4hiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6963; /* *truncv4hiv2si_shift */

            case 5:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4943; /* *truncv4siv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6969; /* *truncv4siv2si_shift */

            case 6:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4947; /* *truncv8qiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6975; /* *truncv8qiv2si_shift */

            case 7:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4951; /* *truncv8hiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6981; /* *truncv8hiv2si_shift */

            case 8:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4955; /* *truncv8siv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6987; /* *truncv8siv2si_shift */

            case 9:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4959; /* *truncv16qiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6993; /* *truncv16qiv2si_shift */

            case 10:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4963; /* *truncv16hiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 6999; /* *truncv16hiv2si_shift */

            case 11:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4967; /* *truncv16siv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7005; /* *truncv16siv2si_shift */

            case 12:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4971; /* *truncv32qiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7011; /* *truncv32qiv2si_shift */

            case 13:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4975; /* *truncv32hiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7017; /* *truncv32hiv2si_shift */

            case 14:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4979; /* *truncv32siv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7023; /* *truncv32siv2si_shift */

            case 15:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4983; /* *truncv64qiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7029; /* *truncv64qiv2si_shift */

            case 16:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4987; /* *truncv64hiv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7035; /* *truncv64hiv2si_shift */

            case 17:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4991; /* *truncv64siv2si_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7041; /* *truncv64siv2si_shift */

            case 18:
              return 8669; /* truncv2div2si2 */

            default:
              return -1;
            }

        case E_V4QImode:
          switch (pattern95 (x3, 
E_V4QImode))
            {
            case 0:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4995; /* *truncv2qiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7047; /* *truncv2qiv4qi_shift */

            case 1:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 4999; /* *truncv2hiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7053; /* *truncv2hiv4qi_shift */

            case 2:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5003; /* *truncv2siv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7059; /* *truncv2siv4qi_shift */

            case 3:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5007; /* *truncv4qiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7065; /* *truncv4qiv4qi_shift */

            case 4:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5011; /* *truncv4hiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7071; /* *truncv4hiv4qi_shift */

            case 5:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5015; /* *truncv4siv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7077; /* *truncv4siv4qi_shift */

            case 6:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5019; /* *truncv8qiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7083; /* *truncv8qiv4qi_shift */

            case 7:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5023; /* *truncv8hiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7089; /* *truncv8hiv4qi_shift */

            case 8:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5027; /* *truncv8siv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7095; /* *truncv8siv4qi_shift */

            case 9:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5031; /* *truncv16qiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7101; /* *truncv16qiv4qi_shift */

            case 10:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5035; /* *truncv16hiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7107; /* *truncv16hiv4qi_shift */

            case 11:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5039; /* *truncv16siv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7113; /* *truncv16siv4qi_shift */

            case 12:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5043; /* *truncv32qiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7119; /* *truncv32qiv4qi_shift */

            case 13:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5047; /* *truncv32hiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7125; /* *truncv32hiv4qi_shift */

            case 14:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5051; /* *truncv32siv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7131; /* *truncv32siv4qi_shift */

            case 15:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5055; /* *truncv64qiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7137; /* *truncv64qiv4qi_shift */

            case 16:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5059; /* *truncv64hiv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7143; /* *truncv64hiv4qi_shift */

            case 17:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5063; /* *truncv64siv4qi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7149; /* *truncv64siv4qi_shift */

            case 18:
              return 8670; /* truncv4div4qi2 */

            default:
              return -1;
            }

        case E_V4HImode:
          switch (pattern95 (x3, 
E_V4HImode))
            {
            case 0:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5067; /* *truncv2qiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7155; /* *truncv2qiv4hi_shift */

            case 1:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5071; /* *truncv2hiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7161; /* *truncv2hiv4hi_shift */

            case 2:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5075; /* *truncv2siv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7167; /* *truncv2siv4hi_shift */

            case 3:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5079; /* *truncv4qiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7173; /* *truncv4qiv4hi_shift */

            case 4:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5083; /* *truncv4hiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7179; /* *truncv4hiv4hi_shift */

            case 5:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5087; /* *truncv4siv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7185; /* *truncv4siv4hi_shift */

            case 6:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5091; /* *truncv8qiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7191; /* *truncv8qiv4hi_shift */

            case 7:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5095; /* *truncv8hiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7197; /* *truncv8hiv4hi_shift */

            case 8:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5099; /* *truncv8siv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7203; /* *truncv8siv4hi_shift */

            case 9:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5103; /* *truncv16qiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7209; /* *truncv16qiv4hi_shift */

            case 10:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5107; /* *truncv16hiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7215; /* *truncv16hiv4hi_shift */

            case 11:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5111; /* *truncv16siv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7221; /* *truncv16siv4hi_shift */

            case 12:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5115; /* *truncv32qiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7227; /* *truncv32qiv4hi_shift */

            case 13:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5119; /* *truncv32hiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7233; /* *truncv32hiv4hi_shift */

            case 14:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5123; /* *truncv32siv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7239; /* *truncv32siv4hi_shift */

            case 15:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5127; /* *truncv64qiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7245; /* *truncv64qiv4hi_shift */

            case 16:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5131; /* *truncv64hiv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7251; /* *truncv64hiv4hi_shift */

            case 17:
              if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
                return 5135; /* *truncv64siv4hi_sdwa */
              if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
                return -1;
              return 7257; /* *truncv64siv4hi_shift */

            case 18:
              return 8671; /* truncv4div4hi2 */

            default:
              return -1;
            }

        case E_V4SImode:
          return recog_28 (x1, insn, pnum_clobbers);

        case E_V8QImode:
          return recog_27 (x1, insn, pnum_clobbers);

        case E_V8HImode:
          return recog_26 (x1, insn, pnum_clobbers);

        case E_V8SImode:
          return recog_25 (x1, insn, pnum_clobbers);

        case E_V16QImode:
          return recog_24 (x1, insn, pnum_clobbers);

        case E_V16HImode:
          return recog_23 (x1, insn, pnum_clobbers);

        case E_V16SImode:
          return recog_22 (x1, insn, pnum_clobbers);

        case E_V32QImode:
          return recog_21 (x1, insn, pnum_clobbers);

        case E_V32HImode:
          return recog_20 (x1, insn, pnum_clobbers);

        case E_V32SImode:
          return recog_19 (x1, insn, pnum_clobbers);

        case E_V64QImode:
          return recog_18 (x1, insn, pnum_clobbers);

        case E_V64HImode:
          return recog_17 (x1, insn, pnum_clobbers);

        case E_V64SImode:
          return recog_16 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern25 (x1))
    {
    case 0:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HImode,
		    fixuns_trunc_cvt)))
        return 3118; /* fixuns_trunchihi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HImode,
		    fixuns_trunc_cvt)))
        return 3124; /* fixuns_truncsihi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HImode,
		    fixuns_trunc_cvt)))
        return 3130; /* fixuns_trunchfhi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HImode,
		    fixuns_trunc_cvt)))
        return 3136; /* fixuns_truncsfhi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HImode,
		    fixuns_trunc_cvt)))
        return -1;
      return 3142; /* fixuns_truncdfhi2 */

    case 1:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SImode,
		    fixuns_trunc_cvt)))
        return 3148; /* fixuns_trunchisi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SImode,
		    fixuns_trunc_cvt)))
        return 3154; /* fixuns_truncsisi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SImode,
		    fixuns_trunc_cvt)))
        return 3160; /* fixuns_trunchfsi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SImode,
		    fixuns_trunc_cvt)))
        return 3166; /* fixuns_truncsfsi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SImode,
		    fixuns_trunc_cvt)))
        return -1;
      return 3172; /* fixuns_truncdfsi2 */

    case 2:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HFmode,
		    fixuns_trunc_cvt)))
        return 3178; /* fixuns_trunchihf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HFmode,
		    fixuns_trunc_cvt)))
        return 3184; /* fixuns_truncsihf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HFmode,
		    fixuns_trunc_cvt)))
        return 3190; /* fixuns_trunchfhf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HFmode,
		    fixuns_trunc_cvt)))
        return 3196; /* fixuns_truncsfhf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HFmode,
		    fixuns_trunc_cvt)))
        return -1;
      return 3202; /* fixuns_truncdfhf2 */

    case 3:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SFmode,
		    fixuns_trunc_cvt)))
        return 3208; /* fixuns_trunchisf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SFmode,
		    fixuns_trunc_cvt)))
        return 3214; /* fixuns_truncsisf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SFmode,
		    fixuns_trunc_cvt)))
        return 3220; /* fixuns_trunchfsf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SFmode,
		    fixuns_trunc_cvt)))
        return 3226; /* fixuns_truncsfsf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SFmode,
		    fixuns_trunc_cvt)))
        return -1;
      return 3232; /* fixuns_truncdfsf2 */

    case 4:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, DFmode,
		    fixuns_trunc_cvt)))
        return 3238; /* fixuns_trunchidf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, DFmode,
		    fixuns_trunc_cvt)))
        return 3244; /* fixuns_truncsidf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, DFmode,
		    fixuns_trunc_cvt)))
        return 3250; /* fixuns_trunchfdf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, DFmode,
		    fixuns_trunc_cvt)))
        return 3256; /* fixuns_truncsfdf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, DFmode,
		    fixuns_trunc_cvt)))
        return -1;
      return 3262; /* fixuns_truncdfdf2 */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3269; /* fixuns_truncv2hiv2hf2 */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3281; /* fixuns_truncv2siv2hf2 */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3293; /* fixuns_truncv2hfv2hf2 */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3305; /* fixuns_truncv2sfv2hf2 */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3317; /* fixuns_truncv2dfv2hf2 */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3329; /* fixuns_truncv2hiv2sf2 */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3341; /* fixuns_truncv2siv2sf2 */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3353; /* fixuns_truncv2hfv2sf2 */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3365; /* fixuns_truncv2sfv2sf2 */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3377; /* fixuns_truncv2dfv2sf2 */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3389; /* fixuns_truncv2hiv2df2 */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3401; /* fixuns_truncv2siv2df2 */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3413; /* fixuns_truncv2hfv2df2 */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3425; /* fixuns_truncv2sfv2df2 */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3437; /* fixuns_truncv2dfv2df2 */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3449; /* fixuns_truncv4hiv4hf2 */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3461; /* fixuns_truncv4siv4hf2 */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3473; /* fixuns_truncv4hfv4hf2 */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3485; /* fixuns_truncv4sfv4hf2 */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3497; /* fixuns_truncv4dfv4hf2 */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3509; /* fixuns_truncv4hiv4sf2 */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3521; /* fixuns_truncv4siv4sf2 */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3533; /* fixuns_truncv4hfv4sf2 */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3545; /* fixuns_truncv4sfv4sf2 */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3557; /* fixuns_truncv4dfv4sf2 */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3569; /* fixuns_truncv4hiv4df2 */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3581; /* fixuns_truncv4siv4df2 */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3593; /* fixuns_truncv4hfv4df2 */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3605; /* fixuns_truncv4sfv4df2 */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3617; /* fixuns_truncv4dfv4df2 */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3629; /* fixuns_truncv8hiv8hf2 */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3641; /* fixuns_truncv8siv8hf2 */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3653; /* fixuns_truncv8hfv8hf2 */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3665; /* fixuns_truncv8sfv8hf2 */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3677; /* fixuns_truncv8dfv8hf2 */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3689; /* fixuns_truncv8hiv8sf2 */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3701; /* fixuns_truncv8siv8sf2 */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3713; /* fixuns_truncv8hfv8sf2 */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3725; /* fixuns_truncv8sfv8sf2 */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3737; /* fixuns_truncv8dfv8sf2 */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3749; /* fixuns_truncv8hiv8df2 */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3761; /* fixuns_truncv8siv8df2 */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3773; /* fixuns_truncv8hfv8df2 */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3785; /* fixuns_truncv8sfv8df2 */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3797; /* fixuns_truncv8dfv8df2 */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3809; /* fixuns_truncv16hiv16hf2 */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3821; /* fixuns_truncv16siv16hf2 */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3833; /* fixuns_truncv16hfv16hf2 */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3845; /* fixuns_truncv16sfv16hf2 */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3857; /* fixuns_truncv16dfv16hf2 */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3869; /* fixuns_truncv16hiv16sf2 */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3881; /* fixuns_truncv16siv16sf2 */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3893; /* fixuns_truncv16hfv16sf2 */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3905; /* fixuns_truncv16sfv16sf2 */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3917; /* fixuns_truncv16dfv16sf2 */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3929; /* fixuns_truncv16hiv16df2 */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3941; /* fixuns_truncv16siv16df2 */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3953; /* fixuns_truncv16hfv16df2 */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3965; /* fixuns_truncv16sfv16df2 */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3977; /* fixuns_truncv16dfv16df2 */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 3989; /* fixuns_truncv32hiv32hf2 */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4001; /* fixuns_truncv32siv32hf2 */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4013; /* fixuns_truncv32hfv32hf2 */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4025; /* fixuns_truncv32sfv32hf2 */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4037; /* fixuns_truncv32dfv32hf2 */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4049; /* fixuns_truncv32hiv32sf2 */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4061; /* fixuns_truncv32siv32sf2 */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4073; /* fixuns_truncv32hfv32sf2 */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4085; /* fixuns_truncv32sfv32sf2 */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4097; /* fixuns_truncv32dfv32sf2 */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4109; /* fixuns_truncv32hiv32df2 */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4121; /* fixuns_truncv32siv32df2 */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4133; /* fixuns_truncv32hfv32df2 */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4145; /* fixuns_truncv32sfv32df2 */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4157; /* fixuns_truncv32dfv32df2 */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4169; /* fixuns_truncv64hiv64hf2 */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4181; /* fixuns_truncv64siv64hf2 */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4193; /* fixuns_truncv64hfv64hf2 */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4205; /* fixuns_truncv64sfv64hf2 */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4217; /* fixuns_truncv64dfv64hf2 */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4229; /* fixuns_truncv64hiv64sf2 */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4241; /* fixuns_truncv64siv64sf2 */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4253; /* fixuns_truncv64hfv64sf2 */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4265; /* fixuns_truncv64sfv64sf2 */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4277; /* fixuns_truncv64dfv64sf2 */

    case 90:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4289; /* fixuns_truncv64hiv64df2 */

    case 91:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4301; /* fixuns_truncv64siv64df2 */

    case 92:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4313; /* fixuns_truncv64hfv64df2 */

    case 93:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4325; /* fixuns_truncv64sfv64df2 */

    case 94:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4337; /* fixuns_truncv64dfv64df2 */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4349; /* fixuns_truncv2hfv2hi2 */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4361; /* fixuns_truncv2sfv2hi2 */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4373; /* fixuns_truncv2dfv2hi2 */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4385; /* fixuns_truncv2hfv2si2 */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4397; /* fixuns_truncv2sfv2si2 */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4409; /* fixuns_truncv2dfv2si2 */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4421; /* fixuns_truncv4hfv4hi2 */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4433; /* fixuns_truncv4sfv4hi2 */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4445; /* fixuns_truncv4dfv4hi2 */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4457; /* fixuns_truncv4hfv4si2 */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4469; /* fixuns_truncv4sfv4si2 */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4481; /* fixuns_truncv4dfv4si2 */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4493; /* fixuns_truncv8hfv8hi2 */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4505; /* fixuns_truncv8sfv8hi2 */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4517; /* fixuns_truncv8dfv8hi2 */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4529; /* fixuns_truncv8hfv8si2 */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4541; /* fixuns_truncv8sfv8si2 */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4553; /* fixuns_truncv8dfv8si2 */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4565; /* fixuns_truncv16hfv16hi2 */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4577; /* fixuns_truncv16sfv16hi2 */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4589; /* fixuns_truncv16dfv16hi2 */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4601; /* fixuns_truncv16hfv16si2 */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4613; /* fixuns_truncv16sfv16si2 */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4625; /* fixuns_truncv16dfv16si2 */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4637; /* fixuns_truncv32hfv32hi2 */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4649; /* fixuns_truncv32sfv32hi2 */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4661; /* fixuns_truncv32dfv32hi2 */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4673; /* fixuns_truncv32hfv32si2 */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4685; /* fixuns_truncv32sfv32si2 */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4697; /* fixuns_truncv32dfv32si2 */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4709; /* fixuns_truncv64hfv64hi2 */

    case 126:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4721; /* fixuns_truncv64sfv64hi2 */

    case 127:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4733; /* fixuns_truncv64dfv64hi2 */

    case 128:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4745; /* fixuns_truncv64hfv64si2 */

    case 129:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4757; /* fixuns_truncv64sfv64si2 */

    case 130:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       fixuns_trunc_cvt)))
        return -1;
      return 4769; /* fixuns_truncv64dfv64si2 */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (XINT (x3, 1) != 3)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          if (pattern174 (x3, 
E_V2DImode, 
E_V2QImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 237; /* movv2qi_sgprbase */

        case E_V2HImode:
          if (pattern174 (x3, 
E_V2DImode, 
E_V2HImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 238; /* movv2hi_sgprbase */

        case E_V2SImode:
          if (pattern174 (x3, 
E_V2DImode, 
E_V2SImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 239; /* movv2si_sgprbase */

        case E_V2HFmode:
          if (pattern174 (x3, 
E_V2DImode, 
E_V2HFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 240; /* movv2hf_sgprbase */

        case E_V2SFmode:
          if (pattern174 (x3, 
E_V2DImode, 
E_V2SFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 241; /* movv2sf_sgprbase */

        case E_V4QImode:
          if (pattern174 (x3, 
E_V4DImode, 
E_V4QImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 242; /* movv4qi_sgprbase */

        case E_V4HImode:
          if (pattern174 (x3, 
E_V4DImode, 
E_V4HImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 243; /* movv4hi_sgprbase */

        case E_V4SImode:
          if (pattern174 (x3, 
E_V4DImode, 
E_V4SImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 244; /* movv4si_sgprbase */

        case E_V4HFmode:
          if (pattern174 (x3, 
E_V4DImode, 
E_V4HFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 245; /* movv4hf_sgprbase */

        case E_V4SFmode:
          if (pattern174 (x3, 
E_V4DImode, 
E_V4SFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 246; /* movv4sf_sgprbase */

        case E_V8QImode:
          if (pattern174 (x3, 
E_V8DImode, 
E_V8QImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 247; /* movv8qi_sgprbase */

        case E_V8HImode:
          if (pattern174 (x3, 
E_V8DImode, 
E_V8HImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 248; /* movv8hi_sgprbase */

        case E_V8SImode:
          if (pattern174 (x3, 
E_V8DImode, 
E_V8SImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 249; /* movv8si_sgprbase */

        case E_V8HFmode:
          if (pattern174 (x3, 
E_V8DImode, 
E_V8HFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 250; /* movv8hf_sgprbase */

        case E_V8SFmode:
          if (pattern174 (x3, 
E_V8DImode, 
E_V8SFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 251; /* movv8sf_sgprbase */

        case E_V16QImode:
          if (pattern174 (x3, 
E_V16DImode, 
E_V16QImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 252; /* movv16qi_sgprbase */

        case E_V16HImode:
          if (pattern174 (x3, 
E_V16DImode, 
E_V16HImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 253; /* movv16hi_sgprbase */

        case E_V16SImode:
          if (pattern174 (x3, 
E_V16DImode, 
E_V16SImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 254; /* movv16si_sgprbase */

        case E_V16HFmode:
          if (pattern174 (x3, 
E_V16DImode, 
E_V16HFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 255; /* movv16hf_sgprbase */

        case E_V16SFmode:
          if (pattern174 (x3, 
E_V16DImode, 
E_V16SFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 256; /* movv16sf_sgprbase */

        case E_V32QImode:
          if (pattern174 (x3, 
E_V32DImode, 
E_V32QImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 257; /* movv32qi_sgprbase */

        case E_V32HImode:
          if (pattern174 (x3, 
E_V32DImode, 
E_V32HImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 258; /* movv32hi_sgprbase */

        case E_V32SImode:
          if (pattern174 (x3, 
E_V32DImode, 
E_V32SImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 259; /* movv32si_sgprbase */

        case E_V32HFmode:
          if (pattern174 (x3, 
E_V32DImode, 
E_V32HFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 260; /* movv32hf_sgprbase */

        case E_V32SFmode:
          if (pattern174 (x3, 
E_V32DImode, 
E_V32SFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 261; /* movv32sf_sgprbase */

        case E_V64QImode:
          if (pattern174 (x3, 
E_V64DImode, 
E_V64QImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 262; /* movv64qi_sgprbase */

        case E_V64HImode:
          if (pattern174 (x3, 
E_V64DImode, 
E_V64HImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 263; /* movv64hi_sgprbase */

        case E_V64SImode:
          if (pattern174 (x3, 
E_V64DImode, 
E_V64SImode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 264; /* movv64si_sgprbase */

        case E_V64HFmode:
          if (pattern174 (x3, 
E_V64DImode, 
E_V64HFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 265; /* movv64hf_sgprbase */

        case E_V64SFmode:
          if (pattern174 (x3, 
E_V64DImode, 
E_V64SFmode) != 0
              || !
#line 664 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 266; /* movv64sf_sgprbase */

        case E_V2DImode:
          if (pattern175 (x3, 
E_V2DImode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 267; /* movv2di_sgprbase */

        case E_V2DFmode:
          if (pattern174 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 268; /* movv2df_sgprbase */

        case E_V4DImode:
          if (pattern175 (x3, 
E_V4DImode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 269; /* movv4di_sgprbase */

        case E_V4DFmode:
          if (pattern174 (x3, 
E_V4DImode, 
E_V4DFmode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 270; /* movv4df_sgprbase */

        case E_V8DImode:
          if (pattern175 (x3, 
E_V8DImode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 271; /* movv8di_sgprbase */

        case E_V8DFmode:
          if (pattern174 (x3, 
E_V8DImode, 
E_V8DFmode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 272; /* movv8df_sgprbase */

        case E_V16DImode:
          if (pattern175 (x3, 
E_V16DImode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 273; /* movv16di_sgprbase */

        case E_V16DFmode:
          if (pattern174 (x3, 
E_V16DImode, 
E_V16DFmode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 274; /* movv16df_sgprbase */

        case E_V32DImode:
          if (pattern175 (x3, 
E_V32DImode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 275; /* movv32di_sgprbase */

        case E_V32DFmode:
          if (pattern174 (x3, 
E_V32DImode, 
E_V32DFmode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 276; /* movv32df_sgprbase */

        case E_V64DImode:
          if (pattern175 (x3, 
E_V64DImode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 277; /* movv64di_sgprbase */

        case E_V64DFmode:
          if (pattern174 (x3, 
E_V64DImode, 
E_V64DFmode) != 0
              || !
#line 680 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 278; /* movv64df_sgprbase */

        case E_V2TImode:
          if (pattern174 (x3, 
E_V2DImode, 
E_V2TImode) != 0
              || !
#line 700 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 279; /* movv2ti_sgprbase */

        case E_V4TImode:
          if (pattern174 (x3, 
E_V4DImode, 
E_V4TImode) != 0
              || !
#line 700 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 280; /* movv4ti_sgprbase */

        case E_V8TImode:
          if (pattern174 (x3, 
E_V8DImode, 
E_V8TImode) != 0
              || !
#line 700 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 281; /* movv8ti_sgprbase */

        case E_V16TImode:
          if (pattern174 (x3, 
E_V16DImode, 
E_V16TImode) != 0
              || !
#line 700 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 282; /* movv16ti_sgprbase */

        case E_V32TImode:
          if (pattern174 (x3, 
E_V32DImode, 
E_V32TImode) != 0
              || !
#line 700 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 283; /* movv32ti_sgprbase */

        case E_V64TImode:
          if (pattern174 (x3, 
E_V64DImode, 
E_V64TImode) != 0
              || !
#line 700 "../../gcc/config/gcn/gcn-valu.md"
(lra_in_progress || reload_completed))
            return -1;
          return 284; /* movv64ti_sgprbase */

        default:
          return -1;
        }

    case 3:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      x8 = XVECEXP (x3, 0, 2);
      operands[3] = x8;
      switch (XINT (x3, 1))
        {
        case 38:
          x4 = XVECEXP (x1, 0, 1);
          if (pattern100 (x4, 
38, 
3, 
UNSPEC) != 0)
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_MODE (x9) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (!register_operand (operands[4], E_DImode))
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x12 = XVECEXP (x9, 0, 2);
          if (!rtx_equal_p (x12, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern220 (x3, 
E_SFmode) != 0)
                return -1;
              return 3026; /* div_scalesf */

            case E_DFmode:
              if (pattern220 (x3, 
E_DFmode) != 0)
                return -1;
              return 3027; /* div_scaledf */

            case E_V2SFmode:
              if (pattern220 (x3, 
E_V2SFmode) != 0)
                return -1;
              return 3028; /* div_scalev2sf */

            case E_V2DFmode:
              if (pattern220 (x3, 
E_V2DFmode) != 0)
                return -1;
              return 3030; /* div_scalev2df */

            case E_V4SFmode:
              if (pattern220 (x3, 
E_V4SFmode) != 0)
                return -1;
              return 3032; /* div_scalev4sf */

            case E_V4DFmode:
              if (pattern220 (x3, 
E_V4DFmode) != 0)
                return -1;
              return 3034; /* div_scalev4df */

            case E_V8SFmode:
              if (pattern220 (x3, 
E_V8SFmode) != 0)
                return -1;
              return 3036; /* div_scalev8sf */

            case E_V8DFmode:
              if (pattern220 (x3, 
E_V8DFmode) != 0)
                return -1;
              return 3038; /* div_scalev8df */

            case E_V16SFmode:
              if (pattern220 (x3, 
E_V16SFmode) != 0)
                return -1;
              return 3040; /* div_scalev16sf */

            case E_V16DFmode:
              if (pattern220 (x3, 
E_V16DFmode) != 0)
                return -1;
              return 3042; /* div_scalev16df */

            case E_V32SFmode:
              if (pattern220 (x3, 
E_V32SFmode) != 0)
                return -1;
              return 3044; /* div_scalev32sf */

            case E_V32DFmode:
              if (pattern220 (x3, 
E_V32DFmode) != 0)
                return -1;
              return 3046; /* div_scalev32df */

            case E_V64SFmode:
              if (pattern220 (x3, 
E_V64SFmode) != 0)
                return -1;
              return 3048; /* div_scalev64sf */

            case E_V64DFmode:
              if (pattern220 (x3, 
E_V64DFmode) != 0)
                return -1;
              return 3050; /* div_scalev64df */

            default:
              return -1;
            }

        case 10:
          x4 = XVECEXP (x1, 0, 1);
          if (pattern72 (x4, 
106) != 0
              || !const_int_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern201 (x3, 
E_V2QImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9183; /* *plus_carry_dpp_shr_v2qi */

            case E_V2HImode:
              if (pattern201 (x3, 
E_V2HImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9184; /* *plus_carry_dpp_shr_v2hi */

            case E_V2SImode:
              if (pattern201 (x3, 
E_V2SImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9185; /* *plus_carry_dpp_shr_v2si */

            case E_V4QImode:
              if (pattern201 (x3, 
E_V4QImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9186; /* *plus_carry_dpp_shr_v4qi */

            case E_V4HImode:
              if (pattern201 (x3, 
E_V4HImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9187; /* *plus_carry_dpp_shr_v4hi */

            case E_V4SImode:
              if (pattern201 (x3, 
E_V4SImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9188; /* *plus_carry_dpp_shr_v4si */

            case E_V8QImode:
              if (pattern201 (x3, 
E_V8QImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9189; /* *plus_carry_dpp_shr_v8qi */

            case E_V8HImode:
              if (pattern201 (x3, 
E_V8HImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9190; /* *plus_carry_dpp_shr_v8hi */

            case E_V8SImode:
              if (pattern201 (x3, 
E_V8SImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9191; /* *plus_carry_dpp_shr_v8si */

            case E_V16QImode:
              if (pattern201 (x3, 
E_V16QImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9192; /* *plus_carry_dpp_shr_v16qi */

            case E_V16HImode:
              if (pattern201 (x3, 
E_V16HImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9193; /* *plus_carry_dpp_shr_v16hi */

            case E_V16SImode:
              if (pattern201 (x3, 
E_V16SImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9194; /* *plus_carry_dpp_shr_v16si */

            case E_V32QImode:
              if (pattern201 (x3, 
E_V32QImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9195; /* *plus_carry_dpp_shr_v32qi */

            case E_V32HImode:
              if (pattern201 (x3, 
E_V32HImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9196; /* *plus_carry_dpp_shr_v32hi */

            case E_V32SImode:
              if (pattern201 (x3, 
E_V32SImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9197; /* *plus_carry_dpp_shr_v32si */

            case E_V64QImode:
              if (pattern201 (x3, 
E_V64QImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9198; /* *plus_carry_dpp_shr_v64qi */

            case E_V64HImode:
              if (pattern201 (x3, 
E_V64HImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9199; /* *plus_carry_dpp_shr_v64hi */

            case E_V64SImode:
              if (pattern201 (x3, 
E_V64SImode) != 0
                  || !
#line 4332 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
                return -1;
              return 9200; /* *plus_carry_dpp_shr_v64si */

            case E_V2DImode:
              if (pattern201 (x3, 
E_V2DImode) != 0)
                return -1;
              return 9207; /* *plus_carry_dpp_shr_v2di */

            case E_V4DImode:
              if (pattern201 (x3, 
E_V4DImode) != 0)
                return -1;
              return 9208; /* *plus_carry_dpp_shr_v4di */

            case E_V8DImode:
              if (pattern201 (x3, 
E_V8DImode) != 0)
                return -1;
              return 9209; /* *plus_carry_dpp_shr_v8di */

            case E_V16DImode:
              if (pattern201 (x3, 
E_V16DImode) != 0)
                return -1;
              return 9210; /* *plus_carry_dpp_shr_v16di */

            case E_V32DImode:
              if (pattern201 (x3, 
E_V32DImode) != 0)
                return -1;
              return 9211; /* *plus_carry_dpp_shr_v32di */

            case E_V64DImode:
              if (pattern201 (x3, 
E_V64DImode) != 0)
                return -1;
              return 9212; /* *plus_carry_dpp_shr_v64di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (XINT (x3, 1) != 11)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER
          || pattern135 (x1) != 0)
        return -1;
      x13 = XVECEXP (x3, 0, 3);
      operands[4] = x13;
      if (!register_operand (operands[4], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern201 (x3, 
E_V2SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9201; /* *plus_carry_in_dpp_shr_v2si */

        case E_V4SImode:
          if (pattern201 (x3, 
E_V4SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9202; /* *plus_carry_in_dpp_shr_v4si */

        case E_V8SImode:
          if (pattern201 (x3, 
E_V8SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9203; /* *plus_carry_in_dpp_shr_v8si */

        case E_V16SImode:
          if (pattern201 (x3, 
E_V16SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9204; /* *plus_carry_in_dpp_shr_v16si */

        case E_V32SImode:
          if (pattern201 (x3, 
E_V32SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9205; /* *plus_carry_in_dpp_shr_v32si */

        case E_V64SImode:
          if (pattern201 (x3, 
E_V64SImode) != 0
              || !
#line 4350 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
            return -1;
          return 9206; /* *plus_carry_in_dpp_shr_v64si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64SImode
      || !scratch_operand (operands[4], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64SImode)
      && general_operand (operands[1], E_V64SImode))
    return gen_split_114 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64SImode)
      || !memory_operand (operands[1], E_V64SImode))
    return NULL;
  return gen_split_210 (insn, operands);
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32DFmode
      || !scratch_operand (operands[4], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32DFmode)
      && general_operand (operands[1], E_V32DFmode))
    return gen_split_109 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32DFmode)
      || !memory_operand (operands[1], E_V32DFmode))
    return NULL;
  return gen_split_205 (insn, operands);
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32HImode
      || !scratch_operand (operands[4], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32HImode)
      && general_operand (operands[1], E_V32HImode))
    return gen_split_104 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32HImode)
      || !memory_operand (operands[1], E_V32HImode))
    return NULL;
  return gen_split_200 (insn, operands);
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_37 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case PLUS:
              x7 = XEXP (x3, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 0);
              switch (GET_CODE (x8))
                {
                case REG:
                case SUBREG:
                  operands[1] = x8;
                  if (!register_operand (operands[1], E_DImode)
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x6) != E_DImode)
                    return NULL;
                  x9 = XEXP (x6, 1);
                  operands[2] = x9;
                  if (!nonmemory_operand (operands[2], E_DImode)
                      || !scratch_operand (operands[3], E_BImode))
                    return NULL;
                  x10 = XEXP (x4, 0);
                  operands[4] = x10;
                  if (!scratch_operand (operands[4], E_DImode)
                      || !
#line 1166 "../../gcc/config/gcn/gcn.md"
( reload_completed))
                    return NULL;
                  return gen_split_12 (insn, operands);

                case SIGN_EXTEND:
                  switch (pattern152 (x1))
                    {
                    case 0:
                      if (!
#line 2040 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])))
                        return NULL;
                      return gen_split_287 (insn, operands);

                    case 1:
                      if (!
#line 2040 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])))
                        return NULL;
                      return gen_split_288 (insn, operands);

                    case 2:
                      if (!
#line 2040 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])))
                        return NULL;
                      return gen_split_289 (insn, operands);

                    case 3:
                      if (!
#line 2040 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])))
                        return NULL;
                      return gen_split_290 (insn, operands);

                    case 4:
                      if (!
#line 2040 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])))
                        return NULL;
                      return gen_split_291 (insn, operands);

                    case 5:
                      if (!
#line 2040 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])))
                        return NULL;
                      return gen_split_292 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case VEC_MERGE:
              switch (pattern110 (x1))
                {
                case 0:
                  if (!
#line 2071 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])
   && gcn_can_split_p (V2DImode, operands[3])))
                    return NULL;
                  return gen_split_293 (insn, operands);

                case 1:
                  if (!
#line 2071 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])
   && gcn_can_split_p (V4DImode, operands[3])))
                    return NULL;
                  return gen_split_294 (insn, operands);

                case 2:
                  if (!
#line 2071 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])
   && gcn_can_split_p (V8DImode, operands[3])))
                    return NULL;
                  return gen_split_295 (insn, operands);

                case 3:
                  if (!
#line 2071 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])
   && gcn_can_split_p (V16DImode, operands[3])))
                    return NULL;
                  return gen_split_296 (insn, operands);

                case 4:
                  if (!
#line 2071 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])
   && gcn_can_split_p (V32DImode, operands[3])))
                    return NULL;
                  return gen_split_297 (insn, operands);

                case 5:
                  if (!
#line 2071 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])
   && gcn_can_split_p (V64DImode, operands[3])))
                    return NULL;
                  return gen_split_298 (insn, operands);

                case 6:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_395 (insn, operands);

                case 7:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_399 (insn, operands);

                case 8:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_403 (insn, operands);

                case 9:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_407 (insn, operands);

                case 10:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_411 (insn, operands);

                case 11:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_415 (insn, operands);

                case 12:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_396 (insn, operands);

                case 13:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_400 (insn, operands);

                case 14:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_404 (insn, operands);

                case 15:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_408 (insn, operands);

                case 16:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_412 (insn, operands);

                case 17:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_416 (insn, operands);

                case 18:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_397 (insn, operands);

                case 19:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_401 (insn, operands);

                case 20:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_405 (insn, operands);

                case 21:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_409 (insn, operands);

                case 22:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_413 (insn, operands);

                case 23:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_417 (insn, operands);

                case 24:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_398 (insn, operands);

                case 25:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_402 (insn, operands);

                case 26:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_406 (insn, operands);

                case 27:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_410 (insn, operands);

                case 28:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_414 (insn, operands);

                case 29:
                  if (!
#line 2868 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                    return NULL;
                  return gen_split_418 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 2:
          return split_36 (x1, insn);

        case 4:
          if (pattern34 (x1) != 0
              || !
#line 1567 "../../gcc/config/gcn/gcn.md"
(reload_completed))
            return NULL;
          return gen_split_18 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
