/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern3 (x3, pnum_clobbers); /* [-1, 25] */
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    case E_V16HFmode:
      if (!gcn_alu_operand (operands[1], E_V16HFmode))
        return -1;
      return 2;

    case E_V16SFmode:
      if (!gcn_alu_operand (operands[1], E_V16SFmode))
        return -1;
      return 3;

    case E_V16DFmode:
      if (!gcn_alu_operand (operands[1], E_V16DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!gcn_alu_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!gcn_alu_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!gcn_alu_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4QImode:
      if (!gcn_alu_operand (operands[1], E_V4QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MULT
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  if (!nonmemory_operand (operands[2], E_DImode))
    return -1;
  x10 = XEXP (x4, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_BImode))
    return -1;
  x12 = XEXP (x6, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_DImode))
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 2);
  operands[4] = x5;
  if (!gcn_exec_reg_operand (operands[4], E_DImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case VEC_DUPLICATE:
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!gcn_alu_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          return pattern42 (x1, 
E_V2SImode); /* [-1, 0] */

        case E_V2DImode:
          if (pattern43 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern42 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V4DImode:
          if (pattern43 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 3;

        case E_V8SImode:
          if (pattern42 (x1, 
E_V8SImode) != 0)
            return -1;
          return 4;

        case E_V8DImode:
          if (pattern43 (x1, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 5;

        case E_V16SImode:
          if (pattern42 (x1, 
E_V16SImode) != 0)
            return -1;
          return 6;

        case E_V16DImode:
          if (pattern43 (x1, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 7;

        case E_V32SImode:
          if (pattern42 (x1, 
E_V32SImode) != 0)
            return -1;
          return 8;

        case E_V32DImode:
          if (pattern43 (x1, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 9;

        case E_V64SImode:
          if (pattern42 (x1, 
E_V64SImode) != 0)
            return -1;
          return 10;

        case E_V64DImode:
          if (pattern43 (x1, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern44 (x1, 
E_V2SImode) != 0)
            return -1;
          return 12;

        case E_V2DImode:
          if (pattern45 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern44 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V4DImode:
          if (pattern45 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 15;

        case E_V8SImode:
          if (pattern44 (x1, 
E_V8SImode) != 0)
            return -1;
          return 16;

        case E_V8DImode:
          if (pattern45 (x1, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 17;

        case E_V16SImode:
          if (pattern44 (x1, 
E_V16SImode) != 0)
            return -1;
          return 18;

        case E_V16DImode:
          if (pattern45 (x1, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 19;

        case E_V32SImode:
          if (pattern44 (x1, 
E_V32SImode) != 0)
            return -1;
          return 20;

        case E_V32DImode:
          if (pattern45 (x1, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 21;

        case E_V64SImode:
          if (pattern44 (x1, 
E_V64SImode) != 0)
            return -1;
          return 22;

        case E_V64DImode:
          if (pattern45 (x1, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern78 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !gcn_alu_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !gcn_alu_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      return pattern86 (x1, 
E_V2QImode); /* [-1, 0] */

    case E_V2HImode:
      if (pattern86 (x1, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern86 (x1, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V2HFmode:
      if (pattern86 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 3;

    case E_V2SFmode:
      if (pattern86 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 4;

    case E_V4QImode:
      if (pattern86 (x1, 
E_V4QImode) != 0)
        return -1;
      return 5;

    case E_V4HImode:
      if (pattern86 (x1, 
E_V4HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern86 (x1, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V4HFmode:
      if (pattern86 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 8;

    case E_V4SFmode:
      if (pattern86 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 9;

    case E_V8QImode:
      if (pattern86 (x1, 
E_V8QImode) != 0)
        return -1;
      return 10;

    case E_V8HImode:
      if (pattern86 (x1, 
E_V8HImode) != 0)
        return -1;
      return 11;

    case E_V8SImode:
      if (pattern86 (x1, 
E_V8SImode) != 0)
        return -1;
      return 12;

    case E_V8HFmode:
      if (pattern86 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 13;

    case E_V8SFmode:
      if (pattern86 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 14;

    case E_V16QImode:
      if (pattern86 (x1, 
E_V16QImode) != 0)
        return -1;
      return 15;

    case E_V16HImode:
      if (pattern86 (x1, 
E_V16HImode) != 0)
        return -1;
      return 16;

    case E_V16SImode:
      if (pattern86 (x1, 
E_V16SImode) != 0)
        return -1;
      return 17;

    case E_V16HFmode:
      if (pattern86 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 18;

    case E_V16SFmode:
      if (pattern86 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 19;

    case E_V32QImode:
      if (pattern86 (x1, 
E_V32QImode) != 0)
        return -1;
      return 20;

    case E_V32HImode:
      if (pattern86 (x1, 
E_V32HImode) != 0)
        return -1;
      return 21;

    case E_V32SImode:
      if (pattern86 (x1, 
E_V32SImode) != 0)
        return -1;
      return 22;

    case E_V32HFmode:
      if (pattern86 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 23;

    case E_V32SFmode:
      if (pattern86 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 24;

    case E_V64QImode:
      if (pattern86 (x1, 
E_V64QImode) != 0)
        return -1;
      return 25;

    case E_V64HImode:
      if (pattern86 (x1, 
E_V64HImode) != 0)
        return -1;
      return 26;

    case E_V64SImode:
      if (pattern86 (x1, 
E_V64SImode) != 0)
        return -1;
      return 27;

    case E_V64HFmode:
      if (pattern86 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 28;

    case E_V64SFmode:
      if (pattern86 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 29;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      if (!gcn_alu_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!gcn_alu_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V8QImode:
      if (!gcn_alu_operand (operands[1], E_V8QImode))
        return -1;
      return 6;

    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16QImode:
      if (!gcn_alu_operand (operands[1], E_V16QImode))
        return -1;
      return 9;

    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 10;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 11;

    case E_V32QImode:
      if (!gcn_alu_operand (operands[1], E_V32QImode))
        return -1;
      return 12;

    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 13;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 14;

    case E_V64QImode:
      if (!gcn_alu_operand (operands[1], E_V64QImode))
        return -1;
      return 15;

    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 16;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 17;

    case E_V64DImode:
      if (!gcn_alu_operand (operands[1], E_V64DImode))
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern133 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !gcn_alu_operand (operands[2], i2)
      || !gcn_register_or_unspec_operand (operands[4], i2))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i2)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i2)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      return 0;

    case E_V2HImode:
      return 1;

    case E_V2SImode:
      return 2;

    case E_V4QImode:
      return 3;

    case E_V4HImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V8QImode:
      return 6;

    case E_V8HImode:
      return 7;

    case E_V8SImode:
      return 8;

    case E_V16QImode:
      return 9;

    case E_V16HImode:
      return 10;

    case E_V16SImode:
      return 11;

    case E_V32QImode:
      return 12;

    case E_V32HImode:
      return 13;

    case E_V32SImode:
      return 14;

    case E_V64QImode:
      return 15;

    case E_V64HImode:
      return 16;

    case E_V64SImode:
      return 17;

    case E_V8DImode:
      return 18;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_alu_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern159 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i2)
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern168 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !general_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern178 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gcn_ds_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !gcn_ds_memory_operand (operands[1], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern183 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_alu_operand (operands[3], i1)
      || !gcn_register_or_unspec_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern194 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i2)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_V16DImode:
      if (!register_operand (operands[1], E_V16DImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V16DImode)
        return -1;
      return 0;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_V16SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x6, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  return pattern222 (x2, 
E_V4DImode, 
E_V4SImode); /* [-1, 0] */
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[5], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V32DImode)
        return -1;
      return 0;

    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V32SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern242 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_alu_operand (operands[3], i1)
      || !gcn_register_or_unspec_operand (operands[5], i1))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 0:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != PLUS
          || GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 34; /* addptrdi3 */

    case 28:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (gcn_alu_operand (operands[1], E_SImode))
        return 61; /* gcn_flbitsi_int */
      if (!gcn_alu_operand (operands[1], E_DImode))
        return -1;
      return 62; /* gcn_flbitdi_int */

    case 4:
      if (GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      if (
#line 1945 "../../gcc/config/gcn/gcn.md"
(TARGET_WBINVL1_CACHE))
        return 80; /* *memory_barrier */
      if (!
#line 1953 "../../gcc/config/gcn/gcn.md"
(TARGET_GLn_CACHE))
        return -1;
      return 81; /* *memory_barrier */

    case 29:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (pattern85 (x3))
        {
        case 0:
          return 2532; /* floorhf2 */

        case 1:
          return 2534; /* floorsf2 */

        case 2:
          return 2536; /* floordf2 */

        default:
          return -1;
        }

    case 30:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (pattern85 (x3))
        {
        case 0:
          return 2533; /* ceilhf2 */

        case 1:
          return 2535; /* ceilsf2 */

        case 2:
          return 2537; /* ceildf2 */

        default:
          return -1;
        }

    case 33:
      switch (pattern75 (x3))
        {
        case 0:
          if (!
#line 3122 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2610; /* exp2hf2 */

        case 1:
          if (!
#line 3122 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2612; /* exp2sf2 */

        default:
          return -1;
        }

    case 34:
      switch (pattern75 (x3))
        {
        case 0:
          if (!
#line 3122 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2611; /* log2hf2 */

        case 1:
          if (!
#line 3122 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2613; /* log2sf2 */

        default:
          return -1;
        }

    case 31:
      switch (pattern75 (x3))
        {
        case 0:
          if (!
#line 3142 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2662; /* *sinhf2_insn */

        case 1:
          if (!
#line 3142 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2664; /* *sinsf2_insn */

        default:
          return -1;
        }

    case 32:
      switch (pattern75 (x3))
        {
        case 0:
          if (!
#line 3142 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2663; /* *coshf2_insn */

        case 1:
          if (!
#line 3142 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2665; /* *cossf2_insn */

        default:
          return -1;
        }

    case 36:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_HFmode:
          if (!gcn_alu_operand (operands[1], E_HFmode))
            return -1;
          return 2753; /* frexphf_exp2 */

        case E_SFmode:
          if (!gcn_alu_operand (operands[1], E_SFmode))
            return -1;
          return 2754; /* frexpsf_exp2 */

        case E_DFmode:
          if (!gcn_alu_operand (operands[1], E_DFmode))
            return -1;
          return 2755; /* frexpdf_exp2 */

        default:
          return -1;
        }

    case 37:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (pattern85 (x3))
        {
        case 0:
          return 2756; /* frexphf_mant2 */

        case 1:
          return 2757; /* frexpsf_mant2 */

        case 2:
          return 2758; /* frexpdf_mant2 */

        default:
          return -1;
        }

    case 27:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (pattern85 (x3))
        {
        case 0:
          return 2987; /* reciphf2 */

        case 1:
          return 2988; /* recipsf2 */

        case 2:
          return 2989; /* recipdf2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern88 (x2))
    {
    case 0:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8924; /* *and_dpp_shr_v2qi */

    case 1:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8932; /* *and_dpp_shr_v2hi */

    case 2:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8940; /* *and_dpp_shr_v2si */

    case 3:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8948; /* *and_dpp_shr_v2hf */

    case 4:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8956; /* *and_dpp_shr_v2sf */

    case 5:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8964; /* *and_dpp_shr_v4qi */

    case 6:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8972; /* *and_dpp_shr_v4hi */

    case 7:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8980; /* *and_dpp_shr_v4si */

    case 8:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8988; /* *and_dpp_shr_v4hf */

    case 9:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 8996; /* *and_dpp_shr_v4sf */

    case 10:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9004; /* *and_dpp_shr_v8qi */

    case 11:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9012; /* *and_dpp_shr_v8hi */

    case 12:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9020; /* *and_dpp_shr_v8si */

    case 13:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9028; /* *and_dpp_shr_v8hf */

    case 14:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9036; /* *and_dpp_shr_v8sf */

    case 15:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9044; /* *and_dpp_shr_v16qi */

    case 16:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9052; /* *and_dpp_shr_v16hi */

    case 17:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9060; /* *and_dpp_shr_v16si */

    case 18:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9068; /* *and_dpp_shr_v16hf */

    case 19:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9076; /* *and_dpp_shr_v16sf */

    case 20:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9084; /* *and_dpp_shr_v32qi */

    case 21:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9092; /* *and_dpp_shr_v32hi */

    case 22:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9100; /* *and_dpp_shr_v32si */

    case 23:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9108; /* *and_dpp_shr_v32hf */

    case 24:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9116; /* *and_dpp_shr_v32sf */

    case 25:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9124; /* *and_dpp_shr_v64qi */

    case 26:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9132; /* *and_dpp_shr_v64hi */

    case 27:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9140; /* *and_dpp_shr_v64si */

    case 28:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9148; /* *and_dpp_shr_v64hf */

    case 29:
      if (!
#line 4287 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_DPP_FULL))
        return -1;
      return 9156; /* *and_dpp_shr_v64sf */

    case 30:
      return 9160; /* *and_dpp_shr_v2di */

    case 31:
      return 9164; /* *and_dpp_shr_v4di */

    case 32:
      return 9168; /* *and_dpp_shr_v8di */

    case 33:
      return 9172; /* *and_dpp_shr_v16di */

    case 34:
      return 9176; /* *and_dpp_shr_v32di */

    case 35:
      return 9180; /* *and_dpp_shr_v64di */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern99 (x2, 
E_V64QImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5859; /* *truncv2qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8343; /* *truncv2qiv64qi_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5863; /* *truncv2hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8349; /* *truncv2hiv64qi_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5867; /* *truncv2siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8355; /* *truncv2siv64qi_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5871; /* *truncv4qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8361; /* *truncv4qiv64qi_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5875; /* *truncv4hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8367; /* *truncv4hiv64qi_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5879; /* *truncv4siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8373; /* *truncv4siv64qi_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5883; /* *truncv8qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8379; /* *truncv8qiv64qi_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5887; /* *truncv8hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8385; /* *truncv8hiv64qi_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5891; /* *truncv8siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8391; /* *truncv8siv64qi_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5895; /* *truncv16qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8397; /* *truncv16qiv64qi_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5899; /* *truncv16hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8403; /* *truncv16hiv64qi_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5903; /* *truncv16siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8409; /* *truncv16siv64qi_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5907; /* *truncv32qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8415; /* *truncv32qiv64qi_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5911; /* *truncv32hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8421; /* *truncv32hiv64qi_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5915; /* *truncv32siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8427; /* *truncv32siv64qi_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5919; /* *truncv64qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8433; /* *truncv64qiv64qi_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5923; /* *truncv64hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8439; /* *truncv64hiv64qi_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5927; /* *truncv64siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8445; /* *truncv64siv64qi_shift */

    case 18:
      return 8682; /* truncv64div64qi2 */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern97 (x2, 
E_V16SImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5571; /* *truncv2qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7911; /* *truncv2qiv16si_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5575; /* *truncv2hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7917; /* *truncv2hiv16si_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5579; /* *truncv2siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7923; /* *truncv2siv16si_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5583; /* *truncv4qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7929; /* *truncv4qiv16si_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5587; /* *truncv4hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7935; /* *truncv4hiv16si_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5591; /* *truncv4siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7941; /* *truncv4siv16si_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5595; /* *truncv8qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7947; /* *truncv8qiv16si_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5599; /* *truncv8hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7953; /* *truncv8hiv16si_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5603; /* *truncv8siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7959; /* *truncv8siv16si_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5607; /* *truncv16qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7965; /* *truncv16qiv16si_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5611; /* *truncv16hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7971; /* *truncv16hiv16si_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5615; /* *truncv16siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7977; /* *truncv16siv16si_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5619; /* *truncv32qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7983; /* *truncv32qiv16si_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5623; /* *truncv32hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7989; /* *truncv32hiv16si_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5627; /* *truncv32siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7995; /* *truncv32siv16si_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5631; /* *truncv64qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8001; /* *truncv64qiv16si_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5635; /* *truncv64hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8007; /* *truncv64hiv16si_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5639; /* *truncv64siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8013; /* *truncv64siv16si_shift */

    case 18:
      return 8678; /* truncv16div16si2 */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern96 (x2, 
E_V8HImode))
    {
    case 0:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5283; /* *truncv2qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7479; /* *truncv2qiv8hi_shift */

    case 1:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5287; /* *truncv2hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7485; /* *truncv2hiv8hi_shift */

    case 2:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5291; /* *truncv2siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7491; /* *truncv2siv8hi_shift */

    case 3:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5295; /* *truncv4qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7497; /* *truncv4qiv8hi_shift */

    case 4:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5299; /* *truncv4hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7503; /* *truncv4hiv8hi_shift */

    case 5:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5303; /* *truncv4siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7509; /* *truncv4siv8hi_shift */

    case 6:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5307; /* *truncv8qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7515; /* *truncv8qiv8hi_shift */

    case 7:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5311; /* *truncv8hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7521; /* *truncv8hiv8hi_shift */

    case 8:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5315; /* *truncv8siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7527; /* *truncv8siv8hi_shift */

    case 9:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5319; /* *truncv16qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7533; /* *truncv16qiv8hi_shift */

    case 10:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5323; /* *truncv16hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7539; /* *truncv16hiv8hi_shift */

    case 11:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5327; /* *truncv16siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7545; /* *truncv16siv8hi_shift */

    case 12:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5331; /* *truncv32qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7551; /* *truncv32qiv8hi_shift */

    case 13:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5335; /* *truncv32hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7557; /* *truncv32hiv8hi_shift */

    case 14:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5339; /* *truncv32siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7563; /* *truncv32siv8hi_shift */

    case 15:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5343; /* *truncv64qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7569; /* *truncv64qiv8hi_shift */

    case 16:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5347; /* *truncv64hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7575; /* *truncv64hiv8hi_shift */

    case 17:
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5351; /* *truncv64siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7581; /* *truncv64siv8hi_shift */

    case 18:
      return 8674; /* truncv8div8hi2 */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern167 (x2, 
E_V2SImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2HFmode:
          if (!gcn_alu_operand (operands[1], E_V2HFmode))
            return -1;
          return 2760; /* frexpv2hf_exp2_exec */

        case E_V2SFmode:
          if (!gcn_alu_operand (operands[1], E_V2SFmode))
            return -1;
          return 2762; /* frexpv2sf_exp2_exec */

        case E_V2DFmode:
          if (!gcn_alu_operand (operands[1], E_V2DFmode))
            return -1;
          return 2764; /* frexpv2df_exp2_exec */

        default:
          return -1;
        }

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern167 (x2, 
E_V4SImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!gcn_alu_operand (operands[1], E_V4HFmode))
            return -1;
          return 2766; /* frexpv4hf_exp2_exec */

        case E_V4SFmode:
          if (!gcn_alu_operand (operands[1], E_V4SFmode))
            return -1;
          return 2768; /* frexpv4sf_exp2_exec */

        case E_V4DFmode:
          if (!gcn_alu_operand (operands[1], E_V4DFmode))
            return -1;
          return 2770; /* frexpv4df_exp2_exec */

        default:
          return -1;
        }

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern167 (x2, 
E_V8SImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!gcn_alu_operand (operands[1], E_V8HFmode))
            return -1;
          return 2772; /* frexpv8hf_exp2_exec */

        case E_V8SFmode:
          if (!gcn_alu_operand (operands[1], E_V8SFmode))
            return -1;
          return 2774; /* frexpv8sf_exp2_exec */

        case E_V8DFmode:
          if (!gcn_alu_operand (operands[1], E_V8DFmode))
            return -1;
          return 2776; /* frexpv8df_exp2_exec */

        default:
          return -1;
        }

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern167 (x2, 
E_V16SImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16HFmode:
          if (!gcn_alu_operand (operands[1], E_V16HFmode))
            return -1;
          return 2778; /* frexpv16hf_exp2_exec */

        case E_V16SFmode:
          if (!gcn_alu_operand (operands[1], E_V16SFmode))
            return -1;
          return 2780; /* frexpv16sf_exp2_exec */

        case E_V16DFmode:
          if (!gcn_alu_operand (operands[1], E_V16DFmode))
            return -1;
          return 2782; /* frexpv16df_exp2_exec */

        default:
          return -1;
        }

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern167 (x2, 
E_V32SImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!gcn_alu_operand (operands[1], E_V32HFmode))
            return -1;
          return 2784; /* frexpv32hf_exp2_exec */

        case E_V32SFmode:
          if (!gcn_alu_operand (operands[1], E_V32SFmode))
            return -1;
          return 2786; /* frexpv32sf_exp2_exec */

        case E_V32DFmode:
          if (!gcn_alu_operand (operands[1], E_V32DFmode))
            return -1;
          return 2788; /* frexpv32df_exp2_exec */

        default:
          return -1;
        }

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern167 (x2, 
E_V64SImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V64HFmode:
          if (!gcn_alu_operand (operands[1], E_V64HFmode))
            return -1;
          return 2790; /* frexpv64hf_exp2_exec */

        case E_V64SFmode:
          if (!gcn_alu_operand (operands[1], E_V64SFmode))
            return -1;
          return 2792; /* frexpv64sf_exp2_exec */

        case E_V64DFmode:
          if (!gcn_alu_operand (operands[1], E_V64DFmode))
            return -1;
          return 2794; /* frexpv64df_exp2_exec */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern145 (x2, 
E_V64QImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5860; /* *truncv2qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8344; /* *truncv2qiv64qi_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5864; /* *truncv2hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8350; /* *truncv2hiv64qi_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5868; /* *truncv2siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8356; /* *truncv2siv64qi_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5872; /* *truncv4qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8362; /* *truncv4qiv64qi_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5876; /* *truncv4hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8368; /* *truncv4hiv64qi_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5880; /* *truncv4siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8374; /* *truncv4siv64qi_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5884; /* *truncv8qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8380; /* *truncv8qiv64qi_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5888; /* *truncv8hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8386; /* *truncv8hiv64qi_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5892; /* *truncv8siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8392; /* *truncv8siv64qi_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5896; /* *truncv16qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8398; /* *truncv16qiv64qi_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5900; /* *truncv16hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8404; /* *truncv16hiv64qi_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5904; /* *truncv16siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8410; /* *truncv16siv64qi_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5908; /* *truncv32qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8416; /* *truncv32qiv64qi_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5912; /* *truncv32hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8422; /* *truncv32hiv64qi_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5916; /* *truncv32siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8428; /* *truncv32siv64qi_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5920; /* *truncv64qiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8434; /* *truncv64qiv64qi_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5924; /* *truncv64hiv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8440; /* *truncv64hiv64qi_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5928; /* *truncv64siv64qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8446; /* *truncv64siv64qi_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V64DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V64QImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8700; /* truncv64div64qi2_exec */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern143 (x2, 
E_V16HImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5500; /* *truncv2qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7804; /* *truncv2qiv16hi_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5504; /* *truncv2hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7810; /* *truncv2hiv16hi_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5508; /* *truncv2siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7816; /* *truncv2siv16hi_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5512; /* *truncv4qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7822; /* *truncv4qiv16hi_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5516; /* *truncv4hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7828; /* *truncv4hiv16hi_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5520; /* *truncv4siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7834; /* *truncv4siv16hi_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5524; /* *truncv8qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7840; /* *truncv8qiv16hi_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5528; /* *truncv8hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7846; /* *truncv8hiv16hi_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5532; /* *truncv8siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7852; /* *truncv8siv16hi_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5536; /* *truncv16qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7858; /* *truncv16qiv16hi_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5540; /* *truncv16hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7864; /* *truncv16hiv16hi_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5544; /* *truncv16siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7870; /* *truncv16siv16hi_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5548; /* *truncv32qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7876; /* *truncv32qiv16hi_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5552; /* *truncv32hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7882; /* *truncv32hiv16hi_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5556; /* *truncv32siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7888; /* *truncv32siv16hi_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5560; /* *truncv64qiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7894; /* *truncv64qiv16hi_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5564; /* *truncv64hiv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7900; /* *truncv64hiv16hi_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5568; /* *truncv64siv16hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7906; /* *truncv64siv16hi_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V16DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V16HImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8695; /* truncv16div16hi2_exec */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern141 (x2, 
E_V4QImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4996; /* *truncv2qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7048; /* *truncv2qiv4qi_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5000; /* *truncv2hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7054; /* *truncv2hiv4qi_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5004; /* *truncv2siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7060; /* *truncv2siv4qi_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5008; /* *truncv4qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7066; /* *truncv4qiv4qi_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5012; /* *truncv4hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7072; /* *truncv4hiv4qi_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5016; /* *truncv4siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7078; /* *truncv4siv4qi_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5020; /* *truncv8qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7084; /* *truncv8qiv4qi_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5024; /* *truncv8hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7090; /* *truncv8hiv4qi_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5028; /* *truncv8siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7096; /* *truncv8siv4qi_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5032; /* *truncv16qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7102; /* *truncv16qiv4qi_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5036; /* *truncv16hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7108; /* *truncv16hiv4qi_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5040; /* *truncv16siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7114; /* *truncv16siv4qi_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5044; /* *truncv32qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7120; /* *truncv32qiv4qi_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5048; /* *truncv32hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7126; /* *truncv32hiv4qi_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5052; /* *truncv32siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7132; /* *truncv32siv4qi_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5056; /* *truncv64qiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7138; /* *truncv64qiv4qi_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5060; /* *truncv64hiv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7144; /* *truncv64hiv4qi_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5064; /* *truncv64siv4qi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7150; /* *truncv64siv4qi_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V4DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V4QImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8688; /* truncv4div4qi2_exec */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern63 (x2))
    {
    case 0:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       floatuns_cvt)))
        return -1;
      return 3274; /* floatunsv2hiv2hf2_exec */

    case 1:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       floatuns_cvt)))
        return -1;
      return 3286; /* floatunsv2siv2hf2_exec */

    case 2:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       floatuns_cvt)))
        return -1;
      return 3298; /* floatunsv2hfv2hf2_exec */

    case 3:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       floatuns_cvt)))
        return -1;
      return 3310; /* floatunsv2sfv2hf2_exec */

    case 4:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       floatuns_cvt)))
        return -1;
      return 3322; /* floatunsv2dfv2hf2_exec */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       floatuns_cvt)))
        return -1;
      return 3334; /* floatunsv2hiv2sf2_exec */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       floatuns_cvt)))
        return -1;
      return 3346; /* floatunsv2siv2sf2_exec */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       floatuns_cvt)))
        return -1;
      return 3358; /* floatunsv2hfv2sf2_exec */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       floatuns_cvt)))
        return -1;
      return 3370; /* floatunsv2sfv2sf2_exec */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       floatuns_cvt)))
        return -1;
      return 3382; /* floatunsv2dfv2sf2_exec */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       floatuns_cvt)))
        return -1;
      return 3394; /* floatunsv2hiv2df2_exec */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       floatuns_cvt)))
        return -1;
      return 3406; /* floatunsv2siv2df2_exec */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       floatuns_cvt)))
        return -1;
      return 3418; /* floatunsv2hfv2df2_exec */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       floatuns_cvt)))
        return -1;
      return 3430; /* floatunsv2sfv2df2_exec */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       floatuns_cvt)))
        return -1;
      return 3442; /* floatunsv2dfv2df2_exec */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       floatuns_cvt)))
        return -1;
      return 3454; /* floatunsv4hiv4hf2_exec */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       floatuns_cvt)))
        return -1;
      return 3466; /* floatunsv4siv4hf2_exec */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       floatuns_cvt)))
        return -1;
      return 3478; /* floatunsv4hfv4hf2_exec */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       floatuns_cvt)))
        return -1;
      return 3490; /* floatunsv4sfv4hf2_exec */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       floatuns_cvt)))
        return -1;
      return 3502; /* floatunsv4dfv4hf2_exec */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       floatuns_cvt)))
        return -1;
      return 3514; /* floatunsv4hiv4sf2_exec */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       floatuns_cvt)))
        return -1;
      return 3526; /* floatunsv4siv4sf2_exec */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       floatuns_cvt)))
        return -1;
      return 3538; /* floatunsv4hfv4sf2_exec */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       floatuns_cvt)))
        return -1;
      return 3550; /* floatunsv4sfv4sf2_exec */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       floatuns_cvt)))
        return -1;
      return 3562; /* floatunsv4dfv4sf2_exec */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       floatuns_cvt)))
        return -1;
      return 3574; /* floatunsv4hiv4df2_exec */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       floatuns_cvt)))
        return -1;
      return 3586; /* floatunsv4siv4df2_exec */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       floatuns_cvt)))
        return -1;
      return 3598; /* floatunsv4hfv4df2_exec */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       floatuns_cvt)))
        return -1;
      return 3610; /* floatunsv4sfv4df2_exec */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       floatuns_cvt)))
        return -1;
      return 3622; /* floatunsv4dfv4df2_exec */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       floatuns_cvt)))
        return -1;
      return 3634; /* floatunsv8hiv8hf2_exec */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       floatuns_cvt)))
        return -1;
      return 3646; /* floatunsv8siv8hf2_exec */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       floatuns_cvt)))
        return -1;
      return 3658; /* floatunsv8hfv8hf2_exec */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       floatuns_cvt)))
        return -1;
      return 3670; /* floatunsv8sfv8hf2_exec */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       floatuns_cvt)))
        return -1;
      return 3682; /* floatunsv8dfv8hf2_exec */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       floatuns_cvt)))
        return -1;
      return 3694; /* floatunsv8hiv8sf2_exec */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       floatuns_cvt)))
        return -1;
      return 3706; /* floatunsv8siv8sf2_exec */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       floatuns_cvt)))
        return -1;
      return 3718; /* floatunsv8hfv8sf2_exec */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       floatuns_cvt)))
        return -1;
      return 3730; /* floatunsv8sfv8sf2_exec */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       floatuns_cvt)))
        return -1;
      return 3742; /* floatunsv8dfv8sf2_exec */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       floatuns_cvt)))
        return -1;
      return 3754; /* floatunsv8hiv8df2_exec */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       floatuns_cvt)))
        return -1;
      return 3766; /* floatunsv8siv8df2_exec */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       floatuns_cvt)))
        return -1;
      return 3778; /* floatunsv8hfv8df2_exec */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       floatuns_cvt)))
        return -1;
      return 3790; /* floatunsv8sfv8df2_exec */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       floatuns_cvt)))
        return -1;
      return 3802; /* floatunsv8dfv8df2_exec */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       floatuns_cvt)))
        return -1;
      return 3814; /* floatunsv16hiv16hf2_exec */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       floatuns_cvt)))
        return -1;
      return 3826; /* floatunsv16siv16hf2_exec */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       floatuns_cvt)))
        return -1;
      return 3838; /* floatunsv16hfv16hf2_exec */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       floatuns_cvt)))
        return -1;
      return 3850; /* floatunsv16sfv16hf2_exec */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       floatuns_cvt)))
        return -1;
      return 3862; /* floatunsv16dfv16hf2_exec */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       floatuns_cvt)))
        return -1;
      return 3874; /* floatunsv16hiv16sf2_exec */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       floatuns_cvt)))
        return -1;
      return 3886; /* floatunsv16siv16sf2_exec */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       floatuns_cvt)))
        return -1;
      return 3898; /* floatunsv16hfv16sf2_exec */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       floatuns_cvt)))
        return -1;
      return 3910; /* floatunsv16sfv16sf2_exec */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       floatuns_cvt)))
        return -1;
      return 3922; /* floatunsv16dfv16sf2_exec */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       floatuns_cvt)))
        return -1;
      return 3934; /* floatunsv16hiv16df2_exec */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       floatuns_cvt)))
        return -1;
      return 3946; /* floatunsv16siv16df2_exec */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       floatuns_cvt)))
        return -1;
      return 3958; /* floatunsv16hfv16df2_exec */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       floatuns_cvt)))
        return -1;
      return 3970; /* floatunsv16sfv16df2_exec */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       floatuns_cvt)))
        return -1;
      return 3982; /* floatunsv16dfv16df2_exec */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       floatuns_cvt)))
        return -1;
      return 3994; /* floatunsv32hiv32hf2_exec */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       floatuns_cvt)))
        return -1;
      return 4006; /* floatunsv32siv32hf2_exec */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       floatuns_cvt)))
        return -1;
      return 4018; /* floatunsv32hfv32hf2_exec */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       floatuns_cvt)))
        return -1;
      return 4030; /* floatunsv32sfv32hf2_exec */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       floatuns_cvt)))
        return -1;
      return 4042; /* floatunsv32dfv32hf2_exec */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       floatuns_cvt)))
        return -1;
      return 4054; /* floatunsv32hiv32sf2_exec */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       floatuns_cvt)))
        return -1;
      return 4066; /* floatunsv32siv32sf2_exec */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       floatuns_cvt)))
        return -1;
      return 4078; /* floatunsv32hfv32sf2_exec */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       floatuns_cvt)))
        return -1;
      return 4090; /* floatunsv32sfv32sf2_exec */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       floatuns_cvt)))
        return -1;
      return 4102; /* floatunsv32dfv32sf2_exec */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       floatuns_cvt)))
        return -1;
      return 4114; /* floatunsv32hiv32df2_exec */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       floatuns_cvt)))
        return -1;
      return 4126; /* floatunsv32siv32df2_exec */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       floatuns_cvt)))
        return -1;
      return 4138; /* floatunsv32hfv32df2_exec */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       floatuns_cvt)))
        return -1;
      return 4150; /* floatunsv32sfv32df2_exec */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       floatuns_cvt)))
        return -1;
      return 4162; /* floatunsv32dfv32df2_exec */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       floatuns_cvt)))
        return -1;
      return 4174; /* floatunsv64hiv64hf2_exec */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       floatuns_cvt)))
        return -1;
      return 4186; /* floatunsv64siv64hf2_exec */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       floatuns_cvt)))
        return -1;
      return 4198; /* floatunsv64hfv64hf2_exec */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       floatuns_cvt)))
        return -1;
      return 4210; /* floatunsv64sfv64hf2_exec */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       floatuns_cvt)))
        return -1;
      return 4222; /* floatunsv64dfv64hf2_exec */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       floatuns_cvt)))
        return -1;
      return 4234; /* floatunsv64hiv64sf2_exec */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       floatuns_cvt)))
        return -1;
      return 4246; /* floatunsv64siv64sf2_exec */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       floatuns_cvt)))
        return -1;
      return 4258; /* floatunsv64hfv64sf2_exec */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       floatuns_cvt)))
        return -1;
      return 4270; /* floatunsv64sfv64sf2_exec */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       floatuns_cvt)))
        return -1;
      return 4282; /* floatunsv64dfv64sf2_exec */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       floatuns_cvt)))
        return -1;
      return 4294; /* floatunsv64hiv64df2_exec */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       floatuns_cvt)))
        return -1;
      return 4306; /* floatunsv64siv64df2_exec */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       floatuns_cvt)))
        return -1;
      return 4318; /* floatunsv64hfv64df2_exec */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       floatuns_cvt)))
        return -1;
      return 4330; /* floatunsv64sfv64df2_exec */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       floatuns_cvt)))
        return -1;
      return 4342; /* floatunsv64dfv64df2_exec */

    case 90:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       floatuns_cvt)))
        return -1;
      return 4354; /* floatunsv2hfv2hi2_exec */

    case 91:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       floatuns_cvt)))
        return -1;
      return 4366; /* floatunsv2sfv2hi2_exec */

    case 92:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       floatuns_cvt)))
        return -1;
      return 4378; /* floatunsv2dfv2hi2_exec */

    case 93:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       floatuns_cvt)))
        return -1;
      return 4390; /* floatunsv2hfv2si2_exec */

    case 94:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       floatuns_cvt)))
        return -1;
      return 4402; /* floatunsv2sfv2si2_exec */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       floatuns_cvt)))
        return -1;
      return 4414; /* floatunsv2dfv2si2_exec */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       floatuns_cvt)))
        return -1;
      return 4426; /* floatunsv4hfv4hi2_exec */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       floatuns_cvt)))
        return -1;
      return 4438; /* floatunsv4sfv4hi2_exec */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       floatuns_cvt)))
        return -1;
      return 4450; /* floatunsv4dfv4hi2_exec */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       floatuns_cvt)))
        return -1;
      return 4462; /* floatunsv4hfv4si2_exec */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       floatuns_cvt)))
        return -1;
      return 4474; /* floatunsv4sfv4si2_exec */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       floatuns_cvt)))
        return -1;
      return 4486; /* floatunsv4dfv4si2_exec */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       floatuns_cvt)))
        return -1;
      return 4498; /* floatunsv8hfv8hi2_exec */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       floatuns_cvt)))
        return -1;
      return 4510; /* floatunsv8sfv8hi2_exec */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       floatuns_cvt)))
        return -1;
      return 4522; /* floatunsv8dfv8hi2_exec */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       floatuns_cvt)))
        return -1;
      return 4534; /* floatunsv8hfv8si2_exec */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       floatuns_cvt)))
        return -1;
      return 4546; /* floatunsv8sfv8si2_exec */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       floatuns_cvt)))
        return -1;
      return 4558; /* floatunsv8dfv8si2_exec */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       floatuns_cvt)))
        return -1;
      return 4570; /* floatunsv16hfv16hi2_exec */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       floatuns_cvt)))
        return -1;
      return 4582; /* floatunsv16sfv16hi2_exec */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       floatuns_cvt)))
        return -1;
      return 4594; /* floatunsv16dfv16hi2_exec */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       floatuns_cvt)))
        return -1;
      return 4606; /* floatunsv16hfv16si2_exec */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       floatuns_cvt)))
        return -1;
      return 4618; /* floatunsv16sfv16si2_exec */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       floatuns_cvt)))
        return -1;
      return 4630; /* floatunsv16dfv16si2_exec */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       floatuns_cvt)))
        return -1;
      return 4642; /* floatunsv32hfv32hi2_exec */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       floatuns_cvt)))
        return -1;
      return 4654; /* floatunsv32sfv32hi2_exec */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       floatuns_cvt)))
        return -1;
      return 4666; /* floatunsv32dfv32hi2_exec */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       floatuns_cvt)))
        return -1;
      return 4678; /* floatunsv32hfv32si2_exec */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       floatuns_cvt)))
        return -1;
      return 4690; /* floatunsv32sfv32si2_exec */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       floatuns_cvt)))
        return -1;
      return 4702; /* floatunsv32dfv32si2_exec */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       floatuns_cvt)))
        return -1;
      return 4714; /* floatunsv64hfv64hi2_exec */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       floatuns_cvt)))
        return -1;
      return 4726; /* floatunsv64sfv64hi2_exec */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       floatuns_cvt)))
        return -1;
      return 4738; /* floatunsv64dfv64hi2_exec */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       floatuns_cvt)))
        return -1;
      return 4750; /* floatunsv64hfv64si2_exec */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       floatuns_cvt)))
        return -1;
      return 4762; /* floatunsv64sfv64si2_exec */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       floatuns_cvt)))
        return -1;
      return 4774; /* floatunsv64dfv64si2_exec */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 589; /* vec_extractv4dfv2df_nop */

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8DFmode))
        return -1;
      return 592; /* vec_extractv8dfv2df_nop */

    case E_V16DFmode:
      if (!register_operand (operands[1], E_V16DFmode))
        return -1;
      return 597; /* vec_extractv16dfv2df_nop */

    case E_V32DFmode:
      if (!register_operand (operands[1], E_V32DFmode))
        return -1;
      return 604; /* vec_extractv32dfv2df_nop */

    case E_V64DFmode:
      if (!register_operand (operands[1], E_V64DFmode))
        return -1;
      return 613; /* vec_extractv64dfv2df_nop */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6075; /* extendv2qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6727; /* *extendv2qiv2qi_shift */

    case 1:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6077; /* extendv2hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6733; /* *extendv2hiv2qi_shift */

    case 2:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6079; /* extendv2siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6739; /* *extendv2siv2qi_shift */

    case 3:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6081; /* extendv4qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6745; /* *extendv4qiv2qi_shift */

    case 4:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6083; /* extendv4hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6751; /* *extendv4hiv2qi_shift */

    case 5:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6085; /* extendv4siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6757; /* *extendv4siv2qi_shift */

    case 6:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6087; /* extendv8qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6763; /* *extendv8qiv2qi_shift */

    case 7:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6089; /* extendv8hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6769; /* *extendv8hiv2qi_shift */

    case 8:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6091; /* extendv8siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6775; /* *extendv8siv2qi_shift */

    case 9:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6093; /* extendv16qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6781; /* *extendv16qiv2qi_shift */

    case 10:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6095; /* extendv16hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6787; /* *extendv16hiv2qi_shift */

    case 11:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6097; /* extendv16siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6793; /* *extendv16siv2qi_shift */

    case 12:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6099; /* extendv32qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6799; /* *extendv32qiv2qi_shift */

    case 13:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6101; /* extendv32hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6805; /* *extendv32hiv2qi_shift */

    case 14:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6103; /* extendv32siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6811; /* *extendv32siv2qi_shift */

    case 15:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6105; /* extendv64qiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6817; /* *extendv64qiv2qi_shift */

    case 16:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6107; /* extendv64hiv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6823; /* *extendv64hiv2qi_shift */

    case 17:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6109; /* extendv64siv2qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6829; /* *extendv64siv2qi_shift */

    case 18:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6111; /* extendv2qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6835; /* *extendv2qiv2hi_shift */

    case 19:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6113; /* extendv2hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6841; /* *extendv2hiv2hi_shift */

    case 20:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6115; /* extendv2siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6847; /* *extendv2siv2hi_shift */

    case 21:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6117; /* extendv4qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6853; /* *extendv4qiv2hi_shift */

    case 22:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6119; /* extendv4hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6859; /* *extendv4hiv2hi_shift */

    case 23:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6121; /* extendv4siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6865; /* *extendv4siv2hi_shift */

    case 24:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6123; /* extendv8qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6871; /* *extendv8qiv2hi_shift */

    case 25:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6125; /* extendv8hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6877; /* *extendv8hiv2hi_shift */

    case 26:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6127; /* extendv8siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6883; /* *extendv8siv2hi_shift */

    case 27:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6129; /* extendv16qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6889; /* *extendv16qiv2hi_shift */

    case 28:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6131; /* extendv16hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6895; /* *extendv16hiv2hi_shift */

    case 29:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6133; /* extendv16siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6901; /* *extendv16siv2hi_shift */

    case 30:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6135; /* extendv32qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6907; /* *extendv32qiv2hi_shift */

    case 31:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6137; /* extendv32hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6913; /* *extendv32hiv2hi_shift */

    case 32:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6139; /* extendv32siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6919; /* *extendv32siv2hi_shift */

    case 33:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6141; /* extendv64qiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6925; /* *extendv64qiv2hi_shift */

    case 34:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6143; /* extendv64hiv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6931; /* *extendv64hiv2hi_shift */

    case 35:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6145; /* extendv64siv2hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6937; /* *extendv64siv2hi_shift */

    case 36:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6147; /* extendv2qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6943; /* *extendv2qiv2si_shift */

    case 37:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6149; /* extendv2hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6949; /* *extendv2hiv2si_shift */

    case 38:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6151; /* extendv2siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6955; /* *extendv2siv2si_shift */

    case 39:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6153; /* extendv4qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6961; /* *extendv4qiv2si_shift */

    case 40:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6155; /* extendv4hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6967; /* *extendv4hiv2si_shift */

    case 41:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6157; /* extendv4siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6973; /* *extendv4siv2si_shift */

    case 42:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6159; /* extendv8qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6979; /* *extendv8qiv2si_shift */

    case 43:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6161; /* extendv8hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6985; /* *extendv8hiv2si_shift */

    case 44:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6163; /* extendv8siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6991; /* *extendv8siv2si_shift */

    case 45:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6165; /* extendv16qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6997; /* *extendv16qiv2si_shift */

    case 46:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6167; /* extendv16hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7003; /* *extendv16hiv2si_shift */

    case 47:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6169; /* extendv16siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7009; /* *extendv16siv2si_shift */

    case 48:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6171; /* extendv32qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7015; /* *extendv32qiv2si_shift */

    case 49:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6173; /* extendv32hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7021; /* *extendv32hiv2si_shift */

    case 50:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6175; /* extendv32siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7027; /* *extendv32siv2si_shift */

    case 51:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6177; /* extendv64qiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7033; /* *extendv64qiv2si_shift */

    case 52:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6179; /* extendv64hiv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7039; /* *extendv64hiv2si_shift */

    case 53:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6181; /* extendv64siv2si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7045; /* *extendv64siv2si_shift */

    case 54:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6183; /* extendv2qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7051; /* *extendv2qiv4qi_shift */

    case 55:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6185; /* extendv2hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7057; /* *extendv2hiv4qi_shift */

    case 56:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6187; /* extendv2siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7063; /* *extendv2siv4qi_shift */

    case 57:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6189; /* extendv4qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7069; /* *extendv4qiv4qi_shift */

    case 58:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6191; /* extendv4hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7075; /* *extendv4hiv4qi_shift */

    case 59:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6193; /* extendv4siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7081; /* *extendv4siv4qi_shift */

    case 60:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6195; /* extendv8qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7087; /* *extendv8qiv4qi_shift */

    case 61:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6197; /* extendv8hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7093; /* *extendv8hiv4qi_shift */

    case 62:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6199; /* extendv8siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7099; /* *extendv8siv4qi_shift */

    case 63:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6201; /* extendv16qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7105; /* *extendv16qiv4qi_shift */

    case 64:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6203; /* extendv16hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7111; /* *extendv16hiv4qi_shift */

    case 65:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6205; /* extendv16siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7117; /* *extendv16siv4qi_shift */

    case 66:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6207; /* extendv32qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7123; /* *extendv32qiv4qi_shift */

    case 67:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6209; /* extendv32hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7129; /* *extendv32hiv4qi_shift */

    case 68:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6211; /* extendv32siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7135; /* *extendv32siv4qi_shift */

    case 69:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6213; /* extendv64qiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7141; /* *extendv64qiv4qi_shift */

    case 70:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6215; /* extendv64hiv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7147; /* *extendv64hiv4qi_shift */

    case 71:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6217; /* extendv64siv4qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7153; /* *extendv64siv4qi_shift */

    case 72:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6219; /* extendv2qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7159; /* *extendv2qiv4hi_shift */

    case 73:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6221; /* extendv2hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7165; /* *extendv2hiv4hi_shift */

    case 74:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6223; /* extendv2siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7171; /* *extendv2siv4hi_shift */

    case 75:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6225; /* extendv4qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7177; /* *extendv4qiv4hi_shift */

    case 76:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6227; /* extendv4hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7183; /* *extendv4hiv4hi_shift */

    case 77:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6229; /* extendv4siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7189; /* *extendv4siv4hi_shift */

    case 78:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6231; /* extendv8qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7195; /* *extendv8qiv4hi_shift */

    case 79:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6233; /* extendv8hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7201; /* *extendv8hiv4hi_shift */

    case 80:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6235; /* extendv8siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7207; /* *extendv8siv4hi_shift */

    case 81:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6237; /* extendv16qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7213; /* *extendv16qiv4hi_shift */

    case 82:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6239; /* extendv16hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7219; /* *extendv16hiv4hi_shift */

    case 83:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6241; /* extendv16siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7225; /* *extendv16siv4hi_shift */

    case 84:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6243; /* extendv32qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7231; /* *extendv32qiv4hi_shift */

    case 85:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6245; /* extendv32hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7237; /* *extendv32hiv4hi_shift */

    case 86:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6247; /* extendv32siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7243; /* *extendv32siv4hi_shift */

    case 87:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6249; /* extendv64qiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7249; /* *extendv64qiv4hi_shift */

    case 88:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6251; /* extendv64hiv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7255; /* *extendv64hiv4hi_shift */

    case 89:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6253; /* extendv64siv4hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7261; /* *extendv64siv4hi_shift */

    case 90:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6255; /* extendv2qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7267; /* *extendv2qiv4si_shift */

    case 91:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6257; /* extendv2hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7273; /* *extendv2hiv4si_shift */

    case 92:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6259; /* extendv2siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7279; /* *extendv2siv4si_shift */

    case 93:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6261; /* extendv4qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7285; /* *extendv4qiv4si_shift */

    case 94:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6263; /* extendv4hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7291; /* *extendv4hiv4si_shift */

    case 95:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6265; /* extendv4siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7297; /* *extendv4siv4si_shift */

    case 96:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6267; /* extendv8qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7303; /* *extendv8qiv4si_shift */

    case 97:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6269; /* extendv8hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7309; /* *extendv8hiv4si_shift */

    case 98:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6271; /* extendv8siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7315; /* *extendv8siv4si_shift */

    case 99:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6273; /* extendv16qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7321; /* *extendv16qiv4si_shift */

    case 100:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6275; /* extendv16hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7327; /* *extendv16hiv4si_shift */

    case 101:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6277; /* extendv16siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7333; /* *extendv16siv4si_shift */

    case 102:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6279; /* extendv32qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7339; /* *extendv32qiv4si_shift */

    case 103:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6281; /* extendv32hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7345; /* *extendv32hiv4si_shift */

    case 104:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6283; /* extendv32siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7351; /* *extendv32siv4si_shift */

    case 105:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6285; /* extendv64qiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7357; /* *extendv64qiv4si_shift */

    case 106:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6287; /* extendv64hiv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7363; /* *extendv64hiv4si_shift */

    case 107:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6289; /* extendv64siv4si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7369; /* *extendv64siv4si_shift */

    case 108:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6291; /* extendv2qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7375; /* *extendv2qiv8qi_shift */

    case 109:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6293; /* extendv2hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7381; /* *extendv2hiv8qi_shift */

    case 110:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6295; /* extendv2siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7387; /* *extendv2siv8qi_shift */

    case 111:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6297; /* extendv4qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7393; /* *extendv4qiv8qi_shift */

    case 112:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6299; /* extendv4hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7399; /* *extendv4hiv8qi_shift */

    case 113:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6301; /* extendv4siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7405; /* *extendv4siv8qi_shift */

    case 114:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6303; /* extendv8qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7411; /* *extendv8qiv8qi_shift */

    case 115:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6305; /* extendv8hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7417; /* *extendv8hiv8qi_shift */

    case 116:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6307; /* extendv8siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7423; /* *extendv8siv8qi_shift */

    case 117:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6309; /* extendv16qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7429; /* *extendv16qiv8qi_shift */

    case 118:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6311; /* extendv16hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7435; /* *extendv16hiv8qi_shift */

    case 119:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6313; /* extendv16siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7441; /* *extendv16siv8qi_shift */

    case 120:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6315; /* extendv32qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7447; /* *extendv32qiv8qi_shift */

    case 121:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6317; /* extendv32hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7453; /* *extendv32hiv8qi_shift */

    case 122:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6319; /* extendv32siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7459; /* *extendv32siv8qi_shift */

    case 123:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6321; /* extendv64qiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7465; /* *extendv64qiv8qi_shift */

    case 124:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6323; /* extendv64hiv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7471; /* *extendv64hiv8qi_shift */

    case 125:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6325; /* extendv64siv8qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7477; /* *extendv64siv8qi_shift */

    case 126:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6327; /* extendv2qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7483; /* *extendv2qiv8hi_shift */

    case 127:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6329; /* extendv2hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7489; /* *extendv2hiv8hi_shift */

    case 128:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6331; /* extendv2siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7495; /* *extendv2siv8hi_shift */

    case 129:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6333; /* extendv4qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7501; /* *extendv4qiv8hi_shift */

    case 130:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6335; /* extendv4hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7507; /* *extendv4hiv8hi_shift */

    case 131:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6337; /* extendv4siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7513; /* *extendv4siv8hi_shift */

    case 132:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6339; /* extendv8qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7519; /* *extendv8qiv8hi_shift */

    case 133:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6341; /* extendv8hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7525; /* *extendv8hiv8hi_shift */

    case 134:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6343; /* extendv8siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7531; /* *extendv8siv8hi_shift */

    case 135:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6345; /* extendv16qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7537; /* *extendv16qiv8hi_shift */

    case 136:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6347; /* extendv16hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7543; /* *extendv16hiv8hi_shift */

    case 137:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6349; /* extendv16siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7549; /* *extendv16siv8hi_shift */

    case 138:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6351; /* extendv32qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7555; /* *extendv32qiv8hi_shift */

    case 139:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6353; /* extendv32hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7561; /* *extendv32hiv8hi_shift */

    case 140:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6355; /* extendv32siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7567; /* *extendv32siv8hi_shift */

    case 141:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6357; /* extendv64qiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7573; /* *extendv64qiv8hi_shift */

    case 142:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6359; /* extendv64hiv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7579; /* *extendv64hiv8hi_shift */

    case 143:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6361; /* extendv64siv8hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7585; /* *extendv64siv8hi_shift */

    case 144:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6363; /* extendv2qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7591; /* *extendv2qiv8si_shift */

    case 145:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6365; /* extendv2hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7597; /* *extendv2hiv8si_shift */

    case 146:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6367; /* extendv2siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7603; /* *extendv2siv8si_shift */

    case 147:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6369; /* extendv4qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7609; /* *extendv4qiv8si_shift */

    case 148:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6371; /* extendv4hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7615; /* *extendv4hiv8si_shift */

    case 149:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6373; /* extendv4siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7621; /* *extendv4siv8si_shift */

    case 150:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6375; /* extendv8qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7627; /* *extendv8qiv8si_shift */

    case 151:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6377; /* extendv8hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7633; /* *extendv8hiv8si_shift */

    case 152:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6379; /* extendv8siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7639; /* *extendv8siv8si_shift */

    case 153:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6381; /* extendv16qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7645; /* *extendv16qiv8si_shift */

    case 154:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6383; /* extendv16hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7651; /* *extendv16hiv8si_shift */

    case 155:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6385; /* extendv16siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7657; /* *extendv16siv8si_shift */

    case 156:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6387; /* extendv32qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7663; /* *extendv32qiv8si_shift */

    case 157:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6389; /* extendv32hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7669; /* *extendv32hiv8si_shift */

    case 158:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6391; /* extendv32siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7675; /* *extendv32siv8si_shift */

    case 159:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6393; /* extendv64qiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7681; /* *extendv64qiv8si_shift */

    case 160:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6395; /* extendv64hiv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7687; /* *extendv64hiv8si_shift */

    case 161:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6397; /* extendv64siv8si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7693; /* *extendv64siv8si_shift */

    case 162:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6399; /* extendv2qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7699; /* *extendv2qiv16qi_shift */

    case 163:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6401; /* extendv2hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7705; /* *extendv2hiv16qi_shift */

    case 164:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6403; /* extendv2siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7711; /* *extendv2siv16qi_shift */

    case 165:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6405; /* extendv4qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7717; /* *extendv4qiv16qi_shift */

    case 166:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6407; /* extendv4hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7723; /* *extendv4hiv16qi_shift */

    case 167:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6409; /* extendv4siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7729; /* *extendv4siv16qi_shift */

    case 168:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6411; /* extendv8qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7735; /* *extendv8qiv16qi_shift */

    case 169:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6413; /* extendv8hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7741; /* *extendv8hiv16qi_shift */

    case 170:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6415; /* extendv8siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7747; /* *extendv8siv16qi_shift */

    case 171:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6417; /* extendv16qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7753; /* *extendv16qiv16qi_shift */

    case 172:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6419; /* extendv16hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7759; /* *extendv16hiv16qi_shift */

    case 173:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6421; /* extendv16siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7765; /* *extendv16siv16qi_shift */

    case 174:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6423; /* extendv32qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7771; /* *extendv32qiv16qi_shift */

    case 175:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6425; /* extendv32hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7777; /* *extendv32hiv16qi_shift */

    case 176:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6427; /* extendv32siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7783; /* *extendv32siv16qi_shift */

    case 177:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6429; /* extendv64qiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7789; /* *extendv64qiv16qi_shift */

    case 178:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6431; /* extendv64hiv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7795; /* *extendv64hiv16qi_shift */

    case 179:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6433; /* extendv64siv16qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7801; /* *extendv64siv16qi_shift */

    case 180:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6435; /* extendv2qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7807; /* *extendv2qiv16hi_shift */

    case 181:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6437; /* extendv2hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7813; /* *extendv2hiv16hi_shift */

    case 182:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6439; /* extendv2siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7819; /* *extendv2siv16hi_shift */

    case 183:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6441; /* extendv4qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7825; /* *extendv4qiv16hi_shift */

    case 184:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6443; /* extendv4hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7831; /* *extendv4hiv16hi_shift */

    case 185:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6445; /* extendv4siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7837; /* *extendv4siv16hi_shift */

    case 186:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6447; /* extendv8qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7843; /* *extendv8qiv16hi_shift */

    case 187:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6449; /* extendv8hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7849; /* *extendv8hiv16hi_shift */

    case 188:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6451; /* extendv8siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7855; /* *extendv8siv16hi_shift */

    case 189:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6453; /* extendv16qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7861; /* *extendv16qiv16hi_shift */

    case 190:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6455; /* extendv16hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7867; /* *extendv16hiv16hi_shift */

    case 191:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6457; /* extendv16siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7873; /* *extendv16siv16hi_shift */

    case 192:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6459; /* extendv32qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7879; /* *extendv32qiv16hi_shift */

    case 193:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6461; /* extendv32hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7885; /* *extendv32hiv16hi_shift */

    case 194:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6463; /* extendv32siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7891; /* *extendv32siv16hi_shift */

    case 195:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6465; /* extendv64qiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7897; /* *extendv64qiv16hi_shift */

    case 196:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6467; /* extendv64hiv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7903; /* *extendv64hiv16hi_shift */

    case 197:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6469; /* extendv64siv16hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7909; /* *extendv64siv16hi_shift */

    case 198:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6471; /* extendv2qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7915; /* *extendv2qiv16si_shift */

    case 199:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6473; /* extendv2hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7921; /* *extendv2hiv16si_shift */

    case 200:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6475; /* extendv2siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7927; /* *extendv2siv16si_shift */

    case 201:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6477; /* extendv4qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7933; /* *extendv4qiv16si_shift */

    case 202:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6479; /* extendv4hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7939; /* *extendv4hiv16si_shift */

    case 203:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6481; /* extendv4siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7945; /* *extendv4siv16si_shift */

    case 204:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6483; /* extendv8qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7951; /* *extendv8qiv16si_shift */

    case 205:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6485; /* extendv8hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7957; /* *extendv8hiv16si_shift */

    case 206:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6487; /* extendv8siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7963; /* *extendv8siv16si_shift */

    case 207:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6489; /* extendv16qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7969; /* *extendv16qiv16si_shift */

    case 208:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6491; /* extendv16hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7975; /* *extendv16hiv16si_shift */

    case 209:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6493; /* extendv16siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7981; /* *extendv16siv16si_shift */

    case 210:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6495; /* extendv32qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7987; /* *extendv32qiv16si_shift */

    case 211:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6497; /* extendv32hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7993; /* *extendv32hiv16si_shift */

    case 212:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6499; /* extendv32siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7999; /* *extendv32siv16si_shift */

    case 213:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6501; /* extendv64qiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8005; /* *extendv64qiv16si_shift */

    case 214:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6503; /* extendv64hiv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8011; /* *extendv64hiv16si_shift */

    case 215:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6505; /* extendv64siv16si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8017; /* *extendv64siv16si_shift */

    case 216:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6507; /* extendv2qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8023; /* *extendv2qiv32qi_shift */

    case 217:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6509; /* extendv2hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8029; /* *extendv2hiv32qi_shift */

    case 218:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6511; /* extendv2siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8035; /* *extendv2siv32qi_shift */

    case 219:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6513; /* extendv4qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8041; /* *extendv4qiv32qi_shift */

    case 220:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6515; /* extendv4hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8047; /* *extendv4hiv32qi_shift */

    case 221:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6517; /* extendv4siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8053; /* *extendv4siv32qi_shift */

    case 222:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6519; /* extendv8qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8059; /* *extendv8qiv32qi_shift */

    case 223:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6521; /* extendv8hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8065; /* *extendv8hiv32qi_shift */

    case 224:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6523; /* extendv8siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8071; /* *extendv8siv32qi_shift */

    case 225:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6525; /* extendv16qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8077; /* *extendv16qiv32qi_shift */

    case 226:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6527; /* extendv16hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8083; /* *extendv16hiv32qi_shift */

    case 227:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6529; /* extendv16siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8089; /* *extendv16siv32qi_shift */

    case 228:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6531; /* extendv32qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8095; /* *extendv32qiv32qi_shift */

    case 229:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6533; /* extendv32hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8101; /* *extendv32hiv32qi_shift */

    case 230:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6535; /* extendv32siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8107; /* *extendv32siv32qi_shift */

    case 231:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6537; /* extendv64qiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8113; /* *extendv64qiv32qi_shift */

    case 232:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6539; /* extendv64hiv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8119; /* *extendv64hiv32qi_shift */

    case 233:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6541; /* extendv64siv32qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8125; /* *extendv64siv32qi_shift */

    case 234:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6543; /* extendv2qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8131; /* *extendv2qiv32hi_shift */

    case 235:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6545; /* extendv2hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8137; /* *extendv2hiv32hi_shift */

    case 236:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6547; /* extendv2siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8143; /* *extendv2siv32hi_shift */

    case 237:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6549; /* extendv4qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8149; /* *extendv4qiv32hi_shift */

    case 238:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6551; /* extendv4hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8155; /* *extendv4hiv32hi_shift */

    case 239:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6553; /* extendv4siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8161; /* *extendv4siv32hi_shift */

    case 240:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6555; /* extendv8qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8167; /* *extendv8qiv32hi_shift */

    case 241:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6557; /* extendv8hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8173; /* *extendv8hiv32hi_shift */

    case 242:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6559; /* extendv8siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8179; /* *extendv8siv32hi_shift */

    case 243:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6561; /* extendv16qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8185; /* *extendv16qiv32hi_shift */

    case 244:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6563; /* extendv16hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8191; /* *extendv16hiv32hi_shift */

    case 245:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6565; /* extendv16siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8197; /* *extendv16siv32hi_shift */

    case 246:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6567; /* extendv32qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8203; /* *extendv32qiv32hi_shift */

    case 247:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6569; /* extendv32hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8209; /* *extendv32hiv32hi_shift */

    case 248:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6571; /* extendv32siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8215; /* *extendv32siv32hi_shift */

    case 249:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6573; /* extendv64qiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8221; /* *extendv64qiv32hi_shift */

    case 250:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6575; /* extendv64hiv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8227; /* *extendv64hiv32hi_shift */

    case 251:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6577; /* extendv64siv32hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8233; /* *extendv64siv32hi_shift */

    case 252:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6579; /* extendv2qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8239; /* *extendv2qiv32si_shift */

    case 253:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6581; /* extendv2hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8245; /* *extendv2hiv32si_shift */

    case 254:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6583; /* extendv2siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8251; /* *extendv2siv32si_shift */

    case 255:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6585; /* extendv4qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8257; /* *extendv4qiv32si_shift */

    case 256:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6587; /* extendv4hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8263; /* *extendv4hiv32si_shift */

    case 257:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6589; /* extendv4siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8269; /* *extendv4siv32si_shift */

    case 258:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6591; /* extendv8qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8275; /* *extendv8qiv32si_shift */

    case 259:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6593; /* extendv8hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8281; /* *extendv8hiv32si_shift */

    case 260:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6595; /* extendv8siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8287; /* *extendv8siv32si_shift */

    case 261:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6597; /* extendv16qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8293; /* *extendv16qiv32si_shift */

    case 262:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6599; /* extendv16hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8299; /* *extendv16hiv32si_shift */

    case 263:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6601; /* extendv16siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8305; /* *extendv16siv32si_shift */

    case 264:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6603; /* extendv32qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8311; /* *extendv32qiv32si_shift */

    case 265:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6605; /* extendv32hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8317; /* *extendv32hiv32si_shift */

    case 266:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6607; /* extendv32siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8323; /* *extendv32siv32si_shift */

    case 267:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6609; /* extendv64qiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8329; /* *extendv64qiv32si_shift */

    case 268:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6611; /* extendv64hiv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8335; /* *extendv64hiv32si_shift */

    case 269:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6613; /* extendv64siv32si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8341; /* *extendv64siv32si_shift */

    case 270:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6615; /* extendv2qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8347; /* *extendv2qiv64qi_shift */

    case 271:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6617; /* extendv2hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8353; /* *extendv2hiv64qi_shift */

    case 272:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6619; /* extendv2siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8359; /* *extendv2siv64qi_shift */

    case 273:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6621; /* extendv4qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8365; /* *extendv4qiv64qi_shift */

    case 274:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6623; /* extendv4hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8371; /* *extendv4hiv64qi_shift */

    case 275:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6625; /* extendv4siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8377; /* *extendv4siv64qi_shift */

    case 276:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6627; /* extendv8qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8383; /* *extendv8qiv64qi_shift */

    case 277:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6629; /* extendv8hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8389; /* *extendv8hiv64qi_shift */

    case 278:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6631; /* extendv8siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8395; /* *extendv8siv64qi_shift */

    case 279:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6633; /* extendv16qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8401; /* *extendv16qiv64qi_shift */

    case 280:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6635; /* extendv16hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8407; /* *extendv16hiv64qi_shift */

    case 281:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6637; /* extendv16siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8413; /* *extendv16siv64qi_shift */

    case 282:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6639; /* extendv32qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8419; /* *extendv32qiv64qi_shift */

    case 283:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6641; /* extendv32hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8425; /* *extendv32hiv64qi_shift */

    case 284:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6643; /* extendv32siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8431; /* *extendv32siv64qi_shift */

    case 285:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6645; /* extendv64qiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8437; /* *extendv64qiv64qi_shift */

    case 286:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6647; /* extendv64hiv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8443; /* *extendv64hiv64qi_shift */

    case 287:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6649; /* extendv64siv64qi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8449; /* *extendv64siv64qi_shift */

    case 288:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6651; /* extendv2qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8455; /* *extendv2qiv64hi_shift */

    case 289:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6653; /* extendv2hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8461; /* *extendv2hiv64hi_shift */

    case 290:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6655; /* extendv2siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8467; /* *extendv2siv64hi_shift */

    case 291:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6657; /* extendv4qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8473; /* *extendv4qiv64hi_shift */

    case 292:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6659; /* extendv4hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8479; /* *extendv4hiv64hi_shift */

    case 293:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6661; /* extendv4siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8485; /* *extendv4siv64hi_shift */

    case 294:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6663; /* extendv8qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8491; /* *extendv8qiv64hi_shift */

    case 295:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6665; /* extendv8hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8497; /* *extendv8hiv64hi_shift */

    case 296:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6667; /* extendv8siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8503; /* *extendv8siv64hi_shift */

    case 297:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6669; /* extendv16qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8509; /* *extendv16qiv64hi_shift */

    case 298:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6671; /* extendv16hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8515; /* *extendv16hiv64hi_shift */

    case 299:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6673; /* extendv16siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8521; /* *extendv16siv64hi_shift */

    case 300:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6675; /* extendv32qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8527; /* *extendv32qiv64hi_shift */

    case 301:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6677; /* extendv32hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8533; /* *extendv32hiv64hi_shift */

    case 302:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6679; /* extendv32siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8539; /* *extendv32siv64hi_shift */

    case 303:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6681; /* extendv64qiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8545; /* *extendv64qiv64hi_shift */

    case 304:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6683; /* extendv64hiv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8551; /* *extendv64hiv64hi_shift */

    case 305:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6685; /* extendv64siv64hi_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8557; /* *extendv64siv64hi_shift */

    case 306:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6687; /* extendv2qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8563; /* *extendv2qiv64si_shift */

    case 307:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6689; /* extendv2hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8569; /* *extendv2hiv64si_shift */

    case 308:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6691; /* extendv2siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8575; /* *extendv2siv64si_shift */

    case 309:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6693; /* extendv4qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8581; /* *extendv4qiv64si_shift */

    case 310:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6695; /* extendv4hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8587; /* *extendv4hiv64si_shift */

    case 311:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6697; /* extendv4siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8593; /* *extendv4siv64si_shift */

    case 312:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6699; /* extendv8qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8599; /* *extendv8qiv64si_shift */

    case 313:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6701; /* extendv8hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8605; /* *extendv8hiv64si_shift */

    case 314:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6703; /* extendv8siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8611; /* *extendv8siv64si_shift */

    case 315:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6705; /* extendv16qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8617; /* *extendv16qiv64si_shift */

    case 316:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6707; /* extendv16hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8623; /* *extendv16hiv64si_shift */

    case 317:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6709; /* extendv16siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8629; /* *extendv16siv64si_shift */

    case 318:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6711; /* extendv32qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8635; /* *extendv32qiv64si_shift */

    case 319:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6713; /* extendv32hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8641; /* *extendv32hiv64si_shift */

    case 320:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6715; /* extendv32siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8647; /* *extendv32siv64si_shift */

    case 321:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6717; /* extendv64qiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8653; /* *extendv64qiv64si_shift */

    case 322:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6719; /* extendv64hiv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8659; /* *extendv64hiv64si_shift */

    case 323:
      if (
#line 3572 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 6721; /* extendv64siv64si_sdwa */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 8665; /* *extendv64siv64si_shift */

    case 324:
      return 8703; /* extendv2qiv2di2 */

    case 325:
      return 8705; /* extendv2hiv2di2 */

    case 326:
      return 8707; /* extendv2siv2di2 */

    case 327:
      return 8709; /* extendv4qiv4di2 */

    case 328:
      return 8711; /* extendv4hiv4di2 */

    case 329:
      return 8713; /* extendv4siv4di2 */

    case 330:
      return 8715; /* extendv8qiv8di2 */

    case 331:
      return 8717; /* extendv8hiv8di2 */

    case 332:
      return 8719; /* extendv8siv8di2 */

    case 333:
      return 8721; /* extendv16qiv16di2 */

    case 334:
      return 8723; /* extendv16hiv16di2 */

    case 335:
      return 8725; /* extendv16siv16di2 */

    case 336:
      return 8727; /* extendv32qiv32di2 */

    case 337:
      return 8729; /* extendv32hiv32di2 */

    case 338:
      return 8731; /* extendv32siv32di2 */

    case 339:
      return 8733; /* extendv64qiv64di2 */

    case 340:
      return 8735; /* extendv64hiv64di2 */

    case 341:
      return 8737; /* extendv64siv64di2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      switch (pattern73 (x2))
        {
        case 0:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V2DImode))))
            return NULL;
          return gen_split_353 (insn, operands);

        case 1:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V4DImode))))
            return NULL;
          return gen_split_356 (insn, operands);

        case 2:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V8DImode))))
            return NULL;
          return gen_split_359 (insn, operands);

        case 3:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V16DImode))))
            return NULL;
          return gen_split_362 (insn, operands);

        case 4:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V32DImode))))
            return NULL;
          return gen_split_365 (insn, operands);

        case 5:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V64DImode))))
            return NULL;
          return gen_split_368 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern73 (x2))
        {
        case 0:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V2DImode))))
            return NULL;
          return gen_split_354 (insn, operands);

        case 1:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V4DImode))))
            return NULL;
          return gen_split_357 (insn, operands);

        case 2:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V8DImode))))
            return NULL;
          return gen_split_360 (insn, operands);

        case 3:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V16DImode))))
            return NULL;
          return gen_split_363 (insn, operands);

        case 4:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V32DImode))))
            return NULL;
          return gen_split_366 (insn, operands);

        case 5:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V64DImode))))
            return NULL;
          return gen_split_369 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern73 (x2))
        {
        case 0:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V2DImode))))
            return NULL;
          return gen_split_355 (insn, operands);

        case 1:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V4DImode))))
            return NULL;
          return gen_split_358 (insn, operands);

        case 2:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V8DImode))))
            return NULL;
          return gen_split_361 (insn, operands);

        case 3:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V16DImode))))
            return NULL;
          return gen_split_364 (insn, operands);

        case 4:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V32DImode))))
            return NULL;
          return gen_split_367 (insn, operands);

        case 5:
          if (!
#line 2682 "../../gcc/config/gcn/gcn-valu.md"
((reload_completed && !gcn_ds_memory_operand (operands[0], V64DImode))))
            return NULL;
          return gen_split_370 (insn, operands);

        default:
          return NULL;
        }

    case TRUNCATE:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      if (!gcn_exec_operand (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          if (pattern154 (x2, 
E_V2QImode, 
E_V2DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_449 (insn, operands);

        case E_V2HImode:
          if (pattern154 (x2, 
E_V2HImode, 
E_V2DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_450 (insn, operands);

        case E_V2SImode:
          if (pattern154 (x2, 
E_V2SImode, 
E_V2DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_451 (insn, operands);

        case E_V4QImode:
          if (pattern154 (x2, 
E_V4QImode, 
E_V4DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_452 (insn, operands);

        case E_V4HImode:
          if (pattern154 (x2, 
E_V4HImode, 
E_V4DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_453 (insn, operands);

        case E_V4SImode:
          if (pattern154 (x2, 
E_V4SImode, 
E_V4DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_454 (insn, operands);

        case E_V8QImode:
          if (pattern154 (x2, 
E_V8QImode, 
E_V8DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_455 (insn, operands);

        case E_V8HImode:
          if (pattern154 (x2, 
E_V8HImode, 
E_V8DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_456 (insn, operands);

        case E_V8SImode:
          if (pattern154 (x2, 
E_V8SImode, 
E_V8DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_457 (insn, operands);

        case E_V16QImode:
          if (pattern154 (x2, 
E_V16QImode, 
E_V16DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_458 (insn, operands);

        case E_V16HImode:
          if (pattern154 (x2, 
E_V16HImode, 
E_V16DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_459 (insn, operands);

        case E_V16SImode:
          if (pattern154 (x2, 
E_V16SImode, 
E_V16DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_460 (insn, operands);

        case E_V32QImode:
          if (pattern154 (x2, 
E_V32QImode, 
E_V32DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_461 (insn, operands);

        case E_V32HImode:
          if (pattern154 (x2, 
E_V32HImode, 
E_V32DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_462 (insn, operands);

        case E_V32SImode:
          if (pattern154 (x2, 
E_V32SImode, 
E_V32DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_463 (insn, operands);

        case E_V64QImode:
          if (pattern154 (x2, 
E_V64QImode, 
E_V64DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_464 (insn, operands);

        case E_V64HImode:
          if (pattern154 (x2, 
E_V64HImode, 
E_V64DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_465 (insn, operands);

        case E_V64SImode:
          if (pattern154 (x2, 
E_V64SImode, 
E_V64DImode) != 0
              || !
#line 3636 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_466 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern74 (x2))
        {
        case 0:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_503 (insn, operands);

        case 1:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_505 (insn, operands);

        case 2:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_507 (insn, operands);

        case 3:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_509 (insn, operands);

        case 4:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_511 (insn, operands);

        case 5:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_513 (insn, operands);

        case 6:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_515 (insn, operands);

        case 7:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_517 (insn, operands);

        case 8:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_519 (insn, operands);

        case 9:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_521 (insn, operands);

        case 10:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_523 (insn, operands);

        case 11:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_525 (insn, operands);

        case 12:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_527 (insn, operands);

        case 13:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_529 (insn, operands);

        case 14:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_531 (insn, operands);

        case 15:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_533 (insn, operands);

        case 16:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_535 (insn, operands);

        case 17:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_537 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern74 (x2))
        {
        case 0:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_504 (insn, operands);

        case 1:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_506 (insn, operands);

        case 2:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_508 (insn, operands);

        case 3:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_510 (insn, operands);

        case 4:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_512 (insn, operands);

        case 5:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_514 (insn, operands);

        case 6:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_516 (insn, operands);

        case 7:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_518 (insn, operands);

        case 8:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_520 (insn, operands);

        case 9:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_522 (insn, operands);

        case 10:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_524 (insn, operands);

        case 11:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_526 (insn, operands);

        case 12:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_528 (insn, operands);

        case 13:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_530 (insn, operands);

        case 14:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_532 (insn, operands);

        case 15:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_534 (insn, operands);

        case 16:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_536 (insn, operands);

        case 17:
          if (!
#line 3686 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_538 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
