/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gcn_valu_dst_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gcn_valu_src0_operand (operands[1], i1)
      || !gcn_valu_src1_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      return pattern9 (x3, pnum_clobbers); /* [-1, 13] */

    case VEC_DUPLICATE:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!gcn_alu_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern10 (x3, 
E_V2SImode) != 0)
            return -1;
          return 14;

        case E_V2DImode:
          if (pattern11 (x3, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 15;

        case E_V4SImode:
          if (pattern10 (x3, 
E_V4SImode) != 0)
            return -1;
          return 16;

        case E_V4DImode:
          if (pattern11 (x3, 
E_V4DImode, 
E_V4SImode) != 0)
            return -1;
          return 17;

        case E_V8SImode:
          if (pattern10 (x3, 
E_V8SImode) != 0)
            return -1;
          return 18;

        case E_V8DImode:
          if (pattern11 (x3, 
E_V8DImode, 
E_V8SImode) != 0)
            return -1;
          return 19;

        case E_V16SImode:
          if (pattern10 (x3, 
E_V16SImode) != 0)
            return -1;
          return 20;

        case E_V16DImode:
          if (pattern11 (x3, 
E_V16DImode, 
E_V16SImode) != 0)
            return -1;
          return 21;

        case E_V32SImode:
          if (pattern10 (x3, 
E_V32SImode) != 0)
            return -1;
          return 22;

        case E_V32DImode:
          if (pattern11 (x3, 
E_V32DImode, 
E_V32SImode) != 0)
            return -1;
          return 23;

        case E_V64SImode:
          if (pattern10 (x3, 
E_V64SImode) != 0)
            return -1;
          return 24;

        case E_V64DImode:
          if (pattern11 (x3, 
E_V64DImode, 
E_V64SImode) != 0)
            return -1;
          return 25;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64DImode)
      || GET_MODE (x1) != E_V64DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64QImode:
      if (!gcn_alu_operand (operands[1], E_V64QImode))
        return -1;
      return 0;

    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gcn_valu_dst_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_valu_src0_operand (operands[1], i1)
      || !gcn_valu_src1com_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern42 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8HFmode:
      if (!gcn_alu_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    case E_V8SFmode:
      if (!gcn_alu_operand (operands[1], E_V8SFmode))
        return -1;
      return 3;

    case E_V8DFmode:
      if (!gcn_alu_operand (operands[1], E_V8DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 0;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 1;

    case E_V64HFmode:
      if (!gcn_alu_operand (operands[1], E_V64HFmode))
        return -1;
      return 2;

    case E_V64SFmode:
      if (!gcn_alu_operand (operands[1], E_V64SFmode))
        return -1;
      return 3;

    case E_V64DFmode:
      if (!gcn_alu_operand (operands[1], E_V64DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  if (!gcn_exec_reg_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HFmode:
      return pattern51 (x1, 
E_V2HFmode); /* [-1, 4] */

    case E_V2SFmode:
      res = pattern51 (x1, 
E_V2SFmode);
      if (res >= 0)
        return res + 5; /* [5, 9] */
      return -1;

    case E_V2DFmode:
      res = pattern51 (x1, 
E_V2DFmode);
      if (res >= 0)
        return res + 10; /* [10, 14] */
      return -1;

    case E_V4HFmode:
      res = pattern52 (x1, 
E_V4HFmode);
      if (res >= 0)
        return res + 15; /* [15, 19] */
      return -1;

    case E_V4SFmode:
      res = pattern52 (x1, 
E_V4SFmode);
      if (res >= 0)
        return res + 20; /* [20, 24] */
      return -1;

    case E_V4DFmode:
      res = pattern52 (x1, 
E_V4DFmode);
      if (res >= 0)
        return res + 25; /* [25, 29] */
      return -1;

    case E_V8HFmode:
      res = pattern53 (x1, 
E_V8HFmode);
      if (res >= 0)
        return res + 30; /* [30, 34] */
      return -1;

    case E_V8SFmode:
      res = pattern53 (x1, 
E_V8SFmode);
      if (res >= 0)
        return res + 35; /* [35, 39] */
      return -1;

    case E_V8DFmode:
      res = pattern53 (x1, 
E_V8DFmode);
      if (res >= 0)
        return res + 40; /* [40, 44] */
      return -1;

    case E_V16HFmode:
      res = pattern54 (x1, 
E_V16HFmode);
      if (res >= 0)
        return res + 45; /* [45, 49] */
      return -1;

    case E_V16SFmode:
      res = pattern54 (x1, 
E_V16SFmode);
      if (res >= 0)
        return res + 50; /* [50, 54] */
      return -1;

    case E_V16DFmode:
      res = pattern54 (x1, 
E_V16DFmode);
      if (res >= 0)
        return res + 55; /* [55, 59] */
      return -1;

    case E_V32HFmode:
      res = pattern55 (x1, 
E_V32HFmode);
      if (res >= 0)
        return res + 60; /* [60, 64] */
      return -1;

    case E_V32SFmode:
      res = pattern55 (x1, 
E_V32SFmode);
      if (res >= 0)
        return res + 65; /* [65, 69] */
      return -1;

    case E_V32DFmode:
      res = pattern55 (x1, 
E_V32DFmode);
      if (res >= 0)
        return res + 70; /* [70, 74] */
      return -1;

    case E_V64HFmode:
      res = pattern56 (x1, 
E_V64HFmode);
      if (res >= 0)
        return res + 75; /* [75, 79] */
      return -1;

    case E_V64SFmode:
      res = pattern56 (x1, 
E_V64SFmode);
      if (res >= 0)
        return res + 80; /* [80, 84] */
      return -1;

    case E_V64DFmode:
      res = pattern56 (x1, 
E_V64DFmode);
      if (res >= 0)
        return res + 85; /* [85, 89] */
      return -1;

    case E_V2HImode:
      res = pattern57 (x1, 
E_V2HImode);
      if (res >= 0)
        return res + 90; /* [90, 92] */
      return -1;

    case E_V2SImode:
      res = pattern57 (x1, 
E_V2SImode);
      if (res >= 0)
        return res + 93; /* [93, 95] */
      return -1;

    case E_V4HImode:
      res = pattern58 (x1, 
E_V4HImode);
      if (res >= 0)
        return res + 96; /* [96, 98] */
      return -1;

    case E_V4SImode:
      res = pattern58 (x1, 
E_V4SImode);
      if (res >= 0)
        return res + 99; /* [99, 101] */
      return -1;

    case E_V8HImode:
      res = pattern59 (x1, 
E_V8HImode);
      if (res >= 0)
        return res + 102; /* [102, 104] */
      return -1;

    case E_V8SImode:
      res = pattern59 (x1, 
E_V8SImode);
      if (res >= 0)
        return res + 105; /* [105, 107] */
      return -1;

    case E_V16HImode:
      res = pattern60 (x1, 
E_V16HImode);
      if (res >= 0)
        return res + 108; /* [108, 110] */
      return -1;

    case E_V16SImode:
      res = pattern60 (x1, 
E_V16SImode);
      if (res >= 0)
        return res + 111; /* [111, 113] */
      return -1;

    case E_V32HImode:
      res = pattern61 (x1, 
E_V32HImode);
      if (res >= 0)
        return res + 114; /* [114, 116] */
      return -1;

    case E_V32SImode:
      res = pattern61 (x1, 
E_V32SImode);
      if (res >= 0)
        return res + 117; /* [117, 119] */
      return -1;

    case E_V64HImode:
      res = pattern62 (x1, 
E_V64HImode);
      if (res >= 0)
        return res + 120; /* [120, 122] */
      return -1;

    case E_V64SImode:
      res = pattern62 (x1, 
E_V64SImode);
      if (res >= 0)
        return res + 123; /* [123, 125] */
      return -1;

    default:
      return -1;
    }
}

int
pattern97 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      if (!gcn_alu_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!gcn_alu_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!gcn_alu_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!gcn_alu_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V8QImode:
      if (!gcn_alu_operand (operands[1], E_V8QImode))
        return -1;
      return 6;

    case E_V8HImode:
      if (!gcn_alu_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!gcn_alu_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16QImode:
      if (!gcn_alu_operand (operands[1], E_V16QImode))
        return -1;
      return 9;

    case E_V16HImode:
      if (!gcn_alu_operand (operands[1], E_V16HImode))
        return -1;
      return 10;

    case E_V16SImode:
      if (!gcn_alu_operand (operands[1], E_V16SImode))
        return -1;
      return 11;

    case E_V32QImode:
      if (!gcn_alu_operand (operands[1], E_V32QImode))
        return -1;
      return 12;

    case E_V32HImode:
      if (!gcn_alu_operand (operands[1], E_V32HImode))
        return -1;
      return 13;

    case E_V32SImode:
      if (!gcn_alu_operand (operands[1], E_V32SImode))
        return -1;
      return 14;

    case E_V64QImode:
      if (!gcn_alu_operand (operands[1], E_V64QImode))
        return -1;
      return 15;

    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 16;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 17;

    case E_V16DImode:
      if (!gcn_alu_operand (operands[1], E_V16DImode))
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gcn_alu_operand (operands[2], i2))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i2)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern119 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gcn_alu_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!gcn_alu_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern125 (x1, 
E_V2SImode, 
E_V2DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern125 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern125 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern125 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern125 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern125 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_MODE (x6) != E_DImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x4) != E_DImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (pattern137 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern137 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (pattern137 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 3;

    case E_V16SImode:
      if (pattern137 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
        return -1;
      return 4;

    case E_V32SImode:
      if (pattern137 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
        return -1;
      return 5;

    case E_V64SImode:
      if (pattern137 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != VEC_DUPLICATE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 106
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x3, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return pattern126 (x3); /* [-1, 5] */
}

int
pattern163 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gcn_alu_operand (operands[1], i2)
      || !gcn_alu_operand (operands[2], i2)
      || !gcn_register_or_unspec_operand (operands[3], i2)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !gcn_alu_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 2);
      operands[3] = x7;
      x8 = XVECEXP (x1, 0, 3);
      operands[4] = x8;
      return 0;

    case PLUS:
      x9 = XEXP (x3, 0);
      if (GET_CODE (x9) != VEC_DUPLICATE)
        return -1;
      x10 = XEXP (x3, 1);
      if (GET_CODE (x10) != SIGN_EXTEND)
        return -1;
      x11 = XEXP (x9, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x12 = XEXP (x10, 0);
      operands[1] = x12;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[3] = x6;
      x7 = XVECEXP (x1, 0, 2);
      operands[4] = x7;
      x8 = XVECEXP (x1, 0, 3);
      operands[5] = x8;
      return 1;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!gcn_alu_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x9, 1);
  x13 = XEXP (x12, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x8, 1);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern195 (x1, 
E_V2DImode, 
E_V2SImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern195 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern195 (x1, 
E_V8DImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern195 (x1, 
E_V16DImode, 
E_V16SImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern195 (x1, 
E_V32DImode, 
E_V32SImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern195 (x1, 
E_V64DImode, 
E_V64SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8QImode:
      if (!register_operand (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V8HFmode:
      if (!register_operand (operands[2], E_V8HFmode))
        return -1;
      return 2;

    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode))
        return -1;
      return 3;

    case E_V8SFmode:
      if (!register_operand (operands[2], E_V8SFmode))
        return -1;
      return 4;

    case E_V8DImode:
      if (!register_operand (operands[2], E_V8DImode))
        return -1;
      return 5;

    case E_V8DFmode:
      if (!register_operand (operands[2], E_V8DFmode))
        return -1;
      return 6;

    case E_V8TImode:
      if (!register_operand (operands[2], E_V8TImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[5], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V2DImode)
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[4], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern35 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  switch (pattern180 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V2DImode:
          x4 = XEXP (x3, 1);
          switch (pattern213 (x4, 
E_V2DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 906; /* scatterv2qi_insn_1offset */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 908; /* scatterv2hi_insn_1offset */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 910; /* scatterv2hf_insn_1offset */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 912; /* scatterv2si_insn_1offset */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 914; /* scatterv2sf_insn_1offset */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 916; /* scatterv2di_insn_1offset */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 918; /* scatterv2df_insn_1offset */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 920; /* scatterv2ti_insn_1offset */

            default:
              return -1;
            }

        case E_V4DImode:
          x4 = XEXP (x3, 1);
          switch (pattern214 (x4, 
E_V4DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 922; /* scatterv4qi_insn_1offset */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 924; /* scatterv4hi_insn_1offset */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 926; /* scatterv4hf_insn_1offset */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 928; /* scatterv4si_insn_1offset */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 930; /* scatterv4sf_insn_1offset */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 932; /* scatterv4di_insn_1offset */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 934; /* scatterv4df_insn_1offset */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 936; /* scatterv4ti_insn_1offset */

            default:
              return -1;
            }

        case E_V8DImode:
          x4 = XEXP (x3, 1);
          switch (pattern215 (x4, 
E_V8DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 938; /* scatterv8qi_insn_1offset */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 940; /* scatterv8hi_insn_1offset */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 942; /* scatterv8hf_insn_1offset */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 944; /* scatterv8si_insn_1offset */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 946; /* scatterv8sf_insn_1offset */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 948; /* scatterv8di_insn_1offset */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 950; /* scatterv8df_insn_1offset */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 952; /* scatterv8ti_insn_1offset */

            default:
              return -1;
            }

        case E_V16DImode:
          x4 = XEXP (x3, 1);
          switch (pattern216 (x4, 
E_V16DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 954; /* scatterv16qi_insn_1offset */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 956; /* scatterv16hi_insn_1offset */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 958; /* scatterv16hf_insn_1offset */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 960; /* scatterv16si_insn_1offset */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 962; /* scatterv16sf_insn_1offset */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 964; /* scatterv16di_insn_1offset */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 966; /* scatterv16df_insn_1offset */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 968; /* scatterv16ti_insn_1offset */

            default:
              return -1;
            }

        case E_V32DImode:
          x4 = XEXP (x3, 1);
          switch (pattern217 (x4, 
E_V32DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 970; /* scatterv32qi_insn_1offset */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 972; /* scatterv32hi_insn_1offset */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 974; /* scatterv32hf_insn_1offset */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 976; /* scatterv32si_insn_1offset */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 978; /* scatterv32sf_insn_1offset */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 980; /* scatterv32di_insn_1offset */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 982; /* scatterv32df_insn_1offset */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 984; /* scatterv32ti_insn_1offset */

            default:
              return -1;
            }

        case E_V64DImode:
          x4 = XEXP (x3, 1);
          switch (pattern218 (x4, 
E_V64DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 986; /* scatterv64qi_insn_1offset */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 988; /* scatterv64hi_insn_1offset */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 990; /* scatterv64hf_insn_1offset */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 992; /* scatterv64si_insn_1offset */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 994; /* scatterv64sf_insn_1offset */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 996; /* scatterv64di_insn_1offset */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 998; /* scatterv64df_insn_1offset */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 1000; /* scatterv64ti_insn_1offset */

            default:
              return -1;
            }

        case E_V2SImode:
          x4 = XEXP (x3, 1);
          switch (pattern213 (x4, 
E_V2SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1002; /* scatterv2qi_insn_1offset_ds */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1004; /* scatterv2hi_insn_1offset_ds */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1006; /* scatterv2hf_insn_1offset_ds */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1008; /* scatterv2si_insn_1offset_ds */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1010; /* scatterv2sf_insn_1offset_ds */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1012; /* scatterv2di_insn_1offset_ds */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1014; /* scatterv2df_insn_1offset_ds */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1016; /* scatterv2ti_insn_1offset_ds */

            default:
              return -1;
            }

        case E_V4SImode:
          x4 = XEXP (x3, 1);
          switch (pattern214 (x4, 
E_V4SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1018; /* scatterv4qi_insn_1offset_ds */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1020; /* scatterv4hi_insn_1offset_ds */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1022; /* scatterv4hf_insn_1offset_ds */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1024; /* scatterv4si_insn_1offset_ds */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1026; /* scatterv4sf_insn_1offset_ds */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1028; /* scatterv4di_insn_1offset_ds */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1030; /* scatterv4df_insn_1offset_ds */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1032; /* scatterv4ti_insn_1offset_ds */

            default:
              return -1;
            }

        case E_V8SImode:
          x4 = XEXP (x3, 1);
          switch (pattern215 (x4, 
E_V8SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1034; /* scatterv8qi_insn_1offset_ds */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1036; /* scatterv8hi_insn_1offset_ds */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1038; /* scatterv8hf_insn_1offset_ds */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1040; /* scatterv8si_insn_1offset_ds */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1042; /* scatterv8sf_insn_1offset_ds */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1044; /* scatterv8di_insn_1offset_ds */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1046; /* scatterv8df_insn_1offset_ds */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1048; /* scatterv8ti_insn_1offset_ds */

            default:
              return -1;
            }

        case E_V16SImode:
          x4 = XEXP (x3, 1);
          switch (pattern216 (x4, 
E_V16SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1050; /* scatterv16qi_insn_1offset_ds */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1052; /* scatterv16hi_insn_1offset_ds */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1054; /* scatterv16hf_insn_1offset_ds */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1056; /* scatterv16si_insn_1offset_ds */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1058; /* scatterv16sf_insn_1offset_ds */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1060; /* scatterv16di_insn_1offset_ds */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1062; /* scatterv16df_insn_1offset_ds */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1064; /* scatterv16ti_insn_1offset_ds */

            default:
              return -1;
            }

        case E_V32SImode:
          x4 = XEXP (x3, 1);
          switch (pattern217 (x4, 
E_V32SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1066; /* scatterv32qi_insn_1offset_ds */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1068; /* scatterv32hi_insn_1offset_ds */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1070; /* scatterv32hf_insn_1offset_ds */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1072; /* scatterv32si_insn_1offset_ds */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1074; /* scatterv32sf_insn_1offset_ds */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1076; /* scatterv32di_insn_1offset_ds */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1078; /* scatterv32df_insn_1offset_ds */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1080; /* scatterv32ti_insn_1offset_ds */

            default:
              return -1;
            }

        case E_V64SImode:
          x4 = XEXP (x3, 1);
          switch (pattern218 (x4, 
E_V64SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1082; /* scatterv64qi_insn_1offset_ds */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1084; /* scatterv64hi_insn_1offset_ds */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1086; /* scatterv64hf_insn_1offset_ds */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1088; /* scatterv64si_insn_1offset_ds */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1090; /* scatterv64sf_insn_1offset_ds */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1092; /* scatterv64di_insn_1offset_ds */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1094; /* scatterv64df_insn_1offset_ds */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1096; /* scatterv64ti_insn_1offset_ds */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x3 = XVECEXP (x2, 0, 0);
      switch (pattern221 (x3))
        {
        case 0:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1098; /* scatterv2qi_insn_2offsets */

        case 1:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1100; /* scatterv2hi_insn_2offsets */

        case 2:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1102; /* scatterv2hf_insn_2offsets */

        case 3:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1104; /* scatterv2si_insn_2offsets */

        case 4:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1106; /* scatterv2sf_insn_2offsets */

        case 5:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1108; /* scatterv2di_insn_2offsets */

        case 6:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1110; /* scatterv2df_insn_2offsets */

        case 7:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1112; /* scatterv2ti_insn_2offsets */

        case 8:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1114; /* scatterv4qi_insn_2offsets */

        case 9:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1116; /* scatterv4hi_insn_2offsets */

        case 10:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1118; /* scatterv4hf_insn_2offsets */

        case 11:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1120; /* scatterv4si_insn_2offsets */

        case 12:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1122; /* scatterv4sf_insn_2offsets */

        case 13:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1124; /* scatterv4di_insn_2offsets */

        case 14:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1126; /* scatterv4df_insn_2offsets */

        case 15:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1128; /* scatterv4ti_insn_2offsets */

        case 16:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1130; /* scatterv8qi_insn_2offsets */

        case 17:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1132; /* scatterv8hi_insn_2offsets */

        case 18:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1134; /* scatterv8hf_insn_2offsets */

        case 19:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1136; /* scatterv8si_insn_2offsets */

        case 20:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1138; /* scatterv8sf_insn_2offsets */

        case 21:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1140; /* scatterv8di_insn_2offsets */

        case 22:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1142; /* scatterv8df_insn_2offsets */

        case 23:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1144; /* scatterv8ti_insn_2offsets */

        case 24:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1146; /* scatterv16qi_insn_2offsets */

        case 25:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1148; /* scatterv16hi_insn_2offsets */

        case 26:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1150; /* scatterv16hf_insn_2offsets */

        case 27:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1152; /* scatterv16si_insn_2offsets */

        case 28:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1154; /* scatterv16sf_insn_2offsets */

        case 29:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1156; /* scatterv16di_insn_2offsets */

        case 30:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1158; /* scatterv16df_insn_2offsets */

        case 31:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1160; /* scatterv16ti_insn_2offsets */

        case 32:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1162; /* scatterv32qi_insn_2offsets */

        case 33:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1164; /* scatterv32hi_insn_2offsets */

        case 34:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1166; /* scatterv32hf_insn_2offsets */

        case 35:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1168; /* scatterv32si_insn_2offsets */

        case 36:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1170; /* scatterv32sf_insn_2offsets */

        case 37:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1172; /* scatterv32di_insn_2offsets */

        case 38:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1174; /* scatterv32df_insn_2offsets */

        case 39:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1176; /* scatterv32ti_insn_2offsets */

        case 40:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1178; /* scatterv64qi_insn_2offsets */

        case 41:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1180; /* scatterv64hi_insn_2offsets */

        case 42:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1182; /* scatterv64hf_insn_2offsets */

        case 43:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1184; /* scatterv64si_insn_2offsets */

        case 44:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1186; /* scatterv64sf_insn_2offsets */

        case 45:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1188; /* scatterv64di_insn_2offsets */

        case 46:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1190; /* scatterv64df_insn_2offsets */

        case 47:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1192; /* scatterv64ti_insn_2offsets */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern141 (x2, 
E_V4HImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5068; /* *truncv2qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7156; /* *truncv2qiv4hi_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5072; /* *truncv2hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7162; /* *truncv2hiv4hi_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5076; /* *truncv2siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7168; /* *truncv2siv4hi_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5080; /* *truncv4qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7174; /* *truncv4qiv4hi_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5084; /* *truncv4hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7180; /* *truncv4hiv4hi_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5088; /* *truncv4siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7186; /* *truncv4siv4hi_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5092; /* *truncv8qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7192; /* *truncv8qiv4hi_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5096; /* *truncv8hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7198; /* *truncv8hiv4hi_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5100; /* *truncv8siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7204; /* *truncv8siv4hi_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5104; /* *truncv16qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7210; /* *truncv16qiv4hi_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5108; /* *truncv16hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7216; /* *truncv16hiv4hi_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5112; /* *truncv16siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7222; /* *truncv16siv4hi_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5116; /* *truncv32qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7228; /* *truncv32qiv4hi_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5120; /* *truncv32hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7234; /* *truncv32hiv4hi_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5124; /* *truncv32siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7240; /* *truncv32siv4hi_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5128; /* *truncv64qiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7246; /* *truncv64qiv4hi_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5132; /* *truncv64hiv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7252; /* *truncv64hiv4hi_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 5136; /* *truncv64siv4hi_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7258; /* *truncv64siv4hi_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V4DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V4HImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8689; /* truncv4div4hi2_exec */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern63 (x2))
    {
    case 0:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       extend_cvt)))
        return -1;
      return 3276; /* extendv2hiv2hf2_exec */

    case 1:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       extend_cvt)))
        return -1;
      return 3288; /* extendv2siv2hf2_exec */

    case 2:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       extend_cvt)))
        return -1;
      return 3300; /* extendv2hfv2hf2_exec */

    case 3:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       extend_cvt)))
        return -1;
      return 3312; /* extendv2sfv2hf2_exec */

    case 4:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       extend_cvt)))
        return -1;
      return 3324; /* extendv2dfv2hf2_exec */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       extend_cvt)))
        return -1;
      return 3336; /* extendv2hiv2sf2_exec */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       extend_cvt)))
        return -1;
      return 3348; /* extendv2siv2sf2_exec */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       extend_cvt)))
        return -1;
      return 3360; /* extendv2hfv2sf2_exec */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       extend_cvt)))
        return -1;
      return 3372; /* extendv2sfv2sf2_exec */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       extend_cvt)))
        return -1;
      return 3384; /* extendv2dfv2sf2_exec */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       extend_cvt)))
        return -1;
      return 3396; /* extendv2hiv2df2_exec */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       extend_cvt)))
        return -1;
      return 3408; /* extendv2siv2df2_exec */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       extend_cvt)))
        return -1;
      return 3420; /* extendv2hfv2df2_exec */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       extend_cvt)))
        return -1;
      return 3432; /* extendv2sfv2df2_exec */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       extend_cvt)))
        return -1;
      return 3444; /* extendv2dfv2df2_exec */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       extend_cvt)))
        return -1;
      return 3456; /* extendv4hiv4hf2_exec */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       extend_cvt)))
        return -1;
      return 3468; /* extendv4siv4hf2_exec */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       extend_cvt)))
        return -1;
      return 3480; /* extendv4hfv4hf2_exec */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       extend_cvt)))
        return -1;
      return 3492; /* extendv4sfv4hf2_exec */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       extend_cvt)))
        return -1;
      return 3504; /* extendv4dfv4hf2_exec */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       extend_cvt)))
        return -1;
      return 3516; /* extendv4hiv4sf2_exec */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       extend_cvt)))
        return -1;
      return 3528; /* extendv4siv4sf2_exec */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       extend_cvt)))
        return -1;
      return 3540; /* extendv4hfv4sf2_exec */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       extend_cvt)))
        return -1;
      return 3552; /* extendv4sfv4sf2_exec */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       extend_cvt)))
        return -1;
      return 3564; /* extendv4dfv4sf2_exec */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       extend_cvt)))
        return -1;
      return 3576; /* extendv4hiv4df2_exec */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       extend_cvt)))
        return -1;
      return 3588; /* extendv4siv4df2_exec */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       extend_cvt)))
        return -1;
      return 3600; /* extendv4hfv4df2_exec */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       extend_cvt)))
        return -1;
      return 3612; /* extendv4sfv4df2_exec */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       extend_cvt)))
        return -1;
      return 3624; /* extendv4dfv4df2_exec */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       extend_cvt)))
        return -1;
      return 3636; /* extendv8hiv8hf2_exec */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       extend_cvt)))
        return -1;
      return 3648; /* extendv8siv8hf2_exec */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       extend_cvt)))
        return -1;
      return 3660; /* extendv8hfv8hf2_exec */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       extend_cvt)))
        return -1;
      return 3672; /* extendv8sfv8hf2_exec */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       extend_cvt)))
        return -1;
      return 3684; /* extendv8dfv8hf2_exec */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       extend_cvt)))
        return -1;
      return 3696; /* extendv8hiv8sf2_exec */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       extend_cvt)))
        return -1;
      return 3708; /* extendv8siv8sf2_exec */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       extend_cvt)))
        return -1;
      return 3720; /* extendv8hfv8sf2_exec */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       extend_cvt)))
        return -1;
      return 3732; /* extendv8sfv8sf2_exec */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       extend_cvt)))
        return -1;
      return 3744; /* extendv8dfv8sf2_exec */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       extend_cvt)))
        return -1;
      return 3756; /* extendv8hiv8df2_exec */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       extend_cvt)))
        return -1;
      return 3768; /* extendv8siv8df2_exec */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       extend_cvt)))
        return -1;
      return 3780; /* extendv8hfv8df2_exec */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       extend_cvt)))
        return -1;
      return 3792; /* extendv8sfv8df2_exec */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       extend_cvt)))
        return -1;
      return 3804; /* extendv8dfv8df2_exec */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       extend_cvt)))
        return -1;
      return 3816; /* extendv16hiv16hf2_exec */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       extend_cvt)))
        return -1;
      return 3828; /* extendv16siv16hf2_exec */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       extend_cvt)))
        return -1;
      return 3840; /* extendv16hfv16hf2_exec */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       extend_cvt)))
        return -1;
      return 3852; /* extendv16sfv16hf2_exec */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       extend_cvt)))
        return -1;
      return 3864; /* extendv16dfv16hf2_exec */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       extend_cvt)))
        return -1;
      return 3876; /* extendv16hiv16sf2_exec */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       extend_cvt)))
        return -1;
      return 3888; /* extendv16siv16sf2_exec */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       extend_cvt)))
        return -1;
      return 3900; /* extendv16hfv16sf2_exec */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       extend_cvt)))
        return -1;
      return 3912; /* extendv16sfv16sf2_exec */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       extend_cvt)))
        return -1;
      return 3924; /* extendv16dfv16sf2_exec */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       extend_cvt)))
        return -1;
      return 3936; /* extendv16hiv16df2_exec */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       extend_cvt)))
        return -1;
      return 3948; /* extendv16siv16df2_exec */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       extend_cvt)))
        return -1;
      return 3960; /* extendv16hfv16df2_exec */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       extend_cvt)))
        return -1;
      return 3972; /* extendv16sfv16df2_exec */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       extend_cvt)))
        return -1;
      return 3984; /* extendv16dfv16df2_exec */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       extend_cvt)))
        return -1;
      return 3996; /* extendv32hiv32hf2_exec */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       extend_cvt)))
        return -1;
      return 4008; /* extendv32siv32hf2_exec */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       extend_cvt)))
        return -1;
      return 4020; /* extendv32hfv32hf2_exec */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       extend_cvt)))
        return -1;
      return 4032; /* extendv32sfv32hf2_exec */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       extend_cvt)))
        return -1;
      return 4044; /* extendv32dfv32hf2_exec */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       extend_cvt)))
        return -1;
      return 4056; /* extendv32hiv32sf2_exec */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       extend_cvt)))
        return -1;
      return 4068; /* extendv32siv32sf2_exec */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       extend_cvt)))
        return -1;
      return 4080; /* extendv32hfv32sf2_exec */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       extend_cvt)))
        return -1;
      return 4092; /* extendv32sfv32sf2_exec */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       extend_cvt)))
        return -1;
      return 4104; /* extendv32dfv32sf2_exec */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       extend_cvt)))
        return -1;
      return 4116; /* extendv32hiv32df2_exec */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       extend_cvt)))
        return -1;
      return 4128; /* extendv32siv32df2_exec */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       extend_cvt)))
        return -1;
      return 4140; /* extendv32hfv32df2_exec */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       extend_cvt)))
        return -1;
      return 4152; /* extendv32sfv32df2_exec */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       extend_cvt)))
        return -1;
      return 4164; /* extendv32dfv32df2_exec */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       extend_cvt)))
        return -1;
      return 4176; /* extendv64hiv64hf2_exec */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       extend_cvt)))
        return -1;
      return 4188; /* extendv64siv64hf2_exec */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       extend_cvt)))
        return -1;
      return 4200; /* extendv64hfv64hf2_exec */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       extend_cvt)))
        return -1;
      return 4212; /* extendv64sfv64hf2_exec */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       extend_cvt)))
        return -1;
      return 4224; /* extendv64dfv64hf2_exec */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       extend_cvt)))
        return -1;
      return 4236; /* extendv64hiv64sf2_exec */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       extend_cvt)))
        return -1;
      return 4248; /* extendv64siv64sf2_exec */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       extend_cvt)))
        return -1;
      return 4260; /* extendv64hfv64sf2_exec */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       extend_cvt)))
        return -1;
      return 4272; /* extendv64sfv64sf2_exec */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       extend_cvt)))
        return -1;
      return 4284; /* extendv64dfv64sf2_exec */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       extend_cvt)))
        return -1;
      return 4296; /* extendv64hiv64df2_exec */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       extend_cvt)))
        return -1;
      return 4308; /* extendv64siv64df2_exec */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       extend_cvt)))
        return -1;
      return 4320; /* extendv64hfv64df2_exec */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       extend_cvt)))
        return -1;
      return 4332; /* extendv64sfv64df2_exec */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       extend_cvt)))
        return -1;
      return 4344; /* extendv64dfv64df2_exec */

    case 90:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       extend_cvt)))
        return -1;
      return 4356; /* extendv2hfv2hi2_exec */

    case 91:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       extend_cvt)))
        return -1;
      return 4368; /* extendv2sfv2hi2_exec */

    case 92:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       extend_cvt)))
        return -1;
      return 4380; /* extendv2dfv2hi2_exec */

    case 93:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       extend_cvt)))
        return -1;
      return 4392; /* extendv2hfv2si2_exec */

    case 94:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       extend_cvt)))
        return -1;
      return 4404; /* extendv2sfv2si2_exec */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       extend_cvt)))
        return -1;
      return 4416; /* extendv2dfv2si2_exec */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       extend_cvt)))
        return -1;
      return 4428; /* extendv4hfv4hi2_exec */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       extend_cvt)))
        return -1;
      return 4440; /* extendv4sfv4hi2_exec */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       extend_cvt)))
        return -1;
      return 4452; /* extendv4dfv4hi2_exec */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       extend_cvt)))
        return -1;
      return 4464; /* extendv4hfv4si2_exec */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       extend_cvt)))
        return -1;
      return 4476; /* extendv4sfv4si2_exec */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       extend_cvt)))
        return -1;
      return 4488; /* extendv4dfv4si2_exec */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       extend_cvt)))
        return -1;
      return 4500; /* extendv8hfv8hi2_exec */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       extend_cvt)))
        return -1;
      return 4512; /* extendv8sfv8hi2_exec */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       extend_cvt)))
        return -1;
      return 4524; /* extendv8dfv8hi2_exec */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       extend_cvt)))
        return -1;
      return 4536; /* extendv8hfv8si2_exec */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       extend_cvt)))
        return -1;
      return 4548; /* extendv8sfv8si2_exec */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       extend_cvt)))
        return -1;
      return 4560; /* extendv8dfv8si2_exec */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       extend_cvt)))
        return -1;
      return 4572; /* extendv16hfv16hi2_exec */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       extend_cvt)))
        return -1;
      return 4584; /* extendv16sfv16hi2_exec */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       extend_cvt)))
        return -1;
      return 4596; /* extendv16dfv16hi2_exec */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       extend_cvt)))
        return -1;
      return 4608; /* extendv16hfv16si2_exec */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       extend_cvt)))
        return -1;
      return 4620; /* extendv16sfv16si2_exec */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       extend_cvt)))
        return -1;
      return 4632; /* extendv16dfv16si2_exec */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       extend_cvt)))
        return -1;
      return 4644; /* extendv32hfv32hi2_exec */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       extend_cvt)))
        return -1;
      return 4656; /* extendv32sfv32hi2_exec */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       extend_cvt)))
        return -1;
      return 4668; /* extendv32dfv32hi2_exec */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       extend_cvt)))
        return -1;
      return 4680; /* extendv32hfv32si2_exec */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       extend_cvt)))
        return -1;
      return 4692; /* extendv32sfv32si2_exec */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       extend_cvt)))
        return -1;
      return 4704; /* extendv32dfv32si2_exec */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       extend_cvt)))
        return -1;
      return 4716; /* extendv64hfv64hi2_exec */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       extend_cvt)))
        return -1;
      return 4728; /* extendv64sfv64hi2_exec */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       extend_cvt)))
        return -1;
      return 4740; /* extendv64dfv64hi2_exec */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       extend_cvt)))
        return -1;
      return 4752; /* extendv64hfv64si2_exec */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       extend_cvt)))
        return -1;
      return 4764; /* extendv64sfv64si2_exec */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       extend_cvt)))
        return -1;
      return 4776; /* extendv64dfv64si2_exec */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x2, 2);
  operands[4] = x4;
  if (!gcn_exec_reg_operand (operands[4], E_DImode))
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern44 (x2, 
E_V2QImode) != 0)
                return -1;
              return 1648; /* mulv2qi3_exec */

            case E_V2HImode:
              if (pattern44 (x2, 
E_V2HImode) != 0)
                return -1;
              return 1650; /* mulv2hi3_exec */

            case E_V2SImode:
              if (pattern44 (x2, 
E_V2SImode) != 0)
                return -1;
              return 1652; /* mulv2si3_exec */

            case E_V4QImode:
              if (pattern44 (x2, 
E_V4QImode) != 0)
                return -1;
              return 1654; /* mulv4qi3_exec */

            case E_V4HImode:
              if (pattern44 (x2, 
E_V4HImode) != 0)
                return -1;
              return 1656; /* mulv4hi3_exec */

            case E_V4SImode:
              if (pattern44 (x2, 
E_V4SImode) != 0)
                return -1;
              return 1658; /* mulv4si3_exec */

            case E_V8QImode:
              if (pattern44 (x2, 
E_V8QImode) != 0)
                return -1;
              return 1660; /* mulv8qi3_exec */

            case E_V8HImode:
              if (pattern44 (x2, 
E_V8HImode) != 0)
                return -1;
              return 1662; /* mulv8hi3_exec */

            case E_V8SImode:
              if (pattern44 (x2, 
E_V8SImode) != 0)
                return -1;
              return 1664; /* mulv8si3_exec */

            case E_V16QImode:
              if (pattern44 (x2, 
E_V16QImode) != 0)
                return -1;
              return 1666; /* mulv16qi3_exec */

            case E_V16HImode:
              if (pattern44 (x2, 
E_V16HImode) != 0)
                return -1;
              return 1668; /* mulv16hi3_exec */

            case E_V16SImode:
              if (pattern44 (x2, 
E_V16SImode) != 0)
                return -1;
              return 1670; /* mulv16si3_exec */

            case E_V32QImode:
              if (pattern44 (x2, 
E_V32QImode) != 0)
                return -1;
              return 1672; /* mulv32qi3_exec */

            case E_V32HImode:
              if (pattern44 (x2, 
E_V32HImode) != 0)
                return -1;
              return 1674; /* mulv32hi3_exec */

            case E_V32SImode:
              if (pattern44 (x2, 
E_V32SImode) != 0)
                return -1;
              return 1676; /* mulv32si3_exec */

            case E_V64QImode:
              if (pattern44 (x2, 
E_V64QImode) != 0)
                return -1;
              return 1678; /* mulv64qi3_exec */

            case E_V64HImode:
              if (pattern44 (x2, 
E_V64HImode) != 0)
                return -1;
              return 1680; /* mulv64hi3_exec */

            case E_V64SImode:
              if (pattern44 (x2, 
E_V64SImode) != 0)
                return -1;
              return 1682; /* mulv64si3_exec */

            case E_V2DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V2DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1725; /* mulv2di3_exec */

            case E_V4DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V4DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1726; /* mulv4di3_exec */

            case E_V8DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V8DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1727; /* mulv8di3_exec */

            case E_V16DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V16DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1728; /* mulv16di3_exec */

            case E_V32DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V32DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1729; /* mulv32di3_exec */

            case E_V64DImode:
              if (pnum_clobbers == NULL
                  || pattern44 (x2, 
E_V64DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1730; /* mulv64di3_exec */

            case E_V2HFmode:
              if (pattern44 (x2, 
E_V2HFmode) != 0)
                return -1;
              return 2239; /* mulv2hf3_exec */

            case E_V2SFmode:
              if (pattern44 (x2, 
E_V2SFmode) != 0)
                return -1;
              return 2247; /* mulv2sf3_exec */

            case E_V2DFmode:
              if (pattern44 (x2, 
E_V2DFmode) != 0)
                return -1;
              return 2255; /* mulv2df3_exec */

            case E_V4HFmode:
              if (pattern44 (x2, 
E_V4HFmode) != 0)
                return -1;
              return 2263; /* mulv4hf3_exec */

            case E_V4SFmode:
              if (pattern44 (x2, 
E_V4SFmode) != 0)
                return -1;
              return 2271; /* mulv4sf3_exec */

            case E_V4DFmode:
              if (pattern44 (x2, 
E_V4DFmode) != 0)
                return -1;
              return 2279; /* mulv4df3_exec */

            case E_V8HFmode:
              if (pattern44 (x2, 
E_V8HFmode) != 0)
                return -1;
              return 2287; /* mulv8hf3_exec */

            case E_V8SFmode:
              if (pattern44 (x2, 
E_V8SFmode) != 0)
                return -1;
              return 2295; /* mulv8sf3_exec */

            case E_V8DFmode:
              if (pattern44 (x2, 
E_V8DFmode) != 0)
                return -1;
              return 2303; /* mulv8df3_exec */

            case E_V16HFmode:
              if (pattern44 (x2, 
E_V16HFmode) != 0)
                return -1;
              return 2311; /* mulv16hf3_exec */

            case E_V16SFmode:
              if (pattern44 (x2, 
E_V16SFmode) != 0)
                return -1;
              return 2319; /* mulv16sf3_exec */

            case E_V16DFmode:
              if (pattern44 (x2, 
E_V16DFmode) != 0)
                return -1;
              return 2327; /* mulv16df3_exec */

            case E_V32HFmode:
              if (pattern44 (x2, 
E_V32HFmode) != 0)
                return -1;
              return 2335; /* mulv32hf3_exec */

            case E_V32SFmode:
              if (pattern44 (x2, 
E_V32SFmode) != 0)
                return -1;
              return 2343; /* mulv32sf3_exec */

            case E_V32DFmode:
              if (pattern44 (x2, 
E_V32DFmode) != 0)
                return -1;
              return 2351; /* mulv32df3_exec */

            case E_V64HFmode:
              if (pattern44 (x2, 
E_V64HFmode) != 0)
                return -1;
              return 2359; /* mulv64hf3_exec */

            case E_V64SFmode:
              if (pattern44 (x2, 
E_V64SFmode) != 0)
                return -1;
              return 2367; /* mulv64sf3_exec */

            case E_V64DFmode:
              if (pattern44 (x2, 
E_V64DFmode) != 0)
                return -1;
              return 2375; /* mulv64df3_exec */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern179 (x2, 
E_V2QImode, 
E_QImode) != 0)
                return -1;
              return 1684; /* mulv2qi3_dup_exec */

            case E_V2HImode:
              if (pattern179 (x2, 
E_V2HImode, 
E_HImode) != 0)
                return -1;
              return 1686; /* mulv2hi3_dup_exec */

            case E_V2SImode:
              if (pattern179 (x2, 
E_V2SImode, 
E_SImode) != 0)
                return -1;
              return 1688; /* mulv2si3_dup_exec */

            case E_V4QImode:
              if (pattern179 (x2, 
E_V4QImode, 
E_QImode) != 0)
                return -1;
              return 1690; /* mulv4qi3_dup_exec */

            case E_V4HImode:
              if (pattern179 (x2, 
E_V4HImode, 
E_HImode) != 0)
                return -1;
              return 1692; /* mulv4hi3_dup_exec */

            case E_V4SImode:
              if (pattern179 (x2, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              return 1694; /* mulv4si3_dup_exec */

            case E_V8QImode:
              if (pattern179 (x2, 
E_V8QImode, 
E_QImode) != 0)
                return -1;
              return 1696; /* mulv8qi3_dup_exec */

            case E_V8HImode:
              if (pattern179 (x2, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              return 1698; /* mulv8hi3_dup_exec */

            case E_V8SImode:
              if (pattern179 (x2, 
E_V8SImode, 
E_SImode) != 0)
                return -1;
              return 1700; /* mulv8si3_dup_exec */

            case E_V16QImode:
              if (pattern179 (x2, 
E_V16QImode, 
E_QImode) != 0)
                return -1;
              return 1702; /* mulv16qi3_dup_exec */

            case E_V16HImode:
              if (pattern179 (x2, 
E_V16HImode, 
E_HImode) != 0)
                return -1;
              return 1704; /* mulv16hi3_dup_exec */

            case E_V16SImode:
              if (pattern179 (x2, 
E_V16SImode, 
E_SImode) != 0)
                return -1;
              return 1706; /* mulv16si3_dup_exec */

            case E_V32QImode:
              if (pattern179 (x2, 
E_V32QImode, 
E_QImode) != 0)
                return -1;
              return 1708; /* mulv32qi3_dup_exec */

            case E_V32HImode:
              if (pattern179 (x2, 
E_V32HImode, 
E_HImode) != 0)
                return -1;
              return 1710; /* mulv32hi3_dup_exec */

            case E_V32SImode:
              if (pattern179 (x2, 
E_V32SImode, 
E_SImode) != 0)
                return -1;
              return 1712; /* mulv32si3_dup_exec */

            case E_V64QImode:
              if (pattern179 (x2, 
E_V64QImode, 
E_QImode) != 0)
                return -1;
              return 1714; /* mulv64qi3_dup_exec */

            case E_V64HImode:
              if (pattern179 (x2, 
E_V64HImode, 
E_HImode) != 0)
                return -1;
              return 1716; /* mulv64hi3_dup_exec */

            case E_V64SImode:
              if (pattern179 (x2, 
E_V64SImode, 
E_SImode) != 0)
                return -1;
              return 1718; /* mulv64si3_dup_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x7 = XEXP (x5, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          switch (pattern161 (x2))
            {
            case 0:
              *pnum_clobbers = 1;
              return 1737; /* mulv2di3_zext_exec */

            case 1:
              *pnum_clobbers = 1;
              return 1738; /* mulv4di3_zext_exec */

            case 2:
              *pnum_clobbers = 1;
              return 1739; /* mulv8di3_zext_exec */

            case 3:
              *pnum_clobbers = 1;
              return 1740; /* mulv16di3_zext_exec */

            case 4:
              *pnum_clobbers = 1;
              return 1741; /* mulv32di3_zext_exec */

            case 5:
              *pnum_clobbers = 1;
              return 1742; /* mulv64di3_zext_exec */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern170 (x2))
            {
            case 0:
              *pnum_clobbers = 1;
              return 1749; /* mulv2di3_zext_dup2_exec */

            case 1:
              *pnum_clobbers = 1;
              return 1750; /* mulv4di3_zext_dup2_exec */

            case 2:
              *pnum_clobbers = 1;
              return 1751; /* mulv8di3_zext_dup2_exec */

            case 3:
              *pnum_clobbers = 1;
              return 1752; /* mulv16di3_zext_dup2_exec */

            case 4:
              *pnum_clobbers = 1;
              return 1753; /* mulv32di3_zext_dup2_exec */

            case 5:
              *pnum_clobbers = 1;
              return 1754; /* mulv64di3_zext_dup2_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern25 (x1))
    {
    case 0:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HImode,
		    extend_cvt)))
        return 3121; /* extendhihi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HImode,
		    extend_cvt)))
        return 3127; /* extendsihi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HImode,
		    extend_cvt)))
        return 3133; /* extendhfhi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HImode,
		    extend_cvt)))
        return 3139; /* extendsfhi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HImode,
		    extend_cvt)))
        return -1;
      return 3145; /* extenddfhi2 */

    case 1:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SImode,
		    extend_cvt)))
        return 3151; /* extendhisi2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SImode,
		    extend_cvt)))
        return 3157; /* extendsisi2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SImode,
		    extend_cvt)))
        return 3163; /* extendhfsi2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SImode,
		    extend_cvt)))
        return 3169; /* extendsfsi2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SImode,
		    extend_cvt)))
        return -1;
      return 3175; /* extenddfsi2 */

    case 2:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, HFmode,
		    extend_cvt)))
        return 3181; /* extendhihf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, HFmode,
		    extend_cvt)))
        return 3187; /* extendsihf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, HFmode,
		    extend_cvt)))
        return 3193; /* extendhfhf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, HFmode,
		    extend_cvt)))
        return 3199; /* extendsfhf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, HFmode,
		    extend_cvt)))
        return -1;
      return 3205; /* extenddfhf2 */

    case 3:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, SFmode,
		    extend_cvt)))
        return 3211; /* extendhisf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, SFmode,
		    extend_cvt)))
        return 3217; /* extendsisf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, SFmode,
		    extend_cvt)))
        return 3223; /* extendhfsf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, SFmode,
		    extend_cvt)))
        return 3229; /* extendsfsf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, SFmode,
		    extend_cvt)))
        return -1;
      return 3235; /* extenddfsf2 */

    case 4:
      if (gcn_alu_operand (operands[1], E_HImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HImode, DFmode,
		    extend_cvt)))
        return 3241; /* extendhidf2 */
      if (gcn_alu_operand (operands[1], E_SImode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SImode, DFmode,
		    extend_cvt)))
        return 3247; /* extendsidf2 */
      if (gcn_alu_operand (operands[1], E_HFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (HFmode, DFmode,
		    extend_cvt)))
        return 3253; /* extendhfdf2 */
      if (gcn_alu_operand (operands[1], E_SFmode)
          && 
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (SFmode, DFmode,
		    extend_cvt)))
        return 3259; /* extendsfdf2 */
      if (!gcn_alu_operand (operands[1], E_DFmode)
          || !
#line 3515 "../../gcc/config/gcn/gcn-valu.md"
(gcn_valid_cvt_p (DFmode, DFmode,
		    extend_cvt)))
        return -1;
      return 3265; /* extenddfdf2 */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       extend_cvt)))
        return -1;
      return 3275; /* extendv2hiv2hf2 */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       extend_cvt)))
        return -1;
      return 3287; /* extendv2siv2hf2 */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       extend_cvt)))
        return -1;
      return 3299; /* extendv2hfv2hf2 */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       extend_cvt)))
        return -1;
      return 3311; /* extendv2sfv2hf2 */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       extend_cvt)))
        return -1;
      return 3323; /* extendv2dfv2hf2 */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       extend_cvt)))
        return -1;
      return 3335; /* extendv2hiv2sf2 */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       extend_cvt)))
        return -1;
      return 3347; /* extendv2siv2sf2 */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       extend_cvt)))
        return -1;
      return 3359; /* extendv2hfv2sf2 */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       extend_cvt)))
        return -1;
      return 3371; /* extendv2sfv2sf2 */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       extend_cvt)))
        return -1;
      return 3383; /* extendv2dfv2sf2 */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       extend_cvt)))
        return -1;
      return 3395; /* extendv2hiv2df2 */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       extend_cvt)))
        return -1;
      return 3407; /* extendv2siv2df2 */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       extend_cvt)))
        return -1;
      return 3419; /* extendv2hfv2df2 */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       extend_cvt)))
        return -1;
      return 3431; /* extendv2sfv2df2 */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       extend_cvt)))
        return -1;
      return 3443; /* extendv2dfv2df2 */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       extend_cvt)))
        return -1;
      return 3455; /* extendv4hiv4hf2 */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       extend_cvt)))
        return -1;
      return 3467; /* extendv4siv4hf2 */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       extend_cvt)))
        return -1;
      return 3479; /* extendv4hfv4hf2 */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       extend_cvt)))
        return -1;
      return 3491; /* extendv4sfv4hf2 */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       extend_cvt)))
        return -1;
      return 3503; /* extendv4dfv4hf2 */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       extend_cvt)))
        return -1;
      return 3515; /* extendv4hiv4sf2 */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       extend_cvt)))
        return -1;
      return 3527; /* extendv4siv4sf2 */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       extend_cvt)))
        return -1;
      return 3539; /* extendv4hfv4sf2 */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       extend_cvt)))
        return -1;
      return 3551; /* extendv4sfv4sf2 */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       extend_cvt)))
        return -1;
      return 3563; /* extendv4dfv4sf2 */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       extend_cvt)))
        return -1;
      return 3575; /* extendv4hiv4df2 */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       extend_cvt)))
        return -1;
      return 3587; /* extendv4siv4df2 */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       extend_cvt)))
        return -1;
      return 3599; /* extendv4hfv4df2 */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       extend_cvt)))
        return -1;
      return 3611; /* extendv4sfv4df2 */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       extend_cvt)))
        return -1;
      return 3623; /* extendv4dfv4df2 */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       extend_cvt)))
        return -1;
      return 3635; /* extendv8hiv8hf2 */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       extend_cvt)))
        return -1;
      return 3647; /* extendv8siv8hf2 */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       extend_cvt)))
        return -1;
      return 3659; /* extendv8hfv8hf2 */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       extend_cvt)))
        return -1;
      return 3671; /* extendv8sfv8hf2 */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       extend_cvt)))
        return -1;
      return 3683; /* extendv8dfv8hf2 */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       extend_cvt)))
        return -1;
      return 3695; /* extendv8hiv8sf2 */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       extend_cvt)))
        return -1;
      return 3707; /* extendv8siv8sf2 */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       extend_cvt)))
        return -1;
      return 3719; /* extendv8hfv8sf2 */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       extend_cvt)))
        return -1;
      return 3731; /* extendv8sfv8sf2 */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       extend_cvt)))
        return -1;
      return 3743; /* extendv8dfv8sf2 */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       extend_cvt)))
        return -1;
      return 3755; /* extendv8hiv8df2 */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       extend_cvt)))
        return -1;
      return 3767; /* extendv8siv8df2 */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       extend_cvt)))
        return -1;
      return 3779; /* extendv8hfv8df2 */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       extend_cvt)))
        return -1;
      return 3791; /* extendv8sfv8df2 */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       extend_cvt)))
        return -1;
      return 3803; /* extendv8dfv8df2 */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       extend_cvt)))
        return -1;
      return 3815; /* extendv16hiv16hf2 */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       extend_cvt)))
        return -1;
      return 3827; /* extendv16siv16hf2 */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       extend_cvt)))
        return -1;
      return 3839; /* extendv16hfv16hf2 */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       extend_cvt)))
        return -1;
      return 3851; /* extendv16sfv16hf2 */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       extend_cvt)))
        return -1;
      return 3863; /* extendv16dfv16hf2 */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       extend_cvt)))
        return -1;
      return 3875; /* extendv16hiv16sf2 */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       extend_cvt)))
        return -1;
      return 3887; /* extendv16siv16sf2 */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       extend_cvt)))
        return -1;
      return 3899; /* extendv16hfv16sf2 */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       extend_cvt)))
        return -1;
      return 3911; /* extendv16sfv16sf2 */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       extend_cvt)))
        return -1;
      return 3923; /* extendv16dfv16sf2 */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       extend_cvt)))
        return -1;
      return 3935; /* extendv16hiv16df2 */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       extend_cvt)))
        return -1;
      return 3947; /* extendv16siv16df2 */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       extend_cvt)))
        return -1;
      return 3959; /* extendv16hfv16df2 */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       extend_cvt)))
        return -1;
      return 3971; /* extendv16sfv16df2 */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       extend_cvt)))
        return -1;
      return 3983; /* extendv16dfv16df2 */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       extend_cvt)))
        return -1;
      return 3995; /* extendv32hiv32hf2 */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       extend_cvt)))
        return -1;
      return 4007; /* extendv32siv32hf2 */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       extend_cvt)))
        return -1;
      return 4019; /* extendv32hfv32hf2 */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       extend_cvt)))
        return -1;
      return 4031; /* extendv32sfv32hf2 */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       extend_cvt)))
        return -1;
      return 4043; /* extendv32dfv32hf2 */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       extend_cvt)))
        return -1;
      return 4055; /* extendv32hiv32sf2 */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       extend_cvt)))
        return -1;
      return 4067; /* extendv32siv32sf2 */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       extend_cvt)))
        return -1;
      return 4079; /* extendv32hfv32sf2 */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       extend_cvt)))
        return -1;
      return 4091; /* extendv32sfv32sf2 */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       extend_cvt)))
        return -1;
      return 4103; /* extendv32dfv32sf2 */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       extend_cvt)))
        return -1;
      return 4115; /* extendv32hiv32df2 */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       extend_cvt)))
        return -1;
      return 4127; /* extendv32siv32df2 */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       extend_cvt)))
        return -1;
      return 4139; /* extendv32hfv32df2 */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       extend_cvt)))
        return -1;
      return 4151; /* extendv32sfv32df2 */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       extend_cvt)))
        return -1;
      return 4163; /* extendv32dfv32df2 */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       extend_cvt)))
        return -1;
      return 4175; /* extendv64hiv64hf2 */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       extend_cvt)))
        return -1;
      return 4187; /* extendv64siv64hf2 */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       extend_cvt)))
        return -1;
      return 4199; /* extendv64hfv64hf2 */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       extend_cvt)))
        return -1;
      return 4211; /* extendv64sfv64hf2 */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       extend_cvt)))
        return -1;
      return 4223; /* extendv64dfv64hf2 */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       extend_cvt)))
        return -1;
      return 4235; /* extendv64hiv64sf2 */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       extend_cvt)))
        return -1;
      return 4247; /* extendv64siv64sf2 */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       extend_cvt)))
        return -1;
      return 4259; /* extendv64hfv64sf2 */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       extend_cvt)))
        return -1;
      return 4271; /* extendv64sfv64sf2 */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       extend_cvt)))
        return -1;
      return 4283; /* extendv64dfv64sf2 */

    case 90:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       extend_cvt)))
        return -1;
      return 4295; /* extendv64hiv64df2 */

    case 91:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       extend_cvt)))
        return -1;
      return 4307; /* extendv64siv64df2 */

    case 92:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       extend_cvt)))
        return -1;
      return 4319; /* extendv64hfv64df2 */

    case 93:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       extend_cvt)))
        return -1;
      return 4331; /* extendv64sfv64df2 */

    case 94:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       extend_cvt)))
        return -1;
      return 4343; /* extendv64dfv64df2 */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       extend_cvt)))
        return -1;
      return 4355; /* extendv2hfv2hi2 */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       extend_cvt)))
        return -1;
      return 4367; /* extendv2sfv2hi2 */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       extend_cvt)))
        return -1;
      return 4379; /* extendv2dfv2hi2 */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       extend_cvt)))
        return -1;
      return 4391; /* extendv2hfv2si2 */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       extend_cvt)))
        return -1;
      return 4403; /* extendv2sfv2si2 */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       extend_cvt)))
        return -1;
      return 4415; /* extendv2dfv2si2 */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       extend_cvt)))
        return -1;
      return 4427; /* extendv4hfv4hi2 */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       extend_cvt)))
        return -1;
      return 4439; /* extendv4sfv4hi2 */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       extend_cvt)))
        return -1;
      return 4451; /* extendv4dfv4hi2 */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       extend_cvt)))
        return -1;
      return 4463; /* extendv4hfv4si2 */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       extend_cvt)))
        return -1;
      return 4475; /* extendv4sfv4si2 */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       extend_cvt)))
        return -1;
      return 4487; /* extendv4dfv4si2 */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       extend_cvt)))
        return -1;
      return 4499; /* extendv8hfv8hi2 */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       extend_cvt)))
        return -1;
      return 4511; /* extendv8sfv8hi2 */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       extend_cvt)))
        return -1;
      return 4523; /* extendv8dfv8hi2 */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       extend_cvt)))
        return -1;
      return 4535; /* extendv8hfv8si2 */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       extend_cvt)))
        return -1;
      return 4547; /* extendv8sfv8si2 */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       extend_cvt)))
        return -1;
      return 4559; /* extendv8dfv8si2 */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       extend_cvt)))
        return -1;
      return 4571; /* extendv16hfv16hi2 */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       extend_cvt)))
        return -1;
      return 4583; /* extendv16sfv16hi2 */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       extend_cvt)))
        return -1;
      return 4595; /* extendv16dfv16hi2 */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       extend_cvt)))
        return -1;
      return 4607; /* extendv16hfv16si2 */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       extend_cvt)))
        return -1;
      return 4619; /* extendv16sfv16si2 */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       extend_cvt)))
        return -1;
      return 4631; /* extendv16dfv16si2 */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       extend_cvt)))
        return -1;
      return 4643; /* extendv32hfv32hi2 */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       extend_cvt)))
        return -1;
      return 4655; /* extendv32sfv32hi2 */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       extend_cvt)))
        return -1;
      return 4667; /* extendv32dfv32hi2 */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       extend_cvt)))
        return -1;
      return 4679; /* extendv32hfv32si2 */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       extend_cvt)))
        return -1;
      return 4691; /* extendv32sfv32si2 */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       extend_cvt)))
        return -1;
      return 4703; /* extendv32dfv32si2 */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       extend_cvt)))
        return -1;
      return 4715; /* extendv64hfv64hi2 */

    case 126:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       extend_cvt)))
        return -1;
      return 4727; /* extendv64sfv64hi2 */

    case 127:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       extend_cvt)))
        return -1;
      return 4739; /* extendv64dfv64hi2 */

    case 128:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       extend_cvt)))
        return -1;
      return 4751; /* extendv64hfv64si2 */

    case 129:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       extend_cvt)))
        return -1;
      return 4763; /* extendv64sfv64si2 */

    case 130:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       extend_cvt)))
        return -1;
      return 4775; /* extendv64dfv64si2 */

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (gcn_conditional_register_operand (operands[0], E_BImode))
    {
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (gcn_alu_operand (operands[2], E_SImode)
          && gcn_compare_operator (operands[1], E_BImode))
        {
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (gcn_alu_operand (operands[3], E_SImode))
            return 23; /* cstoresi4 */
        }
      if (gcn_alu_operand (operands[2], E_DImode))
        {
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (gcn_alu_operand (operands[3], E_DImode))
            {
              if (gcn_compare_64bit_operator (operands[1], E_BImode))
                return 24; /* cstoredi4_vec_and_scalar */
              if (gcn_compare_operator (operands[1], E_BImode))
                return 25; /* cstoredi4_vector */
            }
        }
    }
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_BImode:
          if (!gcn_conditional_register_operand (operands[0], E_BImode)
              || !gcn_fp_compare_operator (operands[1], E_BImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_SFmode:
              if (!gcn_alu_operand (operands[2], E_SFmode)
                  || !gcn_alu_operand (operands[3], E_SFmode))
                return -1;
              return 26; /* cstoresf4 */

            case E_DFmode:
              if (!gcn_alu_operand (operands[2], E_DFmode)
                  || !gcn_alu_operand (operands[3], E_DFmode))
                return -1;
              return 27; /* cstoredf4 */

            default:
              return -1;
            }

        case E_DImode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DImode)
              || !gcn_fp_compare_operator (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V2HImode:
              if (!gcn_alu_operand (operands[2], E_V2HImode)
                  || !gcn_vop3_operand (operands[3], E_V2HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8775; /* vec_cmpv2hidi */

            case E_V2HFmode:
              if (!gcn_alu_operand (operands[2], E_V2HFmode)
                  || !gcn_vop3_operand (operands[3], E_V2HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8776; /* vec_cmpv2hfdi */

            case E_V2SImode:
              if (!gcn_alu_operand (operands[2], E_V2SImode)
                  || !gcn_vop3_operand (operands[3], E_V2SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8777; /* vec_cmpv2sidi */

            case E_V2SFmode:
              if (!gcn_alu_operand (operands[2], E_V2SFmode)
                  || !gcn_vop3_operand (operands[3], E_V2SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8778; /* vec_cmpv2sfdi */

            case E_V2DImode:
              if (!gcn_alu_operand (operands[2], E_V2DImode)
                  || !gcn_vop3_operand (operands[3], E_V2DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8779; /* vec_cmpv2didi */

            case E_V2DFmode:
              if (!gcn_alu_operand (operands[2], E_V2DFmode)
                  || !gcn_vop3_operand (operands[3], E_V2DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8780; /* vec_cmpv2dfdi */

            case E_V4HImode:
              if (!gcn_alu_operand (operands[2], E_V4HImode)
                  || !gcn_vop3_operand (operands[3], E_V4HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8781; /* vec_cmpv4hidi */

            case E_V4HFmode:
              if (!gcn_alu_operand (operands[2], E_V4HFmode)
                  || !gcn_vop3_operand (operands[3], E_V4HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8782; /* vec_cmpv4hfdi */

            case E_V4SImode:
              if (!gcn_alu_operand (operands[2], E_V4SImode)
                  || !gcn_vop3_operand (operands[3], E_V4SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8783; /* vec_cmpv4sidi */

            case E_V4SFmode:
              if (!gcn_alu_operand (operands[2], E_V4SFmode)
                  || !gcn_vop3_operand (operands[3], E_V4SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8784; /* vec_cmpv4sfdi */

            case E_V4DImode:
              if (!gcn_alu_operand (operands[2], E_V4DImode)
                  || !gcn_vop3_operand (operands[3], E_V4DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8785; /* vec_cmpv4didi */

            case E_V4DFmode:
              if (!gcn_alu_operand (operands[2], E_V4DFmode)
                  || !gcn_vop3_operand (operands[3], E_V4DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8786; /* vec_cmpv4dfdi */

            case E_V8HImode:
              if (!gcn_alu_operand (operands[2], E_V8HImode)
                  || !gcn_vop3_operand (operands[3], E_V8HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8787; /* vec_cmpv8hidi */

            case E_V8HFmode:
              if (!gcn_alu_operand (operands[2], E_V8HFmode)
                  || !gcn_vop3_operand (operands[3], E_V8HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8788; /* vec_cmpv8hfdi */

            case E_V8SImode:
              if (!gcn_alu_operand (operands[2], E_V8SImode)
                  || !gcn_vop3_operand (operands[3], E_V8SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8789; /* vec_cmpv8sidi */

            case E_V8SFmode:
              if (!gcn_alu_operand (operands[2], E_V8SFmode)
                  || !gcn_vop3_operand (operands[3], E_V8SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8790; /* vec_cmpv8sfdi */

            case E_V8DImode:
              if (!gcn_alu_operand (operands[2], E_V8DImode)
                  || !gcn_vop3_operand (operands[3], E_V8DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8791; /* vec_cmpv8didi */

            case E_V8DFmode:
              if (!gcn_alu_operand (operands[2], E_V8DFmode)
                  || !gcn_vop3_operand (operands[3], E_V8DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8792; /* vec_cmpv8dfdi */

            case E_V16HImode:
              if (!gcn_alu_operand (operands[2], E_V16HImode)
                  || !gcn_vop3_operand (operands[3], E_V16HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8793; /* vec_cmpv16hidi */

            case E_V16HFmode:
              if (!gcn_alu_operand (operands[2], E_V16HFmode)
                  || !gcn_vop3_operand (operands[3], E_V16HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8794; /* vec_cmpv16hfdi */

            case E_V16SImode:
              if (!gcn_alu_operand (operands[2], E_V16SImode)
                  || !gcn_vop3_operand (operands[3], E_V16SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8795; /* vec_cmpv16sidi */

            case E_V16SFmode:
              if (!gcn_alu_operand (operands[2], E_V16SFmode)
                  || !gcn_vop3_operand (operands[3], E_V16SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8796; /* vec_cmpv16sfdi */

            case E_V16DImode:
              if (!gcn_alu_operand (operands[2], E_V16DImode)
                  || !gcn_vop3_operand (operands[3], E_V16DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8797; /* vec_cmpv16didi */

            case E_V16DFmode:
              if (!gcn_alu_operand (operands[2], E_V16DFmode)
                  || !gcn_vop3_operand (operands[3], E_V16DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8798; /* vec_cmpv16dfdi */

            case E_V32HImode:
              if (!gcn_alu_operand (operands[2], E_V32HImode)
                  || !gcn_vop3_operand (operands[3], E_V32HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8799; /* vec_cmpv32hidi */

            case E_V32HFmode:
              if (!gcn_alu_operand (operands[2], E_V32HFmode)
                  || !gcn_vop3_operand (operands[3], E_V32HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8800; /* vec_cmpv32hfdi */

            case E_V32SImode:
              if (!gcn_alu_operand (operands[2], E_V32SImode)
                  || !gcn_vop3_operand (operands[3], E_V32SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8801; /* vec_cmpv32sidi */

            case E_V32SFmode:
              if (!gcn_alu_operand (operands[2], E_V32SFmode)
                  || !gcn_vop3_operand (operands[3], E_V32SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8802; /* vec_cmpv32sfdi */

            case E_V32DImode:
              if (!gcn_alu_operand (operands[2], E_V32DImode)
                  || !gcn_vop3_operand (operands[3], E_V32DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8803; /* vec_cmpv32didi */

            case E_V32DFmode:
              if (!gcn_alu_operand (operands[2], E_V32DFmode)
                  || !gcn_vop3_operand (operands[3], E_V32DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8804; /* vec_cmpv32dfdi */

            case E_V64HImode:
              if (!gcn_alu_operand (operands[2], E_V64HImode)
                  || !gcn_vop3_operand (operands[3], E_V64HImode))
                return -1;
              *pnum_clobbers = 1;
              return 8805; /* vec_cmpv64hidi */

            case E_V64HFmode:
              if (!gcn_alu_operand (operands[2], E_V64HFmode)
                  || !gcn_vop3_operand (operands[3], E_V64HFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8806; /* vec_cmpv64hfdi */

            case E_V64SImode:
              if (!gcn_alu_operand (operands[2], E_V64SImode)
                  || !gcn_vop3_operand (operands[3], E_V64SImode))
                return -1;
              *pnum_clobbers = 1;
              return 8807; /* vec_cmpv64sidi */

            case E_V64SFmode:
              if (!gcn_alu_operand (operands[2], E_V64SFmode)
                  || !gcn_vop3_operand (operands[3], E_V64SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8808; /* vec_cmpv64sfdi */

            case E_V64DImode:
              if (!gcn_alu_operand (operands[2], E_V64DImode)
                  || !gcn_vop3_operand (operands[3], E_V64DImode))
                return -1;
              *pnum_clobbers = 1;
              return 8809; /* vec_cmpv64didi */

            case E_V64DFmode:
              if (!gcn_alu_operand (operands[2], E_V64DFmode)
                  || !gcn_vop3_operand (operands[3], E_V64DFmode))
                return -1;
              *pnum_clobbers = 1;
              return 8810; /* vec_cmpv64dfdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_DImode)
          || !gcn_fp_compare_operator (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      switch (GET_MODE (x4))
        {
        case E_V2HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V2HImode))
            return -1;
          *pnum_clobbers = 1;
          return 8847; /* vec_cmpv2hidi_dup */

        case E_V2HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V2HFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8848; /* vec_cmpv2hfdi_dup */

        case E_V2SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V2SImode))
            return -1;
          *pnum_clobbers = 1;
          return 8849; /* vec_cmpv2sidi_dup */

        case E_V2SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V2SFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8850; /* vec_cmpv2sfdi_dup */

        case E_V2DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V2DImode))
            return -1;
          *pnum_clobbers = 1;
          return 8851; /* vec_cmpv2didi_dup */

        case E_V2DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V2DFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8852; /* vec_cmpv2dfdi_dup */

        case E_V4HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V4HImode))
            return -1;
          *pnum_clobbers = 1;
          return 8853; /* vec_cmpv4hidi_dup */

        case E_V4HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V4HFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8854; /* vec_cmpv4hfdi_dup */

        case E_V4SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V4SImode))
            return -1;
          *pnum_clobbers = 1;
          return 8855; /* vec_cmpv4sidi_dup */

        case E_V4SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V4SFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8856; /* vec_cmpv4sfdi_dup */

        case E_V4DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V4DImode))
            return -1;
          *pnum_clobbers = 1;
          return 8857; /* vec_cmpv4didi_dup */

        case E_V4DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V4DFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8858; /* vec_cmpv4dfdi_dup */

        case E_V8HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V8HImode))
            return -1;
          *pnum_clobbers = 1;
          return 8859; /* vec_cmpv8hidi_dup */

        case E_V8HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V8HFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8860; /* vec_cmpv8hfdi_dup */

        case E_V8SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V8SImode))
            return -1;
          *pnum_clobbers = 1;
          return 8861; /* vec_cmpv8sidi_dup */

        case E_V8SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V8SFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8862; /* vec_cmpv8sfdi_dup */

        case E_V8DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V8DImode))
            return -1;
          *pnum_clobbers = 1;
          return 8863; /* vec_cmpv8didi_dup */

        case E_V8DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V8DFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8864; /* vec_cmpv8dfdi_dup */

        case E_V16HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V16HImode))
            return -1;
          *pnum_clobbers = 1;
          return 8865; /* vec_cmpv16hidi_dup */

        case E_V16HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V16HFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8866; /* vec_cmpv16hfdi_dup */

        case E_V16SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V16SImode))
            return -1;
          *pnum_clobbers = 1;
          return 8867; /* vec_cmpv16sidi_dup */

        case E_V16SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V16SFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8868; /* vec_cmpv16sfdi_dup */

        case E_V16DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V16DImode))
            return -1;
          *pnum_clobbers = 1;
          return 8869; /* vec_cmpv16didi_dup */

        case E_V16DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V16DFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8870; /* vec_cmpv16dfdi_dup */

        case E_V32HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V32HImode))
            return -1;
          *pnum_clobbers = 1;
          return 8871; /* vec_cmpv32hidi_dup */

        case E_V32HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V32HFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8872; /* vec_cmpv32hfdi_dup */

        case E_V32SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V32SImode))
            return -1;
          *pnum_clobbers = 1;
          return 8873; /* vec_cmpv32sidi_dup */

        case E_V32SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V32SFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8874; /* vec_cmpv32sfdi_dup */

        case E_V32DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V32DImode))
            return -1;
          *pnum_clobbers = 1;
          return 8875; /* vec_cmpv32didi_dup */

        case E_V32DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V32DFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8876; /* vec_cmpv32dfdi_dup */

        case E_V64HImode:
          if (!gcn_alu_operand (operands[2], E_HImode)
              || !gcn_vop3_operand (operands[3], E_V64HImode))
            return -1;
          *pnum_clobbers = 1;
          return 8877; /* vec_cmpv64hidi_dup */

        case E_V64HFmode:
          if (!gcn_alu_operand (operands[2], E_HFmode)
              || !gcn_vop3_operand (operands[3], E_V64HFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8878; /* vec_cmpv64hfdi_dup */

        case E_V64SImode:
          if (!gcn_alu_operand (operands[2], E_SImode)
              || !gcn_vop3_operand (operands[3], E_V64SImode))
            return -1;
          *pnum_clobbers = 1;
          return 8879; /* vec_cmpv64sidi_dup */

        case E_V64SFmode:
          if (!gcn_alu_operand (operands[2], E_SFmode)
              || !gcn_vop3_operand (operands[3], E_V64SFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8880; /* vec_cmpv64sfdi_dup */

        case E_V64DImode:
          if (!gcn_alu_operand (operands[2], E_DImode)
              || !gcn_vop3_operand (operands[3], E_V64DImode))
            return -1;
          *pnum_clobbers = 1;
          return 8881; /* vec_cmpv64didi_dup */

        case E_V64DFmode:
          if (!gcn_alu_operand (operands[2], E_DFmode)
              || !gcn_vop3_operand (operands[3], E_V64DFmode))
            return -1;
          *pnum_clobbers = 1;
          return 8882; /* vec_cmpv64dfdi_dup */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (pattern148 (x3, 
E_V2HFmode) != 0)
                return -1;
              return 2831; /* fmav2hf4 */

            case E_V2SFmode:
              if (pattern148 (x3, 
E_V2SFmode) != 0)
                return -1;
              return 2833; /* fmav2sf4 */

            case E_V2DFmode:
              if (pattern148 (x3, 
E_V2DFmode) != 0)
                return -1;
              return 2835; /* fmav2df4 */

            case E_V4HFmode:
              if (pattern148 (x3, 
E_V4HFmode) != 0)
                return -1;
              return 2837; /* fmav4hf4 */

            case E_V4SFmode:
              if (pattern148 (x3, 
E_V4SFmode) != 0)
                return -1;
              return 2839; /* fmav4sf4 */

            case E_V4DFmode:
              if (pattern148 (x3, 
E_V4DFmode) != 0)
                return -1;
              return 2841; /* fmav4df4 */

            case E_V8HFmode:
              if (pattern148 (x3, 
E_V8HFmode) != 0)
                return -1;
              return 2843; /* fmav8hf4 */

            case E_V8SFmode:
              if (pattern148 (x3, 
E_V8SFmode) != 0)
                return -1;
              return 2845; /* fmav8sf4 */

            case E_V8DFmode:
              if (pattern148 (x3, 
E_V8DFmode) != 0)
                return -1;
              return 2847; /* fmav8df4 */

            case E_V16HFmode:
              if (pattern148 (x3, 
E_V16HFmode) != 0)
                return -1;
              return 2849; /* fmav16hf4 */

            case E_V16SFmode:
              if (pattern148 (x3, 
E_V16SFmode) != 0)
                return -1;
              return 2851; /* fmav16sf4 */

            case E_V16DFmode:
              if (pattern148 (x3, 
E_V16DFmode) != 0)
                return -1;
              return 2853; /* fmav16df4 */

            case E_V32HFmode:
              if (pattern148 (x3, 
E_V32HFmode) != 0)
                return -1;
              return 2855; /* fmav32hf4 */

            case E_V32SFmode:
              if (pattern148 (x3, 
E_V32SFmode) != 0)
                return -1;
              return 2857; /* fmav32sf4 */

            case E_V32DFmode:
              if (pattern148 (x3, 
E_V32DFmode) != 0)
                return -1;
              return 2859; /* fmav32df4 */

            case E_V64HFmode:
              if (pattern148 (x3, 
E_V64HFmode) != 0)
                return -1;
              return 2861; /* fmav64hf4 */

            case E_V64SFmode:
              if (pattern148 (x3, 
E_V64SFmode) != 0)
                return -1;
              return 2863; /* fmav64sf4 */

            case E_V64DFmode:
              if (pattern148 (x3, 
E_V64DFmode) != 0)
                return -1;
              return 2865; /* fmav64df4 */

            case E_HFmode:
              if (pattern148 (x3, 
E_HFmode) != 0)
                return -1;
              return 2903; /* fmahf4 */

            case E_SFmode:
              if (pattern148 (x3, 
E_SFmode) != 0)
                return -1;
              return 2904; /* fmasf4 */

            case E_DFmode:
              if (pattern148 (x3, 
E_DFmode) != 0)
                return -1;
              return 2905; /* fmadf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (pattern149 (x3, 
E_V2HFmode) != 0)
                return -1;
              return 2909; /* fmsv2hf4 */

            case E_V2SFmode:
              if (pattern149 (x3, 
E_V2SFmode) != 0)
                return -1;
              return 2911; /* fmsv2sf4 */

            case E_V2DFmode:
              if (pattern149 (x3, 
E_V2DFmode) != 0)
                return -1;
              return 2913; /* fmsv2df4 */

            case E_V4HFmode:
              if (pattern149 (x3, 
E_V4HFmode) != 0)
                return -1;
              return 2915; /* fmsv4hf4 */

            case E_V4SFmode:
              if (pattern149 (x3, 
E_V4SFmode) != 0)
                return -1;
              return 2917; /* fmsv4sf4 */

            case E_V4DFmode:
              if (pattern149 (x3, 
E_V4DFmode) != 0)
                return -1;
              return 2919; /* fmsv4df4 */

            case E_V8HFmode:
              if (pattern149 (x3, 
E_V8HFmode) != 0)
                return -1;
              return 2921; /* fmsv8hf4 */

            case E_V8SFmode:
              if (pattern149 (x3, 
E_V8SFmode) != 0)
                return -1;
              return 2923; /* fmsv8sf4 */

            case E_V8DFmode:
              if (pattern149 (x3, 
E_V8DFmode) != 0)
                return -1;
              return 2925; /* fmsv8df4 */

            case E_V16HFmode:
              if (pattern149 (x3, 
E_V16HFmode) != 0)
                return -1;
              return 2927; /* fmsv16hf4 */

            case E_V16SFmode:
              if (pattern149 (x3, 
E_V16SFmode) != 0)
                return -1;
              return 2929; /* fmsv16sf4 */

            case E_V16DFmode:
              if (pattern149 (x3, 
E_V16DFmode) != 0)
                return -1;
              return 2931; /* fmsv16df4 */

            case E_V32HFmode:
              if (pattern149 (x3, 
E_V32HFmode) != 0)
                return -1;
              return 2933; /* fmsv32hf4 */

            case E_V32SFmode:
              if (pattern149 (x3, 
E_V32SFmode) != 0)
                return -1;
              return 2935; /* fmsv32sf4 */

            case E_V32DFmode:
              if (pattern149 (x3, 
E_V32DFmode) != 0)
                return -1;
              return 2937; /* fmsv32df4 */

            case E_V64HFmode:
              if (pattern149 (x3, 
E_V64HFmode) != 0)
                return -1;
              return 2939; /* fmsv64hf4 */

            case E_V64SFmode:
              if (pattern149 (x3, 
E_V64SFmode) != 0)
                return -1;
              return 2941; /* fmsv64sf4 */

            case E_V64DFmode:
              if (pattern149 (x3, 
E_V64DFmode) != 0)
                return -1;
              return 2943; /* fmsv64df4 */

            case E_HFmode:
              if (pattern149 (x3, 
E_HFmode) != 0)
                return -1;
              return 2981; /* fmshf4 */

            case E_SFmode:
              if (pattern149 (x3, 
E_SFmode) != 0)
                return -1;
              return 2982; /* fmssf4 */

            case E_DFmode:
              if (pattern149 (x3, 
E_DFmode) != 0)
                return -1;
              return 2983; /* fmsdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (pattern150 (x3, 
E_V2HFmode) != 0)
                return -1;
              return 2867; /* fmav2hf4_negop2 */

            case E_V2SFmode:
              if (pattern150 (x3, 
E_V2SFmode) != 0)
                return -1;
              return 2869; /* fmav2sf4_negop2 */

            case E_V2DFmode:
              if (pattern150 (x3, 
E_V2DFmode) != 0)
                return -1;
              return 2871; /* fmav2df4_negop2 */

            case E_V4HFmode:
              if (pattern150 (x3, 
E_V4HFmode) != 0)
                return -1;
              return 2873; /* fmav4hf4_negop2 */

            case E_V4SFmode:
              if (pattern150 (x3, 
E_V4SFmode) != 0)
                return -1;
              return 2875; /* fmav4sf4_negop2 */

            case E_V4DFmode:
              if (pattern150 (x3, 
E_V4DFmode) != 0)
                return -1;
              return 2877; /* fmav4df4_negop2 */

            case E_V8HFmode:
              if (pattern150 (x3, 
E_V8HFmode) != 0)
                return -1;
              return 2879; /* fmav8hf4_negop2 */

            case E_V8SFmode:
              if (pattern150 (x3, 
E_V8SFmode) != 0)
                return -1;
              return 2881; /* fmav8sf4_negop2 */

            case E_V8DFmode:
              if (pattern150 (x3, 
E_V8DFmode) != 0)
                return -1;
              return 2883; /* fmav8df4_negop2 */

            case E_V16HFmode:
              if (pattern150 (x3, 
E_V16HFmode) != 0)
                return -1;
              return 2885; /* fmav16hf4_negop2 */

            case E_V16SFmode:
              if (pattern150 (x3, 
E_V16SFmode) != 0)
                return -1;
              return 2887; /* fmav16sf4_negop2 */

            case E_V16DFmode:
              if (pattern150 (x3, 
E_V16DFmode) != 0)
                return -1;
              return 2889; /* fmav16df4_negop2 */

            case E_V32HFmode:
              if (pattern150 (x3, 
E_V32HFmode) != 0)
                return -1;
              return 2891; /* fmav32hf4_negop2 */

            case E_V32SFmode:
              if (pattern150 (x3, 
E_V32SFmode) != 0)
                return -1;
              return 2893; /* fmav32sf4_negop2 */

            case E_V32DFmode:
              if (pattern150 (x3, 
E_V32DFmode) != 0)
                return -1;
              return 2895; /* fmav32df4_negop2 */

            case E_V64HFmode:
              if (pattern150 (x3, 
E_V64HFmode) != 0)
                return -1;
              return 2897; /* fmav64hf4_negop2 */

            case E_V64SFmode:
              if (pattern150 (x3, 
E_V64SFmode) != 0)
                return -1;
              return 2899; /* fmav64sf4_negop2 */

            case E_V64DFmode:
              if (pattern150 (x3, 
E_V64DFmode) != 0)
                return -1;
              return 2901; /* fmav64df4_negop2 */

            case E_HFmode:
              if (pattern150 (x3, 
E_HFmode) != 0)
                return -1;
              return 2906; /* fmahf4_negop2 */

            case E_SFmode:
              if (pattern150 (x3, 
E_SFmode) != 0)
                return -1;
              return 2907; /* fmasf4_negop2 */

            case E_DFmode:
              if (pattern150 (x3, 
E_DFmode) != 0)
                return -1;
              return 2908; /* fmadf4_negop2 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (pattern151 (x3, 
E_V2HFmode) != 0)
                return -1;
              return 2945; /* fmsv2hf4_negop2 */

            case E_V2SFmode:
              if (pattern151 (x3, 
E_V2SFmode) != 0)
                return -1;
              return 2947; /* fmsv2sf4_negop2 */

            case E_V2DFmode:
              if (pattern151 (x3, 
E_V2DFmode) != 0)
                return -1;
              return 2949; /* fmsv2df4_negop2 */

            case E_V4HFmode:
              if (pattern151 (x3, 
E_V4HFmode) != 0)
                return -1;
              return 2951; /* fmsv4hf4_negop2 */

            case E_V4SFmode:
              if (pattern151 (x3, 
E_V4SFmode) != 0)
                return -1;
              return 2953; /* fmsv4sf4_negop2 */

            case E_V4DFmode:
              if (pattern151 (x3, 
E_V4DFmode) != 0)
                return -1;
              return 2955; /* fmsv4df4_negop2 */

            case E_V8HFmode:
              if (pattern151 (x3, 
E_V8HFmode) != 0)
                return -1;
              return 2957; /* fmsv8hf4_negop2 */

            case E_V8SFmode:
              if (pattern151 (x3, 
E_V8SFmode) != 0)
                return -1;
              return 2959; /* fmsv8sf4_negop2 */

            case E_V8DFmode:
              if (pattern151 (x3, 
E_V8DFmode) != 0)
                return -1;
              return 2961; /* fmsv8df4_negop2 */

            case E_V16HFmode:
              if (pattern151 (x3, 
E_V16HFmode) != 0)
                return -1;
              return 2963; /* fmsv16hf4_negop2 */

            case E_V16SFmode:
              if (pattern151 (x3, 
E_V16SFmode) != 0)
                return -1;
              return 2965; /* fmsv16sf4_negop2 */

            case E_V16DFmode:
              if (pattern151 (x3, 
E_V16DFmode) != 0)
                return -1;
              return 2967; /* fmsv16df4_negop2 */

            case E_V32HFmode:
              if (pattern151 (x3, 
E_V32HFmode) != 0)
                return -1;
              return 2969; /* fmsv32hf4_negop2 */

            case E_V32SFmode:
              if (pattern151 (x3, 
E_V32SFmode) != 0)
                return -1;
              return 2971; /* fmsv32sf4_negop2 */

            case E_V32DFmode:
              if (pattern151 (x3, 
E_V32DFmode) != 0)
                return -1;
              return 2973; /* fmsv32df4_negop2 */

            case E_V64HFmode:
              if (pattern151 (x3, 
E_V64HFmode) != 0)
                return -1;
              return 2975; /* fmsv64hf4_negop2 */

            case E_V64SFmode:
              if (pattern151 (x3, 
E_V64SFmode) != 0)
                return -1;
              return 2977; /* fmsv64sf4_negop2 */

            case E_V64DFmode:
              if (pattern151 (x3, 
E_V64DFmode) != 0)
                return -1;
              return 2979; /* fmsv64df4_negop2 */

            case E_HFmode:
              if (pattern151 (x3, 
E_HFmode) != 0)
                return -1;
              return 2984; /* fmshf4_negop2 */

            case E_SFmode:
              if (pattern151 (x3, 
E_SFmode) != 0)
                return -1;
              return 2985; /* fmssf4_negop2 */

            case E_DFmode:
              if (pattern151 (x3, 
E_DFmode) != 0)
                return -1;
              return 2986; /* fmsdf4_negop2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG)
            return -1;
          switch (REGNO (x7))
            {
            case 129:
              if (GET_MODE (x7) != E_BImode
                  || pattern78 (x3, 
E_DImode) != 0)
                return -1;
              return 36; /* subdi3 */

            case 106:
              if (GET_MODE (x7) != E_DImode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V2QImode:
                  if (pattern78 (x3, 
E_V2QImode) != 0)
                    return -1;
                  return 1464; /* subv2qi3 */

                case E_V2HImode:
                  if (pattern78 (x3, 
E_V2HImode) != 0)
                    return -1;
                  return 1466; /* subv2hi3 */

                case E_V2SImode:
                  if (pattern78 (x3, 
E_V2SImode) != 0)
                    return -1;
                  return 1468; /* subv2si3 */

                case E_V4QImode:
                  if (pattern78 (x3, 
E_V4QImode) != 0)
                    return -1;
                  return 1470; /* subv4qi3 */

                case E_V4HImode:
                  if (pattern78 (x3, 
E_V4HImode) != 0)
                    return -1;
                  return 1472; /* subv4hi3 */

                case E_V4SImode:
                  if (pattern78 (x3, 
E_V4SImode) != 0)
                    return -1;
                  return 1474; /* subv4si3 */

                case E_V8QImode:
                  if (pattern78 (x3, 
E_V8QImode) != 0)
                    return -1;
                  return 1476; /* subv8qi3 */

                case E_V8HImode:
                  if (pattern78 (x3, 
E_V8HImode) != 0)
                    return -1;
                  return 1478; /* subv8hi3 */

                case E_V8SImode:
                  if (pattern78 (x3, 
E_V8SImode) != 0)
                    return -1;
                  return 1480; /* subv8si3 */

                case E_V16QImode:
                  if (pattern78 (x3, 
E_V16QImode) != 0)
                    return -1;
                  return 1482; /* subv16qi3 */

                case E_V16HImode:
                  if (pattern78 (x3, 
E_V16HImode) != 0)
                    return -1;
                  return 1484; /* subv16hi3 */

                case E_V16SImode:
                  if (pattern78 (x3, 
E_V16SImode) != 0)
                    return -1;
                  return 1486; /* subv16si3 */

                case E_V32QImode:
                  if (pattern78 (x3, 
E_V32QImode) != 0)
                    return -1;
                  return 1488; /* subv32qi3 */

                case E_V32HImode:
                  if (pattern78 (x3, 
E_V32HImode) != 0)
                    return -1;
                  return 1490; /* subv32hi3 */

                case E_V32SImode:
                  if (pattern78 (x3, 
E_V32SImode) != 0)
                    return -1;
                  return 1492; /* subv32si3 */

                case E_V64QImode:
                  if (pattern78 (x3, 
E_V64QImode) != 0)
                    return -1;
                  return 1494; /* subv64qi3 */

                case E_V64HImode:
                  if (pattern78 (x3, 
E_V64HImode) != 0)
                    return -1;
                  return 1496; /* subv64hi3 */

                case E_V64SImode:
                  if (pattern78 (x3, 
E_V64SImode) != 0)
                    return -1;
                  return 1498; /* subv64si3 */

                case E_V2DImode:
                  if (pattern78 (x3, 
E_V2DImode) != 0)
                    return -1;
                  return 1536; /* subv2di3 */

                case E_V4DImode:
                  if (pattern78 (x3, 
E_V4DImode) != 0)
                    return -1;
                  return 1537; /* subv4di3 */

                case E_V8DImode:
                  if (pattern78 (x3, 
E_V8DImode) != 0)
                    return -1;
                  return 1538; /* subv8di3 */

                case E_V16DImode:
                  if (pattern78 (x3, 
E_V16DImode) != 0)
                    return -1;
                  return 1539; /* subv16di3 */

                case E_V32DImode:
                  if (pattern78 (x3, 
E_V32DImode) != 0)
                    return -1;
                  return 1540; /* subv32di3 */

                case E_V64DImode:
                  if (pattern78 (x3, 
E_V64DImode) != 0)
                    return -1;
                  return 1541; /* subv64di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SET:
          x8 = XEXP (x6, 1);
          switch (GET_CODE (x8))
            {
            case GTU:
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != MINUS)
                return -1;
              if (GET_MODE (x9) == E_SImode)
                {
                  x7 = XEXP (x6, 0);
                  if (GET_CODE (x7) == REG
                      && REGNO (x7) == 129
                      && GET_MODE (x7) == E_BImode
                      && pattern78 (x3, 
E_SImode) == 0
                      && pattern191 (x8, 
E_BImode) == 0)
                    return 37; /* subsi3_scalar_carry */
                }
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              if (!register_operand (operands[3], E_DImode)
                  || pattern191 (x8, 
E_DImode) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (pattern206 (x1, 
E_V2SImode) != 0)
                    return -1;
                  return 1500; /* subv2si3_vcc */

                case E_V4SImode:
                  if (pattern206 (x1, 
E_V4SImode) != 0)
                    return -1;
                  return 1502; /* subv4si3_vcc */

                case E_V8SImode:
                  if (pattern206 (x1, 
E_V8SImode) != 0)
                    return -1;
                  return 1504; /* subv8si3_vcc */

                case E_V16SImode:
                  if (pattern206 (x1, 
E_V16SImode) != 0)
                    return -1;
                  return 1506; /* subv16si3_vcc */

                case E_V32SImode:
                  if (pattern206 (x1, 
E_V32SImode) != 0)
                    return -1;
                  return 1508; /* subv32si3_vcc */

                case E_V64SImode:
                  if (pattern206 (x1, 
E_V64SImode) != 0)
                    return -1;
                  return 1510; /* subv64si3_vcc */

                default:
                  return -1;
                }

            case LEU:
              if (GET_MODE (x8) != E_BImode)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != MINUS
                  || GET_MODE (x9) != E_SImode)
                return -1;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 129
                  || GET_MODE (x7) != E_BImode
                  || pattern188 (x3) != 0)
                return -1;
              x10 = XEXP (x8, 1);
              operands[3] = x10;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x11 = XEXP (x9, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x12 = XEXP (x9, 1);
              if (!rtx_equal_p (x12, operands[2])
                  || !
#line 1387 "../../gcc/config/gcn/gcn.md"
(INTVAL (operands[2]) == -INTVAL (operands[3])))
                return -1;
              return 38; /* subsi3_scalar_carry_cst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern101 (x6, 
MINUS, 
GTU) != 0)
        return -1;
      x13 = XEXP (x4, 1);
      operands[1] = x13;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x8 = XEXP (x6, 1);
      x9 = XEXP (x8, 0);
      x11 = XEXP (x9, 0);
      x14 = XEXP (x11, 0);
      x15 = XEXP (x14, 1);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x16 = XEXP (x11, 1);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      switch (pattern197 (x1))
        {
        case 0:
          x17 = XEXP (x4, 0);
          x18 = XEXP (x17, 0);
          if (GET_CODE (x18) != REG
              || REGNO (x18) != 129
              || GET_MODE (x18) != E_BImode)
            return -1;
          x19 = XEXP (x14, 0);
          if (GET_CODE (x19) != ZERO_EXTEND
              || GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XEXP (x19, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 129
              || GET_MODE (x20) != E_BImode)
            return -1;
          x10 = XEXP (x8, 1);
          if (GET_CODE (x10) != GTU
              || GET_MODE (x10) != E_BImode)
            return -1;
          x21 = XEXP (x10, 0);
          if (GET_CODE (x21) != MINUS
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XEXP (x21, 0);
          if (GET_CODE (x22) != ZERO_EXTEND
              || GET_MODE (x22) != E_SImode)
            return -1;
          x23 = XEXP (x22, 0);
          if (GET_CODE (x23) != REG
              || REGNO (x23) != 129
              || GET_MODE (x23) != E_BImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 129
              || GET_MODE (x7) != E_BImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !gcn_alu_operand (operands[1], E_SImode)
              || !gcn_alu_operand (operands[2], E_SImode)
              || pattern243 (x8) != 0)
            return -1;
          x12 = XEXP (x9, 1);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x24 = XEXP (x21, 1);
          if (!rtx_equal_p (x24, operands[1]))
            return -1;
          x25 = XEXP (x10, 1);
          if (!rtx_equal_p (x25, operands[1]))
            return -1;
          return 39; /* subcsi3_scalar */

        case 1:
          x10 = XEXP (x8, 1);
          if (GET_CODE (x10) != LTU
              || GET_MODE (x10) != E_DImode)
            return -1;
          x21 = XEXP (x10, 0);
          if (GET_CODE (x21) != MINUS
              || pattern240 (x1) != 0
              || !gcn_alu_operand (operands[3], E_DImode))
            return -1;
          x7 = XEXP (x6, 0);
          operands[4] = x7;
          if (!register_operand (operands[4], E_DImode)
              || GET_MODE (x8) != E_DImode
              || GET_MODE (x9) != E_DImode)
            return -1;
          x19 = XEXP (x14, 0);
          x26 = XEXP (x19, 2);
          if (!rtx_equal_p (x26, operands[3]))
            return -1;
          x12 = XEXP (x9, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          x22 = XEXP (x21, 0);
          x27 = XEXP (x22, 2);
          if (!rtx_equal_p (x27, operands[3]))
            return -1;
          x24 = XEXP (x21, 1);
          if (!rtx_equal_p (x24, operands[1]))
            return -1;
          x25 = XEXP (x10, 1);
          if (!rtx_equal_p (x25, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern246 (x1, 
E_V2SImode) != 0)
                return -1;
              return 1512; /* subcv2si3 */

            case E_V4SImode:
              if (pattern246 (x1, 
E_V4SImode) != 0)
                return -1;
              return 1514; /* subcv4si3 */

            case E_V8SImode:
              if (pattern246 (x1, 
E_V8SImode) != 0)
                return -1;
              return 1516; /* subcv8si3 */

            case E_V16SImode:
              if (pattern246 (x1, 
E_V16SImode) != 0)
                return -1;
              return 1518; /* subcv16si3 */

            case E_V32SImode:
              if (pattern246 (x1, 
E_V32SImode) != 0)
                return -1;
              return 1520; /* subcv32si3 */

            case E_V64SImode:
              if (pattern246 (x1, 
E_V64SImode) != 0)
                return -1;
              return 1522; /* subcv64si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x17 = XEXP (x4, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 129
          || GET_MODE (x17) != E_BImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x8 = XEXP (x6, 1);
      if (pattern153 (x8, 
MINUS, 
GTU) != 0)
        return -1;
      x9 = XEXP (x8, 0);
      x11 = XEXP (x9, 0);
      x14 = XEXP (x11, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 129
          || GET_MODE (x14) != E_BImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 129
          || GET_MODE (x7) != E_BImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!gcn_alu_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x9, 1);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x10 = XEXP (x8, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      return 40; /* subcsi3_scalar_zero */

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64TImode
      || !scratch_operand (operands[2], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64TImode)
      && general_operand (operands[1], E_V64TImode))
    return gen_split_70 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64TImode)
      || !memory_operand (operands[1], E_V64TImode))
    return NULL;
  return gen_split_166 (insn, operands);
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64DFmode
      || !scratch_operand (operands[2], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64DFmode)
      && general_operand (operands[1], E_V64DFmode))
    return gen_split_69 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64DFmode)
      || !memory_operand (operands[1], E_V64DFmode))
    return NULL;
  return gen_split_165 (insn, operands);
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64SFmode
      || !scratch_operand (operands[2], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64SFmode)
      && general_operand (operands[1], E_V64SFmode))
    return gen_split_67 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64SFmode)
      || !memory_operand (operands[1], E_V64SFmode))
    return NULL;
  return gen_split_163 (insn, operands);
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64HFmode
      || !scratch_operand (operands[2], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64HFmode)
      && general_operand (operands[1], E_V64HFmode))
    return gen_split_65 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64HFmode)
      || !memory_operand (operands[1], E_V64HFmode))
    return NULL;
  return gen_split_161 (insn, operands);
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64QImode
      || !scratch_operand (operands[2], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64QImode)
      && general_operand (operands[1], E_V64QImode))
    return gen_split_63 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64QImode)
      || !memory_operand (operands[1], E_V64QImode))
    return NULL;
  return gen_split_159 (insn, operands);
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32DImode
      || !scratch_operand (operands[2], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32DImode)
      && general_operand (operands[1], E_V32DImode))
    return gen_split_60 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32DImode)
      || !memory_operand (operands[1], E_V32DImode))
    return NULL;
  return gen_split_156 (insn, operands);
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32HFmode
      || !scratch_operand (operands[2], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32HFmode)
      && general_operand (operands[1], E_V32HFmode))
    return gen_split_57 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32HFmode)
      || !memory_operand (operands[1], E_V32HFmode))
    return NULL;
  return gen_split_153 (insn, operands);
}

 rtx_insn *
split_21 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64DImode
      || !scratch_operand (operands[4], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64DImode)
      && general_operand (operands[1], E_V64DImode))
    return gen_split_116 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64DImode)
      || !memory_operand (operands[1], E_V64DImode))
    return NULL;
  return gen_split_212 (insn, operands);
}

 rtx_insn *
split_26 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V64QImode
      || !scratch_operand (operands[4], E_V64DImode))
    return NULL;
  if (memory_operand (operands[0], E_V64QImode)
      && general_operand (operands[1], E_V64QImode))
    return gen_split_111 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V64QImode)
      || !memory_operand (operands[1], E_V64QImode))
    return NULL;
  return gen_split_207 (insn, operands);
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V32SImode
      || !scratch_operand (operands[4], E_V32DImode))
    return NULL;
  if (memory_operand (operands[0], E_V32SImode)
      && general_operand (operands[1], E_V32SImode))
    return gen_split_106 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_V32SImode)
      || !memory_operand (operands[1], E_V32SImode))
    return NULL;
  return gen_split_202 (insn, operands);
}

 rtx_insn *
split_36 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG)
        return NULL;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      switch (REGNO (x6))
        {
        case 129:
          if (GET_MODE (x6) != E_BImode
              || pattern78 (x4, 
E_DImode) != 0
              || !
#line 1345 "../../gcc/config/gcn/gcn.md"
(reload_completed))
            return NULL;
          return gen_split_13 (insn, operands);

        case 106:
          if (GET_MODE (x6) != E_DImode)
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern78 (x4, 
E_V2DImode) != 0
                  || !
#line 1696 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])
   && gcn_can_split_p (V2DImode, operands[1])
   && gcn_can_split_p (V2DImode, operands[2])))
                return NULL;
              return gen_split_239 (insn, operands);

            case E_V4DImode:
              if (pattern78 (x4, 
E_V4DImode) != 0
                  || !
#line 1696 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])
   && gcn_can_split_p (V4DImode, operands[1])
   && gcn_can_split_p (V4DImode, operands[2])))
                return NULL;
              return gen_split_240 (insn, operands);

            case E_V8DImode:
              if (pattern78 (x4, 
E_V8DImode) != 0
                  || !
#line 1696 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])
   && gcn_can_split_p (V8DImode, operands[1])
   && gcn_can_split_p (V8DImode, operands[2])))
                return NULL;
              return gen_split_241 (insn, operands);

            case E_V16DImode:
              if (pattern78 (x4, 
E_V16DImode) != 0
                  || !
#line 1696 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])
   && gcn_can_split_p (V16DImode, operands[1])
   && gcn_can_split_p (V16DImode, operands[2])))
                return NULL;
              return gen_split_242 (insn, operands);

            case E_V32DImode:
              if (pattern78 (x4, 
E_V32DImode) != 0
                  || !
#line 1696 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])
   && gcn_can_split_p (V32DImode, operands[1])
   && gcn_can_split_p (V32DImode, operands[2])))
                return NULL;
              return gen_split_243 (insn, operands);

            case E_V64DImode:
              if (pattern78 (x4, 
E_V64DImode) != 0
                  || !
#line 1696 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])
   && gcn_can_split_p (V64DImode, operands[1])
   && gcn_can_split_p (V64DImode, operands[2])))
                return NULL;
              return gen_split_244 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      if (pattern77 (x1, 
E_DImode) != 0
          || !
#line 1742 "../../gcc/config/gcn/gcn.md"
(reload_completed))
        return NULL;
      return gen_split_19 (insn, operands);

    case AND:
      if (pattern83 (x1) != 0
          || !
#line 1768 "../../gcc/config/gcn/gcn.md"
(reload_completed && gcn_vgpr_register_operand (operands[0], DImode)))
        return NULL;
      return gen_split_20 (insn, operands);

    case IOR:
      if (pattern83 (x1) != 0
          || !
#line 1768 "../../gcc/config/gcn/gcn.md"
(reload_completed && gcn_vgpr_register_operand (operands[0], DImode)))
        return NULL;
      return gen_split_21 (insn, operands);

    case XOR:
      if (pattern83 (x1) != 0
          || !
#line 1768 "../../gcc/config/gcn/gcn.md"
(reload_completed && gcn_vgpr_register_operand (operands[0], DImode)))
        return NULL;
      return gen_split_22 (insn, operands);

    case UNSPEC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return NULL;
      switch (XVECLEN (x4, 0))
        {
        case 1:
          return split_18 (x1, insn);

        case 3:
          if (XINT (x4, 1) != 10
              || pattern135 (x1) != 0)
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern201 (x4, 
E_V2DImode) != 0
                  || !
#line 4369 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_563 (insn, operands);

            case E_V4DImode:
              if (pattern201 (x4, 
E_V4DImode) != 0
                  || !
#line 4369 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_564 (insn, operands);

            case E_V8DImode:
              if (pattern201 (x4, 
E_V8DImode) != 0
                  || !
#line 4369 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_565 (insn, operands);

            case E_V16DImode:
              if (pattern201 (x4, 
E_V16DImode) != 0
                  || !
#line 4369 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_566 (insn, operands);

            case E_V32DImode:
              if (pattern201 (x4, 
E_V32DImode) != 0
                  || !
#line 4369 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_567 (insn, operands);

            case E_V64DImode:
              if (pattern201 (x4, 
E_V64DImode) != 0
                  || !
#line 4369 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_568 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case VEC_MERGE:
      return split_35 (x1, insn);

    case PLUS:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern72 (x5, 
106) != 0)
            return NULL;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern189 (x4, 
E_V2DImode) != 0
                  || !
#line 1630 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])
   && gcn_can_split_p (V2DImode, operands[1])
   && gcn_can_split_p (V2DImode, operands[2])))
                return NULL;
              return gen_split_227 (insn, operands);

            case E_V4DImode:
              if (pattern189 (x4, 
E_V4DImode) != 0
                  || !
#line 1630 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])
   && gcn_can_split_p (V4DImode, operands[1])
   && gcn_can_split_p (V4DImode, operands[2])))
                return NULL;
              return gen_split_228 (insn, operands);

            case E_V8DImode:
              if (pattern189 (x4, 
E_V8DImode) != 0
                  || !
#line 1630 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])
   && gcn_can_split_p (V8DImode, operands[1])
   && gcn_can_split_p (V8DImode, operands[2])))
                return NULL;
              return gen_split_229 (insn, operands);

            case E_V16DImode:
              if (pattern189 (x4, 
E_V16DImode) != 0
                  || !
#line 1630 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])
   && gcn_can_split_p (V16DImode, operands[1])
   && gcn_can_split_p (V16DImode, operands[2])))
                return NULL;
              return gen_split_230 (insn, operands);

            case E_V32DImode:
              if (pattern189 (x4, 
E_V32DImode) != 0
                  || !
#line 1630 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])
   && gcn_can_split_p (V32DImode, operands[1])
   && gcn_can_split_p (V32DImode, operands[2])))
                return NULL;
              return gen_split_231 (insn, operands);

            case E_V64DImode:
              if (pattern189 (x4, 
E_V64DImode) != 0
                  || !
#line 1630 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])
   && gcn_can_split_p (V64DImode, operands[1])
   && gcn_can_split_p (V64DImode, operands[2])))
                return NULL;
              return gen_split_232 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          x9 = XEXP (x7, 0);
          switch (GET_CODE (x9))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
              operands[1] = x9;
              x8 = XEXP (x4, 1);
              switch (GET_CODE (x8))
                {
                case CONST_INT:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                  operands[2] = x8;
                  x5 = XVECEXP (x1, 0, 1);
                  if (pattern72 (x5, 
106) != 0)
                    return NULL;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2DImode:
                      if (pattern194 (x4, 
E_V2DImode, 
E_V2SImode) != 0
                          || !
#line 1764 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])
   && gcn_can_split_p (V2DImode, operands[2])))
                        return NULL;
                      return gen_split_251 (insn, operands);

                    case E_V4DImode:
                      if (pattern194 (x4, 
E_V4DImode, 
E_V4SImode) != 0
                          || !
#line 1764 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])
   && gcn_can_split_p (V4DImode, operands[2])))
                        return NULL;
                      return gen_split_252 (insn, operands);

                    case E_V8DImode:
                      if (pattern194 (x4, 
E_V8DImode, 
E_V8SImode) != 0
                          || !
#line 1764 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])
   && gcn_can_split_p (V8DImode, operands[2])))
                        return NULL;
                      return gen_split_253 (insn, operands);

                    case E_V16DImode:
                      if (pattern194 (x4, 
E_V16DImode, 
E_V16SImode) != 0
                          || !
#line 1764 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])
   && gcn_can_split_p (V16DImode, operands[2])))
                        return NULL;
                      return gen_split_254 (insn, operands);

                    case E_V32DImode:
                      if (pattern194 (x4, 
E_V32DImode, 
E_V32SImode) != 0
                          || !
#line 1764 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])
   && gcn_can_split_p (V32DImode, operands[2])))
                        return NULL;
                      return gen_split_255 (insn, operands);

                    case E_V64DImode:
                      if (pattern194 (x4, 
E_V64DImode, 
E_V64SImode) != 0
                          || !
#line 1764 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])
   && gcn_can_split_p (V64DImode, operands[2])))
                        return NULL;
                      return gen_split_256 (insn, operands);

                    default:
                      return NULL;
                    }

                case VEC_DUPLICATE:
                  x5 = XVECEXP (x1, 0, 1);
                  if (pattern123 (x5) != 0)
                    return NULL;
                  switch (pattern196 (x1))
                    {
                    case 0:
                      if (!
#line 1941 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p (V2DImode, operands[0])))
                        return NULL;
                      return gen_split_275 (insn, operands);

                    case 1:
                      if (!
#line 1941 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p (V4DImode, operands[0])))
                        return NULL;
                      return gen_split_276 (insn, operands);

                    case 2:
                      if (!
#line 1941 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p (V8DImode, operands[0])))
                        return NULL;
                      return gen_split_277 (insn, operands);

                    case 3:
                      if (!
#line 1941 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p (V16DImode, operands[0])))
                        return NULL;
                      return gen_split_278 (insn, operands);

                    case 4:
                      if (!
#line 1941 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p (V32DImode, operands[0])))
                        return NULL;
                      return gen_split_279 (insn, operands);

                    case 5:
                      if (!
#line 1941 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p (V64DImode, operands[0])))
                        return NULL;
                      return gen_split_280 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case VEC_DUPLICATE:
              switch (pattern112 (x1))
                {
                case 0:
                  if (!
#line 1836 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V2DImode, operands[0])
   && gcn_can_split_p (V2DImode, operands[2])))
                    return NULL;
                  return gen_split_263 (insn, operands);

                case 1:
                  if (!
#line 1836 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V4DImode, operands[0])
   && gcn_can_split_p (V4DImode, operands[2])))
                    return NULL;
                  return gen_split_264 (insn, operands);

                case 2:
                  if (!
#line 1836 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V8DImode, operands[0])
   && gcn_can_split_p (V8DImode, operands[2])))
                    return NULL;
                  return gen_split_265 (insn, operands);

                case 3:
                  if (!
#line 1836 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V16DImode, operands[0])
   && gcn_can_split_p (V16DImode, operands[2])))
                    return NULL;
                  return gen_split_266 (insn, operands);

                case 4:
                  if (!
#line 1836 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V32DImode, operands[0])
   && gcn_can_split_p (V32DImode, operands[2])))
                    return NULL;
                  return gen_split_267 (insn, operands);

                case 5:
                  if (!
#line 1836 "../../gcc/config/gcn/gcn-valu.md"
(gcn_can_split_p  (V64DImode, operands[0])
   && gcn_can_split_p (V64DImode, operands[2])))
                    return NULL;
                  return gen_split_268 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return NULL;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern173 (x4, 
E_V2SImode, 
E_V2DImode) != 0
                  || !
#line 2222 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_299 (insn, operands);

            case E_V4DImode:
              if (pattern173 (x4, 
E_V4SImode, 
E_V4DImode) != 0
                  || !
#line 2222 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_300 (insn, operands);

            case E_V8DImode:
              if (pattern173 (x4, 
E_V8SImode, 
E_V8DImode) != 0
                  || !
#line 2222 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_301 (insn, operands);

            case E_V16DImode:
              if (pattern173 (x4, 
E_V16SImode, 
E_V16DImode) != 0
                  || !
#line 2222 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_302 (insn, operands);

            case E_V32DImode:
              if (pattern173 (x4, 
E_V32SImode, 
E_V32DImode) != 0
                  || !
#line 2222 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_303 (insn, operands);

            case E_V64DImode:
              if (pattern173 (x4, 
E_V64SImode, 
E_V64DImode) != 0
                  || !
#line 2222 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_304 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern127 (x4))
            {
            case 0:
              if (!
#line 2301 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_311 (insn, operands);

            case 1:
              if (!
#line 2301 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_312 (insn, operands);

            case 2:
              if (!
#line 2301 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_313 (insn, operands);

            case 3:
              if (!
#line 2301 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_314 (insn, operands);

            case 4:
              if (!
#line 2301 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_315 (insn, operands);

            case 5:
              if (!
#line 2301 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_316 (insn, operands);

            case 6:
              if (!
#line 2372 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_323 (insn, operands);

            case 7:
              if (!
#line 2372 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_324 (insn, operands);

            case 8:
              if (!
#line 2372 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_325 (insn, operands);

            case 9:
              if (!
#line 2372 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_326 (insn, operands);

            case 10:
              if (!
#line 2372 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_327 (insn, operands);

            case 11:
              if (!
#line 2372 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
                return NULL;
              return gen_split_328 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SMIN:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_371 (insn, operands);

        case 1:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_375 (insn, operands);

        case 2:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_379 (insn, operands);

        case 3:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_383 (insn, operands);

        case 4:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_387 (insn, operands);

        case 5:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_391 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_372 (insn, operands);

        case 1:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_376 (insn, operands);

        case 2:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_380 (insn, operands);

        case 3:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_384 (insn, operands);

        case 4:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_388 (insn, operands);

        case 5:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_392 (insn, operands);

        default:
          return NULL;
        }

    case UMIN:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_373 (insn, operands);

        case 1:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_377 (insn, operands);

        case 2:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_381 (insn, operands);

        case 3:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_385 (insn, operands);

        case 4:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_389 (insn, operands);

        case 5:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_393 (insn, operands);

        default:
          return NULL;
        }

    case UMAX:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_374 (insn, operands);

        case 1:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_378 (insn, operands);

        case 2:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_382 (insn, operands);

        case 3:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_386 (insn, operands);

        case 4:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_390 (insn, operands);

        case 5:
          if (!
#line 2836 "../../gcc/config/gcn/gcn-valu.md"
(reload_completed))
            return NULL;
          return gen_split_394 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
