/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gcn_alu_operand (operands[1], i2)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern13 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    case E_V2HFmode:
      if (!gcn_alu_operand (operands[1], E_V2HFmode))
        return -1;
      return 2;

    case E_V2SFmode:
      if (!gcn_alu_operand (operands[1], E_V2SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!gcn_alu_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HImode:
      if (!gcn_alu_operand (operands[1], E_V64HImode))
        return -1;
      return 0;

    case E_V64SImode:
      if (!gcn_alu_operand (operands[1], E_V64SImode))
        return -1;
      return 1;

    case E_V64HFmode:
      if (!gcn_alu_operand (operands[1], E_V64HFmode))
        return -1;
      return 2;

    case E_V64SFmode:
      if (!gcn_alu_operand (operands[1], E_V64SFmode))
        return -1;
      return 3;

    case E_V64DFmode:
      if (!gcn_alu_operand (operands[1], E_V64DFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      if (!gcn_alu_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      return pattern26 (x3, 
E_V2QImode); /* [-1, 17] */

    case E_V2HImode:
      res = pattern26 (x3, 
E_V2HImode);
      if (res >= 0)
        return res + 18; /* [18, 35] */
      return -1;

    case E_V2SImode:
      res = pattern26 (x3, 
E_V2SImode);
      if (res >= 0)
        return res + 36; /* [36, 53] */
      return -1;

    case E_V4QImode:
      res = pattern26 (x3, 
E_V4QImode);
      if (res >= 0)
        return res + 54; /* [54, 71] */
      return -1;

    case E_V4HImode:
      res = pattern26 (x3, 
E_V4HImode);
      if (res >= 0)
        return res + 72; /* [72, 89] */
      return -1;

    case E_V4SImode:
      res = pattern26 (x3, 
E_V4SImode);
      if (res >= 0)
        return res + 90; /* [90, 107] */
      return -1;

    case E_V8QImode:
      res = pattern26 (x3, 
E_V8QImode);
      if (res >= 0)
        return res + 108; /* [108, 125] */
      return -1;

    case E_V8HImode:
      res = pattern26 (x3, 
E_V8HImode);
      if (res >= 0)
        return res + 126; /* [126, 143] */
      return -1;

    case E_V8SImode:
      res = pattern26 (x3, 
E_V8SImode);
      if (res >= 0)
        return res + 144; /* [144, 161] */
      return -1;

    case E_V16QImode:
      res = pattern26 (x3, 
E_V16QImode);
      if (res >= 0)
        return res + 162; /* [162, 179] */
      return -1;

    case E_V16HImode:
      res = pattern26 (x3, 
E_V16HImode);
      if (res >= 0)
        return res + 180; /* [180, 197] */
      return -1;

    case E_V16SImode:
      res = pattern26 (x3, 
E_V16SImode);
      if (res >= 0)
        return res + 198; /* [198, 215] */
      return -1;

    case E_V32QImode:
      res = pattern26 (x3, 
E_V32QImode);
      if (res >= 0)
        return res + 216; /* [216, 233] */
      return -1;

    case E_V32HImode:
      res = pattern26 (x3, 
E_V32HImode);
      if (res >= 0)
        return res + 234; /* [234, 251] */
      return -1;

    case E_V32SImode:
      res = pattern26 (x3, 
E_V32SImode);
      if (res >= 0)
        return res + 252; /* [252, 269] */
      return -1;

    case E_V64QImode:
      res = pattern26 (x3, 
E_V64QImode);
      if (res >= 0)
        return res + 270; /* [270, 287] */
      return -1;

    case E_V64HImode:
      res = pattern26 (x3, 
E_V64HImode);
      if (res >= 0)
        return res + 288; /* [288, 305] */
      return -1;

    case E_V64SImode:
      res = pattern26 (x3, 
E_V64SImode);
      if (res >= 0)
        return res + 306; /* [306, 323] */
      return -1;

    case E_V2DImode:
      res = pattern27 (x3);
      if (res >= 0)
        return res + 324; /* [324, 326] */
      return -1;

    case E_V4DImode:
      res = pattern28 (x3);
      if (res >= 0)
        return res + 327; /* [327, 329] */
      return -1;

    case E_V8DImode:
      res = pattern29 (x3);
      if (res >= 0)
        return res + 330; /* [330, 332] */
      return -1;

    case E_V16DImode:
      res = pattern30 (x3);
      if (res >= 0)
        return res + 333; /* [333, 335] */
      return -1;

    case E_V32DImode:
      res = pattern31 (x3);
      if (res >= 0)
        return res + 336; /* [336, 338] */
      return -1;

    case E_V64DImode:
      res = pattern32 (x3);
      if (res >= 0)
        return res + 339; /* [339, 341] */
      return -1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HFmode:
      if (!gcn_alu_operand (operands[1], E_V4HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!gcn_alu_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!gcn_alu_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern65 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V2QImode:
      if (!gcn_alu_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!gcn_alu_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!gcn_alu_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      return pattern64 (x1, 
E_V2QImode); /* [-1, 17] */

    case E_V2HImode:
      res = pattern64 (x1, 
E_V2HImode);
      if (res >= 0)
        return res + 18; /* [18, 35] */
      return -1;

    case E_V2SImode:
      res = pattern64 (x1, 
E_V2SImode);
      if (res >= 0)
        return res + 36; /* [36, 53] */
      return -1;

    case E_V4QImode:
      res = pattern64 (x1, 
E_V4QImode);
      if (res >= 0)
        return res + 54; /* [54, 71] */
      return -1;

    case E_V4HImode:
      res = pattern64 (x1, 
E_V4HImode);
      if (res >= 0)
        return res + 72; /* [72, 89] */
      return -1;

    case E_V4SImode:
      res = pattern64 (x1, 
E_V4SImode);
      if (res >= 0)
        return res + 90; /* [90, 107] */
      return -1;

    case E_V8QImode:
      res = pattern64 (x1, 
E_V8QImode);
      if (res >= 0)
        return res + 108; /* [108, 125] */
      return -1;

    case E_V8HImode:
      res = pattern64 (x1, 
E_V8HImode);
      if (res >= 0)
        return res + 126; /* [126, 143] */
      return -1;

    case E_V8SImode:
      res = pattern64 (x1, 
E_V8SImode);
      if (res >= 0)
        return res + 144; /* [144, 161] */
      return -1;

    case E_V16QImode:
      res = pattern64 (x1, 
E_V16QImode);
      if (res >= 0)
        return res + 162; /* [162, 179] */
      return -1;

    case E_V16HImode:
      res = pattern64 (x1, 
E_V16HImode);
      if (res >= 0)
        return res + 180; /* [180, 197] */
      return -1;

    case E_V16SImode:
      res = pattern64 (x1, 
E_V16SImode);
      if (res >= 0)
        return res + 198; /* [198, 215] */
      return -1;

    case E_V32QImode:
      res = pattern64 (x1, 
E_V32QImode);
      if (res >= 0)
        return res + 216; /* [216, 233] */
      return -1;

    case E_V32HImode:
      res = pattern64 (x1, 
E_V32HImode);
      if (res >= 0)
        return res + 234; /* [234, 251] */
      return -1;

    case E_V32SImode:
      res = pattern64 (x1, 
E_V32SImode);
      if (res >= 0)
        return res + 252; /* [252, 269] */
      return -1;

    case E_V64QImode:
      res = pattern64 (x1, 
E_V64QImode);
      if (res >= 0)
        return res + 270; /* [270, 287] */
      return -1;

    case E_V64HImode:
      res = pattern64 (x1, 
E_V64HImode);
      if (res >= 0)
        return res + 288; /* [288, 305] */
      return -1;

    case E_V64SImode:
      res = pattern64 (x1, 
E_V64SImode);
      if (res >= 0)
        return res + 306; /* [306, 323] */
      return -1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V2DImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      res = pattern65 ();
      if (res >= 0)
        return res + 324; /* [324, 326] */
      return -1;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V4DImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      res = pattern66 ();
      if (res >= 0)
        return res + 327; /* [327, 329] */
      return -1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V8DImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      res = pattern67 ();
      if (res >= 0)
        return res + 330; /* [330, 332] */
      return -1;

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V16DImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      res = pattern68 ();
      if (res >= 0)
        return res + 333; /* [333, 335] */
      return -1;

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V32DImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      res = pattern69 ();
      if (res >= 0)
        return res + 336; /* [336, 338] */
      return -1;

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64DImode
          || !gcn_alu_or_unspec_operand (operands[2], E_V64DImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      res = pattern70 ();
      if (res >= 0)
        return res + 339; /* [339, 341] */
      return -1;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!gcn_alu_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern103 (x1, 
E_V2DImode, 
E_V2SImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern103 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern103 (x1, 
E_V8DImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V16DImode:
      if (pattern103 (x1, 
E_V16DImode, 
E_V16SImode) != 0)
        return -1;
      return 3;

    case E_V32DImode:
      if (pattern103 (x1, 
E_V32DImode, 
E_V32SImode) != 0)
        return -1;
      return 4;

    case E_V64DImode:
      if (pattern103 (x1, 
E_V64DImode, 
E_V64SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i2)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gcn_ds_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !gcn_ds_memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i2)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern130 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_MERGE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != VEC_DUPLICATE)
    return -1;
  x8 = XEXP (x7, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x6, 1);
  if (GET_CODE (x9) != VEC_DUPLICATE)
    return -1;
  x10 = XEXP (x9, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != AND
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != IOR
      || GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != i2
      || GET_MODE (x14) != E_DImode)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != i1)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != i1)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != VEC_MERGE)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != VEC_DUPLICATE)
    return -1;
  x19 = XEXP (x18, 0);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x20 = XEXP (x17, 1);
  if (GET_CODE (x20) != VEC_DUPLICATE)
    return -1;
  x21 = XEXP (x20, 0);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x22 = XEXP (x13, 1);
  if (GET_CODE (x22) != LTU
      || GET_MODE (x22) != E_DImode)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_CODE (x24) != VEC_MERGE)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != VEC_DUPLICATE)
    return -1;
  x26 = XEXP (x25, 0);
  if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x27 = XEXP (x24, 1);
  if (GET_CODE (x27) != VEC_DUPLICATE)
    return -1;
  x28 = XEXP (x27, 0);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x29 = XEXP (x12, 1);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 126
      || GET_MODE (x29) != E_DImode)
    return -1;
  x30 = XEXP (x6, 2);
  operands[3] = x30;
  return 0;
}

int
pattern157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1)
      || !gcn_alu_or_unspec_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_register_or_unspec_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern177 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[2], i2)
      || !register_operand (operands[1], i1)
      || !gcn_register_or_unspec_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !gcn_alu_operand (operands[3], i1)
      || !gcn_register_or_unspec_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern190 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_alu_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      return 0;

    case VEC_MERGE:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_DUPLICATE)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_CODE (x8) != VEC_DUPLICATE)
        return -1;
      x9 = XEXP (x8, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 0);
      x14 = XEXP (x13, 0);
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != VEC_MERGE)
        return -1;
      x16 = XEXP (x15, 0);
      if (GET_CODE (x16) != VEC_DUPLICATE)
        return -1;
      x17 = XEXP (x16, 0);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x18 = XEXP (x15, 1);
      if (GET_CODE (x18) != VEC_DUPLICATE)
        return -1;
      x19 = XEXP (x18, 0);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V16HImode:
      if (!register_operand (operands[2], E_V16HImode))
        return -1;
      return 1;

    case E_V16HFmode:
      if (!register_operand (operands[2], E_V16HFmode))
        return -1;
      return 2;

    case E_V16SImode:
      if (!register_operand (operands[2], E_V16SImode))
        return -1;
      return 3;

    case E_V16SFmode:
      if (!register_operand (operands[2], E_V16SFmode))
        return -1;
      return 4;

    case E_V16DImode:
      if (!register_operand (operands[2], E_V16DImode))
        return -1;
      return 5;

    case E_V16DFmode:
      if (!register_operand (operands[2], E_V16DFmode))
        return -1;
      return 6;

    case E_V16TImode:
      if (!register_operand (operands[2], E_V16TImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gcn_register_or_unspec_operand (operands[5], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V4DImode)
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_V4SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern239 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gcn_alu_operand (operands[1], i1)
      || !gcn_alu_operand (operands[2], i1)
      || !gcn_register_or_unspec_operand (operands[4], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pattern35 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 4);
  if (!gcn_exec_reg_operand (x3, E_DImode))
    return -1;
  switch (pattern180 (x2))
    {
    case 0:
      operands[5] = x3;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V2DImode:
          x5 = XEXP (x4, 1);
          switch (pattern213 (x5, 
E_V2DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 907; /* scatterv2qi_insn_1offset_exec */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 909; /* scatterv2hi_insn_1offset_exec */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 911; /* scatterv2hf_insn_1offset_exec */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 913; /* scatterv2si_insn_1offset_exec */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 915; /* scatterv2sf_insn_1offset_exec */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 917; /* scatterv2di_insn_1offset_exec */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 919; /* scatterv2df_insn_1offset_exec */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 921; /* scatterv2ti_insn_1offset_exec */

            default:
              return -1;
            }

        case E_V4DImode:
          x5 = XEXP (x4, 1);
          switch (pattern214 (x5, 
E_V4DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 923; /* scatterv4qi_insn_1offset_exec */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 925; /* scatterv4hi_insn_1offset_exec */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 927; /* scatterv4hf_insn_1offset_exec */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 929; /* scatterv4si_insn_1offset_exec */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 931; /* scatterv4sf_insn_1offset_exec */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 933; /* scatterv4di_insn_1offset_exec */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 935; /* scatterv4df_insn_1offset_exec */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 937; /* scatterv4ti_insn_1offset_exec */

            default:
              return -1;
            }

        case E_V8DImode:
          x5 = XEXP (x4, 1);
          switch (pattern215 (x5, 
E_V8DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 939; /* scatterv8qi_insn_1offset_exec */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 941; /* scatterv8hi_insn_1offset_exec */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 943; /* scatterv8hf_insn_1offset_exec */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 945; /* scatterv8si_insn_1offset_exec */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 947; /* scatterv8sf_insn_1offset_exec */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 949; /* scatterv8di_insn_1offset_exec */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 951; /* scatterv8df_insn_1offset_exec */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 953; /* scatterv8ti_insn_1offset_exec */

            default:
              return -1;
            }

        case E_V16DImode:
          x5 = XEXP (x4, 1);
          switch (pattern216 (x5, 
E_V16DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 955; /* scatterv16qi_insn_1offset_exec */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 957; /* scatterv16hi_insn_1offset_exec */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 959; /* scatterv16hf_insn_1offset_exec */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 961; /* scatterv16si_insn_1offset_exec */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 963; /* scatterv16sf_insn_1offset_exec */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 965; /* scatterv16di_insn_1offset_exec */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 967; /* scatterv16df_insn_1offset_exec */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 969; /* scatterv16ti_insn_1offset_exec */

            default:
              return -1;
            }

        case E_V32DImode:
          x5 = XEXP (x4, 1);
          switch (pattern217 (x5, 
E_V32DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 971; /* scatterv32qi_insn_1offset_exec */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 973; /* scatterv32hi_insn_1offset_exec */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 975; /* scatterv32hf_insn_1offset_exec */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 977; /* scatterv32si_insn_1offset_exec */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 979; /* scatterv32sf_insn_1offset_exec */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 981; /* scatterv32di_insn_1offset_exec */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 983; /* scatterv32df_insn_1offset_exec */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 985; /* scatterv32ti_insn_1offset_exec */

            default:
              return -1;
            }

        case E_V64DImode:
          x5 = XEXP (x4, 1);
          switch (pattern218 (x5, 
E_V64DImode))
            {
            case 0:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 987; /* scatterv64qi_insn_1offset_exec */

            case 1:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 989; /* scatterv64hi_insn_1offset_exec */

            case 2:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 991; /* scatterv64hf_insn_1offset_exec */

            case 3:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 993; /* scatterv64si_insn_1offset_exec */

            case 4:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 995; /* scatterv64sf_insn_1offset_exec */

            case 5:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 997; /* scatterv64di_insn_1offset_exec */

            case 6:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 999; /* scatterv64df_insn_1offset_exec */

            case 7:
              if (!
#line 1284 "../../gcc/config/gcn/gcn-valu.md"
((AS_FLAT_P (INTVAL (operands[3]))
    && (INTVAL(operands[1]) == 0
	|| ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x1000)))
    || (AS_GLOBAL_P (INTVAL (operands[3]))
	&& (((unsigned HOST_WIDE_INT)INTVAL(operands[1]) + 0x1000) < 0x2000))))
                return -1;
              return 1001; /* scatterv64ti_insn_1offset_exec */

            default:
              return -1;
            }

        case E_V2SImode:
          x5 = XEXP (x4, 1);
          switch (pattern213 (x5, 
E_V2SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1003; /* scatterv2qi_insn_1offset_ds_exec */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1005; /* scatterv2hi_insn_1offset_ds_exec */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1007; /* scatterv2hf_insn_1offset_ds_exec */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1009; /* scatterv2si_insn_1offset_ds_exec */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1011; /* scatterv2sf_insn_1offset_ds_exec */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1013; /* scatterv2di_insn_1offset_ds_exec */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1015; /* scatterv2df_insn_1offset_ds_exec */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1017; /* scatterv2ti_insn_1offset_ds_exec */

            default:
              return -1;
            }

        case E_V4SImode:
          x5 = XEXP (x4, 1);
          switch (pattern214 (x5, 
E_V4SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1019; /* scatterv4qi_insn_1offset_ds_exec */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1021; /* scatterv4hi_insn_1offset_ds_exec */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1023; /* scatterv4hf_insn_1offset_ds_exec */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1025; /* scatterv4si_insn_1offset_ds_exec */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1027; /* scatterv4sf_insn_1offset_ds_exec */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1029; /* scatterv4di_insn_1offset_ds_exec */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1031; /* scatterv4df_insn_1offset_ds_exec */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1033; /* scatterv4ti_insn_1offset_ds_exec */

            default:
              return -1;
            }

        case E_V8SImode:
          x5 = XEXP (x4, 1);
          switch (pattern215 (x5, 
E_V8SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1035; /* scatterv8qi_insn_1offset_ds_exec */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1037; /* scatterv8hi_insn_1offset_ds_exec */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1039; /* scatterv8hf_insn_1offset_ds_exec */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1041; /* scatterv8si_insn_1offset_ds_exec */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1043; /* scatterv8sf_insn_1offset_ds_exec */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1045; /* scatterv8di_insn_1offset_ds_exec */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1047; /* scatterv8df_insn_1offset_ds_exec */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1049; /* scatterv8ti_insn_1offset_ds_exec */

            default:
              return -1;
            }

        case E_V16SImode:
          x5 = XEXP (x4, 1);
          switch (pattern216 (x5, 
E_V16SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1051; /* scatterv16qi_insn_1offset_ds_exec */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1053; /* scatterv16hi_insn_1offset_ds_exec */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1055; /* scatterv16hf_insn_1offset_ds_exec */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1057; /* scatterv16si_insn_1offset_ds_exec */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1059; /* scatterv16sf_insn_1offset_ds_exec */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1061; /* scatterv16di_insn_1offset_ds_exec */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1063; /* scatterv16df_insn_1offset_ds_exec */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1065; /* scatterv16ti_insn_1offset_ds_exec */

            default:
              return -1;
            }

        case E_V32SImode:
          x5 = XEXP (x4, 1);
          switch (pattern217 (x5, 
E_V32SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1067; /* scatterv32qi_insn_1offset_ds_exec */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1069; /* scatterv32hi_insn_1offset_ds_exec */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1071; /* scatterv32hf_insn_1offset_ds_exec */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1073; /* scatterv32si_insn_1offset_ds_exec */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1075; /* scatterv32sf_insn_1offset_ds_exec */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1077; /* scatterv32di_insn_1offset_ds_exec */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1079; /* scatterv32df_insn_1offset_ds_exec */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1081; /* scatterv32ti_insn_1offset_ds_exec */

            default:
              return -1;
            }

        case E_V64SImode:
          x5 = XEXP (x4, 1);
          switch (pattern218 (x5, 
E_V64SImode))
            {
            case 0:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1083; /* scatterv64qi_insn_1offset_ds_exec */

            case 1:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1085; /* scatterv64hi_insn_1offset_ds_exec */

            case 2:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1087; /* scatterv64hf_insn_1offset_ds_exec */

            case 3:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1089; /* scatterv64si_insn_1offset_ds_exec */

            case 4:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1091; /* scatterv64sf_insn_1offset_ds_exec */

            case 5:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1093; /* scatterv64di_insn_1offset_ds_exec */

            case 6:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1095; /* scatterv64df_insn_1offset_ds_exec */

            case 7:
              if (!
#line 1317 "../../gcc/config/gcn/gcn-valu.md"
((AS_ANY_DS_P (INTVAL (operands[3]))
    && ((unsigned HOST_WIDE_INT)INTVAL(operands[1]) < 0x10000))))
                return -1;
              return 1097; /* scatterv64ti_insn_1offset_ds_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      operands[6] = x3;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern221 (x4))
        {
        case 0:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1099; /* scatterv2qi_insn_2offsets_exec */

        case 1:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1101; /* scatterv2hi_insn_2offsets_exec */

        case 2:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1103; /* scatterv2hf_insn_2offsets_exec */

        case 3:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1105; /* scatterv2si_insn_2offsets_exec */

        case 4:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1107; /* scatterv2sf_insn_2offsets_exec */

        case 5:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1109; /* scatterv2di_insn_2offsets_exec */

        case 6:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1111; /* scatterv2df_insn_2offsets_exec */

        case 7:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1113; /* scatterv2ti_insn_2offsets_exec */

        case 8:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1115; /* scatterv4qi_insn_2offsets_exec */

        case 9:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1117; /* scatterv4hi_insn_2offsets_exec */

        case 10:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1119; /* scatterv4hf_insn_2offsets_exec */

        case 11:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1121; /* scatterv4si_insn_2offsets_exec */

        case 12:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1123; /* scatterv4sf_insn_2offsets_exec */

        case 13:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1125; /* scatterv4di_insn_2offsets_exec */

        case 14:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1127; /* scatterv4df_insn_2offsets_exec */

        case 15:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1129; /* scatterv4ti_insn_2offsets_exec */

        case 16:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1131; /* scatterv8qi_insn_2offsets_exec */

        case 17:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1133; /* scatterv8hi_insn_2offsets_exec */

        case 18:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1135; /* scatterv8hf_insn_2offsets_exec */

        case 19:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1137; /* scatterv8si_insn_2offsets_exec */

        case 20:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1139; /* scatterv8sf_insn_2offsets_exec */

        case 21:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1141; /* scatterv8di_insn_2offsets_exec */

        case 22:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1143; /* scatterv8df_insn_2offsets_exec */

        case 23:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1145; /* scatterv8ti_insn_2offsets_exec */

        case 24:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1147; /* scatterv16qi_insn_2offsets_exec */

        case 25:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1149; /* scatterv16hi_insn_2offsets_exec */

        case 26:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1151; /* scatterv16hf_insn_2offsets_exec */

        case 27:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1153; /* scatterv16si_insn_2offsets_exec */

        case 28:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1155; /* scatterv16sf_insn_2offsets_exec */

        case 29:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1157; /* scatterv16di_insn_2offsets_exec */

        case 30:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1159; /* scatterv16df_insn_2offsets_exec */

        case 31:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1161; /* scatterv16ti_insn_2offsets_exec */

        case 32:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1163; /* scatterv32qi_insn_2offsets_exec */

        case 33:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1165; /* scatterv32hi_insn_2offsets_exec */

        case 34:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1167; /* scatterv32hf_insn_2offsets_exec */

        case 35:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1169; /* scatterv32si_insn_2offsets_exec */

        case 36:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1171; /* scatterv32sf_insn_2offsets_exec */

        case 37:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1173; /* scatterv32di_insn_2offsets_exec */

        case 38:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1175; /* scatterv32df_insn_2offsets_exec */

        case 39:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1177; /* scatterv32ti_insn_2offsets_exec */

        case 40:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1179; /* scatterv64qi_insn_2offsets_exec */

        case 41:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1181; /* scatterv64hi_insn_2offsets_exec */

        case 42:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1183; /* scatterv64hf_insn_2offsets_exec */

        case 43:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1185; /* scatterv64si_insn_2offsets_exec */

        case 44:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1187; /* scatterv64sf_insn_2offsets_exec */

        case 45:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1189; /* scatterv64di_insn_2offsets_exec */

        case 46:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1191; /* scatterv64df_insn_2offsets_exec */

        case 47:
          if (!
#line 1344 "../../gcc/config/gcn/gcn-valu.md"
((AS_GLOBAL_P (INTVAL (operands[4]))
    && (((unsigned HOST_WIDE_INT)INTVAL(operands[2]) + 0x1000) < 0x2000))))
            return -1;
          return 1193; /* scatterv64ti_insn_2offsets_exec */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern140 (x2, 
E_V2SImode))
    {
    case 0:
      if (!gcn_alu_operand (operands[1], E_V2QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4924; /* *truncv2qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6940; /* *truncv2qiv2si_shift_exec */

    case 1:
      if (!gcn_alu_operand (operands[1], E_V2HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4928; /* *truncv2hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6946; /* *truncv2hiv2si_shift_exec */

    case 2:
      if (!gcn_alu_operand (operands[1], E_V2SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4932; /* *truncv2siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6952; /* *truncv2siv2si_shift_exec */

    case 3:
      if (!gcn_alu_operand (operands[1], E_V4QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4936; /* *truncv4qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6958; /* *truncv4qiv2si_shift_exec */

    case 4:
      if (!gcn_alu_operand (operands[1], E_V4HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4940; /* *truncv4hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6964; /* *truncv4hiv2si_shift_exec */

    case 5:
      if (!gcn_alu_operand (operands[1], E_V4SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4944; /* *truncv4siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6970; /* *truncv4siv2si_shift_exec */

    case 6:
      if (!gcn_alu_operand (operands[1], E_V8QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4948; /* *truncv8qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6976; /* *truncv8qiv2si_shift_exec */

    case 7:
      if (!gcn_alu_operand (operands[1], E_V8HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4952; /* *truncv8hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6982; /* *truncv8hiv2si_shift_exec */

    case 8:
      if (!gcn_alu_operand (operands[1], E_V8SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4956; /* *truncv8siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6988; /* *truncv8siv2si_shift_exec */

    case 9:
      if (!gcn_alu_operand (operands[1], E_V16QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4960; /* *truncv16qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 6994; /* *truncv16qiv2si_shift_exec */

    case 10:
      if (!gcn_alu_operand (operands[1], E_V16HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4964; /* *truncv16hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7000; /* *truncv16hiv2si_shift_exec */

    case 11:
      if (!gcn_alu_operand (operands[1], E_V16SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4968; /* *truncv16siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7006; /* *truncv16siv2si_shift_exec */

    case 12:
      if (!gcn_alu_operand (operands[1], E_V32QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4972; /* *truncv32qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7012; /* *truncv32qiv2si_shift_exec */

    case 13:
      if (!gcn_alu_operand (operands[1], E_V32HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4976; /* *truncv32hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7018; /* *truncv32hiv2si_shift_exec */

    case 14:
      if (!gcn_alu_operand (operands[1], E_V32SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4980; /* *truncv32siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7024; /* *truncv32siv2si_shift_exec */

    case 15:
      if (!gcn_alu_operand (operands[1], E_V64QImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4984; /* *truncv64qiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7030; /* *truncv64qiv2si_shift_exec */

    case 16:
      if (!gcn_alu_operand (operands[1], E_V64HImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4988; /* *truncv64hiv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7036; /* *truncv64hiv2si_shift_exec */

    case 17:
      if (!gcn_alu_operand (operands[1], E_V64SImode)
          || !gcn_register_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      if (
#line 3563 "../../gcc/config/gcn/gcn-valu.md"
(TARGET_SDWA))
        return 4992; /* *truncv64siv2si_sdwa_exec */
      if (!
#line 3581 "../../gcc/config/gcn/gcn-valu.md"
(!TARGET_SDWA))
        return -1;
      return 7042; /* *truncv64siv2si_shift_exec */

    case 18:
      if (!gcn_alu_operand (operands[1], E_V2DImode)
          || !gcn_alu_or_unspec_operand (operands[2], E_V2SImode)
          || !gcn_exec_operand (operands[3], E_DImode))
        return -1;
      return 8687; /* truncv2div2si2_exec */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern63 (x2))
    {
    case 0:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HImode, V2HFmode,
		       float_cvt)))
        return -1;
      return 3272; /* floatv2hiv2hf2_exec */

    case 1:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SImode, V2HFmode,
		       float_cvt)))
        return -1;
      return 3284; /* floatv2siv2hf2_exec */

    case 2:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HFmode,
		       float_cvt)))
        return -1;
      return 3296; /* floatv2hfv2hf2_exec */

    case 3:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HFmode,
		       float_cvt)))
        return -1;
      return 3308; /* floatv2sfv2hf2_exec */

    case 4:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HFmode,
		       float_cvt)))
        return -1;
      return 3320; /* floatv2dfv2hf2_exec */

    case 5:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HImode, V2SFmode,
		       float_cvt)))
        return -1;
      return 3332; /* floatv2hiv2sf2_exec */

    case 6:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SImode, V2SFmode,
		       float_cvt)))
        return -1;
      return 3344; /* floatv2siv2sf2_exec */

    case 7:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SFmode,
		       float_cvt)))
        return -1;
      return 3356; /* floatv2hfv2sf2_exec */

    case 8:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SFmode,
		       float_cvt)))
        return -1;
      return 3368; /* floatv2sfv2sf2_exec */

    case 9:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SFmode,
		       float_cvt)))
        return -1;
      return 3380; /* floatv2dfv2sf2_exec */

    case 10:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HImode, V2DFmode,
		       float_cvt)))
        return -1;
      return 3392; /* floatv2hiv2df2_exec */

    case 11:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SImode, V2DFmode,
		       float_cvt)))
        return -1;
      return 3404; /* floatv2siv2df2_exec */

    case 12:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2HFmode, V2DFmode,
		       float_cvt)))
        return -1;
      return 3416; /* floatv2hfv2df2_exec */

    case 13:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2SFmode, V2DFmode,
		       float_cvt)))
        return -1;
      return 3428; /* floatv2sfv2df2_exec */

    case 14:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2DFmode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2DFmode,
		       float_cvt)))
        return -1;
      return 3440; /* floatv2dfv2df2_exec */

    case 15:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HImode, V4HFmode,
		       float_cvt)))
        return -1;
      return 3452; /* floatv4hiv4hf2_exec */

    case 16:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SImode, V4HFmode,
		       float_cvt)))
        return -1;
      return 3464; /* floatv4siv4hf2_exec */

    case 17:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HFmode,
		       float_cvt)))
        return -1;
      return 3476; /* floatv4hfv4hf2_exec */

    case 18:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HFmode,
		       float_cvt)))
        return -1;
      return 3488; /* floatv4sfv4hf2_exec */

    case 19:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HFmode,
		       float_cvt)))
        return -1;
      return 3500; /* floatv4dfv4hf2_exec */

    case 20:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HImode, V4SFmode,
		       float_cvt)))
        return -1;
      return 3512; /* floatv4hiv4sf2_exec */

    case 21:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SImode, V4SFmode,
		       float_cvt)))
        return -1;
      return 3524; /* floatv4siv4sf2_exec */

    case 22:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SFmode,
		       float_cvt)))
        return -1;
      return 3536; /* floatv4hfv4sf2_exec */

    case 23:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SFmode,
		       float_cvt)))
        return -1;
      return 3548; /* floatv4sfv4sf2_exec */

    case 24:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SFmode,
		       float_cvt)))
        return -1;
      return 3560; /* floatv4dfv4sf2_exec */

    case 25:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HImode, V4DFmode,
		       float_cvt)))
        return -1;
      return 3572; /* floatv4hiv4df2_exec */

    case 26:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SImode, V4DFmode,
		       float_cvt)))
        return -1;
      return 3584; /* floatv4siv4df2_exec */

    case 27:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4HFmode, V4DFmode,
		       float_cvt)))
        return -1;
      return 3596; /* floatv4hfv4df2_exec */

    case 28:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4SFmode, V4DFmode,
		       float_cvt)))
        return -1;
      return 3608; /* floatv4sfv4df2_exec */

    case 29:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4DFmode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4DFmode,
		       float_cvt)))
        return -1;
      return 3620; /* floatv4dfv4df2_exec */

    case 30:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HImode, V8HFmode,
		       float_cvt)))
        return -1;
      return 3632; /* floatv8hiv8hf2_exec */

    case 31:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SImode, V8HFmode,
		       float_cvt)))
        return -1;
      return 3644; /* floatv8siv8hf2_exec */

    case 32:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HFmode,
		       float_cvt)))
        return -1;
      return 3656; /* floatv8hfv8hf2_exec */

    case 33:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HFmode,
		       float_cvt)))
        return -1;
      return 3668; /* floatv8sfv8hf2_exec */

    case 34:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HFmode,
		       float_cvt)))
        return -1;
      return 3680; /* floatv8dfv8hf2_exec */

    case 35:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HImode, V8SFmode,
		       float_cvt)))
        return -1;
      return 3692; /* floatv8hiv8sf2_exec */

    case 36:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SImode, V8SFmode,
		       float_cvt)))
        return -1;
      return 3704; /* floatv8siv8sf2_exec */

    case 37:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SFmode,
		       float_cvt)))
        return -1;
      return 3716; /* floatv8hfv8sf2_exec */

    case 38:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SFmode,
		       float_cvt)))
        return -1;
      return 3728; /* floatv8sfv8sf2_exec */

    case 39:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SFmode,
		       float_cvt)))
        return -1;
      return 3740; /* floatv8dfv8sf2_exec */

    case 40:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HImode, V8DFmode,
		       float_cvt)))
        return -1;
      return 3752; /* floatv8hiv8df2_exec */

    case 41:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SImode, V8DFmode,
		       float_cvt)))
        return -1;
      return 3764; /* floatv8siv8df2_exec */

    case 42:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8HFmode, V8DFmode,
		       float_cvt)))
        return -1;
      return 3776; /* floatv8hfv8df2_exec */

    case 43:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8SFmode, V8DFmode,
		       float_cvt)))
        return -1;
      return 3788; /* floatv8sfv8df2_exec */

    case 44:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8DFmode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8DFmode,
		       float_cvt)))
        return -1;
      return 3800; /* floatv8dfv8df2_exec */

    case 45:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HImode, V16HFmode,
		       float_cvt)))
        return -1;
      return 3812; /* floatv16hiv16hf2_exec */

    case 46:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SImode, V16HFmode,
		       float_cvt)))
        return -1;
      return 3824; /* floatv16siv16hf2_exec */

    case 47:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HFmode,
		       float_cvt)))
        return -1;
      return 3836; /* floatv16hfv16hf2_exec */

    case 48:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HFmode,
		       float_cvt)))
        return -1;
      return 3848; /* floatv16sfv16hf2_exec */

    case 49:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HFmode,
		       float_cvt)))
        return -1;
      return 3860; /* floatv16dfv16hf2_exec */

    case 50:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HImode, V16SFmode,
		       float_cvt)))
        return -1;
      return 3872; /* floatv16hiv16sf2_exec */

    case 51:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SImode, V16SFmode,
		       float_cvt)))
        return -1;
      return 3884; /* floatv16siv16sf2_exec */

    case 52:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SFmode,
		       float_cvt)))
        return -1;
      return 3896; /* floatv16hfv16sf2_exec */

    case 53:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SFmode,
		       float_cvt)))
        return -1;
      return 3908; /* floatv16sfv16sf2_exec */

    case 54:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SFmode,
		       float_cvt)))
        return -1;
      return 3920; /* floatv16dfv16sf2_exec */

    case 55:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HImode, V16DFmode,
		       float_cvt)))
        return -1;
      return 3932; /* floatv16hiv16df2_exec */

    case 56:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SImode, V16DFmode,
		       float_cvt)))
        return -1;
      return 3944; /* floatv16siv16df2_exec */

    case 57:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16HFmode, V16DFmode,
		       float_cvt)))
        return -1;
      return 3956; /* floatv16hfv16df2_exec */

    case 58:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16SFmode, V16DFmode,
		       float_cvt)))
        return -1;
      return 3968; /* floatv16sfv16df2_exec */

    case 59:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16DFmode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16DFmode,
		       float_cvt)))
        return -1;
      return 3980; /* floatv16dfv16df2_exec */

    case 60:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HImode, V32HFmode,
		       float_cvt)))
        return -1;
      return 3992; /* floatv32hiv32hf2_exec */

    case 61:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SImode, V32HFmode,
		       float_cvt)))
        return -1;
      return 4004; /* floatv32siv32hf2_exec */

    case 62:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HFmode,
		       float_cvt)))
        return -1;
      return 4016; /* floatv32hfv32hf2_exec */

    case 63:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HFmode,
		       float_cvt)))
        return -1;
      return 4028; /* floatv32sfv32hf2_exec */

    case 64:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HFmode,
		       float_cvt)))
        return -1;
      return 4040; /* floatv32dfv32hf2_exec */

    case 65:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HImode, V32SFmode,
		       float_cvt)))
        return -1;
      return 4052; /* floatv32hiv32sf2_exec */

    case 66:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SImode, V32SFmode,
		       float_cvt)))
        return -1;
      return 4064; /* floatv32siv32sf2_exec */

    case 67:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SFmode,
		       float_cvt)))
        return -1;
      return 4076; /* floatv32hfv32sf2_exec */

    case 68:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SFmode,
		       float_cvt)))
        return -1;
      return 4088; /* floatv32sfv32sf2_exec */

    case 69:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SFmode,
		       float_cvt)))
        return -1;
      return 4100; /* floatv32dfv32sf2_exec */

    case 70:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HImode, V32DFmode,
		       float_cvt)))
        return -1;
      return 4112; /* floatv32hiv32df2_exec */

    case 71:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SImode, V32DFmode,
		       float_cvt)))
        return -1;
      return 4124; /* floatv32siv32df2_exec */

    case 72:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32HFmode, V32DFmode,
		       float_cvt)))
        return -1;
      return 4136; /* floatv32hfv32df2_exec */

    case 73:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32SFmode, V32DFmode,
		       float_cvt)))
        return -1;
      return 4148; /* floatv32sfv32df2_exec */

    case 74:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32DFmode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32DFmode,
		       float_cvt)))
        return -1;
      return 4160; /* floatv32dfv32df2_exec */

    case 75:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HImode, V64HFmode,
		       float_cvt)))
        return -1;
      return 4172; /* floatv64hiv64hf2_exec */

    case 76:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SImode, V64HFmode,
		       float_cvt)))
        return -1;
      return 4184; /* floatv64siv64hf2_exec */

    case 77:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HFmode,
		       float_cvt)))
        return -1;
      return 4196; /* floatv64hfv64hf2_exec */

    case 78:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HFmode,
		       float_cvt)))
        return -1;
      return 4208; /* floatv64sfv64hf2_exec */

    case 79:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HFmode,
		       float_cvt)))
        return -1;
      return 4220; /* floatv64dfv64hf2_exec */

    case 80:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HImode, V64SFmode,
		       float_cvt)))
        return -1;
      return 4232; /* floatv64hiv64sf2_exec */

    case 81:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SImode, V64SFmode,
		       float_cvt)))
        return -1;
      return 4244; /* floatv64siv64sf2_exec */

    case 82:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SFmode,
		       float_cvt)))
        return -1;
      return 4256; /* floatv64hfv64sf2_exec */

    case 83:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SFmode,
		       float_cvt)))
        return -1;
      return 4268; /* floatv64sfv64sf2_exec */

    case 84:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SFmode,
		       float_cvt)))
        return -1;
      return 4280; /* floatv64dfv64sf2_exec */

    case 85:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HImode, V64DFmode,
		       float_cvt)))
        return -1;
      return 4292; /* floatv64hiv64df2_exec */

    case 86:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SImode, V64DFmode,
		       float_cvt)))
        return -1;
      return 4304; /* floatv64siv64df2_exec */

    case 87:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64HFmode, V64DFmode,
		       float_cvt)))
        return -1;
      return 4316; /* floatv64hfv64df2_exec */

    case 88:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64SFmode, V64DFmode,
		       float_cvt)))
        return -1;
      return 4328; /* floatv64sfv64df2_exec */

    case 89:
      if (!
#line 3525 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64DFmode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64DFmode,
		       float_cvt)))
        return -1;
      return 4340; /* floatv64dfv64df2_exec */

    case 90:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2HImode,
		       float_cvt)))
        return -1;
      return 4352; /* floatv2hfv2hi2_exec */

    case 91:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2HImode,
		       float_cvt)))
        return -1;
      return 4364; /* floatv2sfv2hi2_exec */

    case 92:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2HImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2HImode,
		       float_cvt)))
        return -1;
      return 4376; /* floatv2dfv2hi2_exec */

    case 93:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2HFmode)
   && gcn_valid_cvt_p (V2HFmode, V2SImode,
		       float_cvt)))
        return -1;
      return 4388; /* floatv2hfv2si2_exec */

    case 94:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2SFmode)
   && gcn_valid_cvt_p (V2SFmode, V2SImode,
		       float_cvt)))
        return -1;
      return 4400; /* floatv2sfv2si2_exec */

    case 95:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V2SImode) == MODE_VF (V2DFmode)
   && gcn_valid_cvt_p (V2DFmode, V2SImode,
		       float_cvt)))
        return -1;
      return 4412; /* floatv2dfv2si2_exec */

    case 96:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4HImode,
		       float_cvt)))
        return -1;
      return 4424; /* floatv4hfv4hi2_exec */

    case 97:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4HImode,
		       float_cvt)))
        return -1;
      return 4436; /* floatv4sfv4hi2_exec */

    case 98:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4HImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4HImode,
		       float_cvt)))
        return -1;
      return 4448; /* floatv4dfv4hi2_exec */

    case 99:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4HFmode)
   && gcn_valid_cvt_p (V4HFmode, V4SImode,
		       float_cvt)))
        return -1;
      return 4460; /* floatv4hfv4si2_exec */

    case 100:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4SFmode)
   && gcn_valid_cvt_p (V4SFmode, V4SImode,
		       float_cvt)))
        return -1;
      return 4472; /* floatv4sfv4si2_exec */

    case 101:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V4SImode) == MODE_VF (V4DFmode)
   && gcn_valid_cvt_p (V4DFmode, V4SImode,
		       float_cvt)))
        return -1;
      return 4484; /* floatv4dfv4si2_exec */

    case 102:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8HImode,
		       float_cvt)))
        return -1;
      return 4496; /* floatv8hfv8hi2_exec */

    case 103:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8HImode,
		       float_cvt)))
        return -1;
      return 4508; /* floatv8sfv8hi2_exec */

    case 104:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8HImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8HImode,
		       float_cvt)))
        return -1;
      return 4520; /* floatv8dfv8hi2_exec */

    case 105:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8HFmode)
   && gcn_valid_cvt_p (V8HFmode, V8SImode,
		       float_cvt)))
        return -1;
      return 4532; /* floatv8hfv8si2_exec */

    case 106:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8SFmode)
   && gcn_valid_cvt_p (V8SFmode, V8SImode,
		       float_cvt)))
        return -1;
      return 4544; /* floatv8sfv8si2_exec */

    case 107:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V8SImode) == MODE_VF (V8DFmode)
   && gcn_valid_cvt_p (V8DFmode, V8SImode,
		       float_cvt)))
        return -1;
      return 4556; /* floatv8dfv8si2_exec */

    case 108:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16HImode,
		       float_cvt)))
        return -1;
      return 4568; /* floatv16hfv16hi2_exec */

    case 109:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16HImode,
		       float_cvt)))
        return -1;
      return 4580; /* floatv16sfv16hi2_exec */

    case 110:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16HImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16HImode,
		       float_cvt)))
        return -1;
      return 4592; /* floatv16dfv16hi2_exec */

    case 111:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16HFmode)
   && gcn_valid_cvt_p (V16HFmode, V16SImode,
		       float_cvt)))
        return -1;
      return 4604; /* floatv16hfv16si2_exec */

    case 112:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16SFmode)
   && gcn_valid_cvt_p (V16SFmode, V16SImode,
		       float_cvt)))
        return -1;
      return 4616; /* floatv16sfv16si2_exec */

    case 113:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V16SImode) == MODE_VF (V16DFmode)
   && gcn_valid_cvt_p (V16DFmode, V16SImode,
		       float_cvt)))
        return -1;
      return 4628; /* floatv16dfv16si2_exec */

    case 114:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32HImode,
		       float_cvt)))
        return -1;
      return 4640; /* floatv32hfv32hi2_exec */

    case 115:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32HImode,
		       float_cvt)))
        return -1;
      return 4652; /* floatv32sfv32hi2_exec */

    case 116:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32HImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32HImode,
		       float_cvt)))
        return -1;
      return 4664; /* floatv32dfv32hi2_exec */

    case 117:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32HFmode)
   && gcn_valid_cvt_p (V32HFmode, V32SImode,
		       float_cvt)))
        return -1;
      return 4676; /* floatv32hfv32si2_exec */

    case 118:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32SFmode)
   && gcn_valid_cvt_p (V32SFmode, V32SImode,
		       float_cvt)))
        return -1;
      return 4688; /* floatv32sfv32si2_exec */

    case 119:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V32SImode) == MODE_VF (V32DFmode)
   && gcn_valid_cvt_p (V32DFmode, V32SImode,
		       float_cvt)))
        return -1;
      return 4700; /* floatv32dfv32si2_exec */

    case 120:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64HImode,
		       float_cvt)))
        return -1;
      return 4712; /* floatv64hfv64hi2_exec */

    case 121:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64HImode,
		       float_cvt)))
        return -1;
      return 4724; /* floatv64sfv64hi2_exec */

    case 122:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64HImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64HImode,
		       float_cvt)))
        return -1;
      return 4736; /* floatv64dfv64hi2_exec */

    case 123:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64HFmode)
   && gcn_valid_cvt_p (V64HFmode, V64SImode,
		       float_cvt)))
        return -1;
      return 4748; /* floatv64hfv64si2_exec */

    case 124:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64SFmode)
   && gcn_valid_cvt_p (V64SFmode, V64SImode,
		       float_cvt)))
        return -1;
      return 4760; /* floatv64sfv64si2_exec */

    case 125:
      if (!
#line 3536 "../../gcc/config/gcn/gcn-valu.md"
(MODE_VF (V64SImode) == MODE_VF (V64DFmode)
   && gcn_valid_cvt_p (V64DFmode, V64SImode,
		       float_cvt)))
        return -1;
      return 4772; /* floatv64dfv64si2_exec */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!gcn_alu_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2QImode:
          if (!register_operand (operands[1], E_V2QImode))
            return -1;
          return 465; /* vec_extractv2qiqi */

        case E_V4QImode:
          if (!register_operand (operands[1], E_V4QImode))
            return -1;
          return 470; /* vec_extractv4qiqi */

        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 475; /* vec_extractv8qiqi */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 480; /* vec_extractv16qiqi */

        case E_V32QImode:
          if (!register_operand (operands[1], E_V32QImode))
            return -1;
          return 485; /* vec_extractv32qiqi */

        case E_V64QImode:
          if (!register_operand (operands[1], E_V64QImode))
            return -1;
          return 490; /* vec_extractv64qiqi */

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2HImode:
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          return 466; /* vec_extractv2hihi */

        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 471; /* vec_extractv4hihi */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 476; /* vec_extractv8hihi */

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode))
            return -1;
          return 481; /* vec_extractv16hihi */

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32HImode))
            return -1;
          return 486; /* vec_extractv32hihi */

        case E_V64HImode:
          if (!register_operand (operands[1], E_V64HImode))
            return -1;
          return 491; /* vec_extractv64hihi */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          return 467; /* vec_extractv2sisi */

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 472; /* vec_extractv4sisi */

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode))
            return -1;
          return 477; /* vec_extractv8sisi */

        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode))
            return -1;
          return 482; /* vec_extractv16sisi */

        case E_V32SImode:
          if (!register_operand (operands[1], E_V32SImode))
            return -1;
          return 487; /* vec_extractv32sisi */

        case E_V64SImode:
          if (!register_operand (operands[1], E_V64SImode))
            return -1;
          return 492; /* vec_extractv64sisi */

        default:
          return -1;
        }

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x2) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[1], E_V2HFmode))
            return -1;
          return 468; /* vec_extractv2hfhf */

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode))
            return -1;
          return 473; /* vec_extractv4hfhf */

        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 478; /* vec_extractv8hfhf */

        case E_V16HFmode:
          if (!register_operand (operands[1], E_V16HFmode))
            return -1;
          return 483; /* vec_extractv16hfhf */

        case E_V32HFmode:
          if (!register_operand (operands[1], E_V32HFmode))
            return -1;
          return 488; /* vec_extractv32hfhf */

        case E_V64HFmode:
          if (!register_operand (operands[1], E_V64HFmode))
            return -1;
          return 493; /* vec_extractv64hfhf */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode))
            return -1;
          return 469; /* vec_extractv2sfsf */

        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode))
            return -1;
          return 474; /* vec_extractv4sfsf */

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 479; /* vec_extractv8sfsf */

        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode))
            return -1;
          return 484; /* vec_extractv16sfsf */

        case E_V32SFmode:
          if (!register_operand (operands[1], E_V32SFmode))
            return -1;
          return 489; /* vec_extractv32sfsf */

        case E_V64SFmode:
          if (!register_operand (operands[1], E_V64SFmode))
            return -1;
          return 494; /* vec_extractv64sfsf */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode))
            return -1;
          return 495; /* vec_extractv2didi */

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode))
            return -1;
          return 497; /* vec_extractv4didi */

        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode))
            return -1;
          return 499; /* vec_extractv8didi */

        case E_V16DImode:
          if (!register_operand (operands[1], E_V16DImode))
            return -1;
          return 501; /* vec_extractv16didi */

        case E_V32DImode:
          if (!register_operand (operands[1], E_V32DImode))
            return -1;
          return 503; /* vec_extractv32didi */

        case E_V64DImode:
          if (!register_operand (operands[1], E_V64DImode))
            return -1;
          return 505; /* vec_extractv64didi */

        default:
          return -1;
        }

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode))
            return -1;
          return 496; /* vec_extractv2dfdf */

        case E_V4DFmode:
          if (!register_operand (operands[1], E_V4DFmode))
            return -1;
          return 498; /* vec_extractv4dfdf */

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 500; /* vec_extractv8dfdf */

        case E_V16DFmode:
          if (!register_operand (operands[1], E_V16DFmode))
            return -1;
          return 502; /* vec_extractv16dfdf */

        case E_V32DFmode:
          if (!register_operand (operands[1], E_V32DFmode))
            return -1;
          return 504; /* vec_extractv32dfdf */

        case E_V64DFmode:
          if (!register_operand (operands[1], E_V64DFmode))
            return -1;
          return 506; /* vec_extractv64dfdf */

        default:
          return -1;
        }

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x2) != E_TImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2TImode:
          if (!register_operand (operands[1], E_V2TImode))
            return -1;
          return 507; /* vec_extractv2titi */

        case E_V4TImode:
          if (!register_operand (operands[1], E_V4TImode))
            return -1;
          return 508; /* vec_extractv4titi */

        case E_V8TImode:
          if (!register_operand (operands[1], E_V8TImode))
            return -1;
          return 509; /* vec_extractv8titi */

        case E_V16TImode:
          if (!register_operand (operands[1], E_V16TImode))
            return -1;
          return 510; /* vec_extractv16titi */

        case E_V32TImode:
          if (!register_operand (operands[1], E_V32TImode))
            return -1;
          return 511; /* vec_extractv32titi */

        case E_V64TImode:
          if (!register_operand (operands[1], E_V64TImode))
            return -1;
          return 512; /* vec_extractv64titi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_59 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_51 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_52 (x1, insn, pnum_clobbers);

    case PLUS:
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XEXP (x3, 2);
      operands[4] = x6;
      if (!gcn_exec_reg_operand (operands[4], E_DImode))
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V2QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1357; /* addv2qi3_exec */

            case E_V2HImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V2HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1359; /* addv2hi3_exec */

            case E_V2SImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V2SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1361; /* addv2si3_exec */

            case E_V4QImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V4QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1363; /* addv4qi3_exec */

            case E_V4HImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V4HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1365; /* addv4hi3_exec */

            case E_V4SImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V4SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1367; /* addv4si3_exec */

            case E_V8QImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V8QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1369; /* addv8qi3_exec */

            case E_V8HImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V8HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1371; /* addv8hi3_exec */

            case E_V8SImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V8SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1373; /* addv8si3_exec */

            case E_V16QImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V16QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1375; /* addv16qi3_exec */

            case E_V16HImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V16HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1377; /* addv16hi3_exec */

            case E_V16SImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V16SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1379; /* addv16si3_exec */

            case E_V32QImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V32QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1381; /* addv32qi3_exec */

            case E_V32HImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V32HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1383; /* addv32hi3_exec */

            case E_V32SImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V32SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1385; /* addv32si3_exec */

            case E_V64QImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V64QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1387; /* addv64qi3_exec */

            case E_V64HImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V64HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1389; /* addv64hi3_exec */

            case E_V64SImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V64SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1391; /* addv64si3_exec */

            case E_V2DImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V2DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1530; /* addv2di3_exec */

            case E_V4DImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V4DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1531; /* addv4di3_exec */

            case E_V8DImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V8DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1532; /* addv8di3_exec */

            case E_V16DImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V16DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1533; /* addv16di3_exec */

            case E_V32DImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V32DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1534; /* addv32di3_exec */

            case E_V64DImode:
              if (pattern168 (x3, pnum_clobbers, 
E_V64DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1535; /* addv64di3_exec */

            case E_V2HFmode:
              if (pattern44 (x3, 
E_V2HFmode) != 0)
                return -1;
              return 2237; /* addv2hf3_exec */

            case E_V2SFmode:
              if (pattern44 (x3, 
E_V2SFmode) != 0)
                return -1;
              return 2245; /* addv2sf3_exec */

            case E_V2DFmode:
              if (pattern44 (x3, 
E_V2DFmode) != 0)
                return -1;
              return 2253; /* addv2df3_exec */

            case E_V4HFmode:
              if (pattern44 (x3, 
E_V4HFmode) != 0)
                return -1;
              return 2261; /* addv4hf3_exec */

            case E_V4SFmode:
              if (pattern44 (x3, 
E_V4SFmode) != 0)
                return -1;
              return 2269; /* addv4sf3_exec */

            case E_V4DFmode:
              if (pattern44 (x3, 
E_V4DFmode) != 0)
                return -1;
              return 2277; /* addv4df3_exec */

            case E_V8HFmode:
              if (pattern44 (x3, 
E_V8HFmode) != 0)
                return -1;
              return 2285; /* addv8hf3_exec */

            case E_V8SFmode:
              if (pattern44 (x3, 
E_V8SFmode) != 0)
                return -1;
              return 2293; /* addv8sf3_exec */

            case E_V8DFmode:
              if (pattern44 (x3, 
E_V8DFmode) != 0)
                return -1;
              return 2301; /* addv8df3_exec */

            case E_V16HFmode:
              if (pattern44 (x3, 
E_V16HFmode) != 0)
                return -1;
              return 2309; /* addv16hf3_exec */

            case E_V16SFmode:
              if (pattern44 (x3, 
E_V16SFmode) != 0)
                return -1;
              return 2317; /* addv16sf3_exec */

            case E_V16DFmode:
              if (pattern44 (x3, 
E_V16DFmode) != 0)
                return -1;
              return 2325; /* addv16df3_exec */

            case E_V32HFmode:
              if (pattern44 (x3, 
E_V32HFmode) != 0)
                return -1;
              return 2333; /* addv32hf3_exec */

            case E_V32SFmode:
              if (pattern44 (x3, 
E_V32SFmode) != 0)
                return -1;
              return 2341; /* addv32sf3_exec */

            case E_V32DFmode:
              if (pattern44 (x3, 
E_V32DFmode) != 0)
                return -1;
              return 2349; /* addv32df3_exec */

            case E_V64HFmode:
              if (pattern44 (x3, 
E_V64HFmode) != 0)
                return -1;
              return 2357; /* addv64hf3_exec */

            case E_V64SFmode:
              if (pattern44 (x3, 
E_V64SFmode) != 0)
                return -1;
              return 2365; /* addv64sf3_exec */

            case E_V64DFmode:
              if (pattern44 (x3, 
E_V64DFmode) != 0)
                return -1;
              return 2373; /* addv64df3_exec */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          if (pnum_clobbers == NULL)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern177 (x3, 
E_V2QImode, 
E_QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1393; /* addv2qi3_dup_exec */

            case E_V2HImode:
              if (pattern177 (x3, 
E_V2HImode, 
E_HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1395; /* addv2hi3_dup_exec */

            case E_V2SImode:
              if (pattern177 (x3, 
E_V2SImode, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1397; /* addv2si3_dup_exec */

            case E_V4QImode:
              if (pattern177 (x3, 
E_V4QImode, 
E_QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1399; /* addv4qi3_dup_exec */

            case E_V4HImode:
              if (pattern177 (x3, 
E_V4HImode, 
E_HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1401; /* addv4hi3_dup_exec */

            case E_V4SImode:
              if (pattern177 (x3, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1403; /* addv4si3_dup_exec */

            case E_V8QImode:
              if (pattern177 (x3, 
E_V8QImode, 
E_QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1405; /* addv8qi3_dup_exec */

            case E_V8HImode:
              if (pattern177 (x3, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1407; /* addv8hi3_dup_exec */

            case E_V8SImode:
              if (pattern177 (x3, 
E_V8SImode, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1409; /* addv8si3_dup_exec */

            case E_V16QImode:
              if (pattern177 (x3, 
E_V16QImode, 
E_QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1411; /* addv16qi3_dup_exec */

            case E_V16HImode:
              if (pattern177 (x3, 
E_V16HImode, 
E_HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1413; /* addv16hi3_dup_exec */

            case E_V16SImode:
              if (pattern177 (x3, 
E_V16SImode, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1415; /* addv16si3_dup_exec */

            case E_V32QImode:
              if (pattern177 (x3, 
E_V32QImode, 
E_QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1417; /* addv32qi3_dup_exec */

            case E_V32HImode:
              if (pattern177 (x3, 
E_V32HImode, 
E_HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1419; /* addv32hi3_dup_exec */

            case E_V32SImode:
              if (pattern177 (x3, 
E_V32SImode, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1421; /* addv32si3_dup_exec */

            case E_V64QImode:
              if (pattern177 (x3, 
E_V64QImode, 
E_QImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1423; /* addv64qi3_dup_exec */

            case E_V64HImode:
              if (pattern177 (x3, 
E_V64HImode, 
E_HImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1425; /* addv64hi3_dup_exec */

            case E_V64SImode:
              if (pattern177 (x3, 
E_V64SImode, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1427; /* addv64si3_dup_exec */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pnum_clobbers == NULL)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          switch (pattern161 (x3))
            {
            case 0:
              *pnum_clobbers = 1;
              return 1554; /* addv2di3_zext_exec */

            case 1:
              *pnum_clobbers = 1;
              return 1555; /* addv4di3_zext_exec */

            case 2:
              *pnum_clobbers = 1;
              return 1556; /* addv8di3_zext_exec */

            case 3:
              *pnum_clobbers = 1;
              return 1557; /* addv16di3_zext_exec */

            case 4:
              *pnum_clobbers = 1;
              return 1558; /* addv32di3_zext_exec */

            case 5:
              *pnum_clobbers = 1;
              return 1559; /* addv64di3_zext_exec */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pnum_clobbers == NULL)
            return -1;
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) != VEC_DUPLICATE)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          switch (pattern170 (x3))
            {
            case 0:
              *pnum_clobbers = 2;
              return 1590; /* addv2di3_sext_dup2_exec */

            case 1:
              *pnum_clobbers = 2;
              return 1591; /* addv4di3_sext_dup2_exec */

            case 2:
              *pnum_clobbers = 2;
              return 1592; /* addv8di3_sext_dup2_exec */

            case 3:
              *pnum_clobbers = 2;
              return 1593; /* addv16di3_sext_dup2_exec */

            case 4:
              *pnum_clobbers = 2;
              return 1594; /* addv32di3_sext_dup2_exec */

            case 5:
              *pnum_clobbers = 2;
              return 1595; /* addv64di3_sext_dup2_exec */

            default:
              return -1;
            }

        case MEM:
          switch (pattern122 (x3))
            {
            case 0:
              if (!
#line 2117 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1597; /* addv64si3_ds_exec */

            case 1:
              if (!
#line 2117 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1599; /* addv64sf3_ds_exec */

            case 2:
              if (!
#line 2117 "../../gcc/config/gcn/gcn-valu.md"
(rtx_equal_p (operands[0], operands[1])))
                return -1;
              return 1601; /* addv64di3_ds_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      return recog_60 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_50 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_62 (x1, insn, pnum_clobbers);

    case NOT:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      operands[3] = x6;
      if (!gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          if (pattern146 (x3, 
E_V2QImode) != 0)
            return -1;
          return 1756; /* one_cmplv2qi2_exec */

        case E_V2HImode:
          if (pattern146 (x3, 
E_V2HImode) != 0)
            return -1;
          return 1760; /* one_cmplv2hi2_exec */

        case E_V2SImode:
          if (pattern146 (x3, 
E_V2SImode) != 0)
            return -1;
          return 1764; /* one_cmplv2si2_exec */

        case E_V4QImode:
          if (pattern146 (x3, 
E_V4QImode) != 0)
            return -1;
          return 1768; /* one_cmplv4qi2_exec */

        case E_V4HImode:
          if (pattern146 (x3, 
E_V4HImode) != 0)
            return -1;
          return 1772; /* one_cmplv4hi2_exec */

        case E_V4SImode:
          if (pattern146 (x3, 
E_V4SImode) != 0)
            return -1;
          return 1776; /* one_cmplv4si2_exec */

        case E_V8QImode:
          if (pattern146 (x3, 
E_V8QImode) != 0)
            return -1;
          return 1780; /* one_cmplv8qi2_exec */

        case E_V8HImode:
          if (pattern146 (x3, 
E_V8HImode) != 0)
            return -1;
          return 1784; /* one_cmplv8hi2_exec */

        case E_V8SImode:
          if (pattern146 (x3, 
E_V8SImode) != 0)
            return -1;
          return 1788; /* one_cmplv8si2_exec */

        case E_V16QImode:
          if (pattern146 (x3, 
E_V16QImode) != 0)
            return -1;
          return 1792; /* one_cmplv16qi2_exec */

        case E_V16HImode:
          if (pattern146 (x3, 
E_V16HImode) != 0)
            return -1;
          return 1796; /* one_cmplv16hi2_exec */

        case E_V16SImode:
          if (pattern146 (x3, 
E_V16SImode) != 0)
            return -1;
          return 1800; /* one_cmplv16si2_exec */

        case E_V32QImode:
          if (pattern146 (x3, 
E_V32QImode) != 0)
            return -1;
          return 1804; /* one_cmplv32qi2_exec */

        case E_V32HImode:
          if (pattern146 (x3, 
E_V32HImode) != 0)
            return -1;
          return 1808; /* one_cmplv32hi2_exec */

        case E_V32SImode:
          if (pattern146 (x3, 
E_V32SImode) != 0)
            return -1;
          return 1812; /* one_cmplv32si2_exec */

        case E_V64QImode:
          if (pattern146 (x3, 
E_V64QImode) != 0)
            return -1;
          return 1816; /* one_cmplv64qi2_exec */

        case E_V64HImode:
          if (pattern146 (x3, 
E_V64HImode) != 0)
            return -1;
          return 1820; /* one_cmplv64hi2_exec */

        case E_V64SImode:
          if (pattern146 (x3, 
E_V64SImode) != 0)
            return -1;
          return 1824; /* one_cmplv64si2_exec */

        case E_V2DImode:
          if (pattern147 (x3, 
E_V2DImode) != 0)
            return -1;
          return 2212; /* one_cmplv2di2_exec */

        case E_V4DImode:
          if (pattern147 (x3, 
E_V4DImode) != 0)
            return -1;
          return 2214; /* one_cmplv4di2_exec */

        case E_V8DImode:
          if (pattern147 (x3, 
E_V8DImode) != 0)
            return -1;
          return 2216; /* one_cmplv8di2_exec */

        case E_V16DImode:
          if (pattern147 (x3, 
E_V16DImode) != 0)
            return -1;
          return 2218; /* one_cmplv16di2_exec */

        case E_V32DImode:
          if (pattern147 (x3, 
E_V32DImode) != 0)
            return -1;
          return 2220; /* one_cmplv32di2_exec */

        case E_V64DImode:
          if (pattern147 (x3, 
E_V64DImode) != 0)
            return -1;
          return 2222; /* one_cmplv64di2_exec */

        default:
          return -1;
        }

    case POPCOUNT:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      operands[3] = x6;
      if (!gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          if (pattern146 (x3, 
E_V2QImode) != 0)
            return -1;
          return 1758; /* popcountv2qi2_exec */

        case E_V2HImode:
          if (pattern146 (x3, 
E_V2HImode) != 0)
            return -1;
          return 1762; /* popcountv2hi2_exec */

        case E_V2SImode:
          if (pattern146 (x3, 
E_V2SImode) != 0)
            return -1;
          return 1766; /* popcountv2si2_exec */

        case E_V4QImode:
          if (pattern146 (x3, 
E_V4QImode) != 0)
            return -1;
          return 1770; /* popcountv4qi2_exec */

        case E_V4HImode:
          if (pattern146 (x3, 
E_V4HImode) != 0)
            return -1;
          return 1774; /* popcountv4hi2_exec */

        case E_V4SImode:
          if (pattern146 (x3, 
E_V4SImode) != 0)
            return -1;
          return 1778; /* popcountv4si2_exec */

        case E_V8QImode:
          if (pattern146 (x3, 
E_V8QImode) != 0)
            return -1;
          return 1782; /* popcountv8qi2_exec */

        case E_V8HImode:
          if (pattern146 (x3, 
E_V8HImode) != 0)
            return -1;
          return 1786; /* popcountv8hi2_exec */

        case E_V8SImode:
          if (pattern146 (x3, 
E_V8SImode) != 0)
            return -1;
          return 1790; /* popcountv8si2_exec */

        case E_V16QImode:
          if (pattern146 (x3, 
E_V16QImode) != 0)
            return -1;
          return 1794; /* popcountv16qi2_exec */

        case E_V16HImode:
          if (pattern146 (x3, 
E_V16HImode) != 0)
            return -1;
          return 1798; /* popcountv16hi2_exec */

        case E_V16SImode:
          if (pattern146 (x3, 
E_V16SImode) != 0)
            return -1;
          return 1802; /* popcountv16si2_exec */

        case E_V32QImode:
          if (pattern146 (x3, 
E_V32QImode) != 0)
            return -1;
          return 1806; /* popcountv32qi2_exec */

        case E_V32HImode:
          if (pattern146 (x3, 
E_V32HImode) != 0)
            return -1;
          return 1810; /* popcountv32hi2_exec */

        case E_V32SImode:
          if (pattern146 (x3, 
E_V32SImode) != 0)
            return -1;
          return 1814; /* popcountv32si2_exec */

        case E_V64QImode:
          if (pattern146 (x3, 
E_V64QImode) != 0)
            return -1;
          return 1818; /* popcountv64qi2_exec */

        case E_V64HImode:
          if (pattern146 (x3, 
E_V64HImode) != 0)
            return -1;
          return 1822; /* popcountv64hi2_exec */

        case E_V64SImode:
          if (pattern146 (x3, 
E_V64SImode) != 0)
            return -1;
          return 1826; /* popcountv64si2_exec */

        default:
          return -1;
        }

    case AND:
      switch (pattern41 (x3))
        {
        case 0:
          return 1828; /* andv2qi3_exec */

        case 1:
          return 1834; /* andv2hi3_exec */

        case 2:
          return 1840; /* andv2si3_exec */

        case 3:
          return 1846; /* andv4qi3_exec */

        case 4:
          return 1852; /* andv4hi3_exec */

        case 5:
          return 1858; /* andv4si3_exec */

        case 6:
          return 1864; /* andv8qi3_exec */

        case 7:
          return 1870; /* andv8hi3_exec */

        case 8:
          return 1876; /* andv8si3_exec */

        case 9:
          return 1882; /* andv16qi3_exec */

        case 10:
          return 1888; /* andv16hi3_exec */

        case 11:
          return 1894; /* andv16si3_exec */

        case 12:
          return 1900; /* andv32qi3_exec */

        case 13:
          return 1906; /* andv32hi3_exec */

        case 14:
          return 1912; /* andv32si3_exec */

        case 15:
          return 1918; /* andv64qi3_exec */

        case 16:
          return 1924; /* andv64hi3_exec */

        case 17:
          return 1930; /* andv64si3_exec */

        case 18:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1953; /* andv2di3_exec */

        case 19:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1956; /* andv4di3_exec */

        case 20:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1959; /* andv8di3_exec */

        case 21:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1962; /* andv16di3_exec */

        case 22:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1965; /* andv32di3_exec */

        case 23:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1968; /* andv64di3_exec */

        default:
          return -1;
        }

    case IOR:
      switch (pattern41 (x3))
        {
        case 0:
          return 1830; /* iorv2qi3_exec */

        case 1:
          return 1836; /* iorv2hi3_exec */

        case 2:
          return 1842; /* iorv2si3_exec */

        case 3:
          return 1848; /* iorv4qi3_exec */

        case 4:
          return 1854; /* iorv4hi3_exec */

        case 5:
          return 1860; /* iorv4si3_exec */

        case 6:
          return 1866; /* iorv8qi3_exec */

        case 7:
          return 1872; /* iorv8hi3_exec */

        case 8:
          return 1878; /* iorv8si3_exec */

        case 9:
          return 1884; /* iorv16qi3_exec */

        case 10:
          return 1890; /* iorv16hi3_exec */

        case 11:
          return 1896; /* iorv16si3_exec */

        case 12:
          return 1902; /* iorv32qi3_exec */

        case 13:
          return 1908; /* iorv32hi3_exec */

        case 14:
          return 1914; /* iorv32si3_exec */

        case 15:
          return 1920; /* iorv64qi3_exec */

        case 16:
          return 1926; /* iorv64hi3_exec */

        case 17:
          return 1932; /* iorv64si3_exec */

        case 18:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1954; /* iorv2di3_exec */

        case 19:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1957; /* iorv4di3_exec */

        case 20:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1960; /* iorv8di3_exec */

        case 21:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1963; /* iorv16di3_exec */

        case 22:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1966; /* iorv32di3_exec */

        case 23:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1969; /* iorv64di3_exec */

        default:
          return -1;
        }

    case XOR:
      switch (pattern41 (x3))
        {
        case 0:
          return 1832; /* xorv2qi3_exec */

        case 1:
          return 1838; /* xorv2hi3_exec */

        case 2:
          return 1844; /* xorv2si3_exec */

        case 3:
          return 1850; /* xorv4qi3_exec */

        case 4:
          return 1856; /* xorv4hi3_exec */

        case 5:
          return 1862; /* xorv4si3_exec */

        case 6:
          return 1868; /* xorv8qi3_exec */

        case 7:
          return 1874; /* xorv8hi3_exec */

        case 8:
          return 1880; /* xorv8si3_exec */

        case 9:
          return 1886; /* xorv16qi3_exec */

        case 10:
          return 1892; /* xorv16hi3_exec */

        case 11:
          return 1898; /* xorv16si3_exec */

        case 12:
          return 1904; /* xorv32qi3_exec */

        case 13:
          return 1910; /* xorv32hi3_exec */

        case 14:
          return 1916; /* xorv32si3_exec */

        case 15:
          return 1922; /* xorv64qi3_exec */

        case 16:
          return 1928; /* xorv64hi3_exec */

        case 17:
          return 1934; /* xorv64si3_exec */

        case 18:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1955; /* xorv2di3_exec */

        case 19:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1958; /* xorv4di3_exec */

        case 20:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1961; /* xorv8di3_exec */

        case 21:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1964; /* xorv16di3_exec */

        case 22:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1967; /* xorv32di3_exec */

        case 23:
          if (!
#line 2676 "../../gcc/config/gcn/gcn-valu.md"
(!memory_operand (operands[0], VOIDmode)
   || (rtx_equal_p (operands[0], operands[1])
       && register_operand (operands[2], VOIDmode))))
            return -1;
          return 1970; /* xorv64di3_exec */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern46 (x3))
        {
        case 0:
          return 1972; /* ashlv2si3_exec */

        case 1:
          return 1978; /* ashlv2di3_exec */

        case 2:
          return 1984; /* ashlv4si3_exec */

        case 3:
          return 1990; /* ashlv4di3_exec */

        case 4:
          return 1996; /* ashlv8si3_exec */

        case 5:
          return 2002; /* ashlv8di3_exec */

        case 6:
          return 2008; /* ashlv16si3_exec */

        case 7:
          return 2014; /* ashlv16di3_exec */

        case 8:
          return 2020; /* ashlv32si3_exec */

        case 9:
          return 2026; /* ashlv32di3_exec */

        case 10:
          return 2032; /* ashlv64si3_exec */

        case 11:
          return 2038; /* ashlv64di3_exec */

        case 12:
          return 2044; /* vashlv2si3_exec */

        case 13:
          return 2050; /* vashlv2di3_exec */

        case 14:
          return 2056; /* vashlv4si3_exec */

        case 15:
          return 2062; /* vashlv4di3_exec */

        case 16:
          return 2068; /* vashlv8si3_exec */

        case 17:
          return 2074; /* vashlv8di3_exec */

        case 18:
          return 2080; /* vashlv16si3_exec */

        case 19:
          return 2086; /* vashlv16di3_exec */

        case 20:
          return 2092; /* vashlv32si3_exec */

        case 21:
          return 2098; /* vashlv32di3_exec */

        case 22:
          return 2104; /* vashlv64si3_exec */

        case 23:
          return 2110; /* vashlv64di3_exec */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern46 (x3))
        {
        case 0:
          return 1974; /* lshrv2si3_exec */

        case 1:
          return 1980; /* lshrv2di3_exec */

        case 2:
          return 1986; /* lshrv4si3_exec */

        case 3:
          return 1992; /* lshrv4di3_exec */

        case 4:
          return 1998; /* lshrv8si3_exec */

        case 5:
          return 2004; /* lshrv8di3_exec */

        case 6:
          return 2010; /* lshrv16si3_exec */

        case 7:
          return 2016; /* lshrv16di3_exec */

        case 8:
          return 2022; /* lshrv32si3_exec */

        case 9:
          return 2028; /* lshrv32di3_exec */

        case 10:
          return 2034; /* lshrv64si3_exec */

        case 11:
          return 2040; /* lshrv64di3_exec */

        case 12:
          return 2046; /* vlshrv2si3_exec */

        case 13:
          return 2052; /* vlshrv2di3_exec */

        case 14:
          return 2058; /* vlshrv4si3_exec */

        case 15:
          return 2064; /* vlshrv4di3_exec */

        case 16:
          return 2070; /* vlshrv8si3_exec */

        case 17:
          return 2076; /* vlshrv8di3_exec */

        case 18:
          return 2082; /* vlshrv16si3_exec */

        case 19:
          return 2088; /* vlshrv16di3_exec */

        case 20:
          return 2094; /* vlshrv32si3_exec */

        case 21:
          return 2100; /* vlshrv32di3_exec */

        case 22:
          return 2106; /* vlshrv64si3_exec */

        case 23:
          return 2112; /* vlshrv64di3_exec */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern46 (x3))
        {
        case 0:
          return 1976; /* ashrv2si3_exec */

        case 1:
          return 1982; /* ashrv2di3_exec */

        case 2:
          return 1988; /* ashrv4si3_exec */

        case 3:
          return 1994; /* ashrv4di3_exec */

        case 4:
          return 2000; /* ashrv8si3_exec */

        case 5:
          return 2006; /* ashrv8di3_exec */

        case 6:
          return 2012; /* ashrv16si3_exec */

        case 7:
          return 2018; /* ashrv16di3_exec */

        case 8:
          return 2024; /* ashrv32si3_exec */

        case 9:
          return 2030; /* ashrv32di3_exec */

        case 10:
          return 2036; /* ashrv64si3_exec */

        case 11:
          return 2042; /* ashrv64di3_exec */

        case 12:
          return 2048; /* vashrv2si3_exec */

        case 13:
          return 2054; /* vashrv2di3_exec */

        case 14:
          return 2060; /* vashrv4si3_exec */

        case 15:
          return 2066; /* vashrv4di3_exec */

        case 16:
          return 2072; /* vashrv8si3_exec */

        case 17:
          return 2078; /* vashrv8di3_exec */

        case 18:
          return 2084; /* vashrv16si3_exec */

        case 19:
          return 2090; /* vashrv16di3_exec */

        case 20:
          return 2096; /* vashrv32si3_exec */

        case 21:
          return 2102; /* vashrv32di3_exec */

        case 22:
          return 2108; /* vashrv64si3_exec */

        case 23:
          return 2114; /* vashrv64di3_exec */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern47 (x3, pnum_clobbers))
        {
        case 0:
          return 2116; /* sminv2si3_exec */

        case 1:
          return 2124; /* sminv4si3_exec */

        case 2:
          return 2132; /* sminv8si3_exec */

        case 3:
          return 2140; /* sminv16si3_exec */

        case 4:
          return 2148; /* sminv32si3_exec */

        case 5:
          return 2156; /* sminv64si3_exec */

        case 6:
          *pnum_clobbers = 2;
          return 2187; /* sminv2di3_exec */

        case 7:
          *pnum_clobbers = 2;
          return 2191; /* sminv4di3_exec */

        case 8:
          *pnum_clobbers = 2;
          return 2195; /* sminv8di3_exec */

        case 9:
          *pnum_clobbers = 2;
          return 2199; /* sminv16di3_exec */

        case 10:
          *pnum_clobbers = 2;
          return 2203; /* sminv32di3_exec */

        case 11:
          *pnum_clobbers = 2;
          return 2207; /* sminv64di3_exec */

        case 12:
          return 2241; /* sminv2hf3_exec */

        case 13:
          return 2249; /* sminv2sf3_exec */

        case 14:
          return 2257; /* sminv2df3_exec */

        case 15:
          return 2265; /* sminv4hf3_exec */

        case 16:
          return 2273; /* sminv4sf3_exec */

        case 17:
          return 2281; /* sminv4df3_exec */

        case 18:
          return 2289; /* sminv8hf3_exec */

        case 19:
          return 2297; /* sminv8sf3_exec */

        case 20:
          return 2305; /* sminv8df3_exec */

        case 21:
          return 2313; /* sminv16hf3_exec */

        case 22:
          return 2321; /* sminv16sf3_exec */

        case 23:
          return 2329; /* sminv16df3_exec */

        case 24:
          return 2337; /* sminv32hf3_exec */

        case 25:
          return 2345; /* sminv32sf3_exec */

        case 26:
          return 2353; /* sminv32df3_exec */

        case 27:
          return 2361; /* sminv64hf3_exec */

        case 28:
          return 2369; /* sminv64sf3_exec */

        case 29:
          return 2377; /* sminv64df3_exec */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern47 (x3, pnum_clobbers))
        {
        case 0:
          return 2118; /* smaxv2si3_exec */

        case 1:
          return 2126; /* smaxv4si3_exec */

        case 2:
          return 2134; /* smaxv8si3_exec */

        case 3:
          return 2142; /* smaxv16si3_exec */

        case 4:
          return 2150; /* smaxv32si3_exec */

        case 5:
          return 2158; /* smaxv64si3_exec */

        case 6:
          *pnum_clobbers = 2;
          return 2188; /* smaxv2di3_exec */

        case 7:
          *pnum_clobbers = 2;
          return 2192; /* smaxv4di3_exec */

        case 8:
          *pnum_clobbers = 2;
          return 2196; /* smaxv8di3_exec */

        case 9:
          *pnum_clobbers = 2;
          return 2200; /* smaxv16di3_exec */

        case 10:
          *pnum_clobbers = 2;
          return 2204; /* smaxv32di3_exec */

        case 11:
          *pnum_clobbers = 2;
          return 2208; /* smaxv64di3_exec */

        case 12:
          return 2243; /* smaxv2hf3_exec */

        case 13:
          return 2251; /* smaxv2sf3_exec */

        case 14:
          return 2259; /* smaxv2df3_exec */

        case 15:
          return 2267; /* smaxv4hf3_exec */

        case 16:
          return 2275; /* smaxv4sf3_exec */

        case 17:
          return 2283; /* smaxv4df3_exec */

        case 18:
          return 2291; /* smaxv8hf3_exec */

        case 19:
          return 2299; /* smaxv8sf3_exec */

        case 20:
          return 2307; /* smaxv8df3_exec */

        case 21:
          return 2315; /* smaxv16hf3_exec */

        case 22:
          return 2323; /* smaxv16sf3_exec */

        case 23:
          return 2331; /* smaxv16df3_exec */

        case 24:
          return 2339; /* smaxv32hf3_exec */

        case 25:
          return 2347; /* smaxv32sf3_exec */

        case 26:
          return 2355; /* smaxv32df3_exec */

        case 27:
          return 2363; /* smaxv64hf3_exec */

        case 28:
          return 2371; /* smaxv64sf3_exec */

        case 29:
          return 2379; /* smaxv64df3_exec */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern48 (x3, pnum_clobbers))
        {
        case 0:
          return 2120; /* uminv2si3_exec */

        case 1:
          return 2128; /* uminv4si3_exec */

        case 2:
          return 2136; /* uminv8si3_exec */

        case 3:
          return 2144; /* uminv16si3_exec */

        case 4:
          return 2152; /* uminv32si3_exec */

        case 5:
          return 2160; /* uminv64si3_exec */

        case 6:
          *pnum_clobbers = 2;
          return 2189; /* uminv2di3_exec */

        case 7:
          *pnum_clobbers = 2;
          return 2193; /* uminv4di3_exec */

        case 8:
          *pnum_clobbers = 2;
          return 2197; /* uminv8di3_exec */

        case 9:
          *pnum_clobbers = 2;
          return 2201; /* uminv16di3_exec */

        case 10:
          *pnum_clobbers = 2;
          return 2205; /* uminv32di3_exec */

        case 11:
          *pnum_clobbers = 2;
          return 2209; /* uminv64di3_exec */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern48 (x3, pnum_clobbers))
        {
        case 0:
          return 2122; /* umaxv2si3_exec */

        case 1:
          return 2130; /* umaxv4si3_exec */

        case 2:
          return 2138; /* umaxv8si3_exec */

        case 3:
          return 2146; /* umaxv16si3_exec */

        case 4:
          return 2154; /* umaxv32si3_exec */

        case 5:
          return 2162; /* umaxv64si3_exec */

        case 6:
          *pnum_clobbers = 2;
          return 2190; /* umaxv2di3_exec */

        case 7:
          *pnum_clobbers = 2;
          return 2194; /* umaxv4di3_exec */

        case 8:
          *pnum_clobbers = 2;
          return 2198; /* umaxv8di3_exec */

        case 9:
          *pnum_clobbers = 2;
          return 2202; /* umaxv16di3_exec */

        case 10:
          *pnum_clobbers = 2;
          return 2206; /* umaxv32di3_exec */

        case 11:
          *pnum_clobbers = 2;
          return 2210; /* umaxv64di3_exec */

        default:
          return -1;
        }

    case ABS:
      switch (pattern50 (x3))
        {
        case 0:
          return 2422; /* absv2hf2_exec */

        case 1:
          return 2424; /* absv2sf2_exec */

        case 2:
          return 2426; /* absv2df2_exec */

        case 3:
          return 2428; /* absv4hf2_exec */

        case 4:
          return 2430; /* absv4sf2_exec */

        case 5:
          return 2432; /* absv4df2_exec */

        case 6:
          return 2434; /* absv8hf2_exec */

        case 7:
          return 2436; /* absv8sf2_exec */

        case 8:
          return 2438; /* absv8df2_exec */

        case 9:
          return 2440; /* absv16hf2_exec */

        case 10:
          return 2442; /* absv16sf2_exec */

        case 11:
          return 2444; /* absv16df2_exec */

        case 12:
          return 2446; /* absv32hf2_exec */

        case 13:
          return 2448; /* absv32sf2_exec */

        case 14:
          return 2450; /* absv32df2_exec */

        case 15:
          return 2452; /* absv64hf2_exec */

        case 16:
          return 2454; /* absv64sf2_exec */

        case 17:
          return 2456; /* absv64df2_exec */

        default:
          return -1;
        }

    case NEG:
      switch (pattern50 (x3))
        {
        case 0:
          return 2458; /* negv2hf2_exec */

        case 1:
          return 2460; /* negv2sf2_exec */

        case 2:
          return 2462; /* negv2df2_exec */

        case 3:
          return 2464; /* negv4hf2_exec */

        case 4:
          return 2466; /* negv4sf2_exec */

        case 5:
          return 2468; /* negv4df2_exec */

        case 6:
          return 2470; /* negv8hf2_exec */

        case 7:
          return 2472; /* negv8sf2_exec */

        case 8:
          return 2474; /* negv8df2_exec */

        case 9:
          return 2476; /* negv16hf2_exec */

        case 10:
          return 2478; /* negv16sf2_exec */

        case 11:
          return 2480; /* negv16df2_exec */

        case 12:
          return 2482; /* negv32hf2_exec */

        case 13:
          return 2484; /* negv32sf2_exec */

        case 14:
          return 2486; /* negv32df2_exec */

        case 15:
          return 2488; /* negv64hf2_exec */

        case 16:
          return 2490; /* negv64sf2_exec */

        case 17:
          return 2492; /* negv64df2_exec */

        default:
          return -1;
        }

    case SQRT:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      operands[3] = x6;
      if (!gcn_exec_reg_operand (operands[3], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HFmode:
          if (pattern147 (x3, 
E_V2HFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2494; /* sqrtv2hf2_exec */

        case E_V2SFmode:
          if (pattern147 (x3, 
E_V2SFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2496; /* sqrtv2sf2_exec */

        case E_V2DFmode:
          if (pattern147 (x3, 
E_V2DFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2498; /* sqrtv2df2_exec */

        case E_V4HFmode:
          if (pattern147 (x3, 
E_V4HFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2500; /* sqrtv4hf2_exec */

        case E_V4SFmode:
          if (pattern147 (x3, 
E_V4SFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2502; /* sqrtv4sf2_exec */

        case E_V4DFmode:
          if (pattern147 (x3, 
E_V4DFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2504; /* sqrtv4df2_exec */

        case E_V8HFmode:
          if (pattern147 (x3, 
E_V8HFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2506; /* sqrtv8hf2_exec */

        case E_V8SFmode:
          if (pattern147 (x3, 
E_V8SFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2508; /* sqrtv8sf2_exec */

        case E_V8DFmode:
          if (pattern147 (x3, 
E_V8DFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2510; /* sqrtv8df2_exec */

        case E_V16HFmode:
          if (pattern147 (x3, 
E_V16HFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2512; /* sqrtv16hf2_exec */

        case E_V16SFmode:
          if (pattern147 (x3, 
E_V16SFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2514; /* sqrtv16sf2_exec */

        case E_V16DFmode:
          if (pattern147 (x3, 
E_V16DFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2516; /* sqrtv16df2_exec */

        case E_V32HFmode:
          if (pattern147 (x3, 
E_V32HFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2518; /* sqrtv32hf2_exec */

        case E_V32SFmode:
          if (pattern147 (x3, 
E_V32SFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2520; /* sqrtv32sf2_exec */

        case E_V32DFmode:
          if (pattern147 (x3, 
E_V32DFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2522; /* sqrtv32df2_exec */

        case E_V64HFmode:
          if (pattern147 (x3, 
E_V64HFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2524; /* sqrtv64hf2_exec */

        case E_V64SFmode:
          if (pattern147 (x3, 
E_V64SFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2526; /* sqrtv64sf2_exec */

        case E_V64DFmode:
          if (pattern147 (x3, 
E_V64DFmode) != 0
              || !
#line 3056 "../../gcc/config/gcn/gcn-valu.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 2528; /* sqrtv64df2_exec */

        default:
          return -1;
        }

    case FMA:
      return recog_61 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_58 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_57 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_56 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_55 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_54 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_53 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_49 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_48 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 41; /* mulsi3 */

            case E_DImode:
              if (pattern115 (x3, pnum_clobbers) != 0)
                return -1;
              *pnum_clobbers = 3;
              return 50; /* muldi3 */

            case E_V2QImode:
              if (pattern1 (x3, 
E_V2QImode) != 0)
                return -1;
              return 1647; /* mulv2qi3 */

            case E_V2HImode:
              if (pattern1 (x3, 
E_V2HImode) != 0)
                return -1;
              return 1649; /* mulv2hi3 */

            case E_V2SImode:
              if (pattern1 (x3, 
E_V2SImode) != 0)
                return -1;
              return 1651; /* mulv2si3 */

            case E_V4QImode:
              if (pattern1 (x3, 
E_V4QImode) != 0)
                return -1;
              return 1653; /* mulv4qi3 */

            case E_V4HImode:
              if (pattern1 (x3, 
E_V4HImode) != 0)
                return -1;
              return 1655; /* mulv4hi3 */

            case E_V4SImode:
              if (pattern1 (x3, 
E_V4SImode) != 0)
                return -1;
              return 1657; /* mulv4si3 */

            case E_V8QImode:
              if (pattern1 (x3, 
E_V8QImode) != 0)
                return -1;
              return 1659; /* mulv8qi3 */

            case E_V8HImode:
              if (pattern1 (x3, 
E_V8HImode) != 0)
                return -1;
              return 1661; /* mulv8hi3 */

            case E_V8SImode:
              if (pattern1 (x3, 
E_V8SImode) != 0)
                return -1;
              return 1663; /* mulv8si3 */

            case E_V16QImode:
              if (pattern1 (x3, 
E_V16QImode) != 0)
                return -1;
              return 1665; /* mulv16qi3 */

            case E_V16HImode:
              if (pattern1 (x3, 
E_V16HImode) != 0)
                return -1;
              return 1667; /* mulv16hi3 */

            case E_V16SImode:
              if (pattern1 (x3, 
E_V16SImode) != 0)
                return -1;
              return 1669; /* mulv16si3 */

            case E_V32QImode:
              if (pattern1 (x3, 
E_V32QImode) != 0)
                return -1;
              return 1671; /* mulv32qi3 */

            case E_V32HImode:
              if (pattern1 (x3, 
E_V32HImode) != 0)
                return -1;
              return 1673; /* mulv32hi3 */

            case E_V32SImode:
              if (pattern1 (x3, 
E_V32SImode) != 0)
                return -1;
              return 1675; /* mulv32si3 */

            case E_V64QImode:
              if (pattern1 (x3, 
E_V64QImode) != 0)
                return -1;
              return 1677; /* mulv64qi3 */

            case E_V64HImode:
              if (pattern1 (x3, 
E_V64HImode) != 0)
                return -1;
              return 1679; /* mulv64hi3 */

            case E_V64SImode:
              if (pattern1 (x3, 
E_V64SImode) != 0)
                return -1;
              return 1681; /* mulv64si3 */

            case E_V2DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V2DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1719; /* mulv2di3 */

            case E_V4DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V4DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1720; /* mulv4di3 */

            case E_V8DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V8DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1721; /* mulv8di3 */

            case E_V16DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V16DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1722; /* mulv16di3 */

            case E_V32DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V32DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1723; /* mulv32di3 */

            case E_V64DImode:
              if (pnum_clobbers == NULL
                  || pattern1 (x3, 
E_V64DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1724; /* mulv64di3 */

            case E_V2HFmode:
              if (pattern1 (x3, 
E_V2HFmode) != 0)
                return -1;
              return 2238; /* mulv2hf3 */

            case E_V2SFmode:
              if (pattern1 (x3, 
E_V2SFmode) != 0)
                return -1;
              return 2246; /* mulv2sf3 */

            case E_V2DFmode:
              if (pattern1 (x3, 
E_V2DFmode) != 0)
                return -1;
              return 2254; /* mulv2df3 */

            case E_V4HFmode:
              if (pattern1 (x3, 
E_V4HFmode) != 0)
                return -1;
              return 2262; /* mulv4hf3 */

            case E_V4SFmode:
              if (pattern1 (x3, 
E_V4SFmode) != 0)
                return -1;
              return 2270; /* mulv4sf3 */

            case E_V4DFmode:
              if (pattern1 (x3, 
E_V4DFmode) != 0)
                return -1;
              return 2278; /* mulv4df3 */

            case E_V8HFmode:
              if (pattern1 (x3, 
E_V8HFmode) != 0)
                return -1;
              return 2286; /* mulv8hf3 */

            case E_V8SFmode:
              if (pattern1 (x3, 
E_V8SFmode) != 0)
                return -1;
              return 2294; /* mulv8sf3 */

            case E_V8DFmode:
              if (pattern1 (x3, 
E_V8DFmode) != 0)
                return -1;
              return 2302; /* mulv8df3 */

            case E_V16HFmode:
              if (pattern1 (x3, 
E_V16HFmode) != 0)
                return -1;
              return 2310; /* mulv16hf3 */

            case E_V16SFmode:
              if (pattern1 (x3, 
E_V16SFmode) != 0)
                return -1;
              return 2318; /* mulv16sf3 */

            case E_V16DFmode:
              if (pattern1 (x3, 
E_V16DFmode) != 0)
                return -1;
              return 2326; /* mulv16df3 */

            case E_V32HFmode:
              if (pattern1 (x3, 
E_V32HFmode) != 0)
                return -1;
              return 2334; /* mulv32hf3 */

            case E_V32SFmode:
              if (pattern1 (x3, 
E_V32SFmode) != 0)
                return -1;
              return 2342; /* mulv32sf3 */

            case E_V32DFmode:
              if (pattern1 (x3, 
E_V32DFmode) != 0)
                return -1;
              return 2350; /* mulv32df3 */

            case E_V64HFmode:
              if (pattern1 (x3, 
E_V64HFmode) != 0)
                return -1;
              return 2358; /* mulv64hf3 */

            case E_V64SFmode:
              if (pattern1 (x3, 
E_V64SFmode) != 0)
                return -1;
              return 2366; /* mulv64sf3 */

            case E_V64DFmode:
              if (pattern1 (x3, 
E_V64DFmode) != 0)
                return -1;
              return 2374; /* mulv64df3 */

            case E_HFmode:
              if (pattern5 (x3, 
E_HFmode) != 0)
                return -1;
              return 2381; /* mulhf3 */

            case E_SFmode:
              if (pattern5 (x3, 
E_SFmode) != 0)
                return -1;
              return 2385; /* mulsf3 */

            case E_DFmode:
              if (pattern5 (x3, 
E_DFmode) != 0)
                return -1;
              return 2389; /* muldf3 */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V2QImode:
              if (pattern119 (x3, 
E_QImode, 
E_V2QImode) != 0)
                return -1;
              return 1683; /* mulv2qi3_dup */

            case E_V2HImode:
              if (pattern119 (x3, 
E_HImode, 
E_V2HImode) != 0)
                return -1;
              return 1685; /* mulv2hi3_dup */

            case E_V2SImode:
              if (pattern119 (x3, 
E_SImode, 
E_V2SImode) != 0)
                return -1;
              return 1687; /* mulv2si3_dup */

            case E_V4QImode:
              if (pattern119 (x3, 
E_QImode, 
E_V4QImode) != 0)
                return -1;
              return 1689; /* mulv4qi3_dup */

            case E_V4HImode:
              if (pattern119 (x3, 
E_HImode, 
E_V4HImode) != 0)
                return -1;
              return 1691; /* mulv4hi3_dup */

            case E_V4SImode:
              if (pattern119 (x3, 
E_SImode, 
E_V4SImode) != 0)
                return -1;
              return 1693; /* mulv4si3_dup */

            case E_V8QImode:
              if (pattern119 (x3, 
E_QImode, 
E_V8QImode) != 0)
                return -1;
              return 1695; /* mulv8qi3_dup */

            case E_V8HImode:
              if (pattern119 (x3, 
E_HImode, 
E_V8HImode) != 0)
                return -1;
              return 1697; /* mulv8hi3_dup */

            case E_V8SImode:
              if (pattern119 (x3, 
E_SImode, 
E_V8SImode) != 0)
                return -1;
              return 1699; /* mulv8si3_dup */

            case E_V16QImode:
              if (pattern119 (x3, 
E_QImode, 
E_V16QImode) != 0)
                return -1;
              return 1701; /* mulv16qi3_dup */

            case E_V16HImode:
              if (pattern119 (x3, 
E_HImode, 
E_V16HImode) != 0)
                return -1;
              return 1703; /* mulv16hi3_dup */

            case E_V16SImode:
              if (pattern119 (x3, 
E_SImode, 
E_V16SImode) != 0)
                return -1;
              return 1705; /* mulv16si3_dup */

            case E_V32QImode:
              if (pattern119 (x3, 
E_QImode, 
E_V32QImode) != 0)
                return -1;
              return 1707; /* mulv32qi3_dup */

            case E_V32HImode:
              if (pattern119 (x3, 
E_HImode, 
E_V32HImode) != 0)
                return -1;
              return 1709; /* mulv32hi3_dup */

            case E_V32SImode:
              if (pattern119 (x3, 
E_SImode, 
E_V32SImode) != 0)
                return -1;
              return 1711; /* mulv32si3_dup */

            case E_V64QImode:
              if (pattern119 (x3, 
E_QImode, 
E_V64QImode) != 0)
                return -1;
              return 1713; /* mulv64qi3_dup */

            case E_V64HImode:
              if (pattern119 (x3, 
E_HImode, 
E_V64HImode) != 0)
                return -1;
              return 1715; /* mulv64hi3_dup */

            case E_V64SImode:
              if (pattern119 (x3, 
E_SImode, 
E_V64SImode) != 0)
                return -1;
              return 1717; /* mulv64si3_dup */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          switch (pattern93 (x3))
            {
            case 0:
              return 46; /* smulsidi3_reg */

            case 1:
              if (!
#line 1597 "../../gcc/config/gcn/gcn.md"
(TARGET_SDWA))
                return -1;
              return 51; /* mulhisi3 */

            case 2:
              if (!
#line 1607 "../../gcc/config/gcn/gcn.md"
(TARGET_SDWA))
                return -1;
              return 53; /* mulqihi3_scalar */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x5;
          if (!gcn_32bit_immediate_operand (operands[2], E_DImode)
              || pattern120 (x3) != 0)
            return -1;
          return 48; /* smulsidi3_imm */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          switch (pattern93 (x3))
            {
            case 0:
              return 47; /* umulsidi3_reg */

            case 1:
              if (!
#line 1597 "../../gcc/config/gcn/gcn.md"
(TARGET_SDWA))
                return -1;
              return 52; /* umulhisi3 */

            case 2:
              if (!
#line 1607 "../../gcc/config/gcn/gcn.md"
(TARGET_SDWA))
                return -1;
              return 54; /* umulqihi3_scalar */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern120 (x3) != 0
                  || !gcn_32bit_immediate_operand (operands[2], E_DImode))
                return -1;
              return 49; /* umulsidi3_imm */

            case E_V2DImode:
              if (pnum_clobbers == NULL
                  || pattern114 (x3, 
E_V2DImode, 
E_V2SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1731; /* mulv2di3_zext */

            case E_V4DImode:
              if (pnum_clobbers == NULL
                  || pattern114 (x3, 
E_V4DImode, 
E_V4SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1732; /* mulv4di3_zext */

            case E_V8DImode:
              if (pnum_clobbers == NULL
                  || pattern114 (x3, 
E_V8DImode, 
E_V8SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1733; /* mulv8di3_zext */

            case E_V16DImode:
              if (pnum_clobbers == NULL
                  || pattern114 (x3, 
E_V16DImode, 
E_V16SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1734; /* mulv16di3_zext */

            case E_V32DImode:
              if (pnum_clobbers == NULL
                  || pattern114 (x3, 
E_V32DImode, 
E_V32SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1735; /* mulv32di3_zext */

            case E_V64DImode:
              if (pnum_clobbers == NULL
                  || pattern114 (x3, 
E_V64DImode, 
E_V64SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 1736; /* mulv64di3_zext */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern104 (x3))
            {
            case 0:
              *pnum_clobbers = 1;
              return 1743; /* mulv2di3_zext_dup2 */

            case 1:
              *pnum_clobbers = 1;
              return 1744; /* mulv4di3_zext_dup2 */

            case 2:
              *pnum_clobbers = 1;
              return 1745; /* mulv8di3_zext_dup2 */

            case 3:
              *pnum_clobbers = 1;
              return 1746; /* mulv16di3_zext_dup2 */

            case 4:
              *pnum_clobbers = 1;
              return 1747; /* mulv32di3_zext_dup2 */

            case 5:
              *pnum_clobbers = 1;
              return 1748; /* mulv64di3_zext_dup2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2418; /* abshf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 2419; /* abssf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 2420; /* absdf2 */

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 2421; /* absv2hf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 2423; /* absv2sf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 2425; /* absv2df2 */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 2427; /* absv4hf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 2429; /* absv4sf2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2431; /* absv4df2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 2433; /* absv8hf2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 2435; /* absv8sf2 */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 2437; /* absv8df2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 2439; /* absv16hf2 */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 2441; /* absv16sf2 */

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 2443; /* absv16df2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 2445; /* absv32hf2 */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 2447; /* absv32sf2 */

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 2449; /* absv32df2 */

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 2451; /* absv64hf2 */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 2453; /* absv64sf2 */

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 2455; /* absv64df2 */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_87 (x1, insn, pnum_clobbers);

    case PLUS:
      x5 = XEXP (x3, 2);
      if (!gcn_exec_reg_operand (x5, E_DImode))
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          switch (pattern162 (x1, 
PLUS, 
LTU))
            {
            case 0:
              if (pattern204 (x3, 
E_V2QImode) != 0)
                return -1;
              return 1357; /* addv2qi3_exec */

            case 1:
              if (pattern204 (x3, 
E_V2HImode) != 0)
                return -1;
              return 1359; /* addv2hi3_exec */

            case 2:
              if (pattern204 (x3, 
E_V2SImode) != 0)
                return -1;
              return 1361; /* addv2si3_exec */

            case 3:
              if (pattern204 (x3, 
E_V4QImode) != 0)
                return -1;
              return 1363; /* addv4qi3_exec */

            case 4:
              if (pattern204 (x3, 
E_V4HImode) != 0)
                return -1;
              return 1365; /* addv4hi3_exec */

            case 5:
              if (pattern204 (x3, 
E_V4SImode) != 0)
                return -1;
              return 1367; /* addv4si3_exec */

            case 6:
              if (pattern204 (x3, 
E_V8QImode) != 0)
                return -1;
              return 1369; /* addv8qi3_exec */

            case 7:
              if (pattern204 (x3, 
E_V8HImode) != 0)
                return -1;
              return 1371; /* addv8hi3_exec */

            case 8:
              if (pattern204 (x3, 
E_V8SImode) != 0)
                return -1;
              return 1373; /* addv8si3_exec */

            case 9:
              if (pattern204 (x3, 
E_V16QImode) != 0)
                return -1;
              return 1375; /* addv16qi3_exec */

            case 10:
              if (pattern204 (x3, 
E_V16HImode) != 0)
                return -1;
              return 1377; /* addv16hi3_exec */

            case 11:
              if (pattern204 (x3, 
E_V16SImode) != 0)
                return -1;
              return 1379; /* addv16si3_exec */

            case 12:
              if (pattern204 (x3, 
E_V32QImode) != 0)
                return -1;
              return 1381; /* addv32qi3_exec */

            case 13:
              if (pattern204 (x3, 
E_V32HImode) != 0)
                return -1;
              return 1383; /* addv32hi3_exec */

            case 14:
              if (pattern204 (x3, 
E_V32SImode) != 0)
                return -1;
              return 1385; /* addv32si3_exec */

            case 15:
              if (pattern204 (x3, 
E_V64QImode) != 0)
                return -1;
              return 1387; /* addv64qi3_exec */

            case 16:
              if (pattern204 (x3, 
E_V64HImode) != 0)
                return -1;
              return 1389; /* addv64hi3_exec */

            case 17:
              if (pattern204 (x3, 
E_V64SImode) != 0)
                return -1;
              return 1391; /* addv64si3_exec */

            case 18:
              if (pattern204 (x3, 
E_V2DImode) != 0)
                return -1;
              return 1530; /* addv2di3_exec */

            case 19:
              if (pattern204 (x3, 
E_V4DImode) != 0)
                return -1;
              return 1531; /* addv4di3_exec */

            case 20:
              if (pattern204 (x3, 
E_V8DImode) != 0)
                return -1;
              return 1532; /* addv8di3_exec */

            case 21:
              if (pattern204 (x3, 
E_V16DImode) != 0)
                return -1;
              return 1533; /* addv16di3_exec */

            case 22:
              if (pattern204 (x3, 
E_V32DImode) != 0)
                return -1;
              return 1534; /* addv32di3_exec */

            case 23:
              if (pattern204 (x3, 
E_V64DImode) != 0)
                return -1;
              return 1535; /* addv64di3_exec */

            case 24:
              if (pattern238 (x1, 
E_V2SImode) != 0)
                return -1;
              return 1429; /* addv2si3_vcc_exec */

            case 25:
              if (pattern238 (x1, 
E_V4SImode) != 0)
                return -1;
              return 1431; /* addv4si3_vcc_exec */

            case 26:
              if (pattern238 (x1, 
E_V8SImode) != 0)
                return -1;
              return 1433; /* addv8si3_vcc_exec */

            case 27:
              if (pattern238 (x1, 
E_V16SImode) != 0)
                return -1;
              return 1435; /* addv16si3_vcc_exec */

            case 28:
              if (pattern238 (x1, 
E_V32SImode) != 0)
                return -1;
              return 1437; /* addv32si3_vcc_exec */

            case 29:
              if (pattern238 (x1, 
E_V64SImode) != 0)
                return -1;
              return 1439; /* addv64si3_vcc_exec */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x8 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x8))
            {
            case CLOBBER:
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 106
                  || GET_MODE (x9) != E_DImode)
                return -1;
              x10 = XEXP (x6, 0);
              operands[2] = x10;
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              x11 = XEXP (x3, 1);
              operands[3] = x11;
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V2QImode:
                  if (pattern205 (x3, 
E_V2QImode, 
E_QImode) != 0)
                    return -1;
                  return 1393; /* addv2qi3_dup_exec */

                case E_V2HImode:
                  if (pattern205 (x3, 
E_V2HImode, 
E_HImode) != 0)
                    return -1;
                  return 1395; /* addv2hi3_dup_exec */

                case E_V2SImode:
                  if (pattern205 (x3, 
E_V2SImode, 
E_SImode) != 0)
                    return -1;
                  return 1397; /* addv2si3_dup_exec */

                case E_V4QImode:
                  if (pattern205 (x3, 
E_V4QImode, 
E_QImode) != 0)
                    return -1;
                  return 1399; /* addv4qi3_dup_exec */

                case E_V4HImode:
                  if (pattern205 (x3, 
E_V4HImode, 
E_HImode) != 0)
                    return -1;
                  return 1401; /* addv4hi3_dup_exec */

                case E_V4SImode:
                  if (pattern205 (x3, 
E_V4SImode, 
E_SImode) != 0)
                    return -1;
                  return 1403; /* addv4si3_dup_exec */

                case E_V8QImode:
                  if (pattern205 (x3, 
E_V8QImode, 
E_QImode) != 0)
                    return -1;
                  return 1405; /* addv8qi3_dup_exec */

                case E_V8HImode:
                  if (pattern205 (x3, 
E_V8HImode, 
E_HImode) != 0)
                    return -1;
                  return 1407; /* addv8hi3_dup_exec */

                case E_V8SImode:
                  if (pattern205 (x3, 
E_V8SImode, 
E_SImode) != 0)
                    return -1;
                  return 1409; /* addv8si3_dup_exec */

                case E_V16QImode:
                  if (pattern205 (x3, 
E_V16QImode, 
E_QImode) != 0)
                    return -1;
                  return 1411; /* addv16qi3_dup_exec */

                case E_V16HImode:
                  if (pattern205 (x3, 
E_V16HImode, 
E_HImode) != 0)
                    return -1;
                  return 1413; /* addv16hi3_dup_exec */

                case E_V16SImode:
                  if (pattern205 (x3, 
E_V16SImode, 
E_SImode) != 0)
                    return -1;
                  return 1415; /* addv16si3_dup_exec */

                case E_V32QImode:
                  if (pattern205 (x3, 
E_V32QImode, 
E_QImode) != 0)
                    return -1;
                  return 1417; /* addv32qi3_dup_exec */

                case E_V32HImode:
                  if (pattern205 (x3, 
E_V32HImode, 
E_HImode) != 0)
                    return -1;
                  return 1419; /* addv32hi3_dup_exec */

                case E_V32SImode:
                  if (pattern205 (x3, 
E_V32SImode, 
E_SImode) != 0)
                    return -1;
                  return 1421; /* addv32si3_dup_exec */

                case E_V64QImode:
                  if (pattern205 (x3, 
E_V64QImode, 
E_QImode) != 0)
                    return -1;
                  return 1423; /* addv64qi3_dup_exec */

                case E_V64HImode:
                  if (pattern205 (x3, 
E_V64HImode, 
E_HImode) != 0)
                    return -1;
                  return 1425; /* addv64hi3_dup_exec */

                case E_V64SImode:
                  if (pattern205 (x3, 
E_V64SImode, 
E_SImode) != 0)
                    return -1;
                  return 1427; /* addv64si3_dup_exec */

                default:
                  return -1;
                }

            case SET:
              x12 = XEXP (x8, 1);
              if (GET_CODE (x12) != AND
                  || GET_MODE (x12) != E_DImode)
                return -1;
              x13 = XEXP (x12, 0);
              if (GET_CODE (x13) != LTU
                  || GET_MODE (x13) != E_DImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != PLUS)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != VEC_DUPLICATE)
                return -1;
              x16 = XEXP (x13, 1);
              if (GET_CODE (x16) != VEC_DUPLICATE)
                return -1;
              x17 = XEXP (x12, 1);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 126
                  || GET_MODE (x17) != E_DImode)
                return -1;
              x10 = XEXP (x6, 0);
              operands[1] = x10;
              if (!gcn_alu_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              x11 = XEXP (x3, 1);
              operands[4] = x11;
              operands[5] = x5;
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (!register_operand (operands[3], E_DImode))
                return -1;
              x18 = XEXP (x15, 0);
              if (!rtx_equal_p (x18, operands[2]))
                return -1;
              x19 = XEXP (x14, 1);
              if (!rtx_equal_p (x19, operands[1]))
                return -1;
              x20 = XEXP (x16, 0);
              if (!rtx_equal_p (x20, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (pattern241 (x1, 
E_V2SImode) != 0)
                    return -1;
                  return 1441; /* addv2si3_vcc_dup_exec */

                case E_V4SImode:
                  if (pattern241 (x1, 
E_V4SImode) != 0)
                    return -1;
                  return 1443; /* addv4si3_vcc_dup_exec */

                case E_V8SImode:
                  if (pattern241 (x1, 
E_V8SImode) != 0)
                    return -1;
                  return 1445; /* addv8si3_vcc_dup_exec */

                case E_V16SImode:
                  if (pattern241 (x1, 
E_V16SImode) != 0)
                    return -1;
                  return 1447; /* addv16si3_vcc_dup_exec */

                case E_V32SImode:
                  if (pattern241 (x1, 
E_V32SImode) != 0)
                    return -1;
                  return 1449; /* addv32si3_vcc_dup_exec */

                case E_V64SImode:
                  if (pattern241 (x1, 
E_V64SImode) != 0)
                    return -1;
                  return 1451; /* addv64si3_vcc_dup_exec */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (pattern130 (x1, 
PLUS, 
LTU) != 0
              || !register_operand (operands[3], E_DImode))
            return -1;
          x21 = XEXP (x6, 1);
          operands[1] = x21;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          switch (pattern245 (x1))
            {
            case 0:
              return 1453; /* addcv2si3_exec */

            case 1:
              return 1455; /* addcv4si3_exec */

            case 2:
              return 1457; /* addcv8si3_exec */

            case 3:
              return 1459; /* addcv16si3_exec */

            case 4:
              return 1461; /* addcv32si3_exec */

            case 5:
              return 1463; /* addcv64si3_exec */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern134 (x1))
            {
            case 0:
              return 1554; /* addv2di3_zext_exec */

            case 1:
              return 1555; /* addv4di3_zext_exec */

            case 2:
              return 1556; /* addv8di3_zext_exec */

            case 3:
              return 1557; /* addv16di3_zext_exec */

            case 4:
              return 1558; /* addv32di3_zext_exec */

            case 5:
              return 1559; /* addv64di3_zext_exec */

            case 6:
              return 1578; /* addv2di3_vcc_zext_dup2_exec */

            case 7:
              return 1579; /* addv4di3_vcc_zext_dup2_exec */

            case 8:
              return 1580; /* addv8di3_vcc_zext_dup2_exec */

            case 9:
              return 1581; /* addv16di3_vcc_zext_dup2_exec */

            case 10:
              return 1582; /* addv32di3_vcc_zext_dup2_exec */

            case 11:
              return 1583; /* addv64di3_vcc_zext_dup2_exec */

            case 12:
              return 1566; /* addv2di3_vcc_zext_dup_exec */

            case 13:
              return 1567; /* addv4di3_vcc_zext_dup_exec */

            case 14:
              return 1568; /* addv8di3_vcc_zext_dup_exec */

            case 15:
              return 1569; /* addv16di3_vcc_zext_dup_exec */

            case 16:
              return 1570; /* addv32di3_vcc_zext_dup_exec */

            case 17:
              return 1571; /* addv64di3_vcc_zext_dup_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x5 = XEXP (x3, 2);
      if (!gcn_exec_reg_operand (x5, E_DImode))
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x6;
          switch (pattern162 (x1, 
MINUS, 
GTU))
            {
            case 0:
              if (pattern202 (x3, 
E_V2QImode) != 0)
                return -1;
              return 1465; /* subv2qi3_exec */

            case 1:
              if (pattern202 (x3, 
E_V2HImode) != 0)
                return -1;
              return 1467; /* subv2hi3_exec */

            case 2:
              if (pattern202 (x3, 
E_V2SImode) != 0)
                return -1;
              return 1469; /* subv2si3_exec */

            case 3:
              if (pattern202 (x3, 
E_V4QImode) != 0)
                return -1;
              return 1471; /* subv4qi3_exec */

            case 4:
              if (pattern202 (x3, 
E_V4HImode) != 0)
                return -1;
              return 1473; /* subv4hi3_exec */

            case 5:
              if (pattern202 (x3, 
E_V4SImode) != 0)
                return -1;
              return 1475; /* subv4si3_exec */

            case 6:
              if (pattern202 (x3, 
E_V8QImode) != 0)
                return -1;
              return 1477; /* subv8qi3_exec */

            case 7:
              if (pattern202 (x3, 
E_V8HImode) != 0)
                return -1;
              return 1479; /* subv8hi3_exec */

            case 8:
              if (pattern202 (x3, 
E_V8SImode) != 0)
                return -1;
              return 1481; /* subv8si3_exec */

            case 9:
              if (pattern202 (x3, 
E_V16QImode) != 0)
                return -1;
              return 1483; /* subv16qi3_exec */

            case 10:
              if (pattern202 (x3, 
E_V16HImode) != 0)
                return -1;
              return 1485; /* subv16hi3_exec */

            case 11:
              if (pattern202 (x3, 
E_V16SImode) != 0)
                return -1;
              return 1487; /* subv16si3_exec */

            case 12:
              if (pattern202 (x3, 
E_V32QImode) != 0)
                return -1;
              return 1489; /* subv32qi3_exec */

            case 13:
              if (pattern202 (x3, 
E_V32HImode) != 0)
                return -1;
              return 1491; /* subv32hi3_exec */

            case 14:
              if (pattern202 (x3, 
E_V32SImode) != 0)
                return -1;
              return 1493; /* subv32si3_exec */

            case 15:
              if (pattern202 (x3, 
E_V64QImode) != 0)
                return -1;
              return 1495; /* subv64qi3_exec */

            case 16:
              if (pattern202 (x3, 
E_V64HImode) != 0)
                return -1;
              return 1497; /* subv64hi3_exec */

            case 17:
              if (pattern202 (x3, 
E_V64SImode) != 0)
                return -1;
              return 1499; /* subv64si3_exec */

            case 18:
              if (pattern202 (x3, 
E_V2DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              return 1542; /* subv2di3_exec */

            case 19:
              if (pattern202 (x3, 
E_V4DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              return 1543; /* subv4di3_exec */

            case 20:
              if (pattern202 (x3, 
E_V8DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              return 1544; /* subv8di3_exec */

            case 21:
              if (pattern202 (x3, 
E_V16DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              return 1545; /* subv16di3_exec */

            case 22:
              if (pattern202 (x3, 
E_V32DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              return 1546; /* subv32di3_exec */

            case 23:
              if (pattern202 (x3, 
E_V64DImode) != 0
                  || !
#line 1726 "../../gcc/config/gcn/gcn-valu.md"
(register_operand (operands[1], VOIDmode)
   || register_operand (operands[2], VOIDmode)))
                return -1;
              return 1547; /* subv64di3_exec */

            case 24:
              if (pattern239 (x1, 
E_V2SImode) != 0)
                return -1;
              return 1501; /* subv2si3_vcc_exec */

            case 25:
              if (pattern239 (x1, 
E_V4SImode) != 0)
                return -1;
              return 1503; /* subv4si3_vcc_exec */

            case 26:
              if (pattern239 (x1, 
E_V8SImode) != 0)
                return -1;
              return 1505; /* subv8si3_vcc_exec */

            case 27:
              if (pattern239 (x1, 
E_V16SImode) != 0)
                return -1;
              return 1507; /* subv16si3_vcc_exec */

            case 28:
              if (pattern239 (x1, 
E_V32SImode) != 0)
                return -1;
              return 1509; /* subv32si3_vcc_exec */

            case 29:
              if (pattern239 (x1, 
E_V64SImode) != 0)
                return -1;
              return 1511; /* subv64si3_vcc_exec */

            default:
              return -1;
            }

        case MINUS:
          if (pattern130 (x1, 
MINUS, 
GTU) != 0
              || !gcn_alu_operand (operands[3], E_DImode))
            return -1;
          x21 = XEXP (x6, 1);
          operands[1] = x21;
          switch (pattern245 (x1))
            {
            case 0:
              return 1513; /* subcv2si3_exec */

            case 1:
              return 1515; /* subcv4si3_exec */

            case 2:
              return 1517; /* subcv8si3_exec */

            case 3:
              return 1519; /* subcv16si3_exec */

            case 4:
              return 1521; /* subcv32si3_exec */

            case 5:
              return 1523; /* subcv64si3_exec */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x11 = XEXP (x3, 1);
      operands[3] = x11;
      x5 = XEXP (x3, 2);
      operands[4] = x5;
      if (!gcn_exec_reg_operand (operands[4], E_DImode))
        return -1;
      switch (pattern165 (x1))
        {
        case 0:
          return 1725; /* mulv2di3_exec */

        case 1:
          return 1726; /* mulv4di3_exec */

        case 2:
          return 1727; /* mulv8di3_exec */

        case 3:
          return 1728; /* mulv16di3_exec */

        case 4:
          return 1729; /* mulv32di3_exec */

        case 5:
          return 1730; /* mulv64di3_exec */

        case 6:
          return 1737; /* mulv2di3_zext_exec */

        case 7:
          return 1738; /* mulv4di3_zext_exec */

        case 8:
          return 1739; /* mulv8di3_zext_exec */

        case 9:
          return 1740; /* mulv16di3_zext_exec */

        case 10:
          return 1741; /* mulv32di3_zext_exec */

        case 11:
          return 1742; /* mulv64di3_zext_exec */

        case 12:
          return 1749; /* mulv2di3_zext_dup2_exec */

        case 13:
          return 1750; /* mulv4di3_zext_dup2_exec */

        case 14:
          return 1751; /* mulv8di3_zext_dup2_exec */

        case 15:
          return 1752; /* mulv16di3_zext_dup2_exec */

        case 16:
          return 1753; /* mulv32di3_zext_dup2_exec */

        case 17:
          return 1754; /* mulv64di3_zext_dup2_exec */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 38)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x12 = XEXP (x8, 1);
      if (GET_CODE (x12) != AND
          || GET_MODE (x12) != E_DImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != UNSPEC
          || XVECLEN (x13, 0) != 3
          || XINT (x13, 1) != 38
          || GET_MODE (x13) != E_DImode)
        return -1;
      x17 = XEXP (x12, 1);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 126
          || GET_MODE (x17) != E_DImode)
        return -1;
      x22 = XVECEXP (x4, 0, 0);
      operands[1] = x22;
      x23 = XVECEXP (x4, 0, 1);
      operands[2] = x23;
      x24 = XVECEXP (x4, 0, 2);
      operands[3] = x24;
      x11 = XEXP (x3, 1);
      operands[5] = x11;
      x5 = XEXP (x3, 2);
      operands[6] = x5;
      if (!gcn_exec_reg_operand (operands[6], E_DImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      if (!register_operand (operands[4], E_DImode))
        return -1;
      x25 = XVECEXP (x13, 0, 0);
      if (!rtx_equal_p (x25, operands[1]))
        return -1;
      x26 = XVECEXP (x13, 0, 1);
      if (!rtx_equal_p (x26, operands[2]))
        return -1;
      x27 = XVECEXP (x13, 0, 2);
      if (!rtx_equal_p (x27, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (pattern242 (x3, 
E_V2SFmode) != 0)
            return -1;
          return 3029; /* div_scalev2sf_exec */

        case E_V2DFmode:
          if (pattern242 (x3, 
E_V2DFmode) != 0)
            return -1;
          return 3031; /* div_scalev2df_exec */

        case E_V4SFmode:
          if (pattern242 (x3, 
E_V4SFmode) != 0)
            return -1;
          return 3033; /* div_scalev4sf_exec */

        case E_V4DFmode:
          if (pattern242 (x3, 
E_V4DFmode) != 0)
            return -1;
          return 3035; /* div_scalev4df_exec */

        case E_V8SFmode:
          if (pattern242 (x3, 
E_V8SFmode) != 0)
            return -1;
          return 3037; /* div_scalev8sf_exec */

        case E_V8DFmode:
          if (pattern242 (x3, 
E_V8DFmode) != 0)
            return -1;
          return 3039; /* div_scalev8df_exec */

        case E_V16SFmode:
          if (pattern242 (x3, 
E_V16SFmode) != 0)
            return -1;
          return 3041; /* div_scalev16sf_exec */

        case E_V16DFmode:
          if (pattern242 (x3, 
E_V16DFmode) != 0)
            return -1;
          return 3043; /* div_scalev16df_exec */

        case E_V32SFmode:
          if (pattern242 (x3, 
E_V32SFmode) != 0)
            return -1;
          return 3045; /* div_scalev32sf_exec */

        case E_V32DFmode:
          if (pattern242 (x3, 
E_V32DFmode) != 0)
            return -1;
          return 3047; /* div_scalev32df_exec */

        case E_V64SFmode:
          if (pattern242 (x3, 
E_V64SFmode) != 0)
            return -1;
          return 3049; /* div_scalev64sf_exec */

        case E_V64DFmode:
          if (pattern242 (x3, 
E_V64DFmode) != 0)
            return -1;
          return 3051; /* div_scalev64df_exec */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
